var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var app;
(function (app) {
    var ApplicationAppPanel = (function (_super) {
        __extends(ApplicationAppPanel, _super);
        function ApplicationAppPanel(appBar, path) {
            _super.call(this, {
                appBar: appBar
            });
            this.handleGlobalEvents();
            this.route(path);
        }
        ApplicationAppPanel.prototype.route = function (path) {
            var action = path ? path.getElement(0) : undefined;
            switch (action) {
                case 'edit':
                    var id = path.getElement(1);
                    if (id) {
                    }
                    break;
                case 'view':
                    var id = path.getElement(1);
                    if (id) {
                    }
                    break;
                default:
                    new api.app.ShowBrowsePanelEvent().fire();
                    break;
            }
        };
        ApplicationAppPanel.prototype.handleGlobalEvents = function () {
            var _this = this;
            api.app.ShowBrowsePanelEvent.on(function (event) {
                _this.handleBrowse(event);
            });
        };
        ApplicationAppPanel.prototype.handleBrowse = function (event) {
            var browsePanel = this.getBrowsePanel();
            if (!browsePanel) {
                this.addBrowsePanel(new app.browse.ApplicationBrowsePanel());
            }
            else {
                this.showPanel(browsePanel);
            }
        };
        return ApplicationAppPanel;
    })(api.app.BrowseAndWizardBasedAppPanel);
    app.ApplicationAppPanel = ApplicationAppPanel;
})(app || (app = {}));
///<reference path='ApplicationAppPanel.ts' /> 
var app;
(function (app) {
    var browse;
    (function (browse) {
        var GridColumnBuilder = api.ui.grid.GridColumnBuilder;
        var Application = api.application.Application;
        var ApplicationViewer = api.application.ApplicationViewer;
        var TreeGrid = api.ui.treegrid.TreeGrid;
        var TreeGridBuilder = api.ui.treegrid.TreeGridBuilder;
        var DateTimeFormatter = api.ui.treegrid.DateTimeFormatter;
        var TreeGridContextMenu = api.ui.treegrid.TreeGridContextMenu;
        var ApplicationTreeGrid = (function (_super) {
            __extends(ApplicationTreeGrid, _super);
            function ApplicationTreeGrid() {
                var _this = this;
                _super.call(this, new TreeGridBuilder().
                    setColumns([
                    new GridColumnBuilder().
                        setName("Name").
                        setId("displayName").
                        setField("displayName").
                        setFormatter(this.nameFormatter).
                        setMinWidth(250).
                        build(),
                    new GridColumnBuilder().
                        setName("Version").
                        setId("version").
                        setField("version").
                        setCssClass("version").
                        setMinWidth(50).
                        setMaxWidth(70).
                        build(),
                    new GridColumnBuilder().
                        setName("State").
                        setId("state").
                        setField("state").
                        setCssClass("state").
                        setMinWidth(80).
                        setMaxWidth(100).
                        setFormatter(this.stateFormatter).
                        build(),
                    new GridColumnBuilder().
                        setName("ModifiedTime").
                        setId("modifiedTime").
                        setField("modifiedTime").
                        setCssClass("modified").
                        setMinWidth(150).
                        setMaxWidth(170).
                        setFormatter(DateTimeFormatter.format).
                        build()
                ]).
                    prependClasses("application-grid").
                    setShowContextMenu(new TreeGridContextMenu(new browse.ApplicationBrowseActions(this))));
                api.ui.responsive.ResponsiveManager.onAvailableSizeChanged(this, function (item) {
                    _this.getGrid().resizeCanvas();
                });
            }
            ApplicationTreeGrid.prototype.nameFormatter = function (row, cell, value, columnDef, node) {
                var viewer = node.getViewer("name");
                if (!viewer) {
                    var viewer = new ApplicationViewer();
                    viewer.setObject(node.getData());
                    node.setViewer("name", viewer);
                }
                return viewer.toString();
            };
            ApplicationTreeGrid.prototype.stateFormatter = function (row, cell, value, columnDef, node) {
                var data = node.getData(), status, statusEl = new api.dom.DivEl();
                if (data instanceof Application) {
                    statusEl.getEl().setText(value);
                }
                else if (data instanceof ApplicationUploadMock) {
                    status = new api.ui.ProgressBar(data.getUploadItem().getProgress());
                    statusEl.appendChild(status);
                }
                return statusEl.toString();
            };
            ApplicationTreeGrid.prototype.getDataId = function (data) {
                return data.getId();
            };
            ApplicationTreeGrid.prototype.fetchRoot = function () {
                return new api.application.ListApplicationsRequest().sendAndParse();
            };
            ApplicationTreeGrid.prototype.fetch = function (node, dataId) {
                return this.fetchByKey(node.getData().getApplicationKey());
            };
            ApplicationTreeGrid.prototype.fetchByKey = function (applicationKey) {
                var deferred = wemQ.defer();
                new api.application.GetApplicationRequest(applicationKey, true).sendAndParse().then(function (application) {
                    deferred.resolve(application);
                }).catch(function (reason) {
                    api.DefaultErrorHandler.handle(reason);
                });
                return deferred.promise;
            };
            ApplicationTreeGrid.prototype.updateApplicationNode = function (applicationKey) {
                var _this = this;
                var root = this.getRoot().getCurrentRoot();
                root.getChildren().forEach(function (child) {
                    var curApplication = child.getData();
                    if (curApplication.getApplicationKey().toString() == applicationKey.toString()) {
                        _this.updateNode(curApplication);
                    }
                });
            };
            ApplicationTreeGrid.prototype.getByApplicationKey = function (applicationKey) {
                var root = this.getRoot().getCurrentRoot(), result;
                root.getChildren().forEach(function (child) {
                    var curApplication = child.getData();
                    if (curApplication.getApplicationKey().toString() == applicationKey.toString()) {
                        result = curApplication;
                    }
                });
                return result;
            };
            ApplicationTreeGrid.prototype.deleteApplicationNode = function (applicationKey) {
                var _this = this;
                var root = this.getRoot().getCurrentRoot();
                root.getChildren().forEach(function (child) {
                    var curApplication = child.getData();
                    if (curApplication.getApplicationKey().toString() == applicationKey.toString()) {
                        _this.deleteNode(curApplication);
                    }
                });
            };
            ApplicationTreeGrid.prototype.appendApplicationNode = function (applicationKey) {
                var _this = this;
                return this.fetchByKey(applicationKey)
                    .then(function (data) {
                    return _this.appendNode(data, true);
                });
            };
            ApplicationTreeGrid.prototype.refreshNodeData = function (parentNode) {
                var _this = this;
                return this.fetchByKey(parentNode.getData().getApplicationKey()).then(function (curApplication) {
                    parentNode.setData(curApplication);
                    _this.refreshNode(parentNode);
                    return parentNode;
                });
            };
            ApplicationTreeGrid.prototype.appendUploadNode = function (item) {
                var _this = this;
                var appMock = new ApplicationUploadMock(item);
                this.appendNode(appMock, false).then(function () {
                }).done();
                item.onProgress(function (progress) {
                    _this.invalidate();
                });
                item.onUploaded(function (model) {
                    var nodeToRemove = _this.getRoot().getCurrentRoot().findNode(item.getId());
                    if (nodeToRemove) {
                        _this.deleteNode(nodeToRemove.getData());
                        _this.invalidate();
                        _this.triggerSelectionChangedListeners();
                    }
                });
                item.onFailed(function () {
                    _this.deleteNode(appMock);
                    _this.triggerSelectionChangedListeners();
                });
            };
            return ApplicationTreeGrid;
        })(TreeGrid);
        browse.ApplicationTreeGrid = ApplicationTreeGrid;
        var ApplicationUploadMock = (function () {
            function ApplicationUploadMock(uploadItem) {
                this.id = uploadItem.getId();
                this.name = uploadItem.getName();
                this.uploadItem = uploadItem;
            }
            ApplicationUploadMock.prototype.getId = function () {
                return this.id;
            };
            ApplicationUploadMock.prototype.getDisplayName = function () {
                return this.name;
            };
            ApplicationUploadMock.prototype.getName = function () {
                return this.name;
            };
            ApplicationUploadMock.prototype.getUploadItem = function () {
                return this.uploadItem;
            };
            ApplicationUploadMock.prototype.getApplicationKey = function () {
                return this.name;
            };
            ApplicationUploadMock.prototype.isLocal = function () {
                return false;
            };
            return ApplicationUploadMock;
        })();
        browse.ApplicationUploadMock = ApplicationUploadMock;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var StartApplicationAction = (function (_super) {
            __extends(StartApplicationAction, _super);
            function StartApplicationAction(applicationTreeGrid) {
                _super.call(this, "Start");
                this.setEnabled(false);
                this.onExecuted(function () {
                    var applications = applicationTreeGrid.getSelectedDataList();
                    new browse.StartApplicationEvent(applications).fire();
                });
            }
            return StartApplicationAction;
        })(api.ui.Action);
        browse.StartApplicationAction = StartApplicationAction;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var StopApplicationAction = (function (_super) {
            __extends(StopApplicationAction, _super);
            function StopApplicationAction(applicationTreeGrid) {
                _super.call(this, "Stop");
                this.setEnabled(false);
                this.onExecuted(function () {
                    var applications = applicationTreeGrid.getSelectedDataList();
                    new browse.StopApplicationEvent(applications).fire();
                });
            }
            return StopApplicationAction;
        })(api.ui.Action);
        browse.StopApplicationAction = StopApplicationAction;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var Application = api.application.Application;
        var ApplicationBrowseActions = (function () {
            function ApplicationBrowseActions(applicationTreeGrid) {
                this.allActions = [];
                this.START_APPLICATION = new browse.StartApplicationAction(applicationTreeGrid);
                this.STOP_APPLICATION = new browse.StopApplicationAction(applicationTreeGrid);
                this.INSTALL_APPLICATION = new browse.InstallApplicationAction(applicationTreeGrid);
                this.UNINSTALL_APPLICATION = new browse.UninstallApplicationAction(applicationTreeGrid);
                this.INSTALL_APPLICATION.setEnabled(true);
                this.allActions.push(this.START_APPLICATION, this.STOP_APPLICATION, this.UNINSTALL_APPLICATION);
                ApplicationBrowseActions.INSTANCE = this;
            }
            ApplicationBrowseActions.init = function (applicationTreeGrid) {
                new ApplicationBrowseActions(applicationTreeGrid);
                return ApplicationBrowseActions.INSTANCE;
            };
            ApplicationBrowseActions.get = function () {
                return ApplicationBrowseActions.INSTANCE;
            };
            ApplicationBrowseActions.prototype.getAllActions = function () {
                return this.allActions;
            };
            ApplicationBrowseActions.prototype.updateActionsEnabledState = function (applicationBrowseItems) {
                var applicationsSelected = applicationBrowseItems.length;
                var anySelected = applicationsSelected > 0;
                var anyStarted = false;
                var anyStopped = false;
                var localAppSelected = false;
                applicationBrowseItems.forEach(function (applicationBrowseItem) {
                    var state = applicationBrowseItem.getModel().getState();
                    if (state === Application.STATE_STARTED) {
                        anyStarted = true;
                    }
                    else if (state === Application.STATE_STOPPED) {
                        anyStopped = true;
                    }
                    if (applicationBrowseItem.getModel().isLocal()) {
                        localAppSelected = true;
                    }
                });
                this.START_APPLICATION.setEnabled(anyStopped);
                this.STOP_APPLICATION.setEnabled(anyStarted);
                this.UNINSTALL_APPLICATION.setEnabled(anySelected && !localAppSelected);
                var deferred = wemQ.defer();
                deferred.resolve(applicationBrowseItems);
                return deferred.promise;
            };
            return ApplicationBrowseActions;
        })();
        browse.ApplicationBrowseActions = ApplicationBrowseActions;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var Event = api.event.Event;
        var StopApplicationEvent = (function (_super) {
            __extends(StopApplicationEvent, _super);
            function StopApplicationEvent(applications) {
                this.applications = applications;
                _super.call(this);
            }
            StopApplicationEvent.prototype.getApplications = function () {
                return this.applications;
            };
            StopApplicationEvent.on = function (handler) {
                Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            StopApplicationEvent.un = function (handler) {
                Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return StopApplicationEvent;
        })(Event);
        browse.StopApplicationEvent = StopApplicationEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var Event = api.event.Event;
        var StartApplicationEvent = (function (_super) {
            __extends(StartApplicationEvent, _super);
            function StartApplicationEvent(applications) {
                this.applications = applications;
                _super.call(this);
            }
            StartApplicationEvent.prototype.getApplications = function () {
                return this.applications;
            };
            StartApplicationEvent.on = function (handler) {
                Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            StartApplicationEvent.un = function (handler) {
                Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return StartApplicationEvent;
        })(Event);
        browse.StartApplicationEvent = StartApplicationEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var Event = api.event.Event;
        var UninstallApplicationEvent = (function (_super) {
            __extends(UninstallApplicationEvent, _super);
            function UninstallApplicationEvent(applications) {
                this.applications = applications;
                _super.call(this);
            }
            UninstallApplicationEvent.prototype.getApplications = function () {
                return this.applications;
            };
            UninstallApplicationEvent.on = function (handler) {
                Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            UninstallApplicationEvent.un = function (handler) {
                Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return UninstallApplicationEvent;
        })(Event);
        browse.UninstallApplicationEvent = UninstallApplicationEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ApplicationViewer = api.application.ApplicationViewer;
        var ApplicationBrowseItemsSelectionPanel = (function (_super) {
            __extends(ApplicationBrowseItemsSelectionPanel, _super);
            function ApplicationBrowseItemsSelectionPanel() {
                _super.apply(this, arguments);
            }
            ApplicationBrowseItemsSelectionPanel.prototype.createItemViewer = function (item) {
                var viewer = new ApplicationViewer();
                viewer.setObject(item.getModel());
                return viewer;
            };
            return ApplicationBrowseItemsSelectionPanel;
        })(api.app.browse.BrowseItemsSelectionPanel);
        browse.ApplicationBrowseItemsSelectionPanel = ApplicationBrowseItemsSelectionPanel;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ApplicationKey = api.application.ApplicationKey;
        var BrowseItem = api.app.browse.BrowseItem;
        var StartApplicationRequest = api.application.StartApplicationRequest;
        var StopApplicationRequest = api.application.StopApplicationRequest;
        var UninstallApplicationRequest = api.application.UninstallApplicationRequest;
        var ApplicationEventType = api.application.ApplicationEventType;
        var ApplicationBrowsePanel = (function (_super) {
            __extends(ApplicationBrowsePanel, _super);
            function ApplicationBrowsePanel() {
                this.applicationTreeGrid = new browse.ApplicationTreeGrid();
                this.browseActions = this.applicationTreeGrid.getContextMenu().getActions();
                this.toolbar = new browse.ApplicationBrowseToolbar(this.browseActions);
                var browseItemPanel = components.detailPanel = new browse.ApplicationBrowseItemPanel();
                _super.call(this, {
                    browseToolbar: this.toolbar,
                    treeGrid: this.applicationTreeGrid,
                    browseItemPanel: browseItemPanel,
                    filterPanel: undefined
                });
                this.applicationIconUrl = api.util.UriHelper.getAdminUri('common/images/icons/icoMoon/128x128/puzzle.png');
                this.registerEvents();
            }
            ApplicationBrowsePanel.prototype.treeNodesToBrowseItems = function (nodes) {
                var _this = this;
                var browseItems = [];
                nodes.forEach(function (node, index) {
                    for (var i = 0; i <= index; i++) {
                        if (nodes[i].getData().getId() === node.getData().getId()) {
                            break;
                        }
                    }
                    if (i === index) {
                        var applicationEl = node.getData();
                        var item = new BrowseItem(applicationEl).
                            setId(applicationEl.getId()).
                            setDisplayName(applicationEl.getDisplayName()).
                            setPath(applicationEl.getName()).
                            setIconUrl(_this.applicationIconUrl);
                        browseItems.push(item);
                    }
                });
                return browseItems;
            };
            ApplicationBrowsePanel.prototype.registerEvents = function () {
                var _this = this;
                browse.StopApplicationEvent.on(function (event) {
                    var applicationKeys = ApplicationKey.fromApplications(event.getApplications());
                    new StopApplicationRequest(applicationKeys).sendAndParse()
                        .then(function () {
                    }).done();
                });
                browse.StartApplicationEvent.on(function (event) {
                    var applicationKeys = ApplicationKey.fromApplications(event.getApplications());
                    new StartApplicationRequest(applicationKeys).sendAndParse()
                        .then(function () {
                    }).done();
                });
                browse.UninstallApplicationEvent.on(function (event) {
                    var applicationKeys = ApplicationKey.fromClusterApplications(event.getApplications());
                    new UninstallApplicationRequest(applicationKeys).sendAndParse()
                        .then(function () {
                    }).done();
                });
                api.application.ApplicationEvent.on(function (event) {
                    if (ApplicationEventType.INSTALLED == event.getEventType()) {
                        _this.applicationTreeGrid.appendApplicationNode(event.getApplicationKey()).then(function () {
                            setTimeout(function () {
                                _this.applicationTreeGrid.triggerSelectionChangedListeners();
                                var installedApp = _this.applicationTreeGrid.getByApplicationKey(event.getApplicationKey()), installedAppName = !!installedApp ? installedApp.getDisplayName() : event.getApplicationKey();
                                api.notify.showFeedback("Application '" + installedAppName + "' installed successfully");
                            }, 200);
                        });
                    }
                    else if (ApplicationEventType.UNINSTALLED == event.getEventType()) {
                        var uninstalledApp = _this.applicationTreeGrid.getByApplicationKey(event.getApplicationKey()), uninstalledAppName = !!uninstalledApp ? uninstalledApp.getDisplayName() : event.getApplicationKey();
                        api.notify.showFeedback("Application '" + uninstalledAppName + "' uninstalled successfully");
                        _this.applicationTreeGrid.deleteApplicationNode(event.getApplicationKey());
                    }
                    else if (ApplicationEventType.STOPPED == event.getEventType()) {
                        setTimeout(function () {
                            var stoppedApp = _this.applicationTreeGrid.getByApplicationKey(event.getApplicationKey());
                            if (!!stoppedApp) {
                                _this.applicationTreeGrid.updateApplicationNode(event.getApplicationKey());
                            }
                        }, 400);
                    }
                    else if (event.isNeedToUpdateApplication()) {
                        _this.applicationTreeGrid.updateApplicationNode(event.getApplicationKey());
                    }
                });
                api.application.ApplicationUploadStartedEvent.on(function (event) {
                    _this.handleNewAppUpload(event);
                });
            };
            ApplicationBrowsePanel.prototype.handleNewAppUpload = function (event) {
                var _this = this;
                event.getUploadItems().forEach(function (item) {
                    _this.applicationTreeGrid.appendUploadNode(item);
                });
            };
            return ApplicationBrowsePanel;
        })(api.app.browse.BrowsePanel);
        browse.ApplicationBrowsePanel = ApplicationBrowsePanel;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ApplicationBrowseToolbar = (function (_super) {
            __extends(ApplicationBrowseToolbar, _super);
            function ApplicationBrowseToolbar(actions) {
                _super.call(this);
                _super.prototype.addAction.call(this, actions.INSTALL_APPLICATION);
                _super.prototype.addAction.call(this, actions.UNINSTALL_APPLICATION);
                _super.prototype.addAction.call(this, actions.START_APPLICATION);
                _super.prototype.addAction.call(this, actions.STOP_APPLICATION);
            }
            return ApplicationBrowseToolbar;
        })(api.ui.toolbar.Toolbar);
        browse.ApplicationBrowseToolbar = ApplicationBrowseToolbar;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ApplicationBrowseItemPanel = (function (_super) {
            __extends(ApplicationBrowseItemPanel, _super);
            function ApplicationBrowseItemPanel() {
                _super.apply(this, arguments);
            }
            ApplicationBrowseItemPanel.prototype.createItemSelectionPanel = function () {
                return new browse.ApplicationBrowseItemsSelectionPanel();
            };
            ApplicationBrowseItemPanel.prototype.createItemStatisticsPanel = function () {
                return new app.view.ApplicationItemStatisticsPanel();
            };
            return ApplicationBrowseItemPanel;
        })(api.app.browse.BrowseItemPanel);
        browse.ApplicationBrowseItemPanel = ApplicationBrowseItemPanel;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var InstallApplicationAction = (function (_super) {
            __extends(InstallApplicationAction, _super);
            function InstallApplicationAction(applicationTreeGrid) {
                _super.call(this, "Install");
                this.setEnabled(false);
                this.onExecuted(function () {
                    new app.installation.InstallAppPromptEvent().fire();
                });
            }
            return InstallApplicationAction;
        })(api.ui.Action);
        browse.InstallApplicationAction = InstallApplicationAction;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var UninstallApplicationAction = (function (_super) {
            __extends(UninstallApplicationAction, _super);
            function UninstallApplicationAction(applicationTreeGrid) {
                _super.call(this, "Uninstall");
                this.setEnabled(false);
                this.onExecuted(function () {
                    var applications = applicationTreeGrid.getSelectedDataList();
                    new browse.UninstallApplicationDialog(applications).open();
                });
            }
            return UninstallApplicationAction;
        })(api.ui.Action);
        browse.UninstallApplicationAction = UninstallApplicationAction;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var UninstallApplicationDialog = (function (_super) {
            __extends(UninstallApplicationDialog, _super);
            function UninstallApplicationDialog(applications) {
                var _this = this;
                _super.call(this, {
                    title: new api.ui.dialog.ModalDialogHeader("Uninstall Applications")
                });
                this.yesAction = new api.ui.Action('Yes');
                this.noAction = new api.ui.Action('No');
                this.applications = applications;
                this.addClass("uninstall-dialog");
                var message = new api.dom.H6El();
                message.getEl().setInnerHtml("Are you sure you want to uninstall selected application(s)?");
                this.appendChildToContentPanel(message);
                this.yesAction.onExecuted(function () {
                    new browse.UninstallApplicationEvent(_this.applications).fire();
                    _this.close();
                });
                this.addAction(this.yesAction);
                this.noAction.onExecuted(function () {
                    _this.close();
                });
                this.addAction(this.noAction);
            }
            UninstallApplicationDialog.prototype.show = function () {
                api.dom.Body.get().appendChild(this);
                _super.prototype.show.call(this);
            };
            UninstallApplicationDialog.prototype.close = function () {
                _super.prototype.close.call(this);
                this.remove();
            };
            return UninstallApplicationDialog;
        })(api.ui.dialog.ModalDialog);
        browse.UninstallApplicationDialog = UninstallApplicationDialog;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
///<reference path='ApplicationTreeGrid.ts'/>
///<reference path='StartApplicationAction.ts' />
///<reference path='StopApplicationAction.ts' />
///<reference path='ApplicationBrowseActions.ts' />
///<reference path='StopApplicationEvent.ts' />
///<reference path='StartApplicationEvent.ts' />
///<reference path='UninstallApplicationEvent.ts' />
///<reference path='ApplicationBrowseItemsSelectionPanel.ts' />
///<reference path='ApplicationBrowsePanel.ts' />
///<reference path='ApplicationBrowseToolbar.ts' />
///<reference path='ApplicationBrowseItemPanel.ts'/>
///<reference path='InstallApplicationAction.ts'/>
///<reference path='UninstallApplicationAction.ts'/>
///<reference path='UninstallApplicationDialog.ts'/>
var app;
(function (app) {
    var view;
    (function (view) {
        var ApplicationBrowseActions = app.browse.ApplicationBrowseActions;
        var ItemDataGroup = api.app.view.ItemDataGroup;
        var ApplicationItemStatisticsPanel = (function (_super) {
            __extends(ApplicationItemStatisticsPanel, _super);
            function ApplicationItemStatisticsPanel() {
                _super.call(this, "application-item-statistics-panel");
                this.actionMenu =
                    new api.ui.menu.ActionMenu("Application actions", ApplicationBrowseActions.get().START_APPLICATION, ApplicationBrowseActions.get().STOP_APPLICATION);
                this.appendChild(this.actionMenu);
                this.applicationDataContainer = new api.dom.DivEl("application-data-container");
                this.appendChild(this.applicationDataContainer);
            }
            ApplicationItemStatisticsPanel.prototype.setItem = function (item) {
                var _this = this;
                var currentItem = this.getItem();
                if (currentItem && currentItem.equals(item)) {
                    return;
                }
                _super.prototype.setItem.call(this, item);
                var currentApplication = item.getModel();
                this.actionMenu.setLabel(api.util.StringHelper.capitalize(currentApplication.getState()));
                if (currentApplication.isStarted()) {
                    ApplicationBrowseActions.get().START_APPLICATION.setEnabled(false);
                    ApplicationBrowseActions.get().STOP_APPLICATION.setEnabled(true);
                }
                else {
                    ApplicationBrowseActions.get().START_APPLICATION.setEnabled(true);
                    ApplicationBrowseActions.get().STOP_APPLICATION.setEnabled(false);
                }
                this.applicationDataContainer.removeChildren();
                var infoGroup = new ItemDataGroup("Info", "info");
                infoGroup.addDataList("Build date", "TBA");
                infoGroup.addDataList("Version", currentApplication.getVersion());
                infoGroup.addDataList("Key", currentApplication.getApplicationKey().toString());
                infoGroup.addDataList("System Required", ">= " + currentApplication.getMinSystemVersion() + " and < " + currentApplication.getMaxSystemVersion());
                var schemasGroup = new ItemDataGroup("Schemas", "schemas");
                var applicationKey = currentApplication.getApplicationKey();
                var schemaPromises = [
                    new api.schema.content.GetContentTypesByApplicationRequest(applicationKey).sendAndParse(),
                    new api.schema.mixin.GetMixinsByApplicationRequest(applicationKey).sendAndParse(),
                    new api.schema.relationshiptype.GetRelationshipTypesByApplicationRequest(applicationKey).sendAndParse()
                ];
                wemQ.all(schemaPromises).
                    spread(function (contentTypes, mixins, relationshipTypes) {
                    var contentTypeNames = contentTypes.map(function (contentType) { return contentType.getContentTypeName().getLocalName(); }).sort(_this.sortAlphabeticallyAsc);
                    schemasGroup.addDataArray("Content Types", contentTypeNames);
                    var mixinsNames = mixins.map(function (mixin) { return mixin.getMixinName().getLocalName(); }).sort(_this.sortAlphabeticallyAsc);
                    schemasGroup.addDataArray("Mixins", mixinsNames);
                    var relationshipTypeNames = relationshipTypes.map(function (relationshipType) { return relationshipType.getRelationshiptypeName().getLocalName(); }).sort(_this.sortAlphabeticallyAsc);
                    schemasGroup.addDataArray("RelationshipTypes", relationshipTypeNames);
                }).
                    catch(function (reason) { return api.DefaultErrorHandler.handle(reason); }).
                    done();
                var descriptorsGroup = new ItemDataGroup("Descriptors", "descriptors");
                var descriptorPromises = [
                    new api.content.page.GetPageDescriptorsByApplicationRequest(applicationKey).sendAndParse(),
                    new api.content.page.region.GetPartDescriptorsByApplicationRequest(applicationKey).sendAndParse(),
                    new api.content.page.region.GetLayoutDescriptorsByApplicationRequest(applicationKey).sendAndParse()
                ];
                wemQ.all(descriptorPromises).
                    spread(function (pageDescriptors, partDescriptors, layoutDescriptors) {
                    var pageNames = pageDescriptors.map(function (descriptor) { return descriptor.getName().toString(); }).sort(_this.sortAlphabeticallyAsc);
                    descriptorsGroup.addDataArray("Page", pageNames);
                    var partNames = partDescriptors.map(function (descriptor) { return descriptor.getName().toString(); }).sort(_this.sortAlphabeticallyAsc);
                    descriptorsGroup.addDataArray("Part", partNames);
                    var layoutNames = layoutDescriptors.map(function (descriptor) { return descriptor.getName().toString(); }).sort(_this.sortAlphabeticallyAsc);
                    descriptorsGroup.addDataArray("Layout", layoutNames);
                }).
                    catch(function (reason) { return api.DefaultErrorHandler.handle(reason); }).
                    done();
                this.applicationDataContainer.appendChild(infoGroup);
                this.applicationDataContainer.appendChild(schemasGroup);
                this.applicationDataContainer.appendChild(descriptorsGroup);
            };
            ApplicationItemStatisticsPanel.prototype.sortAlphabeticallyAsc = function (a, b) {
                return a.toLocaleLowerCase().localeCompare(b.toLocaleLowerCase());
            };
            return ApplicationItemStatisticsPanel;
        })(api.app.view.ItemStatisticsPanel);
        view.ApplicationItemStatisticsPanel = ApplicationItemStatisticsPanel;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
///<reference path='ApplicationItemStatisticsPanel.ts' /> 
var app;
(function (app) {
    var installation;
    (function (installation) {
        var view;
        (function (view) {
            var MarketAppViewer = (function (_super) {
                __extends(MarketAppViewer, _super);
                function MarketAppViewer(className, size) {
                    if (size === void 0) { size = api.app.NamesAndIconViewSize.small; }
                    _super.call(this, className);
                    this.namesAndIconView = new api.app.NamesAndIconViewBuilder().setSize(size).build();
                }
                MarketAppViewer.prototype.setObject = function (object, relativePath) {
                    var _this = this;
                    if (relativePath === void 0) { relativePath = false; }
                    _super.prototype.setObject.call(this, object);
                    var displayName = this.resolveDisplayName(object), subName = this.resolveSubName(object, relativePath), subTitle = this.resolveSubTitle(object), iconUrl = this.resolveIconUrl(object);
                    this.namesAndIconView.getNamesView().setMainName(displayName, false).
                        setSubName(subName, subTitle);
                    if (!!subTitle) {
                        this.namesAndIconView.getEl().setTitle(subTitle);
                    }
                    else if (!!subName) {
                        this.namesAndIconView.getEl().setTitle(subName);
                    }
                    if (!!iconUrl) {
                        this.namesAndIconView.setIconUrl(iconUrl);
                    }
                    this.namesAndIconView.getIconImageEl().onError(function () {
                        _this.namesAndIconView.setIconClass("icon-puzzle icon-large");
                        _this.namesAndIconView.getIconImageEl().setSrc("");
                    });
                    this.render();
                };
                MarketAppViewer.prototype.resolveDisplayName = function (object) {
                    var appLink = new api.dom.AEl().setUrl(object.getUrl(), "_blank").setHtml(object.getDisplayName(), false);
                    return appLink.toString();
                };
                MarketAppViewer.prototype.resolveSubName = function (object, relativePath) {
                    if (relativePath === void 0) { relativePath = false; }
                    return object.getDescription();
                };
                MarketAppViewer.prototype.resolveSubTitle = function (object) {
                    return object.getDescription();
                };
                MarketAppViewer.prototype.resolveIconUrl = function (object) {
                    return object.getIconUrl();
                };
                MarketAppViewer.prototype.getPreferredHeight = function () {
                    return 50;
                };
                MarketAppViewer.prototype.doRender = function () {
                    this.removeChildren();
                    this.appendChild(this.namesAndIconView);
                    return true;
                };
                return MarketAppViewer;
            })(api.ui.Viewer);
            view.MarketAppViewer = MarketAppViewer;
        })(view = installation.view || (installation.view = {}));
    })(installation = app.installation || (app.installation = {}));
})(app || (app = {}));
var app;
(function (app_1) {
    var installation;
    (function (installation) {
        var view;
        (function (view) {
            var Element = api.dom.Element;
            var ElementHelper = api.dom.ElementHelper;
            var ElementFromHelperBuilder = api.dom.ElementFromHelperBuilder;
            var GridColumnBuilder = api.ui.grid.GridColumnBuilder;
            var TreeGrid = api.ui.treegrid.TreeGrid;
            var TreeGridBuilder = api.ui.treegrid.TreeGridBuilder;
            var MarketAppStatus = api.application.MarketAppStatus;
            var MarketAppStatusFormatter = api.application.MarketAppStatusFormatter;
            var ApplicationEventType = api.application.ApplicationEventType;
            var MarketAppsTreeGrid = (function (_super) {
                __extends(MarketAppsTreeGrid, _super);
                function MarketAppsTreeGrid() {
                    var nameColumn = new GridColumnBuilder().
                        setName("Name").
                        setId("displayName").
                        setField("displayName").
                        setCssClass("app-name-and-icon").
                        setMinWidth(170).
                        setFormatter(this.nameFormatter).
                        build();
                    var versionColumn = new GridColumnBuilder().
                        setName("Version").
                        setId("version").
                        setField("latestVersion").
                        setCssClass("version").
                        setMinWidth(40).
                        build();
                    var appStatusColumns = new GridColumnBuilder().
                        setName("AppStatus").
                        setId("appStatus").
                        setField("status").
                        setCssClass("status").
                        setMinWidth(50).
                        setFormatter(this.appStatusFormatter).
                        setCssClass("app-status").
                        build();
                    _super.call(this, new TreeGridBuilder().
                        setColumns([
                        nameColumn,
                        versionColumn,
                        appStatusColumns
                    ]).
                        setPartialLoadEnabled(false).
                        setCheckableRows(false).
                        setShowToolbar(false).
                        setRowHeight(70).
                        disableMultipleSelection(true).
                        prependClasses("market-app-tree-grid").setSelectedCellCssClass("selected-sort-row").setQuietErrorHandling(true).setAutoLoad(false));
                    this.subsribeAndManageInstallClick();
                    this.subscribeOnUninstallEvent();
                    this.subscribeOnInstallEvent();
                }
                MarketAppsTreeGrid.prototype.subscribeOnUninstallEvent = function () {
                    var _this = this;
                    api.application.ApplicationEvent.on(function (event) {
                        if (ApplicationEventType.UNINSTALLED == event.getEventType()) {
                            var nodeToUpdate = _this.getRoot().getCurrentRoot().findNode(event.getApplicationKey().toString());
                            if (!!nodeToUpdate) {
                                nodeToUpdate.getData().setStatus(MarketAppStatus.NOT_INSTALLED);
                                _this.refresh();
                            }
                        }
                    });
                };
                MarketAppsTreeGrid.prototype.subscribeOnInstallEvent = function () {
                    var _this = this;
                    api.application.ApplicationEvent.on(function (event) {
                        if (ApplicationEventType.INSTALLED == event.getEventType()) {
                            var nodeToUpdate = _this.getRoot().getCurrentRoot().findNode(event.getApplicationKey().toString());
                            if (!!nodeToUpdate) {
                                new api.application.GetApplicationRequest(event.getApplicationKey(), true).sendAndParse().then(function (application) {
                                    if (!!application) {
                                        var marketApplication = nodeToUpdate.getData();
                                        if (_this.installedAppCanBeUpdated(marketApplication, application)) {
                                            marketApplication.setStatus(MarketAppStatus.OLDER_VERSION_INSTALLED);
                                        }
                                        else {
                                            marketApplication.setStatus(MarketAppStatus.INSTALLED);
                                        }
                                        _this.refresh();
                                    }
                                });
                            }
                        }
                    });
                };
                MarketAppsTreeGrid.prototype.subsribeAndManageInstallClick = function () {
                    var _this = this;
                    this.getGrid().subscribeOnClick(function (event, data) {
                        var node = _this.getItem(data.row), app = node.getData(), url = app.getLatestVersionDownloadUrl(), elem = new Element(new ElementFromHelperBuilder().setHelper(new ElementHelper(event.target))), status = app.getStatus();
                        if ((elem.hasClass(MarketAppStatusFormatter.statusInstallCssClass) ||
                            elem.hasClass(MarketAppStatusFormatter.statusUpdateCssClass))) {
                            var progressBar = new api.ui.ProgressBar(0);
                            var progressHandler = function (event) {
                                if (event.getApplicationUrl() == url &&
                                    event.getEventType() == api.application.ApplicationEventType.PROGRESS) {
                                    progressBar.setValue(event.getProgress());
                                }
                            };
                            api.application.ApplicationEvent.on(progressHandler);
                            elem.removeChildren().appendChild(progressBar);
                            new api.application.InstallUrlApplicationRequest(url)
                                .sendAndParse().then(function (result) {
                                api.application.ApplicationEvent.un(progressHandler);
                                if (!result.getFailure()) {
                                    elem.removeClass(MarketAppStatusFormatter.statusInstallCssClass + " " +
                                        MarketAppStatusFormatter.statusUpdateCssClass);
                                    elem.addClass(MarketAppStatusFormatter.getStatusCssClass(MarketAppStatus.INSTALLED));
                                    elem.setHtml(MarketAppStatusFormatter.formatStatus(MarketAppStatus.INSTALLED));
                                    app.setStatus(MarketAppStatus.INSTALLED);
                                }
                                else {
                                    elem.setHtml(MarketAppStatusFormatter.formatStatus(status));
                                }
                            }).catch(function (reason) {
                                api.application.ApplicationEvent.un(progressHandler);
                                elem.setHtml(MarketAppStatusFormatter.formatStatus(status));
                                api.DefaultErrorHandler.handle(reason);
                            });
                        }
                    });
                };
                MarketAppsTreeGrid.prototype.nameFormatter = function (row, cell, value, columnDef, node) {
                    var viewer = node.getViewer("name");
                    if (!viewer) {
                        viewer = new view.MarketAppViewer();
                        viewer.setObject(node.getData(), node.calcLevel() > 1);
                        node.setViewer("name", viewer);
                    }
                    return viewer.toString();
                };
                MarketAppsTreeGrid.prototype.appStatusFormatter = function (row, cell, value, columnDef, node) {
                    var status = node.getData().getStatus(), statusWrapper = new api.dom.DivEl();
                    statusWrapper.setHtml(MarketAppStatusFormatter.formatStatus(status));
                    statusWrapper.addClass(MarketAppStatusFormatter.getStatusCssClass(status));
                    return statusWrapper.toString();
                };
                MarketAppsTreeGrid.prototype.sortNodeChildren = function (node) {
                    this.initData(this.getRoot().getCurrentRoot().treeToList());
                };
                MarketAppsTreeGrid.prototype.fetchChildren = function () {
                    var _this = this;
                    var from = 0;
                    var count = 50;
                    return new api.application.ListMarketApplicationsRequest()
                        .setStart(from)
                        .setCount(count)
                        .setVersion(this.getVersion())
                        .sendAndParse()
                        .then(function (applications) {
                        return _this.setMarketAppsStatuses(applications);
                    })
                        .catch(function (reason) {
                        var status500Message = "Woops... The server seems to be experiencing problems. Please try again later.";
                        var defaultErrorMessage = "Enonic Market is temporarily unavailable. Please try again later.";
                        _this.handleError(reason, reason.getStatusCode() == 500 ? status500Message : defaultErrorMessage);
                        return [];
                    });
                };
                MarketAppsTreeGrid.prototype.getVersion = function () {
                    var version = CONFIG.xpVersion;
                    if (!version) {
                        return '';
                    }
                    var parts = version.split('.');
                    if (parts.length > 3) {
                        parts.pop();
                        return parts.join('.');
                    }
                    return version;
                };
                MarketAppsTreeGrid.prototype.setMarketAppsStatuses = function (marketApplications) {
                    var _this = this;
                    return new api.application.ListApplicationsRequest().sendAndParse().then(function (installedApplications) {
                        marketApplications.forEach(function (marketApp) {
                            for (var i = 0; i < installedApplications.length; i++) {
                                if (marketApp.getAppKey().equals(installedApplications[i].getApplicationKey())) {
                                    if (_this.installedAppCanBeUpdated(marketApp, installedApplications[i])) {
                                        marketApp.setStatus(MarketAppStatus.OLDER_VERSION_INSTALLED);
                                    }
                                    else {
                                        marketApp.setStatus(MarketAppStatus.INSTALLED);
                                    }
                                    break;
                                }
                            }
                        });
                        return marketApplications;
                    });
                };
                MarketAppsTreeGrid.prototype.installedAppCanBeUpdated = function (marketApp, installedApp) {
                    return this.compareVersionNumbers(marketApp.getLatestVersion(), installedApp.getVersion()) > 0;
                };
                MarketAppsTreeGrid.prototype.compareVersionNumbers = function (v1, v2) {
                    var v1parts = v1.split('.');
                    var v2parts = v2.split('.');
                    for (var i = 0; i < v1parts.length; ++i) {
                        if (v2parts.length === i) {
                            return 1;
                        }
                        if (v1parts[i] === v2parts[i]) {
                            continue;
                        }
                        if (v1parts[i] > v2parts[i]) {
                            return 1;
                        }
                        return -1;
                    }
                    if (v1parts.length != v2parts.length) {
                        return -1;
                    }
                    return 0;
                };
                MarketAppsTreeGrid.prototype.getDataId = function (data) {
                    return data.getAppKey().toString();
                };
                return MarketAppsTreeGrid;
            })(TreeGrid);
            view.MarketAppsTreeGrid = MarketAppsTreeGrid;
        })(view = installation.view || (installation.view = {}));
    })(installation = app_1.installation || (app_1.installation = {}));
})(app || (app = {}));
var app;
(function (app) {
    var installation;
    (function (installation) {
        var view;
        (function (view) {
            var MarketAppPanel = (function (_super) {
                __extends(MarketAppPanel, _super);
                function MarketAppPanel(className) {
                    var _this = this;
                    _super.call(this, className);
                    this.gridDataLoaded = false;
                    this.isGridLoadingData = false;
                    var gridInitialized = false;
                    this.onShown(function () {
                        if (gridInitialized) {
                            return;
                        }
                        _this.marketAppsTreeGrid = new view.MarketAppsTreeGrid();
                        _this.marketAppsTreeGrid.onLoaded(_this.dataLoadListener.bind(_this));
                        _this.appendChild(_this.marketAppsTreeGrid);
                        gridInitialized = true;
                    });
                }
                MarketAppPanel.prototype.loadGrid = function () {
                    var _this = this;
                    if (this.isGridLoadingData) {
                        return;
                    }
                    this.isGridLoadingData = true;
                    this.marketAppsTreeGrid.reload().then(function () {
                        _this.isGridLoadingData = false;
                        _this.marketAppsTreeGrid.getGrid().resizeCanvas();
                    });
                };
                MarketAppPanel.prototype.dataLoadListener = function () {
                    var _this = this;
                    if (this.marketAppsTreeGrid.getGrid().getDataView().getLength() > 0) {
                        this.marketAppsTreeGrid.unLoaded(this.dataLoadListener);
                        setTimeout(function () {
                            if (!_this.gridDataLoaded) {
                                _this.gridDataLoaded = true;
                                _this.marketAppsTreeGrid.refresh();
                            }
                        }, 500);
                    }
                };
                MarketAppPanel.prototype.getMarketAppsTreeGrid = function () {
                    return this.marketAppsTreeGrid;
                };
                return MarketAppPanel;
            })(api.ui.panel.Panel);
            view.MarketAppPanel = MarketAppPanel;
        })(view = installation.view || (installation.view = {}));
    })(installation = app.installation || (app.installation = {}));
})(app || (app = {}));
var app;
(function (app) {
    var installation;
    (function (installation) {
        var view;
        (function (view) {
            var UploadAppPanel = (function (_super) {
                __extends(UploadAppPanel, _super);
                function UploadAppPanel(cancelAction, className) {
                    var _this = this;
                    _super.call(this, className);
                    this.initApplicationInput(cancelAction);
                    this.initApplicationUploader();
                    this.onShown(function () {
                        _this.applicationInput.giveFocus();
                    });
                }
                UploadAppPanel.prototype.getApplicationInput = function () {
                    return this.applicationInput;
                };
                UploadAppPanel.prototype.getApplicationUploaderEl = function () {
                    return this.applicationUploaderEl;
                };
                UploadAppPanel.prototype.initApplicationInput = function (cancelAction) {
                    this.applicationInput = new view.ApplicationInput(cancelAction, 'large').
                        setPlaceholder("Paste link or drop files here");
                    this.appendChild(this.applicationInput);
                };
                UploadAppPanel.prototype.initApplicationUploader = function () {
                    var _this = this;
                    var uploaderContainer = new api.dom.DivEl('uploader-container');
                    this.appendChild(uploaderContainer);
                    var uploaderMask = new api.dom.DivEl('uploader-mask');
                    uploaderContainer.appendChild(uploaderMask);
                    this.applicationUploaderEl = new api.application.ApplicationUploaderEl({
                        params: {},
                        name: 'application-uploader',
                        showResult: false,
                        allowMultiSelection: false,
                        deferred: true
                    });
                    uploaderContainer.appendChild(this.applicationUploaderEl);
                    var dragOverEl;
                    this.onDragEnter(function (event) {
                        var target = event.target;
                        if (!!dragOverEl || dragOverEl == _this.getHTMLElement()) {
                            uploaderContainer.show();
                        }
                        dragOverEl = target;
                    });
                    this.onDragLeave(function (event) {
                        var targetEl = event.target;
                        if (dragOverEl == targetEl) {
                            uploaderContainer.hide();
                        }
                    });
                    this.onDrop(function (event) {
                        uploaderContainer.hide();
                    });
                };
                return UploadAppPanel;
            })(api.ui.panel.Panel);
            view.UploadAppPanel = UploadAppPanel;
        })(view = installation.view || (installation.view = {}));
    })(installation = app.installation || (app.installation = {}));
})(app || (app = {}));
var app;
(function (app) {
    var installation;
    (function (installation) {
        var view;
        (function (view) {
            var ApplicationUploaderEl = api.application.ApplicationUploaderEl;
            var InputEl = api.dom.InputEl;
            var ApplicationInput = (function (_super) {
                __extends(ApplicationInput, _super);
                function ApplicationInput(cancelAction, className, originalValue) {
                    var _this = this;
                    this.textInput = new InputEl("text");
                    this.applicationUploaderEl = new ApplicationUploaderEl({
                        name: 'application-input-uploader',
                        allowDrop: false,
                        showResult: false,
                        allowMultiSelection: true,
                        deferred: true,
                        value: originalValue
                    });
                    _super.call(this, this.textInput, this.applicationUploaderEl);
                    this.LAST_KEY_PRESS_TIMEOUT = 1500;
                    this.cancelAction = cancelAction;
                    this.applicationUploaderEl.onUploadStarted(function (event) {
                        var names = event.getUploadItems().map(function (uploadItem) {
                            return uploadItem.getName();
                        });
                        _this.textInput.setValue(names.join(', '));
                    });
                    this.errorPanel = new api.form.ValidationRecordingViewer();
                    this.appendChild(this.errorPanel);
                    this.errorPanel.hide();
                    this.onHidden(function () {
                        _this.errorPanel.hide();
                    });
                    this.addClass("file-input" + (className ? " " + className : ""));
                    this.initUrlEnteredHandler();
                }
                ApplicationInput.prototype.initUrlEnteredHandler = function () {
                    var _this = this;
                    this.onKeyDown(function (event) {
                        clearTimeout(_this.lastTimeKeyPressedTimer);
                        _this.errorPanel.hide();
                        switch (event.keyCode) {
                            case 13:
                                _this.startInstall();
                                break;
                            case 27:
                                break;
                            default:
                                _this.lastTimeKeyPressedTimer = setTimeout(function () {
                                    _this.startInstall();
                                }, _this.LAST_KEY_PRESS_TIMEOUT);
                                break;
                        }
                    });
                };
                ApplicationInput.prototype.initMask = function () {
                    if (!this.mask) {
                        this.mask = new api.ui.mask.LoadMask(this);
                        this.getParentElement().appendChild(this.mask);
                    }
                };
                ApplicationInput.prototype.startInstall = function () {
                    if (!api.util.StringHelper.isEmpty(this.textInput.getValue())) {
                        var url = this.textInput.getValue();
                        if (api.util.StringHelper.testRegex(ApplicationInput.APPLICATION_ADDRESS_MASK, url)) {
                            this.initMask();
                            this.mask.show();
                            this.installWithUrl(url);
                            console.log("url: " + url);
                        }
                    }
                };
                ApplicationInput.prototype.installWithUrl = function (url) {
                    var _this = this;
                    this.mask.show();
                    new api.application.InstallUrlApplicationRequest(url).sendAndParse().then(function (result) {
                        var failure = result.getFailure();
                        _this.showFailure(failure);
                        if (!failure) {
                            _this.cancelAction.execute();
                        }
                        _this.mask.hide();
                    }).catch(function (reason) {
                        _this.mask.hide();
                        api.DefaultErrorHandler.handle(reason);
                    });
                };
                ApplicationInput.prototype.showFailure = function (failure) {
                    if (failure) {
                        this.errorPanel.setError(failure);
                        this.errorPanel.show();
                    }
                    else {
                        this.errorPanel.hide();
                    }
                };
                ApplicationInput.prototype.setUploaderParams = function (params) {
                    this.applicationUploaderEl.setParams(params);
                    return this;
                };
                ApplicationInput.prototype.getUploaderParams = function () {
                    return this.applicationUploaderEl.getParams();
                };
                ApplicationInput.prototype.setPlaceholder = function (placeholder) {
                    this.textInput.setPlaceholder(placeholder);
                    return this;
                };
                ApplicationInput.prototype.getPlaceholder = function () {
                    return this.textInput.getPlaceholder();
                };
                ApplicationInput.prototype.reset = function () {
                    this.textInput.reset();
                    this.applicationUploaderEl.reset();
                    return this;
                };
                ApplicationInput.prototype.stop = function () {
                    this.applicationUploaderEl.stop();
                    return this;
                };
                ApplicationInput.prototype.getUploader = function () {
                    return this.applicationUploaderEl;
                };
                ApplicationInput.prototype.onUploadStarted = function (listener) {
                    this.applicationUploaderEl.onUploadStarted(listener);
                };
                ApplicationInput.prototype.unUploadStarted = function (listener) {
                    this.applicationUploaderEl.unUploadStarted(listener);
                };
                ApplicationInput.prototype.onUploadFailed = function (listener) {
                    this.applicationUploaderEl.onUploadFailed(listener);
                };
                ApplicationInput.prototype.unUploadFailed = function (listener) {
                    this.applicationUploaderEl.unUploadFailed(listener);
                };
                ApplicationInput.prototype.onUploadCompleted = function (listener) {
                    this.applicationUploaderEl.onUploadCompleted(listener);
                };
                ApplicationInput.prototype.unUploadCompleted = function (listener) {
                    this.applicationUploaderEl.unUploadCompleted(listener);
                };
                ApplicationInput.APPLICATION_ADDRESS_MASK = "^(http|https)://\\S+";
                return ApplicationInput;
            })(api.dom.CompositeFormInputEl);
            view.ApplicationInput = ApplicationInput;
        })(view = installation.view || (installation.view = {}));
    })(installation = app.installation || (app.installation = {}));
})(app || (app = {}));
///<reference path='MarketAppViewer.ts'/>
///<reference path='MarketAppsTreeGrid.ts'/>
///<reference path='MarketAppPanel.ts'/>
///<reference path='UploadAppPanel.ts'/>
///<reference path='ApplicationInput.ts'/> 
var app;
(function (app) {
    var installation;
    (function (installation) {
        var DockedPanel = api.ui.panel.DockedPanel;
        var MarketAppPanel = app.installation.view.MarketAppPanel;
        var UploadAppPanel = app.installation.view.UploadAppPanel;
        var InstallAppDialog = (function (_super) {
            __extends(InstallAppDialog, _super);
            function InstallAppDialog() {
                _super.call(this, {
                    title: new api.ui.dialog.ModalDialogHeader("Install Application")
                });
                this.addClass("install-application-dialog hidden");
                this.onMarketLoaded = this.centerMyself.bind(this);
                this.initUploadAppPanel();
                this.initMarketAppPanel();
                api.dom.Body.get().appendChild(this);
            }
            InstallAppDialog.prototype.initMarketAppPanel = function () {
                var _this = this;
                this.marketAppPanel = new MarketAppPanel("market-app-panel");
                this.marketAppPanel.onShown(function () {
                    _this.marketAppPanel.getMarketAppsTreeGrid().onLoaded(_this.onMarketLoaded);
                });
            };
            InstallAppDialog.prototype.initUploadAppPanel = function () {
                var _this = this;
                this.uploadAppPanel = new UploadAppPanel(this.getCancelAction(), "upload-app-panel");
                this.uploadAppPanel.getApplicationInput().onKeyUp(function (event) {
                    if (event.keyCode === 27) {
                        _this.getCancelAction().execute();
                    }
                });
                this.initUploaderListeners();
            };
            InstallAppDialog.prototype.initAndAppendInstallAppsTabsPanel = function () {
                var installAppDockedPanel = new DockedPanel();
                installAppDockedPanel.addClass("install-app-docked-panel");
                installAppDockedPanel.addItem("Enonic Market", true, this.marketAppPanel);
                installAppDockedPanel.addItem("Upload", true, this.uploadAppPanel);
                this.appendChildToContentPanel(installAppDockedPanel);
                this.dockedPanel = installAppDockedPanel;
            };
            InstallAppDialog.prototype.initUploaderListeners = function () {
                var _this = this;
                var uploadFailedHandler = function (event, uploader) {
                    _this.uploadAppPanel.getApplicationInput().showFailure(uploader.getFailure());
                    _this.resetFileInputWithUploader();
                };
                this.uploadAppPanel.getApplicationInput().onUploadFailed(function (event) {
                    uploadFailedHandler(event, _this.uploadAppPanel.getApplicationInput().getUploader());
                });
                this.uploadAppPanel.getApplicationUploaderEl().onUploadFailed(function (event) {
                    uploadFailedHandler(event, _this.uploadAppPanel.getApplicationUploaderEl());
                });
                var uploadCompletedHandler = function (event) {
                    if (event.getUploadItems()) {
                        _this.close();
                    }
                };
                this.uploadAppPanel.getApplicationInput().onUploadCompleted(uploadCompletedHandler);
                this.uploadAppPanel.getApplicationUploaderEl().onUploadCompleted(uploadCompletedHandler);
                var uploadStartedHandler = function (event) {
                    new api.application.ApplicationUploadStartedEvent(event.getUploadItems()).fire();
                };
                this.uploadAppPanel.getApplicationInput().onUploadStarted(uploadStartedHandler);
                this.uploadAppPanel.getApplicationUploaderEl().onUploadStarted(uploadStartedHandler);
            };
            InstallAppDialog.prototype.open = function () {
                if (!this.dockedPanel) {
                    this.initAndAppendInstallAppsTabsPanel();
                }
                _super.prototype.open.call(this);
            };
            InstallAppDialog.prototype.show = function () {
                this.resetFileInputWithUploader();
                _super.prototype.show.call(this);
                this.marketAppPanel.loadGrid();
            };
            InstallAppDialog.prototype.hide = function () {
                _super.prototype.hide.call(this);
                this.uploadAppPanel.getApplicationUploaderEl().stop();
                this.addClass("hidden");
                this.removeClass("animated");
            };
            InstallAppDialog.prototype.close = function () {
                if (!!this.marketAppPanel.getMarketAppsTreeGrid()) {
                    this.marketAppPanel.getMarketAppsTreeGrid().unLoaded(this.onMarketLoaded);
                }
                this.uploadAppPanel.getApplicationInput().reset();
                _super.prototype.close.call(this);
            };
            InstallAppDialog.prototype.resetFileInputWithUploader = function () {
                this.uploadAppPanel.getApplicationUploaderEl().reset();
                this.uploadAppPanel.getApplicationInput().reset();
            };
            return InstallAppDialog;
        })(api.ui.dialog.ModalDialog);
        installation.InstallAppDialog = InstallAppDialog;
    })(installation = app.installation || (app.installation = {}));
})(app || (app = {}));
var app;
(function (app) {
    var installation;
    (function (installation) {
        var InstallAppPromptEvent = (function (_super) {
            __extends(InstallAppPromptEvent, _super);
            function InstallAppPromptEvent() {
                _super.apply(this, arguments);
            }
            InstallAppPromptEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            InstallAppPromptEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return InstallAppPromptEvent;
        })(api.event.Event);
        installation.InstallAppPromptEvent = InstallAppPromptEvent;
    })(installation = app.installation || (app.installation = {}));
})(app || (app = {}));
///<reference path='view/_module.ts'/>
///<reference path='InstallAppDialog.ts'/>
///<reference path='InstallAppPromptEvent.ts'/>
var Application = api.application.Application;
var application = (function () {
    var application = new api.app.Application('applications', 'Applications', 'AM', 'applications');
    application.setPath(api.rest.Path.fromString("/"));
    application.setWindow(window);
    this.serverEventsListener = new api.app.ServerEventsListener([application]);
    var messageId;
    this.lostConnectionDetector = new api.system.LostConnectionDetector();
    this.lostConnectionDetector.setAuthenticated(true);
    this.lostConnectionDetector.onConnectionLost(function () {
        api.notify.NotifyManager.get().hide(messageId);
        messageId = api.notify.showError("Lost connection to server - Please wait until connection is restored", false);
    });
    this.lostConnectionDetector.onSessionExpired(function () {
        api.notify.NotifyManager.get().hide(messageId);
        window.location.href = api.util.UriHelper.getToolUri("");
    });
    this.lostConnectionDetector.onConnectionRestored(function () {
        api.notify.NotifyManager.get().hide(messageId);
    });
    return application;
})();
function getApplication(id) {
    return application;
}
function startApplication() {
    var application = api.app.Application.getApplication();
    var appBar = new api.app.bar.AppBar(application);
    var appPanel = new app.ApplicationAppPanel(appBar, application.getPath());
    var body = api.dom.Body.get();
    body.appendChild(appBar);
    body.appendChild(appPanel);
    api.util.AppHelper.preventDragRedirect();
    application.setLoaded(true);
    this.serverEventsListener.start();
    this.lostConnectionDetector.startPolling();
    window.onmessage = function (e) {
        if (e.data.appLauncherEvent) {
            var eventType = api.app.AppLauncherEventType[e.data.appLauncherEvent];
            if (eventType == api.app.AppLauncherEventType.Show) {
                appPanel.activateCurrentKeyBindings();
            }
        }
    };
    var installAppDialog = new app.installation.InstallAppDialog();
    app.installation.InstallAppPromptEvent.on(function (event) {
        installAppDialog.open();
    });
}
var components;
(function (components) {
})(components || (components = {}));
///<reference path='../../../common/js/_all.d.ts' />
///<reference path='app/_module.ts'/>
///<reference path='app/browse/_module.ts'/>
///<reference path='app/view/_module.ts'/>
///<reference path='app/installation/_module.ts'/>
///<reference path='main.ts' /> 
//# sourceMappingURL=_all.js.map