function startApplication() {
    new app.Main().start();
}
var app;
(function (app) {
    var Main = (function () {
        function Main() {
        }
        Main.prototype.start = function () {
            this.homeMainContainer = this.createHomeMainContainer();
            api.dom.Body.get().appendChild(this.homeMainContainer);
            this.homeMainContainer.showLogin();
        };
        Main.prototype.createHomeMainContainer = function () {
            this.loginForm = new app.login.LoginForm(new app.login.AuthenticatorImpl());
            this.loginForm.onUserAuthenticated(this.onUserAuthenticated.bind(this));
            return new app.home.LoginHomeMainContainerBuilder().
                setLoginForm(this.loginForm).
                build();
        };
        Main.prototype.onUserAuthenticated = function (loginResult) {
            window.location.href = CONFIG.callback ? CONFIG.callback : "..";
        };
        return Main;
    })();
    app.Main = Main;
})(app || (app = {}));
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var app;
(function (app) {
    var home;
    (function (home) {
        var Branding = (function (_super) {
            __extends(Branding, _super);
            function Branding(loadInstallation) {
                var _this = this;
                _super.call(this, 'branding');
                this.productHeader = new api.dom.H1El();
                this.productHeader.setHtml('Enonic XP');
                this.installation = new api.dom.DivEl("installation-info");
                this.appendChild(this.productHeader);
                this.appendChild(this.installation);
                if (loadInstallation) {
                    new api.system.StatusRequest().sendAndParse().then(function (status) {
                        _this.setInstallation(status.getInstallation());
                    }).done();
                }
            }
            Branding.prototype.setInstallation = function (installationText) {
                this.installation.setHtml(installationText);
            };
            return Branding;
        })(api.dom.DivEl);
        home.Branding = Branding;
    })(home = app.home || (app.home = {}));
})(app || (app = {}));
var app;
(function (app) {
    var home;
    (function (home) {
        var CenterPanel = (function (_super) {
            __extends(CenterPanel, _super);
            function CenterPanel() {
                _super.call(this, 'center-panel');
                this.loginPanel = new api.dom.DivEl('login-panel');
                this.appSelectorPanel = new api.dom.DivEl('app-selector-panel');
                this.appendChild(this.loginPanel);
                this.appendChild(this.appSelectorPanel);
            }
            CenterPanel.prototype.addToLoginPanel = function (el) {
                this.loginPanel.appendChild(el);
            };
            CenterPanel.prototype.addToAppSelectorPanel = function (el) {
                this.appSelectorPanel.appendChild(el);
            };
            CenterPanel.prototype.showLoginPanel = function () {
                this.appSelectorPanel.hide();
                this.loginPanel.show();
            };
            CenterPanel.prototype.showAppSelectorPanel = function () {
                this.loginPanel.hide();
                this.appSelectorPanel.show();
            };
            return CenterPanel;
        })(api.dom.DivEl);
        home.CenterPanel = CenterPanel;
    })(home = app.home || (app.home = {}));
})(app || (app = {}));
var app;
(function (app) {
    var home;
    (function (home) {
        var HomeMainContainer = (function (_super) {
            __extends(HomeMainContainer, _super);
            function HomeMainContainer(builder) {
                _super.call(this, 'home-main-container');
                var lazyImage = new api.ui.image.LazyImage(api.util.UriHelper.getAdminUri("/common/images/image1x1.png"));
                this.appendChild(lazyImage);
                this.getEl().setAttribute("tabindex", "100");
                this.loginForm = builder.loginForm;
                this.brandingPanel = new home.Branding();
                this.centerPanel = new home.CenterPanel();
                this.centerPanel.prependChild(this.brandingPanel);
                this.centerPanel.addToLoginPanel(this.loginForm);
                this.appendChild(this.centerPanel);
                this.onAdded(function () {
                    lazyImage.setSrc(api.util.UriHelper.getAdminUri("common/images/background-1920.jpg"));
                });
            }
            HomeMainContainer.prototype.showLogin = function () {
                this.centerPanel.showLoginPanel();
                this.brandingPanel.show();
            };
            HomeMainContainer.prototype.disableBranding = function () {
                this.brandingPanel.hide();
            };
            HomeMainContainer.prototype.showBrowserWarningMessage = function () {
                if (!api.BrowserHelper.isAvailableBrowser()) {
                    if (api.BrowserHelper.isOldBrowser()) {
                        api.notify.showError("Your browser version is obsolete. Please upgrade", false);
                    }
                    else {
                        api.notify.showError("Your browser currently is not supported, try Firefox or Chrome", false);
                    }
                }
            };
            return HomeMainContainer;
        })(api.dom.DivEl);
        home.HomeMainContainer = HomeMainContainer;
        var LoginHomeMainContainerBuilder = (function () {
            function LoginHomeMainContainerBuilder() {
            }
            LoginHomeMainContainerBuilder.prototype.setLoginForm = function (value) {
                this.loginForm = value;
                return this;
            };
            LoginHomeMainContainerBuilder.prototype.build = function () {
                return new HomeMainContainer(this);
            };
            return LoginHomeMainContainerBuilder;
        })();
        home.LoginHomeMainContainerBuilder = LoginHomeMainContainerBuilder;
    })(home = app.home || (app.home = {}));
})(app || (app = {}));
var app;
(function (app) {
    var home;
    (function (home) {
        var LinksContainer = (function (_super) {
            __extends(LinksContainer, _super);
            function LinksContainer() {
                _super.call(this, 'links-container');
                this.links = [];
            }
            LinksContainer.prototype.addLink = function (linkText, linkUrl) {
                if (this.links.length > 0) {
                    this.addSeparator();
                }
                var linkEl = new api.dom.AEl();
                linkEl.setHtml(linkText);
                linkEl.setUrl(linkUrl);
                this.appendChild(linkEl);
                this.links.push({ text: linkText, url: linkUrl });
                return this;
            };
            LinksContainer.prototype.addText = function (linkText) {
                if (this.links.length > 0) {
                    this.addSeparator();
                }
                var spanEl = new api.dom.SpanEl();
                spanEl.setHtml(linkText);
                this.appendChild(spanEl);
                this.links.push({ text: linkText, url: '' });
                return this;
            };
            LinksContainer.prototype.addSeparator = function () {
                var d = document.createElement('div');
                d.innerHTML = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                this.getEl().appendChild(d.firstChild);
            };
            return LinksContainer;
        })(api.dom.DivEl);
        home.LinksContainer = LinksContainer;
    })(home = app.home || (app.home = {}));
})(app || (app = {}));
///<reference path='Branding.ts' />
///<reference path='CenterPanel.ts' />
///<reference path='HomeMainContainer.ts' />
///<reference path='LinksContainer.ts' /> 
var app;
(function (app) {
    var i18n;
    (function (i18n) {
        var messages = {
            'Login': 'Logg inn',
            'Log in': 'Logg inn',
            'userid or e-mail': 'userid eller e-post',
            'password': 'passord'
        };
        api.i18n.addBundle('no', messages);
    })(i18n = app.i18n || (app.i18n = {}));
})(app || (app = {}));
///<reference path='Messages_no.ts' />
var app;
(function (app) {
    var login;
    (function (login) {
        var AuthenticatorImpl = (function () {
            function AuthenticatorImpl() {
            }
            AuthenticatorImpl.prototype.authenticate = function (userName, password, authHandler) {
                var loginCredentials = new api.security.auth.LoginCredentials().
                    setUser(userName).
                    setPassword(password);
                new api.security.auth.LoginRequest(loginCredentials).sendAndParse().then(function (loginResult) {
                    authHandler(loginResult);
                }).catch(function (reason) {
                    api.DefaultErrorHandler.handle(reason);
                }).done();
            };
            return AuthenticatorImpl;
        })();
        login.AuthenticatorImpl = AuthenticatorImpl;
    })(login = app.login || (app.login = {}));
})(app || (app = {}));
var app;
(function (app) {
    var login;
    (function (login) {
        var LoginForm = (function (_super) {
            __extends(LoginForm, _super);
            function LoginForm(authenticator) {
                var _this = this;
                _super.call(this, 'login-form');
                this.authenticator = authenticator;
                this.onUserAuthenticatedHandler = null;
                this.userIdInput = new api.ui.text.TextInput('input-view');
                this.userIdInput.setPlaceholder(_i18n('userid or e-mail'));
                this.passwordInput = new api.ui.text.PasswordInput('input-view');
                this.passwordInput.setPlaceholder(_i18n('password'));
                this.userIdInput.onKeyUp(function (event) {
                    _this.onInputTyped(event);
                });
                this.passwordInput.onKeyUp(function (event) {
                    _this.onInputTyped(event);
                });
                this.loginButton = new api.ui.button.Button();
                this.loginButton.addClass("login-button");
                this.loginButton.hide();
                this.loginButton.onClicked(function (event) {
                    _this.loginButtonClick();
                    event.preventDefault();
                });
                this.messageContainer = new api.dom.DivEl("message-container");
                var passwordDiv = new api.dom.DivEl("password-container");
                passwordDiv.appendChild(this.passwordInput);
                passwordDiv.appendChild(this.loginButton);
                this.appendChild(this.userIdInput);
                this.appendChild(passwordDiv);
                this.appendChild(this.messageContainer);
                this.onShown(function (event) {
                    _this.userIdInput.getEl().simulate("click");
                    _this.userIdInput.giveFocus();
                    var checkLoginButtonInterval = setInterval(function () {
                        if (_this.checkFieldsNotEmpty()) {
                            _this.loginButton.show();
                            clearInterval(checkLoginButtonInterval);
                        }
                        else {
                            _this.loginButton.hide();
                        }
                    }, 100);
                });
                this.onHidden(function (event) {
                    if (document.activeElement) {
                        document.activeElement.blur();
                    }
                });
            }
            LoginForm.prototype.onUserAuthenticated = function (handler) {
                this.onUserAuthenticatedHandler = handler;
            };
            LoginForm.prototype.hide = function () {
                _super.prototype.hide.call(this);
            };
            LoginForm.prototype.loginButtonClick = function () {
                var _this = this;
                var userName = this.userIdInput.getValue();
                var password = this.passwordInput.getValue();
                if (userName === '' || password === '') {
                    return;
                }
                this.userIdInput.removeClass('invalid');
                this.passwordInput.removeClass('invalid');
                this.loginButton.removeClass('invalid');
                this.authenticator.authenticate(userName, password, function (loginResult) { return _this.handleAuthenticateResponse(loginResult); });
            };
            LoginForm.prototype.handleAuthenticateResponse = function (loginResult) {
                if (loginResult.isAuthenticated()) {
                    if (this.onUserAuthenticatedHandler) {
                        this.onUserAuthenticatedHandler(loginResult);
                    }
                    this.passwordInput.setValue('');
                    this.setMessage('');
                }
                else {
                    this.setMessage(loginResult.getMessage() || 'Login failed!');
                    this.passwordInput.giveFocus();
                    this.userIdInput.addClass('invalid');
                    this.passwordInput.addClass('invalid');
                    this.loginButton.addClass('invalid');
                }
            };
            LoginForm.prototype.setMessage = function (text) {
                this.messageContainer.setHtml(text);
            };
            LoginForm.prototype.onInputTyped = function (event) {
                this.userIdInput.removeClass('invalid');
                this.passwordInput.removeClass('invalid');
                this.loginButton.removeClass('invalid');
                var fieldsNotEmpty = this.checkFieldsNotEmpty();
                if (fieldsNotEmpty) {
                    this.loginButton.show();
                    if (event.keyCode !== 13) {
                        this.setMessage('');
                    }
                }
                else {
                    this.loginButton.hide();
                    this.setMessage('');
                }
            };
            LoginForm.prototype.checkFieldsNotEmpty = function () {
                var fieldsNotEmpty = (this.userIdInput.getValue() !== '') && (this.passwordInput.getValue() !== '');
                return fieldsNotEmpty;
            };
            return LoginForm;
        })(api.dom.FormEl);
        login.LoginForm = LoginForm;
    })(login = app.login || (app.login = {}));
})(app || (app = {}));
///<reference path='Authenticator.ts' />
///<reference path='LoginForm.ts' /> 
///<reference path='Main.ts' />
///<reference path='home/_module.ts' />
///<reference path='i18n/_module.ts' />
///<reference path='login/_module.ts' /> 
///<reference path='../../../common/js/_all.d.ts' />
///<reference path='main.ts' />
///<reference path='app/_module.ts' />
//# sourceMappingURL=_all.js.map