var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var app;
(function (app) {
    var browse;
    (function (browse) {
        var filter;
        (function (filter) {
            var FindPrincipalsRequest = api.security.FindPrincipalsRequest;
            var PrincipalType = api.security.PrincipalType;
            var RefreshEvent = api.app.browse.filter.RefreshEvent;
            var PrincipalBrowseFilterPanel = (function (_super) {
                __extends(PrincipalBrowseFilterPanel, _super);
                function PrincipalBrowseFilterPanel() {
                    var _this = this;
                    _super.call(this, null);
                    this.onReset(function () {
                        _this.resetFacets();
                    });
                    this.onRefresh(this.searchFacets);
                    this.onSearch(this.searchFacets);
                    this.initHitsCounter();
                }
                PrincipalBrowseFilterPanel.prototype.resetFacets = function (supressEvent) {
                    this.searchDataAndHandleResponse("", false);
                    if (!supressEvent) {
                        new filter.PrincipalBrowseResetEvent().fire();
                    }
                };
                PrincipalBrowseFilterPanel.prototype.searchFacets = function (event) {
                    var searchText = event.getSearchInputValues().getTextSearchFieldValue();
                    if (!searchText) {
                        this.handleEmptyFilterInput(event);
                        return;
                    }
                    this.searchDataAndHandleResponse(searchText);
                };
                PrincipalBrowseFilterPanel.prototype.handleEmptyFilterInput = function (event) {
                    if (event instanceof RefreshEvent) {
                        this.resetFacets(true);
                    }
                    else {
                        this.reset();
                    }
                };
                PrincipalBrowseFilterPanel.prototype.searchDataAndHandleResponse = function (searchString, fireEvent) {
                    var _this = this;
                    if (fireEvent === void 0) { fireEvent = true; }
                    new FindPrincipalsRequest().
                        setAllowedTypes([PrincipalType.GROUP, PrincipalType.USER, PrincipalType.ROLE]).
                        setSearchQuery(searchString).
                        sendAndParse().then(function (principals) {
                        if (fireEvent) {
                            new filter.PrincipalBrowseSearchEvent(principals).fire();
                        }
                        _this.updateHitsCounter(principals ? principals.length : 0);
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                };
                PrincipalBrowseFilterPanel.prototype.initHitsCounter = function () {
                    this.searchDataAndHandleResponse("", false);
                };
                return PrincipalBrowseFilterPanel;
            })(api.app.browse.filter.BrowseFilterPanel);
            filter.PrincipalBrowseFilterPanel = PrincipalBrowseFilterPanel;
        })(filter = browse.filter || (browse.filter = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var filter;
        (function (filter) {
            var PrincipalBrowseSearchEvent = (function (_super) {
                __extends(PrincipalBrowseSearchEvent, _super);
                function PrincipalBrowseSearchEvent(principals) {
                    _super.call(this);
                    this.principals = principals;
                }
                PrincipalBrowseSearchEvent.prototype.getPrincipals = function () {
                    return this.principals;
                };
                PrincipalBrowseSearchEvent.on = function (handler) {
                    api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
                };
                PrincipalBrowseSearchEvent.un = function (handler) {
                    api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
                };
                return PrincipalBrowseSearchEvent;
            })(api.event.Event);
            filter.PrincipalBrowseSearchEvent = PrincipalBrowseSearchEvent;
        })(filter = browse.filter || (browse.filter = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var filter;
        (function (filter) {
            var PrincipalBrowseResetEvent = (function (_super) {
                __extends(PrincipalBrowseResetEvent, _super);
                function PrincipalBrowseResetEvent() {
                    _super.apply(this, arguments);
                }
                PrincipalBrowseResetEvent.on = function (handler) {
                    api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
                };
                PrincipalBrowseResetEvent.un = function (handler) {
                    api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
                };
                return PrincipalBrowseResetEvent;
            })(api.event.Event);
            filter.PrincipalBrowseResetEvent = PrincipalBrowseResetEvent;
        })(filter = browse.filter || (browse.filter = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
///<reference path='PrincipalBrowseFilterPanel.ts'/>
///<reference path='PrincipalBrowseSearchEvent.ts'/>
///<reference path='PrincipalBrowseResetEvent.ts'/>
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var EditPrincipalAction = (function (_super) {
                __extends(EditPrincipalAction, _super);
                function EditPrincipalAction(grid) {
                    _super.call(this, "Edit", "f4");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        var principals = grid.getSelectedDataList();
                        new browse.EditPrincipalEvent(principals).fire();
                    });
                }
                return EditPrincipalAction;
            })(Action);
            action.EditPrincipalAction = EditPrincipalAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var DeletePrincipalAction = (function (_super) {
                __extends(DeletePrincipalAction, _super);
                function DeletePrincipalAction(grid) {
                    _super.call(this, "Delete", "mod+del");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        api.ui.dialog.ConfirmationDialog.get()
                            .setQuestion("Are you sure you want to delete this user item?")
                            .setNoCallback(null)
                            .setYesCallback(function () {
                            var principalItems = grid.getSelectedDataList().
                                filter(function (userItem) { return browse.UserTreeGridItemType.PRINCIPAL == userItem.getType(); }).
                                map(function (userItem) {
                                return userItem.getPrincipal();
                            });
                            var userStoreItems = grid.getSelectedDataList().
                                filter(function (userItem) { return browse.UserTreeGridItemType.USER_STORE == userItem.getType(); }).
                                map(function (userItem) {
                                return userItem.getUserStore();
                            });
                            var principalKeys = principalItems.
                                filter(function (userItem) {
                                return api.ObjectHelper.iFrameSafeInstanceOf(userItem, api.security.Principal);
                            }).
                                map(function (principal) {
                                return principal.getKey();
                            });
                            var userStoreKeys = userStoreItems.
                                filter(function (userItem) {
                                return api.ObjectHelper.iFrameSafeInstanceOf(userItem, api.security.UserStore);
                            }).
                                map(function (userStore) {
                                return userStore.getKey();
                            });
                            if (principalKeys && principalKeys.length > 0) {
                                new api.security.DeletePrincipalRequest()
                                    .setKeys(principalKeys)
                                    .send()
                                    .done(function (jsonResponse) {
                                    var json = jsonResponse.getJson();
                                    if (json.results && json.results.length > 0) {
                                        var key = json.results[0].principalKey;
                                        api.notify.showFeedback('Principal [' + key + '] deleted!');
                                        api.security.UserItemDeletedEvent.create().setPrincipals(principalItems).build().fire();
                                    }
                                });
                            }
                            if (userStoreKeys && userStoreKeys.length > 0) {
                                new api.security.DeleteUserStoreRequest()
                                    .setKeys(userStoreKeys)
                                    .send()
                                    .done(function (jsonResponse) {
                                    var json = jsonResponse.getJson();
                                    if (json.results && json.results.length > 0) {
                                        var key = json.results[0].userStoreKey;
                                        api.notify.showFeedback('UserStore [' + key + '] deleted!');
                                        api.security.UserItemDeletedEvent.create().setUserStores(userStoreItems).build().fire();
                                    }
                                });
                            }
                        }).open();
                    });
                }
                return DeletePrincipalAction;
            })(Action);
            action.DeletePrincipalAction = DeletePrincipalAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var SynchPrincipalAction = (function (_super) {
                __extends(SynchPrincipalAction, _super);
                function SynchPrincipalAction(grid) {
                    var _this = this;
                    _super.call(this, "Synch");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        var principals = grid.getSelectedDataList();
                        grid.getSelectedDataList().forEach(function (elem) {
                            _this.synch(elem);
                        });
                    });
                }
                SynchPrincipalAction.prototype.synch = function (principal) {
                    console.log('Synch principals action');
                };
                return SynchPrincipalAction;
            })(Action);
            action.SynchPrincipalAction = SynchPrincipalAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var NewPrincipalAction = (function (_super) {
                __extends(NewPrincipalAction, _super);
                function NewPrincipalAction(grid) {
                    _super.call(this, "New", "mod+alt+n");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        var principals = grid.getSelectedDataList();
                        new browse.NewPrincipalEvent(principals).fire();
                    });
                }
                return NewPrincipalAction;
            })(Action);
            action.NewPrincipalAction = NewPrincipalAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
///<reference path='EditPrincipalAction.ts' />
///<reference path='DeletePrincipalAction.ts' />
///<reference path='SynchPrincipalAction.ts' />
///<reference path='NewPrincipalAction.ts' />
var app;
(function (app) {
    var browse;
    (function (browse) {
        var BaseUserEvent = (function (_super) {
            __extends(BaseUserEvent, _super);
            function BaseUserEvent(gridItems) {
                this.gridItems = gridItems;
                _super.call(this);
            }
            BaseUserEvent.prototype.getPrincipals = function () {
                return this.gridItems;
            };
            return BaseUserEvent;
        })(api.event.Event);
        browse.BaseUserEvent = BaseUserEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        (function (UserTreeGridItemType) {
            UserTreeGridItemType[UserTreeGridItemType["USER_STORE"] = 0] = "USER_STORE";
            UserTreeGridItemType[UserTreeGridItemType["PRINCIPAL"] = 1] = "PRINCIPAL";
            UserTreeGridItemType[UserTreeGridItemType["GROUPS"] = 2] = "GROUPS";
            UserTreeGridItemType[UserTreeGridItemType["USERS"] = 3] = "USERS";
            UserTreeGridItemType[UserTreeGridItemType["ROLES"] = 4] = "ROLES";
        })(browse.UserTreeGridItemType || (browse.UserTreeGridItemType = {}));
        var UserTreeGridItemType = browse.UserTreeGridItemType;
        var UserTreeGridItem = (function () {
            function UserTreeGridItem(builder) {
                this.userStore = builder.userStore;
                this.principal = builder.principal;
                this.type = builder.type;
                if (this.type === UserTreeGridItemType.PRINCIPAL) {
                    this.modifiedTime = this.principal.getModifiedTime();
                }
            }
            UserTreeGridItem.prototype.setUserStore = function (userStore) {
                this.userStore = userStore;
            };
            UserTreeGridItem.prototype.getUserStore = function () {
                return this.userStore;
            };
            UserTreeGridItem.prototype.setPrincipal = function (principal) {
                this.principal = principal;
            };
            UserTreeGridItem.prototype.setType = function (type) {
                this.type = type;
            };
            UserTreeGridItem.prototype.getType = function () {
                return this.type;
            };
            UserTreeGridItem.prototype.getPrincipal = function () {
                return this.principal;
            };
            UserTreeGridItem.prototype.getItemDisplayName = function () {
                switch (this.type) {
                    case UserTreeGridItemType.USER_STORE:
                        return this.userStore.getDisplayName();
                    case UserTreeGridItemType.PRINCIPAL:
                        return this.principal.getDisplayName();
                    case UserTreeGridItemType.ROLES:
                        return 'Roles';
                    case UserTreeGridItemType.USERS:
                        return 'Users';
                    case UserTreeGridItemType.GROUPS:
                        return 'Groups';
                }
            };
            UserTreeGridItem.prototype.getDataId = function () {
                switch (this.type) {
                    case UserTreeGridItemType.USER_STORE:
                        return this.userStore.getKey().toString();
                    case UserTreeGridItemType.PRINCIPAL:
                        return this.principal.getKey().toString();
                    case UserTreeGridItemType.GROUPS:
                        return this.userStore.getKey().toString() + '/groups';
                    case UserTreeGridItemType.ROLES:
                        return '/roles';
                    case UserTreeGridItemType.USERS:
                        return this.userStore.getKey().toString() + '/users';
                }
            };
            UserTreeGridItem.prototype.hasChildren = function () {
                return (this.type === UserTreeGridItemType.USER_STORE || this.type === UserTreeGridItemType.GROUPS ||
                    this.type === UserTreeGridItemType.ROLES || this.type === UserTreeGridItemType.USERS);
            };
            UserTreeGridItem.prototype.equals = function (o) {
                if (!api.ObjectHelper.iFrameSafeInstanceOf(o, UserTreeGridItem)) {
                    return false;
                }
                var other = o;
                return this.principal === other.getPrincipal() && this.userStore == other.getUserStore();
            };
            return UserTreeGridItem;
        })();
        browse.UserTreeGridItem = UserTreeGridItem;
        var UserTreeGridItemBuilder = (function () {
            function UserTreeGridItemBuilder() {
            }
            UserTreeGridItemBuilder.prototype.setUserStore = function (userStore) {
                this.userStore = userStore;
                return this;
            };
            UserTreeGridItemBuilder.prototype.setPrincipal = function (principal) {
                this.principal = principal;
                return this;
            };
            UserTreeGridItemBuilder.prototype.setType = function (type) {
                this.type = type;
                return this;
            };
            UserTreeGridItemBuilder.prototype.build = function () {
                return new UserTreeGridItem(this);
            };
            return UserTreeGridItemBuilder;
        })();
        browse.UserTreeGridItemBuilder = UserTreeGridItemBuilder;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var UserTreeGridItemViewer = (function (_super) {
            __extends(UserTreeGridItemViewer, _super);
            function UserTreeGridItemViewer() {
                _super.call(this);
            }
            UserTreeGridItemViewer.prototype.resolveDisplayName = function (object) {
                return object.getItemDisplayName();
            };
            UserTreeGridItemViewer.prototype.resolveUnnamedDisplayName = function (object) {
                return object.getPrincipal() ? object.getPrincipal().getTypeName()
                    : object.getUserStore() ? "User Strore" : "";
            };
            UserTreeGridItemViewer.prototype.resolveSubName = function (object, relativePath) {
                if (relativePath === void 0) { relativePath = false; }
                switch (object.getType()) {
                    case browse.UserTreeGridItemType.USER_STORE:
                        return ('/' + object.getUserStore().getKey().toString());
                    case browse.UserTreeGridItemType.PRINCIPAL:
                        return relativePath ? object.getPrincipal().getKey().getId() :
                            object.getPrincipal().getKey().toPath();
                    default:
                        return object.getItemDisplayName().toLocaleLowerCase();
                }
            };
            UserTreeGridItemViewer.prototype.resolveIconClass = function (object) {
                switch (object.getType()) {
                    case browse.UserTreeGridItemType.USER_STORE:
                        return "icon-address-book icon-large";
                    case browse.UserTreeGridItemType.PRINCIPAL:
                        if (object.getPrincipal().isRole()) {
                            return "icon-shield icon-large";
                        }
                        else if (object.getPrincipal().isGroup()) {
                            return "icon-users icon-large";
                        }
                        else {
                            return "icon-user icon-large";
                        }
                    case browse.UserTreeGridItemType.GROUPS:
                        return "icon-folder icon-large";
                    case browse.UserTreeGridItemType.ROLES:
                        return "icon-folder icon-large";
                    default:
                        return "icon-folder icon-large";
                }
            };
            return UserTreeGridItemViewer;
        })(api.ui.NamesAndIconViewer);
        browse.UserTreeGridItemViewer = UserTreeGridItemViewer;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var GridColumnBuilder = api.ui.grid.GridColumnBuilder;
        var TreeGrid = api.ui.treegrid.TreeGrid;
        var TreeGridBuilder = api.ui.treegrid.TreeGridBuilder;
        var DateTimeFormatter = api.ui.treegrid.DateTimeFormatter;
        var TreeGridContextMenu = api.ui.treegrid.TreeGridContextMenu;
        var ListUserStoresRequest = api.security.ListUserStoresRequest;
        var FindPrincipalsRequest = api.security.FindPrincipalsRequest;
        var PrincipalType = api.security.PrincipalType;
        var UserItemBrowseSearchEvent = app.browse.filter.PrincipalBrowseSearchEvent;
        var UserItemBrowseResetEvent = app.browse.filter.PrincipalBrowseResetEvent;
        var UserItemsTreeGrid = (function (_super) {
            __extends(UserItemsTreeGrid, _super);
            function UserItemsTreeGrid() {
                this.treeGridActions = new browse.UserTreeGridActions(this);
                _super.call(this, new TreeGridBuilder().
                    setColumns([
                    this.getNameColumn(), this.getModifiedTimeColumn()
                ]).
                    setShowContextMenu(new TreeGridContextMenu(this.treeGridActions)).
                    setPartialLoadEnabled(true).
                    setLoadBufferSize(20).
                    prependClasses("user-tree-grid"));
                this.subscribeEvents();
            }
            UserItemsTreeGrid.prototype.getNameColumn = function () {
                return new GridColumnBuilder().
                    setName("Name").
                    setId("name").
                    setField("displayName").
                    setFormatter(this.nameFormatter).
                    setMinWidth(250).
                    build();
            };
            UserItemsTreeGrid.prototype.getModifiedTimeColumn = function () {
                return new GridColumnBuilder().
                    setName("ModifiedTime").
                    setId("modifiedTime").
                    setField("modifiedTime").
                    setCssClass("modified").
                    setMinWidth(150).
                    setMaxWidth(170).
                    setFormatter(DateTimeFormatter.format).
                    build();
            };
            UserItemsTreeGrid.prototype.subscribeEvents = function () {
                var _this = this;
                UserItemBrowseSearchEvent.on(function (event) {
                    var items = event.getPrincipals().map(function (principal) {
                        return new app.browse.UserTreeGridItemBuilder().
                            setPrincipal(principal).
                            setType(browse.UserTreeGridItemType.PRINCIPAL).
                            build();
                    });
                    _this.filter(items);
                    _this.notifyLoaded();
                });
                UserItemBrowseResetEvent.on(function (event) {
                    _this.resetFilter();
                });
                api.ui.responsive.ResponsiveManager.onAvailableSizeChanged(this, function (item) {
                    _this.getGrid().resizeCanvas();
                });
                this.getGrid().subscribeOnDblClick(function (event, data) {
                    if (_this.isActive()) {
                        var node = _this.getGrid().getDataView().getItem(data.row);
                        if (_this.isUserItemEditable(node.getData())) {
                            new app.browse.EditPrincipalEvent([node.getData()]).fire();
                        }
                    }
                });
            };
            UserItemsTreeGrid.prototype.isUserItemEditable = function (userItem) {
                var type = userItem.getType();
                if (type == browse.UserTreeGridItemType.ROLES || type == browse.UserTreeGridItemType.GROUPS || type == browse.UserTreeGridItemType.USERS) {
                    return false;
                }
                return true;
            };
            UserItemsTreeGrid.prototype.nameFormatter = function (row, cell, value, columnDef, node) {
                var viewer = node.getViewer("displayName");
                if (!viewer) {
                    var viewer = new browse.UserTreeGridItemViewer();
                    viewer.setObject(node.getData(), node.calcLevel() > 1);
                    node.setViewer("displayName", viewer);
                }
                return viewer.toString();
            };
            UserItemsTreeGrid.prototype.getTreeGridActions = function () {
                return this.treeGridActions;
            };
            UserItemsTreeGrid.prototype.resolveUserTreeGridItemType = function (principal) {
                if (!principal) {
                    return browse.UserTreeGridItemType.USER_STORE;
                }
                else {
                    switch (principal.getType()) {
                        case PrincipalType.USER:
                            return browse.UserTreeGridItemType.USERS;
                        case PrincipalType.GROUP:
                            return browse.UserTreeGridItemType.GROUPS;
                        case PrincipalType.ROLE:
                            return browse.UserTreeGridItemType.ROLES;
                        default:
                            return browse.UserTreeGridItemType.PRINCIPAL;
                    }
                }
            };
            UserItemsTreeGrid.prototype.updateUserNode = function (principal, userStore) {
                var userTreeGridItem, builder = new browse.UserTreeGridItemBuilder();
                if (!principal) {
                    userTreeGridItem = builder.setUserStore(userStore).setType(browse.UserTreeGridItemType.USER_STORE).build();
                }
                else {
                    userTreeGridItem = builder.setPrincipal(principal).setType(browse.UserTreeGridItemType.PRINCIPAL).build();
                }
                var nodeList = this.getRoot().getCurrentRoot().treeToList();
                nodeList.forEach(function (node) {
                    if (node.getDataId() === userTreeGridItem.getDataId()) {
                        node.setData(userTreeGridItem);
                        node.clearViewers();
                    }
                });
                this.initData(nodeList);
                this.invalidate();
            };
            UserItemsTreeGrid.prototype.appendUserNode = function (principal, userStore, parentOfSameType) {
                if (!principal) {
                    var userTreeGridItem = new browse.UserTreeGridItemBuilder().
                        setUserStore(userStore).
                        setType(browse.UserTreeGridItemType.USER_STORE).
                        build();
                    var children = this.getRoot().getDefaultRoot().getChildren(), roles = children.pop();
                    this.appendNode(userTreeGridItem, true, false);
                    children.push(roles);
                    if (!this.getRoot().isFiltered()) {
                        this.initData(this.getRoot().getDefaultRoot().treeToList());
                        this.invalidate();
                    }
                }
                else {
                    var userTreeGridItem = new browse.UserTreeGridItemBuilder().
                        setPrincipal(principal).
                        setType(browse.UserTreeGridItemType.PRINCIPAL).
                        build();
                    this.appendNode(userTreeGridItem, parentOfSameType, false);
                }
            };
            UserItemsTreeGrid.prototype.deleteUserNodes = function (principals, userStores) {
                if (principals) {
                    var principalItems = principals.map(function (principal) {
                        return new browse.UserTreeGridItemBuilder().setPrincipal(principal).setType(browse.UserTreeGridItemType.PRINCIPAL).build();
                    });
                    this.deleteNodes(principalItems);
                }
                if (userStores) {
                    var userStoreItems = userStores.map(function (userStore) {
                        return new browse.UserTreeGridItemBuilder().setUserStore(userStore).setType(browse.UserTreeGridItemType.USER_STORE).build();
                    });
                    this.deleteNodes(userStoreItems);
                }
            };
            UserItemsTreeGrid.prototype.getDataId = function (item) {
                return item.getDataId();
            };
            UserItemsTreeGrid.prototype.hasChildren = function (item) {
                return item.hasChildren();
            };
            UserItemsTreeGrid.prototype.fetchChildren = function (parentNode) {
                var gridItems = [];
                var deferred = wemQ.defer();
                var level = parentNode ? parentNode.calcLevel() : 0;
                if (level !== 0 && parentNode.getData().getPrincipal() &&
                    parentNode.getData().getType() === browse.UserTreeGridItemType.PRINCIPAL &&
                    parentNode.getData().getPrincipal().isRole() && !!parentNode.getParent()) {
                    parentNode = parentNode.getParent();
                    level--;
                }
                if (level === 0) {
                    new ListUserStoresRequest().sendAndParse().then(function (userStores) {
                        userStores.forEach(function (userStore) {
                            gridItems.push(new browse.UserTreeGridItemBuilder().setUserStore(userStore).setType(browse.UserTreeGridItemType.USER_STORE).build());
                        });
                        gridItems.push(new browse.UserTreeGridItemBuilder().setType(browse.UserTreeGridItemType.ROLES).build());
                        deferred.resolve(gridItems);
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                }
                else if (parentNode.getData().getType() === browse.UserTreeGridItemType.ROLES) {
                    new FindPrincipalsRequest().setAllowedTypes([PrincipalType.ROLE]).sendAndParse().
                        then(function (principals) {
                        principals.forEach(function (principal) {
                            gridItems.push(new browse.UserTreeGridItemBuilder().setPrincipal(principal).setType(browse.UserTreeGridItemType.PRINCIPAL).build());
                        });
                        deferred.resolve(gridItems);
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                }
                else if (level === 1) {
                    var userStoreNode = parentNode.getData();
                    deferred.resolve(this.addUsersGroupsToUserStore(userStoreNode));
                }
                else if (level === 2) {
                    var userStoreNode = parentNode.getParent().getData();
                    var userStoreKey = userStoreNode.getUserStore().getKey();
                    var folder = parentNode.getData();
                    var principalType = this.getPrincipalTypeForFolderItem(folder.getType());
                    new FindPrincipalsRequest().setUserStoreKey(userStoreKey).setAllowedTypes([principalType]).sendAndParse().
                        then(function (principals) {
                        principals.forEach(function (principal) {
                            gridItems.push(new browse.UserTreeGridItemBuilder().setPrincipal(principal).setType(browse.UserTreeGridItemType.PRINCIPAL).build());
                        });
                        deferred.resolve(gridItems);
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                }
                return deferred.promise;
            };
            UserItemsTreeGrid.prototype.refreshNodeData = function (parentNode) {
                var deferred = Q.defer();
                deferred.resolve(parentNode);
                return deferred.promise;
            };
            UserItemsTreeGrid.prototype.getPrincipalTypeForFolderItem = function (itemType) {
                if (itemType === browse.UserTreeGridItemType.GROUPS) {
                    return PrincipalType.GROUP;
                }
                else if (itemType === browse.UserTreeGridItemType.USERS) {
                    return PrincipalType.USER;
                }
                else {
                    throw new Error("Invalid item type for folder with principals: " + browse.UserTreeGridItemType[itemType]);
                }
            };
            UserItemsTreeGrid.prototype.addUsersGroupsToUserStore = function (parentItem) {
                var items = [];
                if (parentItem.getType() == browse.UserTreeGridItemType.USER_STORE) {
                    var userStore = parentItem.getUserStore();
                    var userFolderItem = new browse.UserTreeGridItemBuilder().setUserStore(userStore).setType(browse.UserTreeGridItemType.USERS).build();
                    var groupFolderItem = new browse.UserTreeGridItemBuilder().setUserStore(userStore).setType(browse.UserTreeGridItemType.GROUPS).build();
                    items.push(userFolderItem);
                    items.push(groupFolderItem);
                }
                return items;
            };
            return UserItemsTreeGrid;
        })(TreeGrid);
        browse.UserItemsTreeGrid = UserItemsTreeGrid;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var UserStore = api.security.UserStore;
        var UserTreeGridActions = (function () {
            function UserTreeGridActions(grid) {
                this.actions = [];
                this.NEW = new app.browse.action.NewPrincipalAction(grid);
                this.EDIT = new app.browse.action.EditPrincipalAction(grid);
                this.DELETE = new app.browse.action.DeletePrincipalAction(grid);
                this.SYNCH = new app.browse.action.SynchPrincipalAction(grid);
                this.actions.push(this.NEW, this.EDIT, this.DELETE, this.SYNCH);
            }
            UserTreeGridActions.prototype.getAllActions = function () {
                return this.actions;
            };
            UserTreeGridActions.prototype.updateActionsEnabledState = function (userItemBrowseItems) {
                var userStoresSelected = 0, principalsSelected = 0, directoriesSelected = 0;
                userItemBrowseItems.forEach(function (browseItem) {
                    var item = browseItem.getModel();
                    var itemType = item.getType();
                    switch (itemType) {
                        case browse.UserTreeGridItemType.PRINCIPAL:
                            principalsSelected++;
                            break;
                        case browse.UserTreeGridItemType.ROLES:
                            directoriesSelected++;
                            break;
                        case browse.UserTreeGridItemType.GROUPS:
                            directoriesSelected++;
                            break;
                        case browse.UserTreeGridItemType.USERS:
                            directoriesSelected++;
                            break;
                        case browse.UserTreeGridItemType.USER_STORE:
                            userStoresSelected++;
                            break;
                    }
                });
                var totalSelection = userStoresSelected + principalsSelected + directoriesSelected, anyPrincipal = principalsSelected > 0, anyUserStore = userStoresSelected > 0;
                this.NEW.setEnabled((directoriesSelected <= 1) && (totalSelection <= 1));
                this.EDIT.setEnabled(directoriesSelected < 1 && (anyUserStore || anyPrincipal));
                if (totalSelection == 1) {
                    if (principalsSelected == 1) {
                        this.DELETE.setEnabled(true);
                    }
                    else {
                        this.establishDeleteActionState(userItemBrowseItems[0].getModel());
                    }
                }
                else {
                    this.DELETE.setEnabled(false);
                }
                this.SYNCH.setEnabled(anyUserStore);
                var deferred = wemQ.defer();
                deferred.resolve(userItemBrowseItems);
                return deferred.promise;
            };
            UserTreeGridActions.prototype.establishDeleteActionState = function (userBrowseItem) {
                var _this = this;
                if (this.itemTypeAllowsDeletion(userBrowseItem.getType()) && userBrowseItem.getUserStore() &&
                    userBrowseItem.getUserStore().getKey()) {
                    UserStore.checkOnDeletable(userBrowseItem.getUserStore().getKey()).then(function (result) {
                        _this.DELETE.setEnabled(result);
                    });
                }
                else {
                    this.DELETE.setEnabled(false);
                }
            };
            UserTreeGridActions.prototype.itemTypeAllowsDeletion = function (userTreeGridItemType) {
                return (userTreeGridItemType !== browse.UserTreeGridItemType.USERS && userTreeGridItemType !== browse.UserTreeGridItemType.GROUPS);
            };
            return UserTreeGridActions;
        })();
        browse.UserTreeGridActions = UserTreeGridActions;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var UserBrowseItemsSelectionPanel = (function (_super) {
            __extends(UserBrowseItemsSelectionPanel, _super);
            function UserBrowseItemsSelectionPanel() {
                _super.apply(this, arguments);
            }
            UserBrowseItemsSelectionPanel.prototype.createItemViewer = function (item) {
                var viewer = new browse.UserTreeGridItemViewer();
                viewer.setObject(item.getModel());
                return viewer;
            };
            return UserBrowseItemsSelectionPanel;
        })(api.app.browse.BrowseItemsSelectionPanel);
        browse.UserBrowseItemsSelectionPanel = UserBrowseItemsSelectionPanel;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var BrowseItem = api.app.browse.BrowseItem;
        var UserTreeGridItemType = app.browse.UserTreeGridItemType;
        var UserBrowsePanel = (function (_super) {
            __extends(UserBrowsePanel, _super);
            function UserBrowsePanel() {
                var _this = this;
                this.userTreeGrid = new browse.UserItemsTreeGrid();
                this.browseActions = this.userTreeGrid.getTreeGridActions();
                this.userFilterPanel = new app.browse.filter.PrincipalBrowseFilterPanel();
                this.toolbar = new browse.UserBrowseToolbar(this.browseActions);
                var browseItemPanel = components.detailPanel = new browse.UserBrowseItemPanel();
                _super.call(this, {
                    browseToolbar: this.toolbar,
                    treeGrid: this.userTreeGrid,
                    browseItemPanel: browseItemPanel,
                    filterPanel: this.userFilterPanel
                });
                api.security.UserItemCreatedEvent.on(function (event) {
                    _this.userTreeGrid.appendUserNode(event.getPrincipal(), event.getUserStore(), event.isParentOfSameType());
                    _this.setFilterPanelRefreshNeeded(true);
                });
                api.security.UserItemUpdatedEvent.on(function (event) {
                    _this.userTreeGrid.updateUserNode(event.getPrincipal(), event.getUserStore());
                });
                api.security.UserItemDeletedEvent.on(function (event) {
                    _this.setFilterPanelRefreshNeeded(true);
                    _this.userTreeGrid.deleteUserNodes(event.getPrincipals(), event.getUserStores());
                    _this.refreshFilter();
                });
                this.onShown(function (event) {
                    app.Router.setHash("browse");
                });
            }
            UserBrowsePanel.prototype.treeNodesToBrowseItems = function (nodes) {
                var _this = this;
                var browseItems = [];
                nodes.forEach(function (node) {
                    var userGridItem = node.getData();
                    var item = new BrowseItem(userGridItem).
                        setId(userGridItem.getDataId()).
                        setDisplayName(userGridItem.getItemDisplayName()).
                        setIconClass(_this.selectIconClass(userGridItem));
                    browseItems.push(item);
                });
                return browseItems;
            };
            UserBrowsePanel.prototype.selectIconClass = function (item) {
                var type = item.getType();
                switch (type) {
                    case UserTreeGridItemType.USER_STORE:
                        return "icon-address-book icon-large";
                    case UserTreeGridItemType.PRINCIPAL:
                        if (item.getPrincipal().isRole()) {
                            return "icon-shield icon-large";
                        }
                        else if (item.getPrincipal().isUser()) {
                            return "icon-user icon-large";
                        }
                        else if (item.getPrincipal().isGroup()) {
                            return "icon-users icon-large";
                        }
                        break;
                    case UserTreeGridItemType.GROUPS:
                        return "icon-folder icon-large";
                    case UserTreeGridItemType.ROLES:
                        return "icon-folder icon-large";
                    case UserTreeGridItemType.USERS:
                        return "icon-folder icon-large";
                }
            };
            return UserBrowsePanel;
        })(api.app.browse.BrowsePanel);
        browse.UserBrowsePanel = UserBrowsePanel;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var UserBrowseToolbar = (function (_super) {
            __extends(UserBrowseToolbar, _super);
            function UserBrowseToolbar(actions) {
                _super.call(this);
                this.addClass("user-browse-toolbar");
                this.addActions(actions.getAllActions());
            }
            return UserBrowseToolbar;
        })(api.ui.toolbar.Toolbar);
        browse.UserBrowseToolbar = UserBrowseToolbar;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var UserBrowseItemPanel = (function (_super) {
            __extends(UserBrowseItemPanel, _super);
            function UserBrowseItemPanel() {
                _super.apply(this, arguments);
            }
            UserBrowseItemPanel.prototype.createItemSelectionPanel = function () {
                return new browse.UserBrowseItemsSelectionPanel();
            };
            UserBrowseItemPanel.prototype.createItemStatisticsPanel = function () {
                return new app.view.UserItemStatisticsPanel();
            };
            return UserBrowseItemPanel;
        })(api.app.browse.BrowseItemPanel);
        browse.UserBrowseItemPanel = UserBrowseItemPanel;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var Event = api.event.Event;
        var UpdatePrincipalEvent = (function (_super) {
            __extends(UpdatePrincipalEvent, _super);
            function UpdatePrincipalEvent(principals) {
                this.principals = principals;
                _super.call(this);
            }
            UpdatePrincipalEvent.prototype.getPrincipals = function () {
                return this.principals;
            };
            UpdatePrincipalEvent.on = function (handler) {
                Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            UpdatePrincipalEvent.un = function (handler) {
                Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return UpdatePrincipalEvent;
        })(Event);
        browse.UpdatePrincipalEvent = UpdatePrincipalEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var EditPrincipalEvent = (function (_super) {
            __extends(EditPrincipalEvent, _super);
            function EditPrincipalEvent() {
                _super.apply(this, arguments);
            }
            EditPrincipalEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            EditPrincipalEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return EditPrincipalEvent;
        })(browse.BaseUserEvent);
        browse.EditPrincipalEvent = EditPrincipalEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var UserItemDeletePromptEvent = (function (_super) {
            __extends(UserItemDeletePromptEvent, _super);
            function UserItemDeletePromptEvent() {
                _super.apply(this, arguments);
            }
            UserItemDeletePromptEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            UserItemDeletePromptEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return UserItemDeletePromptEvent;
        })(browse.BaseUserEvent);
        browse.UserItemDeletePromptEvent = UserItemDeletePromptEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var PrincipalDuplicatedEvent = (function (_super) {
            __extends(PrincipalDuplicatedEvent, _super);
            function PrincipalDuplicatedEvent(principal, source, nextToSource) {
                if (nextToSource === void 0) { nextToSource = true; }
                _super.call(this);
                this.principal = principal;
                this.source = source;
                this.nextToSource = nextToSource;
            }
            PrincipalDuplicatedEvent.prototype.getSource = function () {
                return this.source;
            };
            PrincipalDuplicatedEvent.prototype.getPrincipal = function () {
                return this.principal;
            };
            PrincipalDuplicatedEvent.prototype.isNextToSource = function () {
                return this.nextToSource;
            };
            PrincipalDuplicatedEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            PrincipalDuplicatedEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return PrincipalDuplicatedEvent;
        })(api.event.Event);
        browse.PrincipalDuplicatedEvent = PrincipalDuplicatedEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var PrincipalSynchronizedEvent = (function (_super) {
            __extends(PrincipalSynchronizedEvent, _super);
            function PrincipalSynchronizedEvent(principal) {
                _super.call(this);
                this.principal = principal;
            }
            PrincipalSynchronizedEvent.prototype.getPrincipal = function () {
                return this.principal;
            };
            PrincipalSynchronizedEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            PrincipalSynchronizedEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return PrincipalSynchronizedEvent;
        })(api.event.Event);
        browse.PrincipalSynchronizedEvent = PrincipalSynchronizedEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var NewPrincipalEvent = (function (_super) {
            __extends(NewPrincipalEvent, _super);
            function NewPrincipalEvent() {
                _super.apply(this, arguments);
            }
            NewPrincipalEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            NewPrincipalEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return NewPrincipalEvent;
        })(browse.BaseUserEvent);
        browse.NewPrincipalEvent = NewPrincipalEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
///<reference path='BaseUserEvent.ts'/>
///<reference path='UserTreeGridItem.ts'/>
///<reference path='UserTreeGridItemViewer.ts'/>
///<reference path='UserItemsTreeGrid.ts'/>
///<reference path='UserTreeGridActions.ts' />
///<reference path='UserBrowseItemsSelectionPanel.ts' />
///<reference path='UserBrowsePanel.ts' />
///<reference path='UserBrowseToolbar.ts' />
///<reference path='UserBrowseItemPanel.ts'/>
///<reference path='UpdatePrincipalEvent.ts'/>
///<reference path='EditPrincipalEvent.ts'/>
///<reference path='UserItemDeletePromptEvent.ts'/>
///<reference path='PrincipalDuplicatedEvent.ts'/>
///<reference path='PrincipalSynchronizedEvent.ts'/>
///<reference path='NewPrincipalEvent.ts'/>
var app;
(function (app) {
    var view;
    (function (view) {
        var ItemStatisticsPanel = api.app.view.ItemStatisticsPanel;
        var ItemDataGroup = api.app.view.ItemDataGroup;
        var UserTreeGridItemType = app.browse.UserTreeGridItemType;
        var PrincipalType = api.security.PrincipalType;
        var GetPrincipalByKeyRequest = api.security.GetPrincipalByKeyRequest;
        var PrincipalViewer = api.ui.security.PrincipalViewer;
        var UserItemStatisticsPanel = (function (_super) {
            __extends(UserItemStatisticsPanel, _super);
            function UserItemStatisticsPanel() {
                _super.call(this, "principal-item-statistics-panel");
                this.userDataContainer = new api.dom.DivEl("user-data-container");
                this.appendChild(this.userDataContainer);
            }
            UserItemStatisticsPanel.prototype.setItem = function (item) {
                var currentItem = this.getItem();
                if (!currentItem || !currentItem.equals(item)) {
                    switch (item.getModel().getType()) {
                        case UserTreeGridItemType.PRINCIPAL:
                            this.populatePrincipalViewItem(item);
                            break;
                        default:
                    }
                    this.userDataContainer.removeChildren();
                    if (item.getModel().getPrincipal()) {
                        var type = item.getModel().getPrincipal().getType();
                        switch (type) {
                            case PrincipalType.USER:
                                this.appendUserMetadata(item);
                                break;
                            case PrincipalType.GROUP:
                                this.appendGroupRoleMetadata(item);
                                break;
                            case PrincipalType.ROLE:
                                this.appendGroupRoleMetadata(item);
                                break;
                        }
                    }
                    _super.prototype.setItem.call(this, item);
                }
            };
            UserItemStatisticsPanel.prototype.populatePrincipalViewItem = function (item) {
                item.setPathName(item.getModel().getPrincipal().getKey().getId());
                item.setPath(item.getModel().getPrincipal().getKey().toPath(true));
                item.setIconSize(128);
            };
            UserItemStatisticsPanel.prototype.appendUserMetadata = function (item) {
                var _this = this;
                var userGroup = new ItemDataGroup("User", "user");
                userGroup.addDataList("E-mail", " ");
                this.userDataContainer.appendChild(userGroup);
                var rolesAndGroupsGroup = new ItemDataGroup("Roles & Groups", "roles-and-groups");
                rolesAndGroupsGroup.addDataArray("Roles", []);
                rolesAndGroupsGroup.addDataArray("Groups", []);
                this.userDataContainer.appendChild(rolesAndGroupsGroup);
                new GetPrincipalByKeyRequest(item.getModel().getPrincipal().getKey()).
                    includeUserMemberships(true).
                    sendAndParse().
                    then(function (principal) {
                    userGroup = new ItemDataGroup("User", "user");
                    userGroup.addDataList("E-mail", principal.asUser().getEmail());
                    rolesAndGroupsGroup = new ItemDataGroup("Roles & Groups", "memeberships");
                    var roles = principal.asUser().getMemberships().
                        filter(function (el) { return el.isRole(); }).
                        map(function (el) {
                        var viewer = new PrincipalViewer();
                        viewer.setObject(el);
                        return viewer.getHtml();
                    });
                    rolesAndGroupsGroup.addDataArray("Roles", roles);
                    var groups = principal.asUser().getMemberships().
                        filter(function (el) { return el.isGroup(); }).
                        map(function (el) {
                        var viewer = new PrincipalViewer();
                        viewer.setObject(el);
                        return viewer.getHtml();
                    });
                    rolesAndGroupsGroup.addDataArray("Groups", groups);
                    _this.userDataContainer.removeChildren();
                    _this.userDataContainer.appendChild(userGroup);
                    _this.userDataContainer.appendChild(rolesAndGroupsGroup);
                }).catch(function (reason) {
                    api.DefaultErrorHandler.handle(reason);
                }).finally(function () {
                }).done();
            };
            UserItemStatisticsPanel.prototype.appendGroupRoleMetadata = function (item) {
                var _this = this;
                var name = PrincipalType[item.getModel().getPrincipal().getType()], name = name.charAt(0) + name.slice(1).toLowerCase();
                var groupAndRoleGroup = new ItemDataGroup(name, "group-and-role");
                groupAndRoleGroup.addDataList(" ", "");
                this.userDataContainer.appendChild(groupAndRoleGroup);
                var membersGroup = new ItemDataGroup("Members", "members");
                membersGroup.addDataArray("Members", []);
                this.userDataContainer.appendChild(membersGroup);
                new GetPrincipalByKeyRequest(item.getModel().getPrincipal().getKey()).
                    includeUserMemberships(true).
                    sendAndParse().
                    then(function (principal) {
                    var membersPromises = (principal.isGroup() ? principal.asGroup().getMembers() : principal.asRole().getMembers())
                        .map(function (el) {
                        return new GetPrincipalByKeyRequest(el).sendAndParse();
                    });
                    wemQ.all(membersPromises).then(function (results) {
                        groupAndRoleGroup = new ItemDataGroup(name, "group-and-role");
                        groupAndRoleGroup.addDataList(" ", "");
                        membersGroup = new ItemDataGroup("Members", "members");
                        membersGroup.addDataArray("Members", results.map(function (el) {
                            var viewer = new PrincipalViewer();
                            viewer.setObject(el);
                            return viewer.getHtml();
                        }));
                        _this.userDataContainer.removeChildren();
                        _this.userDataContainer.appendChild(groupAndRoleGroup);
                        _this.userDataContainer.appendChild(membersGroup);
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                }).catch(function (reason) {
                    api.DefaultErrorHandler.handle(reason);
                }).finally(function () {
                }).done();
            };
            return UserItemStatisticsPanel;
        })(ItemStatisticsPanel);
        view.UserItemStatisticsPanel = UserItemStatisticsPanel;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var UserItemHeader = (function (_super) {
            __extends(UserItemHeader, _super);
            function UserItemHeader() {
                _super.call(this, "principal-item-header");
                this.displayName = new api.dom.H2El();
                this.subTitle = new api.dom.H3El();
                this.appendChild(this.displayName);
                this.appendChild(this.subTitle);
            }
            UserItemHeader.prototype.setTitle = function (value) {
                this.displayName.getEl().setInnerHtml(value);
            };
            UserItemHeader.prototype.setSubTitle = function (value) {
                this.subTitle.getEl().setInnerHtml(value);
            };
            return UserItemHeader;
        })(api.dom.DivEl);
        view.UserItemHeader = UserItemHeader;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
///<reference path='UserItemStatisticsPanel.ts' />
///<reference path='UserItemHeader.ts' /> 
var app;
(function (app) {
    var wizard;
    (function (wizard_1) {
        var ResponsiveManager = api.ui.responsive.ResponsiveManager;
        var FormIcon = api.app.wizard.FormIcon;
        var UserItemWizardPanel = (function (_super) {
            __extends(UserItemWizardPanel, _super);
            function UserItemWizardPanel(params, callback) {
                var _this = this;
                this.constructing = true;
                var iconUrl = api.dom.ImgEl.PLACEHOLDER;
                this.formIcon = new FormIcon(iconUrl, "Click to upload icon");
                this.formIcon.addClass("icon icon-xlarge");
                _super.call(this, {
                    tabId: params.tabId,
                    persistedItem: params.getPersistedItem(),
                    formIcon: this.formIcon,
                    mainToolbar: this.toolbar,
                    header: this.wizardHeader,
                    actions: this.wizardActions,
                    livePanel: null,
                    split: false
                }, function () {
                    _this.addClass("principal-wizard-panel");
                    var responsiveItem = ResponsiveManager.onAvailableSizeChanged(_this, function (item) {
                        if (_this.isVisible()) {
                            _this.updateStickyToolbar();
                        }
                    });
                    _this.onRemoved(function (event) {
                        ResponsiveManager.unAvailableSizeChanged(_this);
                    });
                    _this.constructing = false;
                    callback(_this);
                });
            }
            UserItemWizardPanel.prototype.getUserItemType = function () {
                throw new Error("Must be implemented by inheritors");
            };
            UserItemWizardPanel.prototype.giveInitialFocus = function () {
                this.wizardHeader.giveFocus();
                this.startRememberFocus();
            };
            UserItemWizardPanel.prototype.saveChanges = function () {
                if (!this.wizardHeader.getName()) {
                    var deferred = wemQ.defer();
                    api.notify.showError("Name can not be empty");
                    deferred.reject(new Error("Name can not be empty"));
                    return deferred.promise;
                }
                else {
                    return _super.prototype.saveChanges.call(this);
                }
            };
            UserItemWizardPanel.prototype.createSteps = function () {
                throw new Error("Must be implemented by inheritors");
            };
            UserItemWizardPanel.prototype.preLayoutNew = function () {
                var deferred = wemQ.defer();
                this.saveChanges().
                    then(function () {
                    deferred.resolve(null);
                }).catch(function (reason) {
                    deferred.reject(reason);
                }).done();
                return deferred.promise;
            };
            UserItemWizardPanel.prototype.layoutPersistedItem = function (persistedItem) {
                throw new Error("Must be implemented by inheritors");
            };
            UserItemWizardPanel.prototype.doLayoutPersistedItem = function (item) {
                var parallelPromises = [
                    this.createSteps()
                ];
                return wemQ.all(parallelPromises).
                    spread(function () {
                });
            };
            UserItemWizardPanel.prototype.persistNewItem = function () {
                throw new Error("Must be implemented by inheritors");
            };
            UserItemWizardPanel.prototype.postPersistNewItem = function (persisted) {
                var deferred = wemQ.defer();
                deferred.resolve(null);
                return deferred.promise;
            };
            UserItemWizardPanel.prototype.updatePersistedItem = function () {
                throw new Error("Must be implemented by inheritors");
            };
            UserItemWizardPanel.prototype.getPersistedItemKey = function () {
                throw new Error("Must be implemented by inheritors");
            };
            UserItemWizardPanel.prototype.getCloseAction = function () {
                return this.wizardActions.getCloseAction();
            };
            return UserItemWizardPanel;
        })(api.app.wizard.WizardPanel);
        wizard_1.UserItemWizardPanel = UserItemWizardPanel;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var UserItemWizardPanelParams = (function () {
            function UserItemWizardPanelParams() {
            }
            UserItemWizardPanelParams.prototype.getPersistedItem = function () {
                throw new Error("Must be implemented by inheritors");
            };
            return UserItemWizardPanelParams;
        })();
        wizard.UserItemWizardPanelParams = UserItemWizardPanelParams;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_2) {
        var Principal = api.security.Principal;
        var PrincipalType = api.security.PrincipalType;
        var PrincipalNamedEvent = api.security.PrincipalNamedEvent;
        var ConfirmationDialog = api.ui.dialog.ConfirmationDialog;
        var ResponsiveManager = api.ui.responsive.ResponsiveManager;
        var WizardHeaderWithDisplayNameAndNameBuilder = api.app.wizard.WizardHeaderWithDisplayNameAndNameBuilder;
        var PrincipalWizardPanel = (function (_super) {
            __extends(PrincipalWizardPanel, _super);
            function PrincipalWizardPanel(params, callback) {
                var _this = this;
                this.principalNamedListeners = [];
                this.principalType = params.persistedType;
                this.principalPath = params.persistedPath;
                if (params.persistedPrincipal) {
                    this.persistedPrincipalKey = params.persistedPrincipal.getKey();
                }
                this.parentOfSameType = params.parentOfSameType;
                this.userStore = params.userStore;
                this.wizardActions = new app.wizard.action.UserItemWizardActions(this);
                this.toolbar = new wizard_2.PrincipalWizardToolbar({
                    saveAction: this.wizardActions.getSaveAction(),
                    deleteAction: this.wizardActions.getDeleteAction()
                });
                this.wizardHeader = new WizardHeaderWithDisplayNameAndNameBuilder().build();
                this.wizardHeader.setPath(this.principalPath);
                if (params.persistedPrincipal) {
                    this.wizardHeader.disableNameInput();
                    this.wizardHeader.setAutoGenerationEnabled(false);
                }
                else {
                    this.getPrincipalWizardHeader().onPropertyChanged(function (event) {
                        var updateStatus = event.getPropertyName() === "name" ||
                            (_this.getPrincipalWizardHeader().isAutoGenerationEnabled() && event.getPropertyName() === "displayName");
                        if (updateStatus) {
                            _this.wizardActions.getSaveAction().setEnabled(!!event.getNewValue());
                        }
                    });
                }
                _super.call(this, params, function () {
                    _this.addClass("principal-wizard-panel");
                    switch (_this.principalType) {
                        case PrincipalType.USER:
                            _this.formIcon.addClass("icon-user");
                            break;
                        case PrincipalType.GROUP:
                            _this.formIcon.addClass("icon-users");
                            break;
                        case PrincipalType.ROLE:
                            _this.formIcon.addClass("icon-shield");
                            break;
                    }
                    var responsiveItem = ResponsiveManager.onAvailableSizeChanged(_this, function (item) {
                        if (_this.isVisible()) {
                            _this.updateStickyToolbar();
                        }
                    });
                    _this.onRemoved(function (event) {
                        ResponsiveManager.unAvailableSizeChanged(_this);
                    });
                    _this.onShown(function (event) {
                        if (_this.getPersistedItem()) {
                            app.Router.setHash("edit/" + _this.getPersistedItem().getKey());
                        }
                        else {
                            app.Router.setHash("new/" + PrincipalType[_this.principalType].toLowerCase());
                        }
                        responsiveItem.update();
                    });
                    _this.constructing = false;
                    callback(_this);
                });
            }
            PrincipalWizardPanel.prototype.getUserItemType = function () {
                switch (this.principalType) {
                    case PrincipalType.USER:
                        return "User";
                    case PrincipalType.GROUP:
                        return "Group";
                    case PrincipalType.ROLE:
                        return "Role";
                    default:
                        return "";
                }
            };
            PrincipalWizardPanel.prototype.isParentOfSameType = function () {
                return this.parentOfSameType;
            };
            PrincipalWizardPanel.prototype.getUserStore = function () {
                return this.userStore;
            };
            PrincipalWizardPanel.prototype.getUserStoreKey = function () {
                return !!this.userStore ? this.userStore.getKey() : null;
            };
            PrincipalWizardPanel.prototype.getPrincipalWizardHeader = function () {
                return this.wizardHeader;
            };
            PrincipalWizardPanel.prototype.giveInitialFocus = function () {
                this.wizardHeader.giveFocus();
                this.startRememberFocus();
            };
            PrincipalWizardPanel.prototype.saveChanges = function () {
                if (!this.wizardHeader.getName()) {
                    var deferred = wemQ.defer();
                    api.notify.showError("Name can not be empty");
                    deferred.reject(new Error("Name can not be empty"));
                    return deferred.promise;
                }
                else {
                    return _super.prototype.saveChanges.call(this);
                }
            };
            PrincipalWizardPanel.prototype.createSteps = function (principal) {
                throw new Error("Must be implemented by inheritors");
            };
            PrincipalWizardPanel.prototype.preLayoutNew = function () {
                var deferred = wemQ.defer();
                this.saveChanges().
                    then(function () {
                    deferred.resolve(null);
                }).catch(function (reason) {
                    deferred.reject(reason);
                }).done();
                return deferred.promise;
            };
            PrincipalWizardPanel.prototype.postLayoutNew = function () {
                var deferred = wemQ.defer();
                this.wizardHeader.initNames("", this.principalPath, false);
                deferred.resolve(null);
                return deferred.promise;
            };
            PrincipalWizardPanel.prototype.layoutPersistedItem = function (persistedPrincipal) {
                var _this = this;
                var viewedPrincipal;
                if (!this.constructing) {
                    var deferred = wemQ.defer();
                    viewedPrincipal = this.assembleViewedItem();
                    if (!viewedPrincipal.equals(persistedPrincipal)) {
                        console.warn("Received Principal from server differs from what's viewed:");
                        console.warn(" viewedPrincipal: ", viewedPrincipal);
                        console.warn(" persistedPrincipal: ", persistedPrincipal);
                        ConfirmationDialog.get().
                            setQuestion("Received Principal from server differs from what you have. Would you like to load changes from server?").
                            setYesCallback(function () { return _this.doLayoutPersistedItem(persistedPrincipal.clone()); }).
                            setNoCallback(function () {
                        }).
                            show();
                    }
                    deferred.resolve(null);
                    return deferred.promise;
                }
                else {
                    return this.doLayoutPersistedItem(persistedPrincipal.clone());
                }
            };
            PrincipalWizardPanel.prototype.doLayoutPersistedItem = function (principal) {
                var parallelPromises = [
                    this.createSteps()
                ];
                return wemQ.all(parallelPromises).
                    spread(function () {
                });
            };
            PrincipalWizardPanel.prototype.postLayoutPersisted = function (existing) {
                var deferred = wemQ.defer();
                this.wizardHeader.initNames(existing.getDisplayName(), existing.getKey().getId(), false);
                deferred.resolve(null);
                return deferred.promise;
            };
            PrincipalWizardPanel.prototype.persistNewItem = function () {
                throw new Error("Must be implemented by inheritors");
            };
            PrincipalWizardPanel.prototype.postPersistNewItem = function (persistedPrincipal) {
                app.Router.setHash("edit/" + persistedPrincipal.getKey());
                var deferred = wemQ.defer();
                deferred.resolve(null);
                return deferred.promise;
            };
            PrincipalWizardPanel.prototype.updatePersistedItem = function () {
                throw new Error("Must be implemented by inheritors");
            };
            PrincipalWizardPanel.prototype.hasUnsavedChanges = function () {
                var persistedPrincipal = this.getPersistedItem();
                if (persistedPrincipal == undefined) {
                    return true;
                }
                else {
                    var viewedPrincipal = this.assembleViewedItem();
                    return !viewedPrincipal.equals(this.getPersistedItem());
                }
            };
            PrincipalWizardPanel.prototype.getPersistedItemKey = function () {
                return this.persistedPrincipalKey;
            };
            PrincipalWizardPanel.prototype.assembleViewedItem = function () {
                var key = this.getPersistedItem().getKey(), displayName = this.wizardHeader.getDisplayName(), modifiedTime = this.getPersistedItem().getModifiedTime();
                var principal = Principal.create().setKey(key).setDisplayName(displayName).setModifiedTime(modifiedTime).build();
                return principal;
            };
            PrincipalWizardPanel.prototype.resolvePrincipalNameForUpdateRequest = function () {
                if (api.util.StringHelper.isEmpty(this.wizardHeader.getName())) {
                    return this.getPersistedItem().getDisplayName();
                }
                else {
                    return this.wizardHeader.getName();
                }
            };
            PrincipalWizardPanel.prototype.getCloseAction = function () {
                return this.wizardActions.getCloseAction();
            };
            PrincipalWizardPanel.prototype.onPrincipalNamed = function (listener) {
                this.principalNamedListeners.push(listener);
            };
            PrincipalWizardPanel.prototype.notifyPrincipalNamed = function (principal) {
                var _this = this;
                this.principalNamedListeners.forEach(function (listener) {
                    listener.call(_this, new PrincipalNamedEvent(_this, principal));
                });
            };
            return PrincipalWizardPanel;
        })(wizard_2.UserItemWizardPanel);
        wizard_2.PrincipalWizardPanel = PrincipalWizardPanel;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_3) {
        var UserBuilder = api.security.UserBuilder;
        var CreateUserRequest = api.security.CreateUserRequest;
        var UpdateUserRequest = api.security.UpdateUserRequest;
        var PrincipalKey = api.security.PrincipalKey;
        var GetPrincipalByKeyRequest = api.security.GetPrincipalByKeyRequest;
        var ConfirmationDialog = api.ui.dialog.ConfirmationDialog;
        var WizardStep = api.app.wizard.WizardStep;
        var UserWizardPanel = (function (_super) {
            __extends(UserWizardPanel, _super);
            function UserWizardPanel(params, callback) {
                var _this = this;
                this.userEmailWizardStepForm = new wizard_3.UserEmailWizardStepForm(params.userStore ? params.userStore.getKey() : null);
                this.userPasswordWizardStepForm = new wizard_3.UserPasswordWizardStepForm();
                this.userMembershipsWizardStepForm = new wizard_3.UserMembershipsWizardStepForm();
                _super.call(this, params, function () {
                    _this.addClass("user-wizard-panel");
                    callback(_this);
                });
            }
            UserWizardPanel.prototype.giveInitialFocus = function () {
                this.wizardHeader.giveFocus();
                this.startRememberFocus();
            };
            UserWizardPanel.prototype.saveChanges = function () {
                if (this.userEmailWizardStepForm.isValid() && (this.getPersistedItem() || this.userPasswordWizardStepForm.isValid())) {
                    return _super.prototype.saveChanges.call(this);
                }
                else {
                    this.showErrors();
                    var deferred = wemQ.defer();
                    deferred.resolve(null);
                    return deferred.promise;
                }
            };
            UserWizardPanel.prototype.createSteps = function (principal) {
                var deferred = wemQ.defer();
                var steps = [];
                steps.push(new WizardStep("User", this.userEmailWizardStepForm));
                steps.push(new WizardStep("Authentication", this.userPasswordWizardStepForm));
                steps.push(new WizardStep("Groups & Roles", this.userMembershipsWizardStepForm));
                this.setSteps(steps);
                deferred.resolve(steps);
                return deferred.promise;
            };
            UserWizardPanel.prototype.preLayoutNew = function () {
                var deferred = wemQ.defer();
                this.doLayoutPersistedItem(null);
                deferred.resolve(null);
                return deferred.promise;
            };
            UserWizardPanel.prototype.postLayoutNew = function () {
                var deferred = wemQ.defer();
                this.wizardHeader.initNames("", "", false);
                deferred.resolve(null);
                return deferred.promise;
            };
            UserWizardPanel.prototype.layoutPersistedItem = function (persistedPrincipal) {
                var _this = this;
                if (!this.constructing) {
                    var deferred = wemQ.defer();
                    var viewedPrincipal = this.assembleViewedItem();
                    if (!this.isPersistedEqualsViewed()) {
                        console.warn("Received Principal from server differs from what's viewed:");
                        console.warn(" viewedPrincipal: ", viewedPrincipal);
                        console.warn(" persistedPrincipal: ", persistedPrincipal);
                        ConfirmationDialog.get().
                            setQuestion("Received Principal from server differs from what you have. Would you like to load changes from server?").
                            setYesCallback(function () { return _this.doLayoutPersistedItem(persistedPrincipal.clone()); }).
                            setNoCallback(function () {
                        }).
                            show();
                    }
                    deferred.resolve(null);
                    return deferred.promise;
                }
                else {
                    return this.doLayoutPersistedItem(persistedPrincipal.clone());
                }
            };
            UserWizardPanel.prototype.doLayoutPersistedItem = function (principal) {
                var _this = this;
                var parallelPromises = [
                    this.createSteps()
                ];
                if (!!principal) {
                    parallelPromises.push(new GetPrincipalByKeyRequest(this.getPersistedItem().getKey()).
                        includeUserMemberships(true).
                        sendAndParse().
                        then(function (p) {
                        _this.getPersistedItem().asUser();
                        _this.getPersistedItem().asUser().setMemberships(p.asUser().getMemberships());
                        principal = _this.getPersistedItem().asUser().clone();
                    }));
                }
                return wemQ.all(parallelPromises).spread(function () {
                    _this.wizardHeader.setDisplayName(principal.getDisplayName());
                    _this.userEmailWizardStepForm.layout(principal);
                    _this.userPasswordWizardStepForm.layout(principal);
                    _this.userMembershipsWizardStepForm.layout(principal);
                    return wemQ(null);
                });
            };
            UserWizardPanel.prototype.persistNewItem = function () {
                var _this = this;
                return this.produceCreateUserRequest().sendAndParse().
                    then(function (principal) {
                    _this.wizardHeader.disableNameInput();
                    _this.wizardHeader.setAutoGenerationEnabled(false);
                    api.notify.showFeedback('User was created!');
                    new api.security.UserItemCreatedEvent(principal, _this.getUserStore(), _this.isParentOfSameType()).fire();
                    _this.userPasswordWizardStepForm.updatePrincipal(principal);
                    _this.notifyPrincipalNamed(principal);
                    return principal;
                });
            };
            UserWizardPanel.prototype.produceCreateUserRequest = function () {
                var key = PrincipalKey.ofUser(this.getUserStoreKey(), this.wizardHeader.getName()), name = this.wizardHeader.getDisplayName(), email = this.userEmailWizardStepForm.getEmail(), login = this.wizardHeader.getName(), password = this.userPasswordWizardStepForm.getPassword(), memberships = this.userMembershipsWizardStepForm.getMemberships().map(function (el) {
                    return el.getKey();
                });
                return new CreateUserRequest().setKey(key).
                    setDisplayName(name).
                    setEmail(email).
                    setLogin(login).
                    setPassword(password).
                    setMemberships(memberships);
            };
            UserWizardPanel.prototype.updatePersistedItem = function () {
                var _this = this;
                return this.produceUpdateUserRequest(this.assembleViewedItem()).
                    sendAndParse().
                    then(function (principal) {
                    if (!_this.getPersistedItem().getDisplayName() && !!principal.getDisplayName()) {
                        _this.notifyPrincipalNamed(principal);
                    }
                    _this.userEmailWizardStepForm.layout(principal);
                    api.notify.showFeedback('User was updated!');
                    new api.security.UserItemUpdatedEvent(principal, _this.getUserStore()).fire();
                    return principal;
                });
            };
            UserWizardPanel.prototype.produceUpdateUserRequest = function (viewedPrincipal) {
                var user = viewedPrincipal.asUser(), key = user.getKey(), displayName = user.getDisplayName(), email = user.getEmail(), login = user.getLogin(), oldMemberships = this.getPersistedItem().asUser().getMemberships().map(function (el) {
                    return el.getKey();
                }), oldMembershipsIds = oldMemberships.map(function (el) {
                    return el.getId();
                }), newMemberships = user.getMemberships().map(function (el) {
                    return el.getKey();
                }), newMembershipsIds = newMemberships.map(function (el) {
                    return el.getId();
                }), addMemberships = newMemberships.filter(function (el) {
                    return oldMembershipsIds.indexOf(el.getId()) < 0;
                }), removeMemberships = oldMemberships.filter(function (el) {
                    return newMembershipsIds.indexOf(el.getId()) < 0;
                });
                return new UpdateUserRequest().
                    setKey(key).
                    setDisplayName(displayName).
                    setEmail(email).
                    setLogin(login).
                    addMemberships(addMemberships).
                    removeMemberships(removeMemberships);
            };
            UserWizardPanel.prototype.assembleViewedItem = function () {
                return new UserBuilder(!!this.getPersistedItem() ? this.getPersistedItem().asUser() : null).
                    setEmail(this.userEmailWizardStepForm.getEmail()).
                    setLogin(this.wizardHeader.getName()).setMemberships(this.userMembershipsWizardStepForm.getMemberships()).setDisplayName(this.wizardHeader.getDisplayName()).
                    build();
            };
            UserWizardPanel.prototype.isPersistedEqualsViewed = function () {
                var persistedPrincipal = this.getPersistedItem().asUser();
                var viewedPrincipal = this.assembleViewedItem().asUser();
                viewedPrincipal.getMemberships().sort(function (a, b) {
                    return a.getKey().getId().localeCompare(b.getKey().getId());
                });
                persistedPrincipal.getMemberships().sort(function (a, b) {
                    return a.getKey().getId().localeCompare(b.getKey().getId());
                });
                var viewedMembershipsKeys = viewedPrincipal.getMemberships().map(function (el) {
                    return el.getKey();
                }), persistedMembershipsKeys = persistedPrincipal.getMemberships().map(function (el) {
                    return el.getKey();
                });
                if (api.ObjectHelper.arrayEquals(viewedMembershipsKeys, persistedMembershipsKeys)) {
                    viewedPrincipal.setMemberships(persistedPrincipal.getMemberships());
                }
                return viewedPrincipal.equals(persistedPrincipal);
            };
            UserWizardPanel.prototype.hasUnsavedChanges = function () {
                var persistedPrincipal = this.getPersistedItem(), email = this.userEmailWizardStepForm.getEmail(), memberships = this.userMembershipsWizardStepForm.getMemberships();
                if (persistedPrincipal == undefined) {
                    return this.wizardHeader.getName() !== "" ||
                        this.wizardHeader.getDisplayName() !== "" ||
                        (!!email && email !== "") ||
                        (!!memberships && memberships.length !== 0);
                }
                else {
                    return !this.isPersistedEqualsViewed();
                }
            };
            UserWizardPanel.prototype.showErrors = function () {
                if (!this.userEmailWizardStepForm.isValid()) {
                    this.showEmailErrors();
                }
                if (!(this.getPersistedItem() || this.userPasswordWizardStepForm.isValid())) {
                    this.showPasswordErrors();
                }
            };
            UserWizardPanel.prototype.showEmailErrors = function () {
                var formEmail = this.userEmailWizardStepForm.getEmail();
                if (api.util.StringHelper.isEmpty(formEmail)) {
                    api.notify.showError("E-mail can not be empty.");
                }
                else if (!this.userEmailWizardStepForm.isValid()) {
                    api.notify.showError("E-mail is invalid.");
                }
            };
            UserWizardPanel.prototype.showPasswordErrors = function () {
                var password = this.userPasswordWizardStepForm.getPassword();
                if (api.util.StringHelper.isEmpty(password)) {
                    api.notify.showError("Password can not be empty.");
                }
                else if (!this.userEmailWizardStepForm.isValid()) {
                    api.notify.showError("Password is invalid.");
                }
            };
            return UserWizardPanel;
        })(wizard_3.PrincipalWizardPanel);
        wizard_3.UserWizardPanel = UserWizardPanel;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_4) {
        var ConfirmationDialog = api.ui.dialog.ConfirmationDialog;
        var GroupRoleWizardPanel = (function (_super) {
            __extends(GroupRoleWizardPanel, _super);
            function GroupRoleWizardPanel(membersWizardStepForm, params, callback) {
                var _this = this;
                this.descriptionWizardStepForm = new wizard_4.PrincipalDescriptionWizardStepForm();
                this.membersWizardStepForm = membersWizardStepForm;
                _super.call(this, params, function () {
                    _this.addClass("group-role-wizard-panel");
                    callback(_this);
                });
            }
            GroupRoleWizardPanel.prototype.getDescriptionWizardStepForm = function () {
                return this.descriptionWizardStepForm;
            };
            GroupRoleWizardPanel.prototype.getMembersWizardStepForm = function () {
                return this.membersWizardStepForm;
            };
            GroupRoleWizardPanel.prototype.giveInitialFocus = function () {
                this.wizardHeader.giveFocus();
                this.startRememberFocus();
            };
            GroupRoleWizardPanel.prototype.preLayoutNew = function () {
                var deferred = wemQ.defer();
                this.doLayoutPersistedItem(null);
                deferred.resolve(null);
                return deferred.promise;
            };
            GroupRoleWizardPanel.prototype.postLayoutNew = function () {
                var deferred = wemQ.defer();
                this.wizardHeader.initNames("", "", false);
                deferred.resolve(null);
                return deferred.promise;
            };
            GroupRoleWizardPanel.prototype.layoutPersistedItem = function (persistedPrincipal) {
                var _this = this;
                if (!this.constructing) {
                    var deferred = wemQ.defer();
                    var viewedPrincipal = this.assembleViewedItem();
                    if (!this.isPersistedEqualsViewed()) {
                        console.warn("Received Principal from server differs from what's viewed:");
                        console.warn(" viewedPrincipal: ", viewedPrincipal);
                        console.warn(" persistedPrincipal: ", persistedPrincipal);
                        ConfirmationDialog.get().
                            setQuestion("Received Principal from server differs from what you have. Would you like to load changes from server?").
                            setYesCallback(function () { return _this.doLayoutPersistedItem(persistedPrincipal.clone()); }).
                            setNoCallback(function () {
                        }).
                            show();
                    }
                    deferred.resolve(null);
                    return deferred.promise;
                }
                else {
                    return this.doLayoutPersistedItem(persistedPrincipal.clone());
                }
            };
            GroupRoleWizardPanel.prototype.hasUnsavedChanges = function () {
                var persistedPrincipal = this.getPersistedItem();
                if (persistedPrincipal == undefined) {
                    return this.wizardHeader.getName() !== "" ||
                        this.wizardHeader.getDisplayName() !== "" ||
                        this.membersWizardStepForm.getMembers().length !== 0;
                }
                else {
                    return !this.isPersistedEqualsViewed();
                }
            };
            GroupRoleWizardPanel.prototype.isPersistedEqualsViewed = function () {
                throw new Error("Must be implemented by inheritors");
            };
            GroupRoleWizardPanel.prototype.show = function () {
                var _this = this;
                setTimeout(function () {
                    _super.prototype.show.call(_this);
                }, 0);
            };
            return GroupRoleWizardPanel;
        })(wizard_4.PrincipalWizardPanel);
        wizard_4.GroupRoleWizardPanel = GroupRoleWizardPanel;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_5) {
        var RoleBuilder = api.security.RoleBuilder;
        var CreateRoleRequest = api.security.CreateRoleRequest;
        var UpdateRoleRequest = api.security.UpdateRoleRequest;
        var PrincipalKey = api.security.PrincipalKey;
        var RoleKeys = api.security.RoleKeys;
        var WizardStep = api.app.wizard.WizardStep;
        var RoleWizardPanel = (function (_super) {
            __extends(RoleWizardPanel, _super);
            function RoleWizardPanel(params, callback) {
                var _this = this;
                _super.call(this, new wizard_5.RoleMembersWizardStepForm(), params, function () {
                    _this.addClass("role-wizard-panel");
                    callback(_this);
                });
            }
            RoleWizardPanel.prototype.createSteps = function (principal) {
                var deferred = wemQ.defer();
                var steps = [];
                steps.push(new WizardStep("Role", this.getDescriptionWizardStepForm()));
                var principalKey = principal ? principal.getKey() : undefined;
                if (!RoleKeys.EVERYONE.equals(principalKey)) {
                    steps.push(new WizardStep("Grants", this.getMembersWizardStepForm()));
                }
                this.setSteps(steps);
                deferred.resolve(steps);
                return deferred.promise;
            };
            RoleWizardPanel.prototype.doLayoutPersistedItem = function (principal) {
                var _this = this;
                var parallelPromises = [
                    this.createSteps(principal)
                ];
                return wemQ.all(parallelPromises).spread(function () {
                    _this.wizardHeader.setDisplayName(principal.getDisplayName());
                    _this.getDescriptionWizardStepForm().layout(principal);
                    _this.getMembersWizardStepForm().layout(principal);
                    return wemQ(null);
                });
            };
            RoleWizardPanel.prototype.persistNewItem = function () {
                var _this = this;
                return this.produceCreateRoleRequest().sendAndParse().
                    then(function (principal) {
                    _this.getPrincipalWizardHeader().disableNameInput();
                    _this.wizardHeader.setAutoGenerationEnabled(false);
                    api.notify.showFeedback('Role was created!');
                    new api.security.UserItemCreatedEvent(principal, _this.getUserStore(), _this.isParentOfSameType()).fire();
                    _this.notifyPrincipalNamed(principal);
                    return principal;
                });
            };
            RoleWizardPanel.prototype.produceCreateRoleRequest = function () {
                var key = PrincipalKey.ofRole(this.wizardHeader.getName()), name = this.wizardHeader.getDisplayName(), members = this.getMembersWizardStepForm().getMembers().map(function (el) {
                    return el.getKey();
                }), description = this.getDescriptionWizardStepForm().getDescription();
                return new CreateRoleRequest().setKey(key).setDisplayName(name).setMembers(members).setDescription(description);
            };
            RoleWizardPanel.prototype.updatePersistedItem = function () {
                var _this = this;
                return this.produceUpdateRoleRequest(this.assembleViewedItem()).
                    sendAndParse().
                    then(function (principal) {
                    if (!_this.getPersistedItem().getDisplayName() && !!principal.getDisplayName()) {
                        _this.notifyPrincipalNamed(principal);
                    }
                    api.notify.showFeedback('Role was updated!');
                    new api.security.UserItemUpdatedEvent(principal, _this.getUserStore()).fire();
                    return principal;
                });
            };
            RoleWizardPanel.prototype.produceUpdateRoleRequest = function (viewedPrincipal) {
                var role = viewedPrincipal.asRole(), key = role.getKey(), displayName = role.getDisplayName(), description = role.getDescription(), oldMembers = this.getPersistedItem().asRole().getMembers(), oldMembersIds = oldMembers.map(function (el) {
                    return el.getId();
                }), newMembers = role.getMembers(), newMembersIds = newMembers.map(function (el) {
                    return el.getId();
                }), addMembers = newMembers.filter(function (el) {
                    return oldMembersIds.indexOf(el.getId()) < 0;
                }), removeMembers = oldMembers.filter(function (el) {
                    return newMembersIds.indexOf(el.getId()) < 0;
                });
                return new UpdateRoleRequest().
                    setKey(key).
                    setDisplayName(displayName).addMembers(addMembers).removeMembers(removeMembers).setDescription(description);
            };
            RoleWizardPanel.prototype.assembleViewedItem = function () {
                return new RoleBuilder(this.getPersistedItem().asRole()).
                    setMembers(this.getMembersWizardStepForm().getMembers().map(function (el) {
                    return el.getKey();
                })).setDisplayName(this.wizardHeader.getDisplayName()).setDescription(this.getDescriptionWizardStepForm().getDescription()).
                    build();
            };
            RoleWizardPanel.prototype.isPersistedEqualsViewed = function () {
                var persistedPrincipal = this.getPersistedItem().asRole();
                var viewedPrincipal = this.assembleViewedItem().asRole();
                viewedPrincipal.getMembers().sort(function (a, b) {
                    return a.getId().localeCompare(b.getId());
                });
                persistedPrincipal.getMembers().sort(function (a, b) {
                    return a.getId().localeCompare(b.getId());
                });
                return viewedPrincipal.equals(persistedPrincipal);
            };
            return RoleWizardPanel;
        })(wizard_5.GroupRoleWizardPanel);
        wizard_5.RoleWizardPanel = RoleWizardPanel;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_6) {
        var GroupBuilder = api.security.GroupBuilder;
        var CreateGroupRequest = api.security.CreateGroupRequest;
        var UpdateGroupRequest = api.security.UpdateGroupRequest;
        var PrincipalKey = api.security.PrincipalKey;
        var WizardStep = api.app.wizard.WizardStep;
        var GroupWizardPanel = (function (_super) {
            __extends(GroupWizardPanel, _super);
            function GroupWizardPanel(params, callback) {
                var _this = this;
                _super.call(this, new wizard_6.GroupMembersWizardStepForm(), params, function () {
                    _this.addClass("group-wizard-panel");
                    callback(_this);
                });
            }
            GroupWizardPanel.prototype.createSteps = function (principal) {
                var deferred = wemQ.defer();
                var steps = [];
                steps.push(new WizardStep("Group", this.getDescriptionWizardStepForm()));
                steps.push(new WizardStep("Grants", this.getMembersWizardStepForm()));
                this.setSteps(steps);
                deferred.resolve(steps);
                return deferred.promise;
            };
            GroupWizardPanel.prototype.doLayoutPersistedItem = function (principal) {
                var _this = this;
                var parallelPromises = [
                    this.createSteps()
                ];
                return wemQ.all(parallelPromises).spread(function () {
                    _this.wizardHeader.setDisplayName(principal.getDisplayName());
                    _this.getDescriptionWizardStepForm().layout(principal);
                    _this.getMembersWizardStepForm().layout(principal);
                    return wemQ(null);
                });
            };
            GroupWizardPanel.prototype.persistNewItem = function () {
                var _this = this;
                return this.produceCreateGroupRequest().sendAndParse().
                    then(function (principal) {
                    _this.getPrincipalWizardHeader().disableNameInput();
                    _this.wizardHeader.setAutoGenerationEnabled(false);
                    api.notify.showFeedback('Group was created!');
                    new api.security.UserItemCreatedEvent(principal, _this.getUserStore(), _this.isParentOfSameType()).fire();
                    _this.notifyPrincipalNamed(principal);
                    _this.getMembersWizardStepForm().getLoader().skipPrincipal(principal.getKey());
                    return principal;
                });
            };
            GroupWizardPanel.prototype.produceCreateGroupRequest = function () {
                var key = PrincipalKey.ofGroup(this.getUserStoreKey(), this.wizardHeader.getName()), name = this.wizardHeader.getDisplayName(), members = this.getMembersWizardStepForm().getMembers().map(function (el) {
                    return el.getKey();
                }), description = this.getDescriptionWizardStepForm().getDescription();
                return new CreateGroupRequest().setKey(key).setDisplayName(name).setMembers(members).setDescription(description);
            };
            GroupWizardPanel.prototype.updatePersistedItem = function () {
                var _this = this;
                return this.produceUpdateGroupRequest(this.assembleViewedItem()).
                    sendAndParse().
                    then(function (principal) {
                    if (!_this.getPersistedItem().getDisplayName() && !!principal.getDisplayName()) {
                        _this.notifyPrincipalNamed(principal);
                    }
                    api.notify.showFeedback('Group was updated!');
                    new api.security.UserItemUpdatedEvent(principal, _this.getUserStore()).fire();
                    return principal;
                });
            };
            GroupWizardPanel.prototype.produceUpdateGroupRequest = function (viewedPrincipal) {
                var group = viewedPrincipal.asGroup(), key = group.getKey(), displayName = group.getDisplayName(), description = group.getDescription(), oldMembers = this.getPersistedItem().asGroup().getMembers(), oldMembersIds = oldMembers.map(function (el) {
                    return el.getId();
                }), newMembers = group.getMembers(), newMembersIds = newMembers.map(function (el) {
                    return el.getId();
                }), addMembers = newMembers.filter(function (el) {
                    return oldMembersIds.indexOf(el.getId()) < 0;
                }), removeMembers = oldMembers.filter(function (el) {
                    return newMembersIds.indexOf(el.getId()) < 0;
                });
                return new UpdateGroupRequest().
                    setKey(key).
                    setDisplayName(displayName).addMembers(addMembers).removeMembers(removeMembers).setDescription(description);
            };
            GroupWizardPanel.prototype.assembleViewedItem = function () {
                return new GroupBuilder(this.getPersistedItem().asGroup()).
                    setMembers(this.getMembersWizardStepForm().getMembers().map(function (el) {
                    return el.getKey();
                })).setDisplayName(this.wizardHeader.getDisplayName()).setDescription(this.getDescriptionWizardStepForm().getDescription()).
                    build();
            };
            GroupWizardPanel.prototype.isPersistedEqualsViewed = function () {
                var persistedPrincipal = this.getPersistedItem().asGroup();
                var viewedPrincipal = this.assembleViewedItem().asGroup();
                viewedPrincipal.getMembers().sort(function (a, b) {
                    return a.getId().localeCompare(b.getId());
                });
                persistedPrincipal.getMembers().sort(function (a, b) {
                    return a.getId().localeCompare(b.getId());
                });
                return viewedPrincipal.equals(persistedPrincipal);
            };
            return GroupWizardPanel;
        })(wizard_6.GroupRoleWizardPanel);
        wizard_6.GroupWizardPanel = GroupWizardPanel;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_7) {
        var UserStoreKey = api.security.UserStoreKey;
        var UserStoreNamedEvent = api.security.UserStoreNamedEvent;
        var CreateUserStoreRequest = api.security.CreateUserStoreRequest;
        var UpdateUserStoreRequest = api.security.UpdateUserStoreRequest;
        var UserStoreBuilder = api.security.UserStoreBuilder;
        var ResponsiveManager = api.ui.responsive.ResponsiveManager;
        var WizardStep = api.app.wizard.WizardStep;
        var FormIcon = api.app.wizard.FormIcon;
        var WizardHeaderWithDisplayNameAndNameBuilder = api.app.wizard.WizardHeaderWithDisplayNameAndNameBuilder;
        var UserStoreWizardPanel = (function (_super) {
            __extends(UserStoreWizardPanel, _super);
            function UserStoreWizardPanel(params, callback) {
                var _this = this;
                this.descriptionWizardStepForm = new wizard_7.PrincipalDescriptionWizardStepForm();
                this.permissionsWizardStepForm = new wizard_7.SecurityWizardStepForm();
                this.constructing = true;
                this.isUserStoreFormValid = false;
                this.userStoreNamedListeners = [];
                this.userStorePath = params.persistedPath;
                this.defaultUserStore = params.defaultUserStore;
                if (params.userStore) {
                    this.persistedUserStoreKey = params.userStore.getKey();
                }
                var iconUrl = api.dom.ImgEl.PLACEHOLDER;
                this.formIcon = new FormIcon(iconUrl, "Click to upload icon");
                this.formIcon.addClass("icon icon-xlarge");
                this.formIcon.addClass("icon-shield");
                this.wizardActions = new app.wizard.action.UserStoreWizardActions(this);
                this.toolbar = new wizard_7.UserStoreWizardToolbar({
                    saveAction: this.wizardActions.getSaveAction(),
                    deleteAction: this.wizardActions.getDeleteAction()
                });
                this.wizardHeader = new WizardHeaderWithDisplayNameAndNameBuilder().build();
                this.wizardHeader.setPath(this.userStorePath);
                if (params.userStore) {
                    this.wizardHeader.disableNameInput();
                    this.wizardHeader.setAutoGenerationEnabled(false);
                }
                else {
                    this.getUserStoreWizardHeader().onPropertyChanged(function (event) {
                        var updateStatus = event.getPropertyName() === "name" ||
                            (_this.getUserStoreWizardHeader().isAutoGenerationEnabled() && event.getPropertyName() === "displayName");
                        if (updateStatus) {
                            _this.wizardActions.getSaveAction().setEnabled(!!event.getNewValue());
                        }
                    });
                }
                _super.call(this, params, function () {
                    _this.addClass("principal-wizard-panel");
                    var responsiveItem = ResponsiveManager.onAvailableSizeChanged(_this, function (item) {
                        if (_this.isVisible()) {
                            _this.updateStickyToolbar();
                        }
                    });
                    _this.onRemoved(function (event) {
                        ResponsiveManager.unAvailableSizeChanged(_this);
                    });
                    _this.onShown(function (event) {
                        if (_this.getPersistedItem()) {
                            app.Router.setHash("edit/" + _this.getPersistedItem().getKey());
                        }
                        else {
                            app.Router.setHash("new/");
                        }
                        responsiveItem.update();
                    });
                    _this.constructing = false;
                    callback(_this);
                });
                this.formIcon.addClass("icon-address-book");
            }
            UserStoreWizardPanel.prototype.getUserItemType = function () {
                return "User Store";
            };
            UserStoreWizardPanel.prototype.getUserStoreWizardHeader = function () {
                return this.wizardHeader;
            };
            UserStoreWizardPanel.prototype.giveInitialFocus = function () {
                this.wizardHeader.giveFocus();
                this.startRememberFocus();
            };
            UserStoreWizardPanel.prototype.saveChanges = function () {
                if (!this.wizardHeader.getName()) {
                    var deferred = wemQ.defer();
                    api.notify.showError("Name can not be empty");
                    deferred.reject(new Error("Name can not be empty"));
                    return deferred.promise;
                }
                else {
                    return _super.prototype.saveChanges.call(this);
                }
            };
            UserStoreWizardPanel.prototype.createSteps = function () {
                var deferred = wemQ.defer();
                var steps = [];
                steps.push(new WizardStep("UserStore", this.descriptionWizardStepForm));
                steps.push(new WizardStep("Permissions", this.permissionsWizardStepForm));
                this.setSteps(steps);
                deferred.resolve(steps);
                return deferred.promise;
            };
            UserStoreWizardPanel.prototype.preLayoutNew = function () {
                var deferred = wemQ.defer();
                this.doLayoutPersistedItem(null);
                deferred.resolve(null);
                return deferred.promise;
            };
            UserStoreWizardPanel.prototype.postLayoutNew = function () {
                var deferred = wemQ.defer();
                this.wizardHeader.initNames("", this.userStorePath, false);
                this.permissionsWizardStepForm.layoutReadOnly(this.defaultUserStore);
                deferred.resolve(null);
                return deferred.promise;
            };
            UserStoreWizardPanel.prototype.layoutPersistedItem = function (persistedUserStore) {
                var viewedUserStore;
                if (!this.constructing) {
                    var deferred = wemQ.defer();
                    deferred.resolve(null);
                    return deferred.promise;
                }
                else {
                    return this.doLayoutPersistedItem(persistedUserStore.clone());
                }
            };
            UserStoreWizardPanel.prototype.doLayoutPersistedItem = function (userStore) {
                var parallelPromises = [
                    this.createSteps()
                ];
                return wemQ.all(parallelPromises).
                    spread(function () {
                });
            };
            UserStoreWizardPanel.prototype.postLayoutPersisted = function (existing) {
                var deferred = wemQ.defer();
                this.wizardHeader.initNames(existing.getDisplayName(), existing.getKey().getId(), false);
                this.permissionsWizardStepForm.layout(existing.clone(), this.defaultUserStore);
                deferred.resolve(null);
                return deferred.promise;
            };
            UserStoreWizardPanel.prototype.persistNewItem = function () {
                var _this = this;
                return this.produceCreateUserStoreRequest().sendAndParse().
                    then(function (userStore) {
                    _this.wizardHeader.disableNameInput();
                    _this.wizardHeader.setAutoGenerationEnabled(false);
                    api.notify.showFeedback('UserStore was created!');
                    new api.security.UserItemCreatedEvent(null, userStore).fire();
                    return userStore;
                });
            };
            UserStoreWizardPanel.prototype.postPersistNewItem = function (userStore) {
                app.Router.setHash("edit/" + userStore.getKey());
                var deferred = wemQ.defer();
                deferred.resolve(null);
                return deferred.promise;
            };
            UserStoreWizardPanel.prototype.updatePersistedItem = function () {
                var _this = this;
                return this.produceUpdateUserStoreRequest(this.assembleViewedUserStore()).
                    sendAndParse().
                    then(function (userStore) {
                    if (!_this.getPersistedItem().getDisplayName() && !!userStore.getDisplayName()) {
                        _this.notifyUserStoreNamed(userStore);
                    }
                    api.notify.showFeedback('UserStore was updated!');
                    new api.security.UserItemUpdatedEvent(null, userStore).fire();
                    return userStore;
                });
            };
            UserStoreWizardPanel.prototype.hasUnsavedChanges = function () {
                var persistedUserStore = this.getPersistedItem();
                if (persistedUserStore == undefined) {
                    return this.wizardHeader.getName() !== "" ||
                        this.wizardHeader.getDisplayName() !== "" ||
                        !this.permissionsWizardStepForm.getPermissions().equals(this.defaultUserStore.getPermissions());
                }
                else {
                    var viewedUserStore = this.assembleViewedUserStore();
                    return !this.getPersistedItem().equals(viewedUserStore);
                }
            };
            UserStoreWizardPanel.prototype.resolveUserStoreNameForUpdateRequest = function () {
                if (api.util.StringHelper.isEmpty(this.wizardHeader.getName())) {
                    return this.getPersistedItem().getDisplayName();
                }
                else {
                    return this.wizardHeader.getName();
                }
            };
            UserStoreWizardPanel.prototype.getPersistedItemKey = function () {
                return this.persistedUserStoreKey;
            };
            UserStoreWizardPanel.prototype.assembleViewedUserStore = function () {
                return new UserStoreBuilder().
                    setDisplayName(this.wizardHeader.getDisplayName()).
                    setKey(this.getPersistedItem().getKey().toString()).
                    setPermissions(this.permissionsWizardStepForm.getPermissions()).
                    build();
            };
            UserStoreWizardPanel.prototype.produceCreateUserStoreRequest = function () {
                var key = new UserStoreKey(this.wizardHeader.getName()), name = this.wizardHeader.getDisplayName(), permissions = this.permissionsWizardStepForm.getPermissions();
                return new CreateUserStoreRequest().
                    setDisplayName(name).
                    setKey(key).
                    setPermissions(permissions);
            };
            UserStoreWizardPanel.prototype.produceUpdateUserStoreRequest = function (viewedUserStore) {
                var key = this.getPersistedItem().getKey(), name = viewedUserStore.getDisplayName(), permissions = viewedUserStore.getPermissions();
                return new UpdateUserStoreRequest().
                    setKey(key).
                    setDisplayName(name).
                    setPermissions(permissions);
            };
            UserStoreWizardPanel.prototype.onUserStoreNamed = function (listener) {
                this.userStoreNamedListeners.push(listener);
            };
            UserStoreWizardPanel.prototype.notifyUserStoreNamed = function (userStore) {
                var _this = this;
                this.userStoreNamedListeners.forEach(function (listener) {
                    listener.call(_this, new UserStoreNamedEvent(_this, userStore));
                });
            };
            return UserStoreWizardPanel;
        })(wizard_7.UserItemWizardPanel);
        wizard_7.UserStoreWizardPanel = UserStoreWizardPanel;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_8) {
        var PrincipalType = api.security.PrincipalType;
        var PrincipalWizardPanelFactory = (function () {
            function PrincipalWizardPanelFactory() {
            }
            PrincipalWizardPanelFactory.prototype.setPrincipalToEdit = function (value) {
                this.principalKey = value;
                return this;
            };
            PrincipalWizardPanelFactory.prototype.setPrincipalType = function (value) {
                this.principalType = value;
                return this;
            };
            PrincipalWizardPanelFactory.prototype.setPrincipalPath = function (value) {
                this.principalPath = value;
                return this;
            };
            PrincipalWizardPanelFactory.prototype.setUserStore = function (value) {
                this.userStore = value;
                return this;
            };
            PrincipalWizardPanelFactory.prototype.setParentOfSameType = function (value) {
                this.parentOfSameType = value;
                return this;
            };
            PrincipalWizardPanelFactory.prototype.setAppBarTabId = function (value) {
                this.appBarTabId = value;
                return this;
            };
            PrincipalWizardPanelFactory.prototype.createForNew = function () {
                this.creatingForNew = true;
                return this.newPrincipalWizardPanelForNew();
            };
            PrincipalWizardPanelFactory.prototype.createForEdit = function () {
                var _this = this;
                this.creatingForNew = false;
                return this.loadPrincipalToEdit().then(function (loadedPrincipalToEdit) {
                    _this.principalToEdit = loadedPrincipalToEdit;
                    return _this.newPrincipalWizardPanelForEdit();
                });
            };
            PrincipalWizardPanelFactory.prototype.loadPrincipalToEdit = function () {
                return new api.security.GetPrincipalByKeyRequest(this.principalKey).sendAndParse();
            };
            PrincipalWizardPanelFactory.prototype.newPrincipalWizardPanelForNew = function () {
                var deferred = wemQ.defer();
                var wizardParams = new app.wizard.PrincipalWizardPanelParams().
                    setPrincipalType(this.principalType).
                    setPrincipalPath(this.principalPath).
                    setUserStore(this.userStore).
                    setParentOfSameType(this.parentOfSameType).
                    setAppBarTabId(this.appBarTabId);
                this.resolvePrincipalWizardPanel(deferred, wizardParams);
                return deferred.promise;
            };
            PrincipalWizardPanelFactory.prototype.newPrincipalWizardPanelForEdit = function () {
                var deferred = wemQ.defer();
                var wizardParams = new wizard_8.PrincipalWizardPanelParams().
                    setAppBarTabId(this.appBarTabId).
                    setPrincipalType(this.principalType).
                    setPrincipalPath(this.principalPath).
                    setUserStore(this.userStore).
                    setPersistedPrincipal(this.principalToEdit);
                this.resolvePrincipalWizardPanel(deferred, wizardParams);
                return deferred.promise;
            };
            PrincipalWizardPanelFactory.prototype.resolvePrincipalWizardPanel = function (deferred, wizardParams) {
                switch (wizardParams.persistedType) {
                    case PrincipalType.ROLE:
                        new wizard_8.RoleWizardPanel(wizardParams, function (wizard) {
                            deferred.resolve(wizard);
                        });
                        break;
                    case PrincipalType.USER:
                        new wizard_8.UserWizardPanel(wizardParams, function (wizard) {
                            deferred.resolve(wizard);
                        });
                        break;
                    case PrincipalType.GROUP:
                        new wizard_8.GroupWizardPanel(wizardParams, function (wizard) {
                            deferred.resolve(wizard);
                        });
                        break;
                    default:
                        new wizard_8.PrincipalWizardPanel(wizardParams, function (wizard) {
                            deferred.resolve(wizard);
                        });
                }
            };
            return PrincipalWizardPanelFactory;
        })();
        wizard_8.PrincipalWizardPanelFactory = PrincipalWizardPanelFactory;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_9) {
        var UserStoreWizardPanelFactory = (function () {
            function UserStoreWizardPanelFactory() {
            }
            UserStoreWizardPanelFactory.prototype.setUserStore = function (value) {
                this.userStore = value;
                return this;
            };
            UserStoreWizardPanelFactory.prototype.setUserStoreKey = function (value) {
                this.userStoreKey = value;
                return this;
            };
            UserStoreWizardPanelFactory.prototype.setAppBarTabId = function (value) {
                this.appBarTabId = value;
                return this;
            };
            UserStoreWizardPanelFactory.prototype.createForNew = function () {
                var _this = this;
                this.creatingForNew = true;
                return this.loadDefaultUserStore().then(function (defaultUserStore) {
                    _this.defaultUserStore = defaultUserStore;
                    return _this.newUserStoreWizardPanelForNew();
                });
            };
            UserStoreWizardPanelFactory.prototype.createForEdit = function () {
                var _this = this;
                this.creatingForNew = false;
                return this.loadUserStoreToEdit().then(function (loadedUserStoreToEdit) {
                    _this.userStoreToEdit = loadedUserStoreToEdit;
                    return _this.loadDefaultUserStore().then(function (defaultUserStore) {
                        _this.defaultUserStore = defaultUserStore;
                        return _this.newUserStoreWizardPanelForEdit();
                    });
                });
            };
            UserStoreWizardPanelFactory.prototype.loadUserStoreToEdit = function () {
                return new api.security.GetUserStoreByKeyRequest(this.userStoreKey).sendAndParse();
            };
            UserStoreWizardPanelFactory.prototype.loadDefaultUserStore = function () {
                return new api.security.GetDefaultUserStoreRequest().sendAndParse();
            };
            UserStoreWizardPanelFactory.prototype.newUserStoreWizardPanelForNew = function () {
                var deferred = wemQ.defer();
                var wizardParams = new app.wizard.UserStoreWizardPanelParams().
                    setUserStoreKey(this.userStoreKey).
                    setDefaultUserStore(this.defaultUserStore).
                    setAppBarTabId(this.appBarTabId);
                this.resolveUserStoreWizardPanel(deferred, wizardParams);
                return deferred.promise;
            };
            UserStoreWizardPanelFactory.prototype.newUserStoreWizardPanelForEdit = function () {
                var deferred = wemQ.defer();
                var wizardParams = new wizard_9.UserStoreWizardPanelParams().
                    setUserStoreKey(this.userStoreKey).
                    setUserStore(this.userStoreToEdit).
                    setDefaultUserStore(this.defaultUserStore).
                    setAppBarTabId(this.appBarTabId);
                this.resolveUserStoreWizardPanel(deferred, wizardParams);
                return deferred.promise;
            };
            UserStoreWizardPanelFactory.prototype.resolveUserStoreWizardPanel = function (deferred, wizardParams) {
                new wizard_9.UserStoreWizardPanel(wizardParams, function (wizard) {
                    deferred.resolve(wizard);
                });
            };
            return UserStoreWizardPanelFactory;
        })();
        wizard_9.UserStoreWizardPanelFactory = UserStoreWizardPanelFactory;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var PrincipalWizardPanelParams = (function (_super) {
            __extends(PrincipalWizardPanelParams, _super);
            function PrincipalWizardPanelParams() {
                _super.apply(this, arguments);
            }
            PrincipalWizardPanelParams.prototype.setPersistedPrincipal = function (value) {
                this.persistedPrincipal = value;
                return this;
            };
            PrincipalWizardPanelParams.prototype.setPrincipalType = function (value) {
                this.persistedType = value;
                return this;
            };
            PrincipalWizardPanelParams.prototype.setPrincipalPath = function (value) {
                this.persistedPath = value;
                return this;
            };
            PrincipalWizardPanelParams.prototype.setAppBarTabId = function (value) {
                this.tabId = value;
                return this;
            };
            PrincipalWizardPanelParams.prototype.setUserStore = function (value) {
                this.userStore = value;
                return this;
            };
            PrincipalWizardPanelParams.prototype.setParentOfSameType = function (value) {
                this.parentOfSameType = value;
                return this;
            };
            PrincipalWizardPanelParams.prototype.getPersistedItem = function () {
                return this.persistedPrincipal;
            };
            return PrincipalWizardPanelParams;
        })(wizard.UserItemWizardPanelParams);
        wizard.PrincipalWizardPanelParams = PrincipalWizardPanelParams;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var UserStoreWizardPanelParams = (function (_super) {
            __extends(UserStoreWizardPanelParams, _super);
            function UserStoreWizardPanelParams() {
                _super.apply(this, arguments);
            }
            UserStoreWizardPanelParams.prototype.setUserStore = function (value) {
                this.userStore = value;
                return this;
            };
            UserStoreWizardPanelParams.prototype.setDefaultUserStore = function (value) {
                this.defaultUserStore = value;
                return this;
            };
            UserStoreWizardPanelParams.prototype.setAppBarTabId = function (value) {
                this.tabId = value;
                return this;
            };
            UserStoreWizardPanelParams.prototype.setUserStoreKey = function (value) {
                this.userStoreKey = value;
                return this;
            };
            UserStoreWizardPanelParams.prototype.setPersistedPath = function (value) {
                this.persistedPath = value;
                return this;
            };
            UserStoreWizardPanelParams.prototype.getPersistedItem = function () {
                return this.userStore;
            };
            return UserStoreWizardPanelParams;
        })(wizard.UserItemWizardPanelParams);
        wizard.UserStoreWizardPanelParams = UserStoreWizardPanelParams;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var PrincipalWizardToolbar = (function (_super) {
            __extends(PrincipalWizardToolbar, _super);
            function PrincipalWizardToolbar(params) {
                _super.call(this);
                _super.prototype.addAction.call(this, params.saveAction);
                _super.prototype.addAction.call(this, params.deleteAction);
                _super.prototype.addGreedySpacer.call(this);
            }
            return PrincipalWizardToolbar;
        })(api.ui.toolbar.Toolbar);
        wizard.PrincipalWizardToolbar = PrincipalWizardToolbar;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var UserStoreWizardToolbar = (function (_super) {
            __extends(UserStoreWizardToolbar, _super);
            function UserStoreWizardToolbar(params) {
                _super.call(this);
                _super.prototype.addAction.call(this, params.saveAction);
                _super.prototype.addAction.call(this, params.deleteAction);
            }
            return UserStoreWizardToolbar;
        })(api.ui.toolbar.Toolbar);
        wizard.UserStoreWizardToolbar = UserStoreWizardToolbar;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var PrincipalDescriptionWizardStepForm = (function (_super) {
            __extends(PrincipalDescriptionWizardStepForm, _super);
            function PrincipalDescriptionWizardStepForm() {
                var _this = this;
                _super.call(this);
                this.description = new api.ui.text.TextInput("middle");
                this.description.onFocus(function (event) {
                    _this.notifyFocused(event);
                });
                this.description.onBlur(function (event) {
                    _this.notifyBlurred(event);
                });
                var formView = new api.dom.DivEl("form-view"), inputView = new api.dom.DivEl("input-view valid"), label = new api.dom.LabelEl("Description", this.description, "input-label"), inputTypeView = new api.dom.DivEl("input-type-view"), inputOccurrenceView = new api.dom.DivEl("input-occurrence-view single-occurrence"), inputWrapper = new api.dom.DivEl("input-wrapper");
                inputWrapper.appendChild(this.description);
                inputOccurrenceView.appendChild(inputWrapper);
                inputTypeView.appendChild(inputOccurrenceView);
                inputView.appendChild(label);
                inputView.appendChild(inputTypeView);
                formView.appendChild(inputView);
                this.appendChild(formView);
            }
            PrincipalDescriptionWizardStepForm.prototype.layout = function (principal) {
                if (api.ObjectHelper.iFrameSafeInstanceOf(principal, api.security.Role)
                    || api.ObjectHelper.iFrameSafeInstanceOf(principal, api.security.Group)) {
                    var description = principal.getDescription();
                    this.description.setValue(!!description ? description : "");
                }
                else {
                    this.description.setValue("");
                }
            };
            PrincipalDescriptionWizardStepForm.prototype.giveFocus = function () {
                return this.description.giveFocus();
            };
            PrincipalDescriptionWizardStepForm.prototype.getDescription = function () {
                return this.description.getValue();
            };
            return PrincipalDescriptionWizardStepForm;
        })(api.app.wizard.WizardStepForm);
        wizard.PrincipalDescriptionWizardStepForm = PrincipalDescriptionWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var PrincipalKey = api.security.PrincipalKey;
        var PrincipalType = api.security.PrincipalType;
        var PrincipalLoader = api.security.PrincipalLoader;
        var FormItemBuilder = api.ui.form.FormItemBuilder;
        var PrincipalComboBox = api.ui.security.PrincipalComboBox;
        var PrincipalMembersWizardStepForm = (function (_super) {
            __extends(PrincipalMembersWizardStepForm, _super);
            function PrincipalMembersWizardStepForm(loadedHandler) {
                var _this = this;
                _super.call(this);
                loadedHandler = loadedHandler || (function () {
                });
                this.loader = new PrincipalLoader().setAllowedTypes([PrincipalType.GROUP, PrincipalType.USER]).
                    skipPrincipals([PrincipalKey.ofAnonymous()]);
                this.principals = new PrincipalComboBox(this.loader);
                var handler = function () {
                    _this.selectMembers();
                    loadedHandler();
                    _this.principals.unLoaded(handler);
                };
                this.principals.onLoaded(handler);
                var principalsFormItem = new FormItemBuilder(this.principals).
                    setLabel('Members').
                    build();
                var fieldSet = new api.ui.form.Fieldset();
                fieldSet.add(principalsFormItem);
                var form = new api.ui.form.Form().add(fieldSet);
                form.onFocus(function (event) {
                    _this.notifyFocused(event);
                });
                form.onBlur(function (event) {
                    _this.notifyBlurred(event);
                });
                this.appendChild(form);
            }
            PrincipalMembersWizardStepForm.prototype.layout = function (principal) {
                this.principal = principal;
                this.loader.skipPrincipal(principal.getKey());
                this.selectMembers();
            };
            PrincipalMembersWizardStepForm.prototype.selectMembers = function () {
                var _this = this;
                if (!!this.principal) {
                    var principalKeys = this.getPrincipalMembers().map(function (key) {
                        return key.getId();
                    });
                    var selected = this.principals.getDisplayValues().filter(function (principal) {
                        return principalKeys.indexOf(principal.getKey().getId()) >= 0;
                    });
                    selected.forEach(function (selection) {
                        _this.principals.select(selection);
                    });
                }
            };
            PrincipalMembersWizardStepForm.prototype.getMembers = function () {
                return this.principals.getSelectedDisplayValues();
            };
            PrincipalMembersWizardStepForm.prototype.getPrincipals = function () {
                return this.principals;
            };
            PrincipalMembersWizardStepForm.prototype.getPrincipal = function () {
                return this.principal;
            };
            PrincipalMembersWizardStepForm.prototype.getPrincipalMembers = function () {
                throw new Error("Must be implemented by inheritors");
            };
            PrincipalMembersWizardStepForm.prototype.giveFocus = function () {
                return this.principals.giveFocus();
            };
            PrincipalMembersWizardStepForm.prototype.getLoader = function () {
                return this.loader;
            };
            return PrincipalMembersWizardStepForm;
        })(api.app.wizard.WizardStepForm);
        wizard.PrincipalMembersWizardStepForm = PrincipalMembersWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var EmailInput = api.ui.text.EmailInput;
        var FormItemBuilder = api.ui.form.FormItemBuilder;
        var Validators = api.ui.form.Validators;
        var UserEmailWizardStepForm = (function (_super) {
            __extends(UserEmailWizardStepForm, _super);
            function UserEmailWizardStepForm(userStoreKey) {
                var _this = this;
                _super.call(this);
                this.userStoreKey = userStoreKey;
                this.email = new EmailInput();
                this.email.setUserStoreKey(this.userStoreKey);
                var emailFormItem = new FormItemBuilder(this.email).
                    setLabel('Email').
                    setValidator(Validators.required).
                    build();
                var fieldSet = new api.ui.form.Fieldset();
                fieldSet.add(emailFormItem);
                var form = new api.ui.form.Form().add(fieldSet);
                form.onFocus(function (event) {
                    _this.notifyFocused(event);
                });
                form.onBlur(function (event) {
                    _this.notifyBlurred(event);
                });
                form.onValidityChanged(function (event) {
                    _this.notifyValidityChanged(new api.app.wizard.WizardStepValidityChangedEvent(event.isValid()));
                });
                this.appendChild(form);
            }
            UserEmailWizardStepForm.prototype.layout = function (principal) {
                this.email.setValue(principal.asUser().getEmail());
                this.email.setName(principal.asUser().getEmail());
                this.email.setOriginEmail(principal.asUser().getEmail());
            };
            UserEmailWizardStepForm.prototype.isValid = function () {
                return this.email.isValid();
            };
            UserEmailWizardStepForm.prototype.getEmail = function () {
                return this.email.getValue();
            };
            UserEmailWizardStepForm.prototype.giveFocus = function () {
                return this.email.giveFocus();
            };
            return UserEmailWizardStepForm;
        })(api.app.wizard.WizardStepForm);
        wizard.UserEmailWizardStepForm = UserEmailWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var PasswordGenerator = api.ui.text.PasswordGenerator;
        var FormItemBuilder = api.ui.form.FormItemBuilder;
        var Validators = api.ui.form.Validators;
        var Fieldset = api.ui.form.Fieldset;
        var Button = api.ui.button.Button;
        var UserPasswordWizardStepForm = (function (_super) {
            __extends(UserPasswordWizardStepForm, _super);
            function UserPasswordWizardStepForm() {
                var _this = this;
                _super.call(this);
                this.password = new PasswordGenerator();
                this.changePasswordButton = new Button("Change Password");
                this.changePasswordButton.addClass("change-password-button");
                this.createPasswordFormItem = new FormItemBuilder(this.password).
                    setLabel('Password').
                    setValidator(Validators.required).
                    build();
                this.updatePasswordFormItem = new FormItemBuilder(this.changePasswordButton).
                    setLabel('Password').
                    build();
                this.fieldSet = new Fieldset();
                this.fieldSet.add(this.createPasswordFormItem);
                this.fieldSet.add(this.updatePasswordFormItem);
                var passwordForm = new api.ui.form.Form().add(this.fieldSet);
                passwordForm.onValidityChanged(function (event) {
                    _this.notifyValidityChanged(new api.app.wizard.WizardStepValidityChangedEvent(event.isValid()));
                });
                this.changePasswordButton.onClicked(function () {
                    new wizard.OpenChangePasswordDialogEvent(_this.principal).fire();
                });
                this.updatePasswordFormItem.setVisible(false);
                this.appendChild(passwordForm);
            }
            UserPasswordWizardStepForm.prototype.layout = function (principal) {
                this.updatePrincipal(principal);
            };
            UserPasswordWizardStepForm.prototype.updatePrincipal = function (principal) {
                this.principal = principal;
                if (principal) {
                    this.fieldSet.removeItem(this.createPasswordFormItem);
                    this.updatePasswordFormItem.setVisible(true);
                }
            };
            UserPasswordWizardStepForm.prototype.isValid = function () {
                return !!this.principal || !!this.password.getValue();
            };
            UserPasswordWizardStepForm.prototype.getPassword = function () {
                return this.password.getValue();
            };
            UserPasswordWizardStepForm.prototype.giveFocus = function () {
                return this.password.giveFocus();
            };
            return UserPasswordWizardStepForm;
        })(api.app.wizard.WizardStepForm);
        wizard.UserPasswordWizardStepForm = UserPasswordWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var Principal = api.security.Principal;
        var PrincipalType = api.security.PrincipalType;
        var PrincipalLoader = api.security.PrincipalLoader;
        var RoleKeys = api.security.RoleKeys;
        var FormItemBuilder = api.ui.form.FormItemBuilder;
        var PrincipalComboBox = api.ui.security.PrincipalComboBox;
        var UserMembershipsWizardStepForm = (function (_super) {
            __extends(UserMembershipsWizardStepForm, _super);
            function UserMembershipsWizardStepForm() {
                var _this = this;
                _super.call(this, "user-memberships");
                this.groupsLoaded = false;
                this.rolesLoaded = false;
                var groupsLoader = new PrincipalLoader().setAllowedTypes([PrincipalType.GROUP]);
                var rolesLoader = new PrincipalLoader().setAllowedTypes([PrincipalType.ROLE]).
                    skipPrincipals([RoleKeys.EVERYONE]);
                this.groups = new PrincipalComboBox(groupsLoader);
                groupsLoader.load();
                this.roles = new PrincipalComboBox(rolesLoader);
                rolesLoader.load();
                var groupsHandler = function () { _this.groupsLoaded = true; _this.selectMembership(); _this.groups.unLoaded(groupsHandler); };
                var rolesHandler = function () { _this.rolesLoaded = true; _this.selectMembership(); _this.roles.unLoaded(rolesHandler); };
                this.groups.onLoaded(groupsHandler);
                this.roles.onLoaded(rolesHandler);
                var groupsFormItem = new FormItemBuilder(this.groups).
                    setLabel('Groups').
                    build();
                var rolesFormItem = new FormItemBuilder(this.roles).
                    setLabel('Roles').
                    build();
                var fieldSet = new api.ui.form.Fieldset();
                fieldSet.add(groupsFormItem);
                fieldSet.add(rolesFormItem);
                var form = new api.ui.form.Form().add(fieldSet);
                this.appendChild(form);
                form.onFocus(function (event) {
                    _this.notifyFocused(event);
                });
                form.onBlur(function (event) {
                    _this.notifyBlurred(event);
                });
                this.appendChild(form);
            }
            UserMembershipsWizardStepForm.prototype.layout = function (principal) {
                this.principal = principal;
                this.selectMembership();
            };
            UserMembershipsWizardStepForm.prototype.selectMembership = function () {
                var _this = this;
                if (!!this.principal && this.groupsLoaded && this.rolesLoaded) {
                    var groups = this.principal.asUser().getMemberships().
                        filter(function (el) { return el.isGroup(); }).
                        map(function (el) { return el.getKey().getId(); });
                    var roles = this.principal.asUser().getMemberships().
                        filter(function (el) { return el.isRole(); }).
                        map(function (el) { return el.getKey().getId(); });
                    this.groups.getDisplayValues().filter(function (principal) {
                        return groups.indexOf(principal.getKey().getId()) >= 0;
                    }).forEach(function (selection) {
                        _this.groups.select(selection);
                    });
                    this.roles.getDisplayValues().filter(function (principal) {
                        return roles.indexOf(principal.getKey().getId()) >= 0;
                    }).forEach(function (selection) {
                        _this.roles.select(selection);
                    });
                }
            };
            UserMembershipsWizardStepForm.prototype.getMemberships = function () {
                return this.groups.getSelectedDisplayValues().
                    concat(this.roles.getSelectedDisplayValues()).
                    map(function (el) { return Principal.fromPrincipal(el); });
            };
            UserMembershipsWizardStepForm.prototype.giveFocus = function () {
                return this.groups.giveFocus();
            };
            return UserMembershipsWizardStepForm;
        })(api.app.wizard.WizardStepForm);
        wizard.UserMembershipsWizardStepForm = UserMembershipsWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var RoleMembersWizardStepForm = (function (_super) {
            __extends(RoleMembersWizardStepForm, _super);
            function RoleMembersWizardStepForm() {
                _super.call(this);
                this.getLoader().load();
            }
            RoleMembersWizardStepForm.prototype.getPrincipalMembers = function () {
                return this.getPrincipal().asRole().getMembers();
            };
            return RoleMembersWizardStepForm;
        })(wizard.PrincipalMembersWizardStepForm);
        wizard.RoleMembersWizardStepForm = RoleMembersWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var GroupMembersWizardStepForm = (function (_super) {
            __extends(GroupMembersWizardStepForm, _super);
            function GroupMembersWizardStepForm() {
                _super.call(this);
                this.getLoader().load();
            }
            GroupMembersWizardStepForm.prototype.getPrincipalMembers = function () {
                return this.getPrincipal().asGroup().getMembers();
            };
            return GroupMembersWizardStepForm;
        })(wizard.PrincipalMembersWizardStepForm);
        wizard.GroupMembersWizardStepForm = GroupMembersWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var UserStoreAccessControlComboBox = api.ui.security.acl.UserStoreAccessControlComboBox;
        var FormItemBuilder = api.ui.form.FormItemBuilder;
        var Validators = api.ui.form.Validators;
        var DivEl = api.dom.DivEl;
        var SecurityWizardStepForm = (function (_super) {
            __extends(SecurityWizardStepForm, _super);
            function SecurityWizardStepForm() {
                var _this = this;
                _super.call(this, "security-wizard-step-form");
                this.inheritance = new DivEl();
                this.comboBox = new UserStoreAccessControlComboBox();
                this.comboBox.addClass('principal-combobox');
                var accessComboBoxFormItem = new FormItemBuilder(this.comboBox).
                    setValidator(Validators.required).
                    setLabel("Permissions").
                    build();
                var fieldSet = new api.ui.form.Fieldset();
                fieldSet.add(accessComboBoxFormItem);
                var form = new api.ui.form.Form().add(fieldSet);
                form.onFocus(function (event) {
                    _this.notifyFocused(event);
                });
                form.onBlur(function (event) {
                    _this.notifyBlurred(event);
                });
                this.appendChild(this.inheritance);
                this.appendChild(form);
            }
            SecurityWizardStepForm.prototype.layout = function (userStore, defaultUserStore) {
                var _this = this;
                this.userStore = userStore;
                this.comboBox.clearSelection();
                if (defaultUserStore) {
                    defaultUserStore.getPermissions().getEntries().forEach(function (item) {
                        _this.comboBox.select(item, true);
                    });
                }
                userStore.getPermissions().getEntries().forEach(function (item) {
                    if (!_this.comboBox.isSelected(item)) {
                        _this.comboBox.select(item);
                    }
                });
            };
            SecurityWizardStepForm.prototype.layoutReadOnly = function (userStore) {
                var _this = this;
                this.userStore = userStore;
                this.comboBox.clearSelection();
                userStore.getPermissions().getEntries().forEach(function (item) {
                    if (!_this.comboBox.isSelected(item)) {
                        _this.comboBox.select(item, true);
                    }
                });
            };
            SecurityWizardStepForm.prototype.giveFocus = function () {
                return this.comboBox.giveFocus();
            };
            SecurityWizardStepForm.prototype.getPermissions = function () {
                return new api.security.acl.UserStoreAccessControlList(this.comboBox.getSelectedDisplayValues());
            };
            return SecurityWizardStepForm;
        })(api.app.wizard.WizardStepForm);
        wizard.SecurityWizardStepForm = SecurityWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var OpenChangePasswordDialogEvent = (function (_super) {
            __extends(OpenChangePasswordDialogEvent, _super);
            function OpenChangePasswordDialogEvent(principal) {
                this.principal = principal;
                _super.call(this);
            }
            OpenChangePasswordDialogEvent.prototype.getPrincipal = function () {
                return this.principal;
            };
            OpenChangePasswordDialogEvent.on = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            OpenChangePasswordDialogEvent.un = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            return OpenChangePasswordDialogEvent;
        })(api.event.Event);
        wizard.OpenChangePasswordDialogEvent = OpenChangePasswordDialogEvent;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var PasswordGenerator = api.ui.text.PasswordGenerator;
        var FormItemBuilder = api.ui.form.FormItemBuilder;
        var Validators = api.ui.form.Validators;
        var ChangeUserPasswordDialog = (function (_super) {
            __extends(ChangeUserPasswordDialog, _super);
            function ChangeUserPasswordDialog() {
                var _this = this;
                _super.call(this, {
                    title: new api.ui.dialog.ModalDialogHeader("Change password")
                });
                this.getEl().addClass("change-password-dialog");
                this.userPath = new api.dom.H6El().addClass("user-path");
                var descMessage = new api.dom.H6El().addClass("desc-message").
                    setHtml("Password will be updated immediately after finishing");
                this.appendChildToContentPanel(this.userPath);
                this.appendChildToContentPanel(descMessage);
                this.password = new PasswordGenerator();
                this.password.onInput(function () { return _this.toggleChangePasswordButton(); });
                this.password.onValidityChanged(function () { return _this.toggleChangePasswordButton(); });
                this.onShown(function () { return _this.toggleChangePasswordButton(); });
                var passwordFormItem = new FormItemBuilder(this.password).
                    setLabel('Password').
                    setValidator(Validators.required).
                    build();
                var fieldSet = new api.ui.form.Fieldset();
                fieldSet.add(passwordFormItem);
                var form = new api.ui.form.Form().add(fieldSet);
                this.appendChildToContentPanel(form);
                this.initializeActions();
                wizard.OpenChangePasswordDialogEvent.on(function (event) {
                    _this.principal = event.getPrincipal();
                    _this.userPath.setHtml(_this.principal.getKey().toPath());
                    _this.open();
                });
                this.addCancelButtonToBottom();
            }
            ChangeUserPasswordDialog.prototype.initializeActions = function () {
                var _this = this;
                this.changePasswordButton = this.addAction(new api.ui.Action("Change Password", "").onExecuted(function () {
                    new api.security.SetUserPasswordRequest().
                        setKey(_this.principal.getKey()).
                        setPassword(_this.password.getValue()).sendAndParse().then(function (result) {
                        api.notify.showFeedback('Password was changed!');
                        _this.close();
                    });
                }));
                this.changePasswordButton.setEnabled(false);
            };
            ChangeUserPasswordDialog.prototype.toggleChangePasswordButton = function () {
                if (this.password.getValue().length == 0) {
                    this.changePasswordButton.setEnabled(false);
                }
                else {
                    this.changePasswordButton.setEnabled(true);
                }
            };
            ChangeUserPasswordDialog.prototype.open = function () {
                _super.prototype.open.call(this);
            };
            ChangeUserPasswordDialog.prototype.show = function () {
                api.dom.Body.get().appendChild(this);
                _super.prototype.show.call(this);
            };
            ChangeUserPasswordDialog.prototype.close = function () {
                this.password.setValue("");
                _super.prototype.close.call(this);
                this.remove();
            };
            ChangeUserPasswordDialog.prototype.getPrincipal = function () {
                return this.principal;
            };
            return ChangeUserPasswordDialog;
        })(api.ui.dialog.ModalDialog);
        wizard.ChangeUserPasswordDialog = ChangeUserPasswordDialog;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='UserItemWizardPanel.ts' />
///<reference path='UserItemWizardPanelParams.ts' />
///<reference path='PrincipalWizardPanel.ts' />
///<reference path='UserWizardPanel.ts' />
///<reference path='GroupRoleWizardPanel.ts' />
///<reference path='RoleWizardPanel.ts' />
///<reference path='GroupWizardPanel.ts' />
///<reference path='UserstoreWizardPanel.ts' />
///<reference path='PrincipalWizardPanelFactory.ts' />
///<reference path='UserStoreWizardPanelFactory.ts' />
///<reference path='PrincipalWizardPanelParams.ts' />
///<reference path='UserStoreWizardPanelParams.ts' />
///<reference path='PrincipalWizardToolbar.ts' />
///<reference path='UserStoreWizardToolbar.ts' />
///<reference path='PrincipalDescriptionWizardStepForm.ts' />
///<reference path='PrincipalMembersWizardStepForm.ts' />
///<reference path='UserEmailWizardStepForm.ts' />
///<reference path='UserPasswordWizardStepForm.ts' />
///<reference path='UserMembershipsWizardStepForm.ts' />
///<reference path='RoleMembersWizardStepForm.ts' />
///<reference path='GroupMembersWizardStepForm.ts' />
///<reference path='SecurityWizardStepForm.ts' />
///<reference path='OpenChangePasswordDialogEvent.ts' />
///<reference path='ChangeUserPasswordDialog.ts' />
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var action;
        (function (action) {
            var DeleteUserItemAction = (function (_super) {
                __extends(DeleteUserItemAction, _super);
                function DeleteUserItemAction(wizardPanel) {
                    _super.call(this, "Delete", "mod+del", true);
                    this.onExecuted(function () {
                        api.ui.dialog.ConfirmationDialog.get()
                            .setQuestion("Are you sure you want to delete this item?")
                            .setNoCallback(null)
                            .setYesCallback(function () {
                            wizardPanel.close();
                            var persistedItem = wizardPanel.getPersistedItem(), isPrincipal = (wizardPanel instanceof wizard.PrincipalWizardPanel) && !!persistedItem, userItemKey;
                            if (isPrincipal) {
                                userItemKey = persistedItem.getKey();
                                new api.security.DeletePrincipalRequest()
                                    .setKeys([userItemKey])
                                    .send()
                                    .done(function (jsonResponse) {
                                    var json = jsonResponse.getJson();
                                    if (json.results && json.results.length > 0) {
                                        var key = json.results[0].principalKey;
                                        api.notify.showFeedback('Principal [' + key + '] deleted!');
                                        api.security.UserItemDeletedEvent.create().setPrincipals([persistedItem]).build().fire();
                                    }
                                });
                            }
                            else {
                                userItemKey = persistedItem.getKey();
                                new api.security.DeleteUserStoreRequest()
                                    .setKeys([userItemKey])
                                    .send()
                                    .done(function (jsonResponse) {
                                    var json = jsonResponse.getJson();
                                    if (json.results && json.results.length > 0) {
                                        var key = json.results[0].userStoreKey;
                                        api.notify.showFeedback('UserStore [' + key + '] deleted!');
                                        api.security.UserItemDeletedEvent.create().setUserStores([persistedItem]).build().fire();
                                    }
                                });
                            }
                        }).open();
                    });
                }
                return DeleteUserItemAction;
            })(api.ui.Action);
            action.DeleteUserItemAction = DeleteUserItemAction;
        })(action = wizard.action || (wizard.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var action;
        (function (action) {
            var UserItemWizardActions = (function (_super) {
                __extends(UserItemWizardActions, _super);
                function UserItemWizardActions(wizardPanel) {
                    this.save = new api.app.wizard.SaveAction(wizardPanel);
                    this.delete = new action.DeleteUserItemAction(wizardPanel);
                    this.close = new api.app.wizard.CloseAction(wizardPanel);
                    _super.call(this, this.save, this.delete, this.close);
                }
                UserItemWizardActions.prototype.enableActionsForNew = function () {
                    this.save.setEnabled(false);
                    this.delete.setEnabled(false);
                };
                UserItemWizardActions.prototype.enableActionsForExisting = function () {
                    this.save.setEnabled(true);
                    this.delete.setEnabled(true);
                };
                UserItemWizardActions.prototype.getDeleteAction = function () {
                    return this.delete;
                };
                UserItemWizardActions.prototype.getSaveAction = function () {
                    return this.save;
                };
                UserItemWizardActions.prototype.getCloseAction = function () {
                    return this.close;
                };
                return UserItemWizardActions;
            })(api.app.wizard.WizardActions);
            action.UserItemWizardActions = UserItemWizardActions;
        })(action = wizard.action || (wizard.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var action;
        (function (action) {
            var UserStore = api.security.UserStore;
            var UserStoreWizardActions = (function (_super) {
                __extends(UserStoreWizardActions, _super);
                function UserStoreWizardActions(wizardPanel) {
                    _super.call(this, wizardPanel);
                    this.establishDeleteActionState(wizardPanel.getPersistedItemKey());
                }
                UserStoreWizardActions.prototype.establishDeleteActionState = function (key) {
                    var _this = this;
                    if (key) {
                        UserStore.checkOnDeletable(key).then(function (result) {
                            _this.getDeleteAction().setEnabled(result);
                        });
                    }
                };
                return UserStoreWizardActions;
            })(action.UserItemWizardActions);
            action.UserStoreWizardActions = UserStoreWizardActions;
        })(action = wizard.action || (wizard.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='DeletePrincipalAction.ts' />
///<reference path='UserItemWizardActions.ts' />
///<reference path='UserStoreWizardActions.ts' />
var app;
(function (app) {
    var AppBarTabMenuItemBuilder = api.app.bar.AppBarTabMenuItemBuilder;
    var AppBarTabId = api.app.bar.AppBarTabId;
    var UserTreeGridItemType = app.browse.UserTreeGridItemType;
    var PrincipalType = api.security.PrincipalType;
    var PrincipalKey = api.security.PrincipalKey;
    var GetUserStoreByKeyRequest = api.security.GetUserStoreByKeyRequest;
    var UserAppPanel = (function (_super) {
        __extends(UserAppPanel, _super);
        function UserAppPanel(appBar, path) {
            _super.call(this, {
                appBar: appBar
            });
            this.mask = new api.ui.mask.LoadMask(this);
            this.handleGlobalEvents();
            this.route(path);
        }
        UserAppPanel.prototype.route = function (path) {
            var action = path ? path.getElement(0) : undefined;
            switch (action) {
                case 'edit':
                    var id = path.getElement(1);
                    if (id && this.isValidPrincipalKey(id)) {
                        new api.security.GetPrincipalByKeyRequest(api.security.PrincipalKey.fromString(id)).sendAndParse().
                            done(function (principal) {
                            new app.browse.EditPrincipalEvent([
                                new app.browse.UserTreeGridItemBuilder().
                                    setPrincipal(principal).
                                    setType(UserTreeGridItemType.PRINCIPAL).
                                    build()
                            ]).fire();
                        });
                    }
                    else if (id && this.isValidUserStoreKey(id)) {
                        new GetUserStoreByKeyRequest(api.security.UserStoreKey.fromString(id)).sendAndParse().done(function (userStore) {
                            new app.browse.EditPrincipalEvent([
                                new app.browse.UserTreeGridItemBuilder().setUserStore(userStore).setType(UserTreeGridItemType.USER_STORE).build()
                            ]).fire();
                        });
                    }
                    else {
                        new api.app.ShowBrowsePanelEvent().fire();
                    }
                    break;
                case 'view':
                    var id = path.getElement(1);
                    if (id) {
                    }
                    break;
                default:
                    new api.app.ShowBrowsePanelEvent().fire();
                    break;
            }
        };
        UserAppPanel.prototype.isValidPrincipalKey = function (value) {
            try {
                api.security.PrincipalKey.fromString(value);
                return true;
            }
            catch (e) {
                return false;
            }
        };
        UserAppPanel.prototype.isValidUserStoreKey = function (value) {
            try {
                api.security.UserStoreKey.fromString(value);
                return true;
            }
            catch (e) {
                return false;
            }
        };
        UserAppPanel.prototype.addWizardPanel = function (tabMenuItem, wizardPanel) {
            _super.prototype.addWizardPanel.call(this, tabMenuItem, wizardPanel);
            wizardPanel.getHeader().onPropertyChanged(function (event) {
                if (event.getPropertyName() === "displayName") {
                    var name = event.getNewValue();
                    if (api.ObjectHelper.iFrameSafeInstanceOf(wizardPanel, app.wizard.UserStoreWizardPanel)) {
                        name = name ||
                            api.content.ContentUnnamed.prettifyUnnamed(wizardPanel.getUserItemType());
                    }
                    else if (api.ObjectHelper.iFrameSafeInstanceOf(wizardPanel, app.wizard.PrincipalWizardPanel)) {
                        name = name ||
                            api.content.ContentUnnamed.prettifyUnnamed(wizardPanel.getUserItemType());
                    }
                    tabMenuItem.setLabel(name, !event.getNewValue());
                }
            });
            wizardPanel.onValidityChanged(function (event) {
                tabMenuItem.markInvalid(!wizardPanel.isValid());
            });
        };
        UserAppPanel.prototype.handleGlobalEvents = function () {
            var _this = this;
            api.app.ShowBrowsePanelEvent.on(function (event) {
                _this.handleBrowse(event);
            });
            app.browse.NewPrincipalEvent.on(function (event) {
                _this.handleNew(event);
            });
            app.browse.EditPrincipalEvent.on(function (event) {
                _this.handleEdit(event);
            });
        };
        UserAppPanel.prototype.handleBrowse = function (event) {
            var browsePanel = this.getBrowsePanel();
            if (!browsePanel) {
                this.addBrowsePanel(new app.browse.UserBrowsePanel());
            }
            else {
                this.selectPanelByIndex(this.getPanelIndex(browsePanel));
            }
        };
        UserAppPanel.prototype.handleWizardCreated = function (wizard, tabName) {
            var tabMenuItem = new AppBarTabMenuItemBuilder().setLabel(api.content.ContentUnnamed.prettifyUnnamed(tabName)).
                setTabId(wizard.getTabId()).
                setCloseAction(wizard.getCloseAction()).
                build();
            this.addWizardPanel(tabMenuItem, wizard);
        };
        UserAppPanel.prototype.handleWizardUpdated = function (wizard, tabMenuItem, closeMenuItem) {
            var displayName, id;
            if (api.ObjectHelper.iFrameSafeInstanceOf(wizard.getPersistedItem(), api.security.Principal)) {
                displayName = wizard.getPersistedItem().getDisplayName() ||
                    api.content.ContentUnnamed.prettifyUnnamed(wizard.getPersistedItem().getDisplayName());
                id = wizard.getPersistedItem().getKey().getId();
            }
            else if (api.ObjectHelper.iFrameSafeInstanceOf(wizard.getPersistedItem(), api.security.UserStore)) {
                displayName = wizard.getPersistedItem().getDisplayName() ||
                    api.content.ContentUnnamed.prettifyUnnamed(wizard.getUserItemType());
                id = wizard.getPersistedItem().getKey().getId();
            }
            if (closeMenuItem != null) {
                this.getAppBarTabMenu().deselectNavigationItem();
                this.getAppBarTabMenu().removeNavigationItem(closeMenuItem);
                this.removePanelByIndex(closeMenuItem.getIndex());
            }
            tabMenuItem = new AppBarTabMenuItemBuilder().setLabel(displayName).
                setTabId(wizard.getTabId()).
                setEditing(true).
                setCloseAction(wizard.getCloseAction()).
                build();
            this.addWizardPanel(tabMenuItem, wizard);
            var viewTabId = AppBarTabId.forView(id);
            var viewTabMenuItem = this.getAppBarTabMenu().getNavigationItemById(viewTabId);
            if (viewTabMenuItem != null) {
                this.removePanelByIndex(viewTabMenuItem.getIndex());
            }
        };
        UserAppPanel.prototype.handleNew = function (event) {
            var _this = this;
            var userItem = event.getPrincipals()[0], userStoreDeferred = wemQ.defer(), userStoreRequest, principalType, principalPath = "", tabName;
            if (userItem) {
                userStoreDeferred.resolve(userItem.getUserStore());
                userStoreRequest = userStoreDeferred.promise;
                switch (userItem.getType()) {
                    case UserTreeGridItemType.USERS:
                        principalType = PrincipalType.USER;
                        principalPath = PrincipalKey.ofUser(userItem.getUserStore().getKey(), "none").toPath(true);
                        tabName = "User";
                        break;
                    case UserTreeGridItemType.GROUPS:
                        principalType = PrincipalType.GROUP;
                        principalPath = PrincipalKey.ofGroup(userItem.getUserStore().getKey(), "none").toPath(true);
                        tabName = "Group";
                        break;
                    case UserTreeGridItemType.ROLES:
                        principalType = PrincipalType.ROLE;
                        principalPath = PrincipalKey.ofRole("none").toPath(true);
                        tabName = "Role";
                        break;
                    case UserTreeGridItemType.PRINCIPAL:
                        principalType = userItem.getPrincipal().getType();
                        principalPath = userItem.getPrincipal().getKey().toPath(true);
                        tabName = PrincipalType[principalType];
                        tabName = tabName[0] + tabName.slice(1).toLowerCase();
                        if (userItem.getPrincipal().getType() !== PrincipalType.ROLE) {
                            userStoreRequest = new GetUserStoreByKeyRequest(userItem.getPrincipal().getKey().getUserStore()).sendAndParse();
                        }
                        break;
                    case UserTreeGridItemType.USER_STORE:
                        tabName = "User Store";
                }
            }
            else {
                tabName = "User Store";
            }
            var tabId = !!tabName ? AppBarTabId.forNew(tabName) : null, tabMenuItem = !!tabId ? this.getAppBarTabMenu().getNavigationItemById(tabId) : null;
            if (tabMenuItem != null) {
                this.selectPanel(tabMenuItem);
            }
            else {
                this.mask.show();
                if (userItem && userItem.getType() !== UserTreeGridItemType.USER_STORE) {
                    userStoreRequest.then(function (userStore) {
                        return new app.wizard.PrincipalWizardPanelFactory().
                            setAppBarTabId(tabId).
                            setPrincipalType(principalType).
                            setPrincipalPath(principalPath).
                            setUserStore(userStore).
                            setParentOfSameType(userItem.getType() === UserTreeGridItemType.PRINCIPAL).
                            createForNew();
                    }).then(function (wizard) {
                        _this.handleWizardCreated(wizard, tabName);
                        wizard.onPrincipalNamed(function (event) {
                            _this.handlePrincipalNamedEvent(event);
                        });
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).finally(function () {
                        _this.mask.hide();
                    }).done();
                }
                else {
                    new app.wizard.UserStoreWizardPanelFactory().
                        setAppBarTabId(tabId).createForNew().then(function (wizard) {
                        _this.handleWizardCreated(wizard, tabName);
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).finally(function () {
                        _this.mask.hide();
                    }).done();
                }
            }
        };
        UserAppPanel.prototype.handleEdit = function (event) {
            var _this = this;
            var userItems = event.getPrincipals();
            userItems.forEach(function (userItem) {
                if (!userItem) {
                    return;
                }
                var closeViewPanelMenuItem = _this.resolveTabMenuItemForUserItemBeingViewed(userItem);
                var tabMenuItem = _this.resolveTabMenuItemForUserItemBeingEdited(userItem);
                if (tabMenuItem != null) {
                    _this.selectPanel(tabMenuItem);
                }
                else {
                    _this.mask.show();
                    var tabId = _this.getTabIdForUserItem(userItem);
                    if (userItem.getType() == UserTreeGridItemType.PRINCIPAL) {
                        new app.wizard.PrincipalWizardPanelFactory().
                            setAppBarTabId(tabId).
                            setPrincipalType(userItem.getPrincipal().getType()).
                            setPrincipalPath(userItem.getPrincipal().getKey().toPath(true)).
                            setPrincipalToEdit(userItem.getPrincipal().getKey()).
                            createForEdit().then(function (wizard) {
                            _this.handleWizardUpdated(wizard, tabMenuItem, closeViewPanelMenuItem);
                        }).catch(function (reason) {
                            api.DefaultErrorHandler.handle(reason);
                        }).finally(function () {
                            _this.mask.hide();
                        }).done();
                    }
                    else if (userItem.getType() === UserTreeGridItemType.USER_STORE) {
                        new app.wizard.UserStoreWizardPanelFactory().
                            setAppBarTabId(tabId).
                            setUserStoreKey(userItem.getUserStore().getKey()).
                            createForEdit().then(function (wizard) {
                            _this.handleWizardUpdated(wizard, tabMenuItem, closeViewPanelMenuItem);
                        }).catch(function (reason) {
                            api.DefaultErrorHandler.handle(reason);
                        }).finally(function () {
                            _this.mask.hide();
                        }).done();
                    }
                }
            });
        };
        UserAppPanel.prototype.handlePrincipalNamedEvent = function (event) {
            var e = event;
            var wizard = e.getWizard(), tabMenuItem = this.getAppBarTabMenu().getNavigationItemById(wizard.getTabId());
            var newTabId = api.app.bar.AppBarTabId.forEdit(e.getPrincipal().getKey().getId());
            tabMenuItem.setTabId(newTabId);
            wizard.setTabId(newTabId);
            var name = e.getPrincipal().getDisplayName();
            if (api.ObjectHelper.iFrameSafeInstanceOf(wizard, app.wizard.PrincipalWizardPanel)) {
                name = name ||
                    api.content.ContentUnnamed.prettifyUnnamed(wizard.getUserItemType());
            }
            this.getAppBarTabMenu().getNavigationItemById(newTabId).setLabel(name, !e.getPrincipal().getDisplayName());
        };
        UserAppPanel.prototype.resolveTabMenuItemForUserItemBeingEditedOrViewed = function (userItem) {
            var result = this.resolveTabMenuItemForUserItemBeingEdited(userItem);
            if (!result) {
                result = this.resolveTabMenuItemForUserItemBeingViewed(userItem);
            }
            return result;
        };
        UserAppPanel.prototype.resolveTabMenuItemForUserItemBeingEdited = function (userItem) {
            if (!!userItem) {
                var appBarTabId = this.getTabIdForUserItem(userItem);
                var tabId = this.getAppBarTabMenu().getNavigationItemById(appBarTabId);
                if (tabId) {
                    return tabId;
                }
            }
            return null;
        };
        UserAppPanel.prototype.resolveTabMenuItemForUserItemBeingViewed = function (userItem) {
            if (!!userItem) {
                var appBarTabId = this.getTabIdForUserItem(userItem);
                var tabId = this.getAppBarTabMenu().getNavigationItemById(appBarTabId);
                if (tabId) {
                    return tabId;
                }
            }
            return null;
        };
        UserAppPanel.prototype.getTabIdForUserItem = function (userItem) {
            var appBarTabId;
            if (UserTreeGridItemType.PRINCIPAL == userItem.getType()) {
                appBarTabId = AppBarTabId.forEdit(userItem.getPrincipal().getKey().getId());
            }
            else if (UserTreeGridItemType.USER_STORE == userItem.getType()) {
                appBarTabId = AppBarTabId.forEdit(userItem.getUserStore().getKey().getId());
            }
            return appBarTabId;
        };
        return UserAppPanel;
    })(api.app.BrowseAndWizardBasedAppPanel);
    app.UserAppPanel = UserAppPanel;
})(app || (app = {}));
var app;
(function (app) {
    var Router = (function () {
        function Router() {
        }
        Router.setHash = function (path) {
            hasher.changed.active = false;
            hasher.setHash(path);
            hasher.changed.active = true;
        };
        Router.getPath = function () {
            return window.location.hash ? window.location.hash.substr(1) : "/";
        };
        return Router;
    })();
    app.Router = Router;
})(app || (app = {}));
///<reference path='UserAppPanel.ts' />
///<reference path='Router.ts' /> 
var application = (function () {
    var application = new api.app.Application('user-manager', 'Users', 'UM', 'user-manager');
    application.setPath(api.rest.Path.fromString(app.Router.getPath()));
    application.setWindow(window);
    this.serverEventsListener = new api.app.ServerEventsListener([application]);
    var messageId;
    this.lostConnectionDetector = new api.system.LostConnectionDetector();
    this.lostConnectionDetector.setAuthenticated(true);
    this.lostConnectionDetector.onConnectionLost(function () {
        api.notify.NotifyManager.get().hide(messageId);
        messageId = api.notify.showError("Lost connection to server - Please wait until connection is restored", false);
    });
    this.lostConnectionDetector.onSessionExpired(function () {
        api.notify.NotifyManager.get().hide(messageId);
        window.location.href = api.util.UriHelper.getToolUri("");
    });
    this.lostConnectionDetector.onConnectionRestored(function () {
        api.notify.NotifyManager.get().hide(messageId);
    });
    return application;
})();
function getApplication(id) {
    return application;
}
function startApplication() {
    var application = api.app.Application.getApplication();
    var appBar = new api.app.bar.AppBar(application);
    var appPanel = new app.UserAppPanel(appBar, application.getPath());
    var body = api.dom.Body.get();
    body.appendChild(appBar);
    body.appendChild(appPanel);
    api.util.AppHelper.preventDragRedirect();
    var changePasswordDialog = new app.wizard.ChangeUserPasswordDialog();
    application.setLoaded(true);
    this.serverEventsListener.start();
    this.lostConnectionDetector.startPolling();
    window.onmessage = function (e) {
        if (e.data.appLauncherEvent) {
            var eventType = api.app.AppLauncherEventType[e.data.appLauncherEvent];
            if (eventType == api.app.AppLauncherEventType.Show) {
                appPanel.activateCurrentKeyBindings();
            }
        }
    };
}
var components;
(function (components) {
})(components || (components = {}));
///<reference path='../../../common/js/_all.d.ts' />
///<reference path='app/browse/filter/_module.ts' />
///<reference path='app/browse/action/_module.ts'/>
///<reference path='app/browse/_module.ts'/>
///<reference path='app/view/_module.ts'/>
///<reference path='app/wizard/_module.ts'/>
///<reference path='app/wizard/action/_module.ts'/>
///<reference path='app/_module.ts'/>
///<reference path='main.ts' /> 
//# sourceMappingURL=_all.js.map