var app;
(function (app) {
    var Router = (function () {
        function Router() {
        }
        Router.setHash = function (path) {
            hasher.changed.active = false;
            hasher.setHash(path);
            hasher.changed.active = true;
        };
        Router.getPath = function () {
            return window.location.hash ? window.location.hash.substr(1) : "/";
        };
        return Router;
    })();
    app.Router = Router;
})(app || (app = {}));
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var app;
(function (app) {
    var ContentIconUrlResolver = api.content.ContentIconUrlResolver;
    var ContentId = api.content.ContentId;
    var ContentUpdatedEvent = api.content.event.ContentUpdatedEvent;
    var AppBarTabId = api.app.bar.AppBarTabId;
    var AppBarTabMenuItemBuilder = api.app.bar.AppBarTabMenuItemBuilder;
    var ShowBrowsePanelEvent = api.app.ShowBrowsePanelEvent;
    var ContentAppPanel = (function (_super) {
        __extends(ContentAppPanel, _super);
        function ContentAppPanel(appBar, path) {
            _super.call(this, {
                appBar: appBar
            });
            this.mask = new api.ui.mask.LoadMask(this);
            this.handleGlobalEvents();
            this.route(path);
        }
        ContentAppPanel.prototype.addWizardPanel = function (tabMenuItem, wizardPanel) {
            _super.prototype.addWizardPanel.call(this, tabMenuItem, wizardPanel);
            wizardPanel.getHeader().onPropertyChanged(function (event) {
                if (event.getPropertyName() === "displayName") {
                    var contentType = wizardPanel.getContentType(), name = event.getNewValue() || api.content.ContentUnnamed.prettifyUnnamed(contentType.getDisplayName());
                    tabMenuItem.setLabel(name, !event.getNewValue(), false);
                }
            });
            var contentWizardPanel = wizardPanel;
            tabMenuItem.markInvalid(!contentWizardPanel.getPersistedItem().isValid());
            contentWizardPanel.onValidityChanged(function (event) {
                tabMenuItem.markInvalid(!contentWizardPanel.isValid());
            });
        };
        ContentAppPanel.prototype.route = function (path) {
            var action = path ? path.getElement(0) : undefined;
            switch (action) {
                case 'edit':
                    var id = path.getElement(1);
                    if (id) {
                        api.content.ContentSummaryAndCompareStatusFetcher.fetch(new ContentId(id)).
                            done(function (content) {
                            new api.content.event.EditContentEvent([content]).fire();
                        });
                    }
                    break;
                case 'view':
                    var id = path.getElement(1);
                    if (id) {
                        api.content.ContentSummaryAndCompareStatusFetcher.fetch(new ContentId(id)).
                            done(function (content) {
                            new app.browse.ViewContentEvent([content]).fire();
                        });
                    }
                    break;
                default:
                    new ShowBrowsePanelEvent().fire();
                    break;
            }
        };
        ContentAppPanel.prototype.handleGlobalEvents = function () {
            var _this = this;
            app.create.NewContentEvent.on(function (event) {
                _this.handleNewContent(event);
            });
            app.browse.ViewContentEvent.on(function (event) {
                _this.handleView(event);
            });
            api.content.event.EditContentEvent.on(function (event) {
                _this.handleEdit(event);
            });
            ShowBrowsePanelEvent.on(function (event) {
                _this.handleBrowse(event);
            });
            ContentUpdatedEvent.on(function (event) {
                _this.handleUpdated(event);
            });
            app.browse.SortContentEvent.on(function (event) {
                _this.handleSort(event);
            });
            app.browse.MoveContentEvent.on(function (event) {
                _this.handleMove(event);
            });
        };
        ContentAppPanel.prototype.handleUpdated = function (event) {
        };
        ContentAppPanel.prototype.handleBrowse = function (event) {
            var browsePanel = this.getBrowsePanel();
            if (!browsePanel) {
                this.addBrowsePanel(new app.browse.ContentBrowsePanel());
            }
            else {
                this.selectPanelByIndex(this.getPanelIndex(browsePanel));
            }
        };
        ContentAppPanel.prototype.handleNewContent = function (newContentEvent) {
            var _this = this;
            var contentTypeSummary = newContentEvent.getContentType();
            var tabId = AppBarTabId.forNew(contentTypeSummary.getName());
            var tabMenuItem = this.getAppBarTabMenu().getNavigationItemById(tabId);
            if (tabMenuItem != null) {
                this.selectPanel(tabMenuItem);
            }
            else {
                this.mask.show();
                var contentWizardPanelFactory = new app.wizard.ContentWizardPanelFactory().
                    setAppBarTabId(tabId).
                    setParentContent(newContentEvent.getParentContent()).
                    setContentTypeName(contentTypeSummary.getContentTypeName());
                contentWizardPanelFactory.setCreateSite(newContentEvent.getContentType().isSite());
                contentWizardPanelFactory.createForNew().then(function (wizard) {
                    if (!wizard.getPersistedItem()) {
                        wizard.close();
                        return;
                    }
                    var newTabId = AppBarTabId.forNew(wizard.getPersistedItem().getContentId().toString());
                    tabMenuItem = new AppBarTabMenuItemBuilder().
                        setLabel(api.content.ContentUnnamed.prettifyUnnamed(contentTypeSummary.getDisplayName())).
                        setTabId(newTabId).
                        setCloseAction(wizard.getCloseAction()).
                        build();
                    wizard.setTabId(newTabId);
                    wizard.onContentNamed(function (event) {
                        _this.handleContentNamedEvent(event);
                    });
                    _this.addWizardPanel(tabMenuItem, wizard);
                    if (newContentEvent.getContentType().isSite() && _this.getBrowsePanel()) {
                        var content = newContentEvent.getParentContent();
                        if (!!content) {
                            _this.getBrowsePanel().getTreeGrid().refreshNodeById(content.getId());
                        }
                    }
                }).catch(function (reason) {
                    api.DefaultErrorHandler.handle(reason);
                }).finally(function () {
                    _this.mask.hide();
                }).done();
            }
        };
        ContentAppPanel.prototype.handleEdit = function (event) {
            var _this = this;
            var contents = event.getModels();
            contents.forEach(function (content) {
                if (!content || !content.getContentSummary()) {
                    return;
                }
                var closeViewPanelMenuItem = _this.resolveTabMenuItemForContentBeingViewed(content.getContentSummary());
                var tabMenuItem = _this.resolveTabMenuItemForContentBeingEdited(content.getContentSummary());
                if (tabMenuItem != null) {
                    _this.selectPanel(tabMenuItem);
                }
                else {
                    _this.mask.show();
                    var tabId = AppBarTabId.forEdit(content.getId());
                    new app.wizard.ContentWizardPanelFactory().
                        setAppBarTabId(tabId).
                        setContentIdToEdit(content.getContentId()).
                        createForEdit(content.getContentSummary()).then(function (wizard) {
                        if (closeViewPanelMenuItem != null) {
                            _this.getAppBarTabMenu().deselectNavigationItem();
                            _this.getAppBarTabMenu().removeNavigationItem(closeViewPanelMenuItem);
                            _this.removePanelByIndex(closeViewPanelMenuItem.getIndex());
                        }
                        var contentType = wizard.getContentType(), name = content.getDisplayName() || api.content.ContentUnnamed.prettifyUnnamed(contentType.getDisplayName());
                        tabMenuItem = new AppBarTabMenuItemBuilder().
                            setLabel(name).
                            setMarkUnnamed(!content.getDisplayName()).
                            setMarkInvalid(!content.getContentSummary().isValid()).
                            setTabId(tabId).
                            setEditing(true).
                            setCloseAction(wizard.getCloseAction()).
                            build();
                        _this.addWizardPanel(tabMenuItem, wizard);
                        var viewTabId = AppBarTabId.forView(content.getId());
                        var viewTabMenuItem = _this.getAppBarTabMenu().getNavigationItemById(viewTabId);
                        if (viewTabMenuItem != null) {
                            _this.removePanelByIndex(viewTabMenuItem.getIndex());
                        }
                    }).catch(function (reason) {
                        if (tabId) {
                            var tabMenuItem = _this.getAppBarTabMenu().getNavigationItemById(tabId);
                            if (tabMenuItem) {
                                _this.removePanelByIndex(tabMenuItem.getIndex());
                            }
                        }
                        api.DefaultErrorHandler.handle(reason);
                    }).finally(function () {
                        _this.mask.hide();
                    }).done();
                }
            });
        };
        ContentAppPanel.prototype.handleView = function (event) {
            var _this = this;
            var contents = event.getModels();
            contents.forEach(function (content) {
                if (!content || !content.getContentSummary()) {
                    return;
                }
                var tabMenuItem = _this.resolveTabMenuItemForContentBeingEditedOrViewed(content.getContentSummary());
                if (tabMenuItem) {
                    _this.selectPanel(tabMenuItem);
                }
                else {
                    var tabId = AppBarTabId.forView(content.getId());
                    var contentItemViewPanel = new app.view.ContentItemViewPanel();
                    tabMenuItem = new AppBarTabMenuItemBuilder().
                        setLabel(content.getDisplayName()).
                        setMarkInvalid(!content.getContentSummary().isValid()).
                        setTabId(tabId).
                        setCloseAction(contentItemViewPanel.getCloseAction()).
                        build();
                    if (!content.getDisplayName()) {
                        new api.schema.content.GetContentTypeByNameRequest(content.getContentSummary().getType()).
                            sendAndParse().
                            then(function (contentType) {
                            tabMenuItem.setLabel(api.content.ContentUnnamed.prettifyUnnamed(contentType.getDisplayName()), true);
                        }).done();
                    }
                    var contentItem = new api.app.view.ViewItem(content)
                        .setDisplayName(content.getDisplayName())
                        .setPath(content.getPath().toString())
                        .setIconUrl(new ContentIconUrlResolver().setContent(content.getContentSummary()).resolve());
                    contentItemViewPanel.setItem(contentItem);
                    _this.addViewPanel(tabMenuItem, contentItemViewPanel);
                }
            });
        };
        ContentAppPanel.prototype.handleSort = function (event) {
            var contents = event.getModels();
            new app.browse.OpenSortDialogEvent(contents[0]).fire();
        };
        ContentAppPanel.prototype.handleMove = function (event) {
            var contents = event.getModels();
            new app.browse.OpenMoveDialogEvent(contents.map(function (content) { return content.getContentSummary(); })).fire();
        };
        ContentAppPanel.prototype.handleContentNamedEvent = function (event) {
            var wizard = event.getWizard(), tabMenuItem = this.getAppBarTabMenu().getNavigationItemById(wizard.getTabId());
            var newTabId = AppBarTabId.forEdit(event.getContent().getId());
            tabMenuItem.setTabId(newTabId);
            wizard.setTabId(newTabId);
        };
        ContentAppPanel.prototype.resolveTabMenuItemForContentBeingEditedOrViewed = function (content) {
            var result = this.resolveTabMenuItemForContentBeingEdited(content);
            if (!result) {
                result = this.resolveTabMenuItemForContentBeingViewed(content);
            }
            return result;
        };
        ContentAppPanel.prototype.resolveTabMenuItemForContentBeingEdited = function (content) {
            if (!!content) {
                var tabId = this.getAppBarTabMenu().getNavigationItemById(AppBarTabId.forEdit(content.getId()));
                if (tabId) {
                    return tabId;
                }
            }
            return null;
        };
        ContentAppPanel.prototype.resolveTabMenuItemForContentBeingViewed = function (content) {
            if (!!content) {
                var tabId = this.getAppBarTabMenu().getNavigationItemById(AppBarTabId.forView(content.getId()));
                if (tabId) {
                    return tabId;
                }
            }
            return null;
        };
        return ContentAppPanel;
    })(api.app.BrowseAndWizardBasedAppPanel);
    app.ContentAppPanel = ContentAppPanel;
})(app || (app = {}));
///<reference path='Router.ts' />
///<reference path='ContentAppPanel.ts' />
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var button;
            (function (button) {
                var MobileDetailsPanelToggleButton = (function (_super) {
                    __extends(MobileDetailsPanelToggleButton, _super);
                    function MobileDetailsPanelToggleButton(detailsPanel, slideInCallback) {
                        var _this = this;
                        _super.call(this, "mobile-details-panel-toggle-button");
                        this.detailsPanel = detailsPanel;
                        this.onClicked(function () {
                            _this.toggleClass(MobileDetailsPanelToggleButton.EXPANDED_CLASS);
                            if (_this.hasClass(MobileDetailsPanelToggleButton.EXPANDED_CLASS)) {
                                _this.detailsPanel.slideIn();
                                if (!!slideInCallback) {
                                    slideInCallback();
                                }
                            }
                            else {
                                _this.detailsPanel.slideOut();
                            }
                        });
                    }
                    MobileDetailsPanelToggleButton.EXPANDED_CLASS = "expanded";
                    return MobileDetailsPanelToggleButton;
                })(api.dom.DivEl);
                button.MobileDetailsPanelToggleButton = MobileDetailsPanelToggleButton;
            })(button = detail.button || (detail.button = {}));
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var button;
            (function (button) {
                var NonMobileDetailsPanelToggleButton = (function (_super) {
                    __extends(NonMobileDetailsPanelToggleButton, _super);
                    function NonMobileDetailsPanelToggleButton() {
                        var _this = this;
                        _super.call(this, "button", api.StyleHelper.COMMON_PREFIX);
                        this.addClass("non-mobile-details-panel-toggle-button");
                        this.onClicked(function () {
                            _this.toggleClass("expanded");
                        });
                    }
                    return NonMobileDetailsPanelToggleButton;
                })(api.dom.DivEl);
                button.NonMobileDetailsPanelToggleButton = NonMobileDetailsPanelToggleButton;
            })(button = detail.button || (detail.button = {}));
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var button;
            (function (button) {
                var InfoWidgetToggleButton = (function (_super) {
                    __extends(InfoWidgetToggleButton, _super);
                    function InfoWidgetToggleButton(detailsPanel) {
                        var _this = this;
                        _super.call(this, "info-widget-toggle-button");
                        this.detailsPanel = detailsPanel;
                        this.onClicked(function (event) {
                            _this.addClass("active");
                            detailsPanel.activateDefaultWidget();
                        });
                    }
                    InfoWidgetToggleButton.prototype.setActive = function () {
                        this.addClass("active");
                    };
                    InfoWidgetToggleButton.prototype.setInactive = function () {
                        this.removeClass("active");
                    };
                    return InfoWidgetToggleButton;
                })(api.dom.DivEl);
                button.InfoWidgetToggleButton = InfoWidgetToggleButton;
            })(button = detail.button || (detail.button = {}));
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
///<reference path='MobileDetailsPanelToggleButton.ts' />
///<reference path='NonMobileDetailsPanelToggleButton.ts' />
///<reference path='InfoWidgetToggleButton.ts' /> 
var app;
(function (app) {
    var view;
    (function (view_1) {
        var detail;
        (function (detail) {
            var Dropdown = api.ui.selector.dropdown.Dropdown;
            var InfoWidgetToggleButton = app.view.detail.button.InfoWidgetToggleButton;
            var WidgetsSelectionRow = (function (_super) {
                __extends(WidgetsSelectionRow, _super);
                function WidgetsSelectionRow(detailsPanel) {
                    var _this = this;
                    _super.call(this, "widgets-selection-row");
                    this.detailsPanel = detailsPanel;
                    this.infoWidgetToggleButton = new InfoWidgetToggleButton(detailsPanel);
                    this.widgetSelectorDropdown = new WidgetSelectorDropdown(detailsPanel);
                    this.widgetSelectorDropdown.addClass("widget-selector");
                    this.widgetSelectorDropdown.getInput().getEl().setDisabled(true);
                    this.widgetSelectorDropdown.getInput().setPlaceholder("");
                    this.widgetSelectorDropdown.onOptionSelected(function (event) {
                        var widgetView = event.getOption().displayValue.getWidgetView();
                        widgetView.setActive();
                    });
                    this.infoWidgetToggleButton.onClicked(function () {
                        if (_this.widgetSelectorDropdown.isDropdownShown()) {
                            _this.widgetSelectorDropdown.hideDropdown();
                        }
                    });
                    this.widgetSelectorDropdown.prependChild(this.infoWidgetToggleButton);
                    this.appendChild(this.widgetSelectorDropdown);
                }
                WidgetsSelectionRow.prototype.updateState = function (widgetView) {
                    if (this.detailsPanel.isDefaultWidget(widgetView)) {
                        this.infoWidgetToggleButton.setActive();
                        this.widgetSelectorDropdown.removeClass("non-default-selected");
                    }
                    else {
                        this.widgetSelectorDropdown.addClass("non-default-selected");
                        this.infoWidgetToggleButton.setInactive();
                        if (this.widgetSelectorDropdown.getValue() != widgetView.getWidgetName()) {
                            this.widgetSelectorDropdown.setValue(widgetView.getWidgetName());
                        }
                    }
                    if (this.widgetSelectorDropdown.getSelectedOption()) {
                        this.widgetSelectorDropdown.getSelectedOptionView().getEl().setDisplay("inline-block");
                    }
                };
                WidgetsSelectionRow.prototype.updateWidgetsDropdown = function (widgetViews) {
                    var _this = this;
                    this.widgetSelectorDropdown.removeAllOptions();
                    widgetViews.forEach(function (view) {
                        var option = {
                            value: view.getWidgetName(),
                            displayValue: new WidgetViewOption(view)
                        };
                        _this.widgetSelectorDropdown.addOption(option);
                    });
                    if (this.widgetSelectorDropdown.getOptionCount() < 2) {
                        this.widgetSelectorDropdown.addClass("single-optioned");
                    }
                    var visisbleNow = this.isVisible();
                    if (visisbleNow) {
                        this.setVisible(false);
                    }
                    this.widgetSelectorDropdown.selectRow(0, true);
                    if (visisbleNow) {
                        this.setVisible(true);
                    }
                };
                return WidgetsSelectionRow;
            })(api.dom.DivEl);
            detail.WidgetsSelectionRow = WidgetsSelectionRow;
            var WidgetSelectorDropdown = (function (_super) {
                __extends(WidgetSelectorDropdown, _super);
                function WidgetSelectorDropdown(detailsPanel) {
                    var _this = this;
                    _super.call(this, "widgetSelector", { disableFilter: true, skipExpandOnClick: true });
                    this.onClicked(function (event) {
                        if (_this.isDefaultOptionDisplayValueViewer(event.target)) {
                            if (_this.getSelectedOption()) {
                                var widgetView = _this.getSelectedOption().displayValue.getWidgetView();
                                if (widgetView != detailsPanel.getActiveWidget()) {
                                    widgetView.setActive();
                                }
                                _this.hideDropdown();
                            }
                        }
                    });
                }
                WidgetSelectorDropdown.prototype.isDefaultOptionDisplayValueViewer = function (object) {
                    if (object && object["id"]) {
                        var id = object["id"].toString();
                        return id.indexOf("DropdownHandle") < 0 && id.indexOf("InfoWidgetToggleButton") < 0;
                    }
                    return false;
                };
                return WidgetSelectorDropdown;
            })(Dropdown);
            detail.WidgetSelectorDropdown = WidgetSelectorDropdown;
            var WidgetViewOption = (function () {
                function WidgetViewOption(widgetView) {
                    this.widgetView = widgetView;
                }
                WidgetViewOption.prototype.getWidgetView = function () {
                    return this.widgetView;
                };
                WidgetViewOption.prototype.toString = function () {
                    return this.widgetView.getWidgetName();
                };
                return WidgetViewOption;
            })();
            detail.WidgetViewOption = WidgetViewOption;
        })(detail = view_1.detail || (view_1.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var ResponsiveManager = api.ui.responsive.ResponsiveManager;
            var ContentSummaryViewer = api.content.ContentSummaryViewer;
            var ContentsPublishedEvent = api.content.event.ContentsPublishedEvent;
            var DetailsPanel = (function (_super) {
                __extends(DetailsPanel, _super);
                function DetailsPanel(builder) {
                    var _this = this;
                    _super.call(this, "details-panel");
                    this.widgetViews = [];
                    this.detailsContainer = new api.dom.DivEl("details-container");
                    this.minWidth = 280;
                    this.parentMinWidth = 15;
                    this.sizeChangedListeners = [];
                    this.setDoOffset(false);
                    this.initSlideFunctions(builder.getSlideFrom());
                    this.useSplitter = builder.isUseSplitter();
                    this.ghostDragger = new api.dom.DivEl("ghost-dragger");
                    if (this.useSplitter) {
                        this.splitter = new api.dom.DivEl("splitter");
                        this.appendChild(this.splitter);
                        this.onRendered(function () { return _this.onRenderedHandler(); });
                    }
                    this.managePublishEvent();
                    this.initViewer(builder.isUseViewer());
                    this.initDefaultWidgetView();
                    this.initCommonWidgetViews();
                    this.initDivForNoSelection();
                    this.initWidgetsSelectionRow();
                    this.appendChild(this.detailsContainer);
                    this.appendChild(this.divForNoSelection);
                    this.onPanelSizeChanged(function () {
                        _this.setDetailsContainerHeight();
                    });
                    this.layout();
                }
                DetailsPanel.prototype.managePublishEvent = function () {
                    var _this = this;
                    ContentsPublishedEvent.on(function (event) {
                        if (_this.getItem()) {
                            var itemId = _this.getItem().getId();
                            var idPublished = event.getContentIds().some(function (id, index, array) {
                                return itemId === id.toString();
                            });
                            if (idPublished) {
                                _this.versionsWidgetItemView.reloadActivePanel();
                            }
                        }
                    });
                };
                DetailsPanel.prototype.initDivForNoSelection = function () {
                    this.divForNoSelection = new api.dom.DivEl("no-selection-message");
                    this.divForNoSelection.getEl().setInnerHtml("Select an item - and we'll show you the details!");
                    this.appendChild(this.divForNoSelection);
                };
                DetailsPanel.prototype.initWidgetsSelectionRow = function () {
                    this.widgetsSelectionRow = new detail.WidgetsSelectionRow(this);
                    this.appendChild(this.widgetsSelectionRow);
                };
                DetailsPanel.prototype.getCustomWidgetViewsAndUpdateDropdown = function () {
                    var _this = this;
                    var deferred = wemQ.defer();
                    if (!this.alreadyFetchedCustomWidgets) {
                        this.getAndInitCustomWidgetViews().done(function () {
                            _this.initWidgetsDropdownForSelectedItem();
                            _this.alreadyFetchedCustomWidgets = true;
                            deferred.resolve(null);
                        });
                    }
                    else {
                        deferred.resolve(null);
                    }
                    return deferred.promise;
                };
                DetailsPanel.prototype.setActiveWidget = function (widgetView) {
                    if (this.activeWidget) {
                        this.activeWidget.setInactive();
                    }
                    this.activeWidget = widgetView;
                    this.widgetsSelectionRow.updateState(this.activeWidget);
                };
                DetailsPanel.prototype.getActiveWidget = function () {
                    return this.activeWidget;
                };
                DetailsPanel.prototype.setActiveWidgetWithName = function (value) {
                    var _this = this;
                    if (DetailsPanel.DEFAULT_WIDGET_NAME == value) {
                        this.defaultWidgetView.setActive();
                        return;
                    }
                    this.widgetViews.forEach(function (widgetView) {
                        if (widgetView.getWidgetName() == value && widgetView != _this.activeWidget) {
                            widgetView.setActive();
                        }
                    });
                };
                DetailsPanel.prototype.resetActiveWidget = function () {
                    this.activeWidget = null;
                };
                DetailsPanel.prototype.activateDefaultWidget = function () {
                    var defaultWidget = this.getDefaultWidget();
                    if (defaultWidget) {
                        defaultWidget.setActive();
                    }
                };
                DetailsPanel.prototype.isDefaultWidget = function (widgetView) {
                    return widgetView == this.defaultWidgetView;
                };
                DetailsPanel.prototype.getDefaultWidget = function () {
                    return this.defaultWidgetView;
                };
                DetailsPanel.prototype.initSlideFunctions = function (slideFrom) {
                    switch (slideFrom) {
                        case SLIDE_FROM.RIGHT:
                            this.slideInFunction = this.slideInRight;
                            this.slideOutFunction = this.slideOutRight;
                            break;
                        case SLIDE_FROM.LEFT:
                            this.slideInFunction = this.slideInLeft;
                            this.slideOutFunction = this.slideOutLeft;
                            break;
                        case SLIDE_FROM.TOP:
                            this.slideInFunction = this.slideInTop;
                            this.slideOutFunction = this.slideOutTop;
                            break;
                        case SLIDE_FROM.BOTTOM:
                            this.slideInFunction = this.slideInBottom;
                            this.slideOutFunction = this.slideOutBottom;
                            break;
                        default:
                            this.slideInFunction = this.slideInRight;
                            this.slideOutFunction = this.slideOutRight;
                    }
                };
                DetailsPanel.prototype.initViewer = function (useViewer) {
                    this.useViewer = useViewer;
                    if (useViewer) {
                        this.viewer = new ContentSummaryViewer();
                        this.viewer.addClass("details-panel-label");
                        this.appendChild(this.viewer);
                    }
                };
                DetailsPanel.prototype.setItem = function (item) {
                    if (DetailsPanel.debug) {
                        console.debug('DetailsPanel.setItem: ', item);
                    }
                    if (!api.ObjectHelper.equals(item, this.item)) {
                        this.item = item;
                        if (item) {
                            this.layout(false);
                            return this.updateWidgetsForItem();
                        }
                        else {
                            this.layout();
                        }
                    }
                    return wemQ(null);
                };
                DetailsPanel.prototype.getItem = function () {
                    return this.item;
                };
                DetailsPanel.prototype.getWidgetsInterfaceNames = function () {
                    return ["com.enonic.xp.content-manager.context-widget", "contentstudio.detailpanel"];
                };
                DetailsPanel.prototype.updateWidgetsForItem = function () {
                    var _this = this;
                    if (DetailsPanel.debug) {
                        console.debug('DetailsPanel.updateWidgetsForItem');
                    }
                    this.updateViewer();
                    var defaultPromise = this.updateDefaultWidgetViews();
                    var commonPromise = this.updateCommonWidgetViews();
                    var customPromise = this.updateCustomWidgetViews();
                    return wemQ.all([defaultPromise, commonPromise, customPromise]).then(function () {
                        _this.setDetailsContainerHeight();
                        _this.activeWidget.slideIn();
                    });
                };
                DetailsPanel.prototype.updateDefaultWidgetViews = function () {
                    var promises = [];
                    if (this.item) {
                        promises.push(this.statusWidgetItemView.setStatus(this.item.getCompareStatus()));
                        promises.push(this.propWidgetItemView.setContent(this.item.getContentSummary()));
                        promises.push(this.attachmentsWidgetItemView.setContent(this.item.getContentSummary()));
                        promises.push(this.userAccessWidgetItemView.setContentId(this.item.getContentId()));
                    }
                    return wemQ.all(promises);
                };
                DetailsPanel.prototype.updateCommonWidgetViews = function () {
                    return this.versionsWidgetItemView.setItem(this.item);
                };
                DetailsPanel.prototype.updateCustomWidgetViews = function () {
                    var _this = this;
                    var promises = [];
                    this.widgetViews.forEach(function (widgetView) {
                        if (widgetView.isUrlBased()) {
                            promises.push(widgetView.setContent(_this.item));
                        }
                    });
                    return wemQ.all(promises);
                };
                DetailsPanel.prototype.initWidgetsDropdownForSelectedItem = function () {
                    this.widgetsSelectionRow.updateWidgetsDropdown(this.widgetViews);
                    this.activateDefaultWidget();
                };
                DetailsPanel.prototype.initDefaultWidgetView = function () {
                    this.statusWidgetItemView = new detail.StatusWidgetItemView();
                    this.propWidgetItemView = new detail.PropertiesWidgetItemView();
                    this.attachmentsWidgetItemView = new detail.AttachmentsWidgetItemView();
                    this.userAccessWidgetItemView = new detail.UserAccessWidgetItemView();
                    this.defaultWidgetView = detail.WidgetView.create().
                        setName(DetailsPanel.DEFAULT_WIDGET_NAME).
                        setDetailsPanel(this).
                        addWidgetItemView(this.statusWidgetItemView).
                        addWidgetItemView(this.userAccessWidgetItemView).
                        addWidgetItemView(this.propWidgetItemView).
                        addWidgetItemView(this.attachmentsWidgetItemView).
                        build();
                    this.detailsContainer.appendChild(this.defaultWidgetView);
                };
                DetailsPanel.prototype.initCommonWidgetViews = function () {
                    this.versionsWidgetItemView = new detail.VersionsWidgetItemView();
                    var versionsWidgetView = detail.WidgetView.create().
                        setName("Version history").
                        setDetailsPanel(this).
                        addWidgetItemView(this.versionsWidgetItemView).
                        build();
                    this.addWidgets([versionsWidgetView]);
                };
                DetailsPanel.prototype.getAndInitCustomWidgetViews = function () {
                    var _this = this;
                    var getWidgetsByInterfaceRequest = new api.content.GetWidgetsByInterfaceRequest(this.getWidgetsInterfaceNames());
                    return getWidgetsByInterfaceRequest.sendAndParse().then(function (widgets) {
                        widgets.forEach(function (widget) {
                            var widgetView = detail.WidgetView.create().
                                setName(widget.getDisplayName()).
                                setDetailsPanel(_this).
                                setWidget(widget).
                                build();
                            _this.addWidget(widgetView);
                        });
                    }).catch(function (reason) {
                        if (reason && reason.message) {
                        }
                        else {
                        }
                    });
                };
                DetailsPanel.prototype.onRenderedHandler = function () {
                    var _this = this;
                    var initialPos = 0;
                    var splitterPosition = 0;
                    this.actualWidth = this.getEl().getWidth();
                    this.mask = new api.ui.mask.DragMask(this.getParentElement());
                    var dragListener = function (e) {
                        if (_this.splitterWithinBoundaries(initialPos - e.clientX)) {
                            splitterPosition = e.clientX;
                            _this.ghostDragger.getEl().setLeftPx(e.clientX - _this.getEl().getOffsetLeft());
                        }
                    };
                    this.splitter.onMouseDown(function (e) {
                        e.preventDefault();
                        initialPos = e.clientX;
                        splitterPosition = e.clientX;
                        _this.ghostDragger.insertBeforeEl(_this.splitter);
                        _this.startDrag(dragListener);
                    });
                    this.mask.onMouseUp(function (e) {
                        if (_this.ghostDragger.getHTMLElement().parentNode) {
                            _this.actualWidth = _this.getEl().getWidth() + initialPos - splitterPosition;
                            _this.stopDrag(dragListener);
                            _this.removeChild(_this.ghostDragger);
                            ResponsiveManager.fireResizeEvent();
                        }
                    });
                };
                DetailsPanel.prototype.setDetailsContainerHeight = function () {
                    var panelHeight = this.getEl().getHeight(), panelOffset = this.getEl().getOffsetToParent(), containerHeight = this.detailsContainer.getEl().getHeight(), containerOffset = this.detailsContainer.getEl().getOffsetToParent();
                    if (containerOffset.top > 0 && containerHeight !== (panelHeight - panelOffset.top - containerOffset.top)) {
                        this.detailsContainer.getEl().setHeightPx(panelHeight - panelOffset.top - containerOffset.top);
                    }
                };
                DetailsPanel.prototype.splitterWithinBoundaries = function (offset) {
                    var newWidth = this.actualWidth + offset;
                    return (newWidth >= this.minWidth) && (newWidth <= this.getParentElement().getEl().getWidth() - this.parentMinWidth);
                };
                DetailsPanel.prototype.startDrag = function (dragListener) {
                    this.mask.show();
                    this.addClass("dragging");
                    this.mask.onMouseMove(dragListener);
                    this.ghostDragger.getEl().setLeftPx(this.splitter.getEl().getOffsetLeftRelativeToParent()).setTop(null);
                };
                DetailsPanel.prototype.stopDrag = function (dragListener) {
                    var _this = this;
                    this.getEl().setWidthPx(this.actualWidth);
                    this.removeClass("dragging");
                    setTimeout(function () {
                        _this.notifyPanelSizeChanged();
                        _this.widgetsSelectionRow.render();
                    }, 800);
                    this.mask.hide();
                    this.mask.unMouseMove(dragListener);
                };
                DetailsPanel.prototype.addWidget = function (widget) {
                    this.widgetViews.push(widget);
                    this.detailsContainer.appendChild(widget);
                };
                DetailsPanel.prototype.addWidgets = function (widgetViews) {
                    var _this = this;
                    widgetViews.forEach(function (widget) {
                        _this.addWidget(widget);
                    });
                };
                DetailsPanel.prototype.setWidthPx = function (value) {
                    this.getEl().setWidthPx(value);
                    this.actualWidth = value;
                };
                DetailsPanel.prototype.getActualWidth = function () {
                    return this.actualWidth;
                };
                DetailsPanel.prototype.updateViewer = function () {
                    if (this.useViewer && this.item) {
                        this.viewer.setObject(this.item.getContentSummary());
                    }
                };
                DetailsPanel.prototype.slideIn = function () {
                    this.slideInFunction();
                };
                DetailsPanel.prototype.slideOut = function () {
                    this.slideOutFunction();
                };
                DetailsPanel.prototype.resetWidgetsWidth = function () {
                    this.widgetViews.forEach(function (widgetView) {
                        widgetView.resetContainerWidth();
                    });
                };
                DetailsPanel.prototype.layout = function (empty) {
                    if (empty === void 0) { empty = true; }
                    if (this.widgetsSelectionRow) {
                        this.widgetsSelectionRow.setVisible(!empty);
                    }
                    if (this.viewer) {
                        this.viewer.setVisible(!empty);
                    }
                    this.detailsContainer.setVisible(!empty);
                    this.toggleClass("no-selection", empty);
                };
                DetailsPanel.prototype.slideInRight = function () {
                    this.getEl().setRightPx(0);
                };
                DetailsPanel.prototype.slideOutRight = function () {
                    this.getEl().setRightPx(-this.getEl().getWidthWithBorder());
                };
                DetailsPanel.prototype.slideInLeft = function () {
                    this.getEl().setLeftPx(0);
                };
                DetailsPanel.prototype.slideOutLeft = function () {
                    this.getEl().setLeftPx(-this.getEl().getWidthWithBorder());
                };
                DetailsPanel.prototype.slideInTop = function () {
                    this.getEl().setTopPx(36);
                };
                DetailsPanel.prototype.slideOutTop = function () {
                    this.getEl().setTopPx(-window.outerHeight);
                };
                DetailsPanel.prototype.slideInBottom = function () {
                    this.getEl().setTopPx(36);
                };
                DetailsPanel.prototype.slideOutBottom = function () {
                    this.getEl().setTopPx(window.outerHeight);
                };
                DetailsPanel.prototype.notifyPanelSizeChanged = function () {
                    this.sizeChangedListeners.forEach(function (listener) { return listener(); });
                };
                DetailsPanel.prototype.onPanelSizeChanged = function (listener) {
                    this.sizeChangedListeners.push(listener);
                };
                DetailsPanel.create = function () {
                    return new Builder();
                };
                DetailsPanel.DEFAULT_WIDGET_NAME = "Info";
                DetailsPanel.debug = false;
                return DetailsPanel;
            })(api.ui.panel.Panel);
            detail.DetailsPanel = DetailsPanel;
            var Builder = (function () {
                function Builder() {
                    this.useViewer = true;
                    this.slideFrom = SLIDE_FROM.RIGHT;
                    this.useSplitter = true;
                }
                Builder.prototype.setUseViewer = function (value) {
                    this.useViewer = value;
                    return this;
                };
                Builder.prototype.setSlideFrom = function (value) {
                    this.slideFrom = value;
                    return this;
                };
                Builder.prototype.setName = function (value) {
                    this.name = value;
                    return this;
                };
                Builder.prototype.setUseSplitter = function (value) {
                    this.useSplitter = value;
                    return this;
                };
                Builder.prototype.isUseViewer = function () {
                    return this.useViewer;
                };
                Builder.prototype.getSlideFrom = function () {
                    return this.slideFrom;
                };
                Builder.prototype.getName = function () {
                    return this.name;
                };
                Builder.prototype.isUseSplitter = function () {
                    return this.useSplitter;
                };
                Builder.prototype.build = function () {
                    return new DetailsPanel(this);
                };
                return Builder;
            })();
            detail.Builder = Builder;
            (function (SLIDE_FROM) {
                SLIDE_FROM[SLIDE_FROM["LEFT"] = 0] = "LEFT";
                SLIDE_FROM[SLIDE_FROM["RIGHT"] = 1] = "RIGHT";
                SLIDE_FROM[SLIDE_FROM["BOTTOM"] = 2] = "BOTTOM";
                SLIDE_FROM[SLIDE_FROM["TOP"] = 3] = "TOP";
            })(detail.SLIDE_FROM || (detail.SLIDE_FROM = {}));
            var SLIDE_FROM = detail.SLIDE_FROM;
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var ActiveDetailsPanelManager = (function () {
                function ActiveDetailsPanelManager() {
                }
                ActiveDetailsPanelManager.setActiveDetailsPanel = function (detailsPanelToMakeActive) {
                    ActiveDetailsPanelManager.debouncedSetActiveDetailsPanel(detailsPanelToMakeActive);
                };
                ActiveDetailsPanelManager.getActiveDetailsPanel = function () {
                    return ActiveDetailsPanelManager.activeDetailsPanel;
                };
                ActiveDetailsPanelManager.doSetActiveDetailsPanel = function (detailsPanelToMakeActive) {
                    var activeItem = null, currentlyActivePanel = ActiveDetailsPanelManager.getActiveDetailsPanel(), currentlyActiveWidget;
                    if (currentlyActivePanel == detailsPanelToMakeActive || !detailsPanelToMakeActive) {
                        return;
                    }
                    else if (currentlyActivePanel) {
                        activeItem = currentlyActivePanel.getItem();
                        currentlyActiveWidget = currentlyActivePanel.getActiveWidget();
                    }
                    ActiveDetailsPanelManager.activeDetailsPanel = detailsPanelToMakeActive;
                    detailsPanelToMakeActive.getCustomWidgetViewsAndUpdateDropdown().then(function () {
                        detailsPanelToMakeActive.setItem(activeItem);
                        if (currentlyActiveWidget) {
                            detailsPanelToMakeActive.setActiveWidgetWithName(currentlyActiveWidget.getWidgetName());
                        }
                    });
                };
                ActiveDetailsPanelManager.debouncedSetActiveDetailsPanel = api.util.AppHelper.debounce(ActiveDetailsPanelManager.doSetActiveDetailsPanel, 300, false);
                return ActiveDetailsPanelManager;
            })();
            detail.ActiveDetailsPanelManager = ActiveDetailsPanelManager;
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var ResponsiveRanges = api.ui.responsive.ResponsiveRanges;
            var ActiveDetailsPanelsManager = app.view.detail.ActiveDetailsPanelManager;
            var NonMobileDetailsPanelsManager = (function () {
                function NonMobileDetailsPanelsManager(builder) {
                    var _this = this;
                    this.resizeEventMonitorLocked = false;
                    this.toggleButton = new app.view.detail.button.NonMobileDetailsPanelToggleButton();
                    this.debouncedResizeHandler = api.util.AppHelper.debounce(this.doHandleResizeEvent, 300, false);
                    this.splitPanelWithGridAndDetails = builder.getSplitPanelWithGridAndDetails();
                    this.defaultDockedDetailsPanel = builder.getDefaultDetailsPanel();
                    this.floatingDetailsPanel = builder.getFloatingDetailsPanel();
                    this.toggleButton.onClicked(function (event) {
                        if (_this.requiresAnimation()) {
                            _this.doPanelAnimation();
                        }
                    });
                    this.defaultDockedDetailsPanel.onShown(function () {
                        _this.splitPanelWithGridAndDetails.distribute();
                    });
                }
                NonMobileDetailsPanelsManager.prototype.handleResizeEvent = function () {
                    this.debouncedResizeHandler();
                };
                NonMobileDetailsPanelsManager.prototype.doHandleResizeEvent = function () {
                    var _this = this;
                    if (!this.resizeEventMonitorLocked && this.nonMobileDetailsPanelIsActive() && this.contentBrowsePanelIsVisible()) {
                        this.resizeEventMonitorLocked = true;
                        if (this.needsSwitchToFloatingMode() || this.needsSwitchToDockedMode()) {
                            this.doPanelAnimation();
                        }
                        else if (!this.splitPanelWithGridAndDetails.isSecondPanelHidden()) {
                            this.defaultDockedDetailsPanel.notifyPanelSizeChanged();
                        }
                        else if (this.isFloatingDetailsPanelActive()) {
                            this.floatingDetailsPanel.notifyPanelSizeChanged();
                        }
                        setTimeout(function () {
                            _this.resizeEventMonitorLocked = false;
                        }, 600);
                    }
                    else {
                        return;
                    }
                };
                NonMobileDetailsPanelsManager.prototype.contentBrowsePanelIsVisible = function () {
                    return this.splitPanelWithGridAndDetails.getParentElement().isVisible();
                };
                NonMobileDetailsPanelsManager.prototype.isFloatingDetailsPanelActive = function () {
                    return ActiveDetailsPanelsManager.getActiveDetailsPanel() == this.floatingDetailsPanel;
                };
                NonMobileDetailsPanelsManager.prototype.nonMobileDetailsPanelIsActive = function () {
                    return ActiveDetailsPanelsManager.getActiveDetailsPanel() == this.defaultDockedDetailsPanel ||
                        ActiveDetailsPanelsManager.getActiveDetailsPanel() == this.floatingDetailsPanel;
                };
                NonMobileDetailsPanelsManager.prototype.doPanelAnimation = function (canSetActivePanel) {
                    var _this = this;
                    if (canSetActivePanel === void 0) { canSetActivePanel = true; }
                    if (this.requiresFloatingPanelDueToShortWidth()) {
                        if (!this.splitPanelWithGridAndDetails.isSecondPanelHidden()) {
                            this.dockedToFloatingSync();
                        }
                        if (canSetActivePanel) {
                            detail.ActiveDetailsPanelManager.setActiveDetailsPanel(this.floatingDetailsPanel);
                        }
                        if (this.isExpanded()) {
                            this.floatingDetailsPanel.resetWidgetsWidth();
                            this.floatingDetailsPanel.slideIn();
                            this.floatingDetailsPanel.notifyPanelSizeChanged();
                        }
                        else {
                            this.floatingDetailsPanel.slideOut();
                        }
                        this.splitPanelWithGridAndDetails.setActiveWidthPxOfSecondPanel(this.floatingDetailsPanel.getActualWidth());
                    }
                    else {
                        if (this.floatingPanelIsShown()) {
                            this.floatingToDockedSync();
                        }
                        if (canSetActivePanel) {
                            detail.ActiveDetailsPanelManager.setActiveDetailsPanel(this.defaultDockedDetailsPanel);
                        }
                        this.defaultDockedDetailsPanel.addClass("left-bordered");
                        if (this.isExpanded()) {
                            this.splitPanelWithGridAndDetails.showSecondPanel(false);
                        }
                        else if (!this.splitPanelWithGridAndDetails.isSecondPanelHidden()) {
                            this.splitPanelWithGridAndDetails.foldSecondPanel();
                        }
                        setTimeout(function () {
                            _this.defaultDockedDetailsPanel.removeClass("left-bordered");
                            if (_this.isExpanded()) {
                                _this.splitPanelWithGridAndDetails.showSplitter();
                                _this.defaultDockedDetailsPanel.notifyPanelSizeChanged();
                            }
                        }, 500);
                    }
                    this.ensureButtonHasCorrectState();
                };
                NonMobileDetailsPanelsManager.prototype.hideActivePanel = function () {
                    this.toggleButton.removeClass("expanded");
                    this.doPanelAnimation(false);
                };
                NonMobileDetailsPanelsManager.prototype.hideDockedDetailsPanel = function () {
                    this.splitPanelWithGridAndDetails.foldSecondPanel();
                };
                NonMobileDetailsPanelsManager.prototype.getToggleButton = function () {
                    return this.toggleButton;
                };
                NonMobileDetailsPanelsManager.prototype.getActivePanel = function () {
                    return this.requiresFloatingPanelDueToShortWidth() ? this.floatingDetailsPanel : this.defaultDockedDetailsPanel;
                };
                NonMobileDetailsPanelsManager.prototype.isExpanded = function () {
                    return this.toggleButton.hasClass("expanded");
                };
                NonMobileDetailsPanelsManager.prototype.dockedToFloatingSync = function () {
                    var activePanelWidth = this.splitPanelWithGridAndDetails.getActiveWidthPxOfSecondPanel();
                    this.hideDockedDetailsPanel();
                    this.floatingDetailsPanel.setWidthPx(activePanelWidth);
                };
                NonMobileDetailsPanelsManager.prototype.floatingToDockedSync = function () {
                    this.floatingDetailsPanel.slideOut();
                    var activePanelWidth = this.floatingDetailsPanel.getActualWidth();
                    this.splitPanelWithGridAndDetails.setActiveWidthPxOfSecondPanel(activePanelWidth);
                };
                NonMobileDetailsPanelsManager.prototype.needsSwitchToFloatingMode = function () {
                    if (this.requiresFloatingPanelDueToShortWidth() && !this.splitPanelWithGridAndDetails.isSecondPanelHidden()) {
                        return true;
                    }
                    return false;
                };
                NonMobileDetailsPanelsManager.prototype.needsSwitchToDockedMode = function () {
                    if (!this.requiresFloatingPanelDueToShortWidth() && this.splitPanelWithGridAndDetails.isSecondPanelHidden() &&
                        this.isExpanded()) {
                        return true;
                    }
                    return false;
                };
                NonMobileDetailsPanelsManager.prototype.requiresAnimation = function () {
                    if (this.isExpanded()) {
                        if (this.splitPanelWithGridAndDetails.isSecondPanelHidden() && !this.floatingPanelIsShown()) {
                            return true;
                        }
                    }
                    else {
                        if (!this.splitPanelWithGridAndDetails.isSecondPanelHidden() || this.floatingPanelIsShown()) {
                            return true;
                        }
                    }
                    return false;
                };
                NonMobileDetailsPanelsManager.prototype.floatingPanelIsShown = function () {
                    var right = this.floatingDetailsPanel.getHTMLElement().style.right;
                    if (right && right.indexOf("px") > -1) {
                        right = right.substring(0, right.indexOf("px"));
                        return Number(right) >= 0;
                    }
                    return false;
                };
                NonMobileDetailsPanelsManager.prototype.requiresFloatingPanelDueToShortWidth = function () {
                    var splitPanelWidth = this.splitPanelWithGridAndDetails.getEl().getWidthWithBorder();
                    if (this.floatingPanelIsShown()) {
                        return (splitPanelWidth - this.floatingDetailsPanel.getActualWidth()) < 320;
                    }
                    else {
                        var defaultDetailsPanelWidth = this.splitPanelWithGridAndDetails.getActiveWidthPxOfSecondPanel();
                        return (splitPanelWidth - defaultDetailsPanelWidth) < 320;
                    }
                };
                NonMobileDetailsPanelsManager.prototype.requiresCollapsedDetailsPanel = function () {
                    var splitPanelWidth = this.splitPanelWithGridAndDetails.getEl().getWidthWithBorder();
                    return this.requiresFloatingPanelDueToShortWidth() || ResponsiveRanges._1620_1920.isFitOrSmaller(splitPanelWidth);
                };
                NonMobileDetailsPanelsManager.prototype.ensureButtonHasCorrectState = function () {
                    this.toggleButton.toggleClass("expanded", !this.splitPanelWithGridAndDetails.isSecondPanelHidden() || this.floatingPanelIsShown());
                };
                NonMobileDetailsPanelsManager.create = function () {
                    return new NonMobileDetailsPanelsManagerBuilder();
                };
                return NonMobileDetailsPanelsManager;
            })();
            detail.NonMobileDetailsPanelsManager = NonMobileDetailsPanelsManager;
            var NonMobileDetailsPanelsManagerBuilder = (function () {
                function NonMobileDetailsPanelsManagerBuilder() {
                }
                NonMobileDetailsPanelsManagerBuilder.prototype.setSplitPanelWithGridAndDetails = function (splitPanelWithGridAndDetails) {
                    this.splitPanelWithGridAndDetails = splitPanelWithGridAndDetails;
                };
                NonMobileDetailsPanelsManagerBuilder.prototype.setDefaultDetailsPanel = function (defaultDockedDetailsPanel) {
                    this.defaultDockedDetailsPanel = defaultDockedDetailsPanel;
                };
                NonMobileDetailsPanelsManagerBuilder.prototype.setFloatingDetailsPanel = function (floatingDetailsPanel) {
                    this.floatingDetailsPanel = floatingDetailsPanel;
                };
                NonMobileDetailsPanelsManagerBuilder.prototype.getSplitPanelWithGridAndDetails = function () {
                    return this.splitPanelWithGridAndDetails;
                };
                NonMobileDetailsPanelsManagerBuilder.prototype.getDefaultDetailsPanel = function () {
                    return this.defaultDockedDetailsPanel;
                };
                NonMobileDetailsPanelsManagerBuilder.prototype.getFloatingDetailsPanel = function () {
                    return this.floatingDetailsPanel;
                };
                NonMobileDetailsPanelsManagerBuilder.prototype.build = function () {
                    return new NonMobileDetailsPanelsManager(this);
                };
                return NonMobileDetailsPanelsManagerBuilder;
            })();
            detail.NonMobileDetailsPanelsManagerBuilder = NonMobileDetailsPanelsManagerBuilder;
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var WidgetView = (function (_super) {
                __extends(WidgetView, _super);
                function WidgetView(builder) {
                    var _this = this;
                    _super.call(this, "widget-view " + (builder.widget ? "external-widget" : "internal-widget"));
                    this.containerWidth = 0;
                    this.url = "";
                    this.detailsPanel = builder.detailsPanel;
                    this.widgetName = builder.name;
                    this.widgetItemViews = builder.widgetItemViews;
                    this.widget = builder.widget;
                    if (!this.widgetItemViews.length) {
                        this.createWidgetItemView();
                    }
                    this.layout();
                    if (this.isUrlBased()) {
                        this.detailsPanel.onPanelSizeChanged(function () {
                            var containerWidth = _this.detailsPanel.getEl().getWidth();
                            if (_this.detailsPanel.getItem() && containerWidth !== _this.containerWidth) {
                                _this.setContent(_this.detailsPanel.getItem(), true);
                            }
                        });
                    }
                }
                WidgetView.prototype.resetContainerWidth = function () {
                    this.containerWidth = 0;
                };
                WidgetView.prototype.getWidgetUrl = function (content) {
                    var path = content.getPath().toString();
                    return api.rendering.UriHelper.getAdminUri(this.widget.getUrl(), path);
                };
                WidgetView.prototype.getFullUrl = function (url) {
                    return url + "/" + this.detailsPanel.getEl().getWidth();
                };
                WidgetView.prototype.isDetailsPanelVisible = function () {
                    return this.detailsPanel.getHTMLElement().clientWidth > 0;
                };
                WidgetView.prototype.setContentForWidgetItemView = function (widgetItemView, content, force) {
                    if (force === void 0) { force = false; }
                    if (!this.isUrlBased() || !this.isDetailsPanelVisible()) {
                        return wemQ.resolve(null);
                    }
                    this.url = this.getWidgetUrl(content);
                    return widgetItemView.setUrl(this.getFullUrl(this.url), force);
                };
                WidgetView.prototype.setContent = function (content, force) {
                    var _this = this;
                    if (force === void 0) { force = false; }
                    var promises = [];
                    this.widgetItemViews.forEach(function (widgetItemView) {
                        if (_this.isUrlBased() && (force || _this.url !== _this.getWidgetUrl(content))) {
                            promises.push(_this.setContentForWidgetItemView(widgetItemView, content, force));
                        }
                    });
                    this.containerWidth = this.detailsPanel.getEl().getWidth();
                    return wemQ.all(promises);
                };
                WidgetView.prototype.createWidgetItemView = function () {
                    var widgetItemView = new detail.WidgetItemView();
                    if (this.detailsPanel.getItem()) {
                        this.setContentForWidgetItemView(widgetItemView, this.detailsPanel.getItem());
                    }
                    this.widgetItemViews.push(widgetItemView);
                };
                WidgetView.prototype.layout = function () {
                    var _this = this;
                    this.slideOut();
                    var layoutTasks = [];
                    this.widgetItemViews.forEach(function (itemView) {
                        _this.appendChild(itemView);
                        layoutTasks.push(itemView.layout());
                    });
                    return wemQ.all(layoutTasks);
                };
                WidgetView.prototype.calcHeight = function () {
                    var originalHeight = this.getEl().getHeight();
                    if (originalHeight == 0) {
                        this.setVisible(false);
                    }
                    this.getEl().setHeight("auto");
                    var height = this.getEl().getHeight();
                    this.getEl().setHeightPx(originalHeight);
                    if (originalHeight == 0) {
                        this.setVisible(true);
                    }
                    if (WidgetView.debug) {
                        console.debug('WidgetView.calcHeight: ', height, 'originalHeight: ', originalHeight);
                    }
                    return height;
                };
                WidgetView.prototype.getWidgetName = function () {
                    return this.widgetName;
                };
                WidgetView.prototype.slideOut = function () {
                    this.getEl().setMaxHeightPx(this.getEl().getHeight());
                    this.getEl().setMaxHeightPx(0);
                };
                WidgetView.prototype.slideIn = function () {
                    var _this = this;
                    if (this.hasDynamicHeight()) {
                        this.redoLayout();
                    }
                    else {
                        this.getEl().setMaxHeightPx(this.getParentElement().getEl().getHeight());
                    }
                    setTimeout(function () {
                        _this.getEl().setMaxHeight("none");
                    }, 100);
                };
                WidgetView.prototype.setActive = function () {
                    if (WidgetView.debug) {
                        console.debug('WidgetView.setActive: ', this.getWidgetName());
                    }
                    if (this.isActive()) {
                        return;
                    }
                    this.detailsPanel.setActiveWidget(this);
                    this.slideIn();
                };
                WidgetView.prototype.setInactive = function () {
                    if (WidgetView.debug) {
                        console.debug('WidgetView.setInactive: ', this.getWidgetName());
                    }
                    this.detailsPanel.resetActiveWidget();
                    this.slideOut();
                };
                WidgetView.prototype.isActive = function () {
                    return this.detailsPanel.getActiveWidget() == this;
                };
                WidgetView.prototype.hasDynamicHeight = function () {
                    return this.isUrlBased() && this.isActive();
                };
                WidgetView.prototype.redoLayout = function () {
                    var firstItemView = this.widgetItemViews[0];
                    if (!firstItemView) {
                        return;
                    }
                    this.getEl().setHeight("");
                    firstItemView.hide();
                    setTimeout(function () {
                        firstItemView.show();
                    }, 200);
                };
                WidgetView.prototype.isUrlBased = function () {
                    return !!this.widget && !!this.widget.getUrl();
                };
                WidgetView.create = function () {
                    return new WidgetViewBuilder();
                };
                WidgetView.debug = false;
                return WidgetView;
            })(api.dom.DivEl);
            detail.WidgetView = WidgetView;
            var WidgetViewBuilder = (function () {
                function WidgetViewBuilder() {
                    this.widgetItemViews = [];
                }
                WidgetViewBuilder.prototype.setName = function (name) {
                    this.name = name;
                    return this;
                };
                WidgetViewBuilder.prototype.setDetailsPanel = function (detailsPanel) {
                    this.detailsPanel = detailsPanel;
                    return this;
                };
                WidgetViewBuilder.prototype.addWidgetItemView = function (widgetItemView) {
                    this.widgetItemViews.push(widgetItemView);
                    return this;
                };
                WidgetViewBuilder.prototype.setWidget = function (widget) {
                    this.widget = widget;
                    return this;
                };
                WidgetViewBuilder.prototype.build = function () {
                    return new WidgetView(this);
                };
                return WidgetViewBuilder;
            })();
            detail.WidgetViewBuilder = WidgetViewBuilder;
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var LinkEl = api.dom.LinkEl;
            var WidgetItemView = (function (_super) {
                __extends(WidgetItemView, _super);
                function WidgetItemView(className) {
                    _super.call(this, "widget-item-view" + (className ? " " + className : ""));
                    this.uid = "";
                }
                WidgetItemView.prototype.layout = function () {
                    if (WidgetItemView.debug) {
                        console.debug('WidgetItemView.layout: ', this);
                    }
                    return wemQ(null);
                };
                WidgetItemView.prototype.getFullWidgetUrl = function (url, uid) {
                    return url + "?uid=" + uid;
                };
                WidgetItemView.prototype.setUrl = function (url, keepId) {
                    if (keepId === void 0) { keepId = false; }
                    var deferred = wemQ.defer(), uid = (!keepId || !this.uid) ? Date.now().toString() : this.uid, linkEl = new LinkEl(this.getFullWidgetUrl(url, uid)), el = this.getEl(), onLinkLoaded = (function (event) {
                        var mainContainer = wemjq(event.target["import"]).find("div")[0];
                        if (mainContainer) {
                            el.appendChild(document.importNode(mainContainer, true));
                        }
                        linkEl.unLoaded(onLinkLoaded);
                        deferred.resolve(null);
                    });
                    this.uid = uid;
                    this.removeChildren();
                    linkEl.onLoaded(onLinkLoaded);
                    this.appendChild(linkEl);
                    return deferred.promise;
                };
                WidgetItemView.debug = false;
                return WidgetItemView;
            })(api.dom.DivEl);
            detail.WidgetItemView = WidgetItemView;
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var CompareStatus = api.content.CompareStatus;
            var CompareStatusFormatter = api.content.CompareStatusFormatter;
            var StatusWidgetItemView = (function (_super) {
                __extends(StatusWidgetItemView, _super);
                function StatusWidgetItemView() {
                    _super.call(this, "status-widget-item-view");
                }
                StatusWidgetItemView.prototype.setStatus = function (status) {
                    if (StatusWidgetItemView.debug) {
                        console.debug('StatusWidgetItemView.setStatus: ', status);
                    }
                    if (status != this.status) {
                        this.status = status;
                        return this.layout();
                    }
                    return wemQ(null);
                };
                StatusWidgetItemView.prototype.layout = function () {
                    var _this = this;
                    if (StatusWidgetItemView.debug) {
                        console.debug('StatusWidgetItemView.layout');
                    }
                    this.removeChildren();
                    return _super.prototype.layout.call(this).then(function () {
                        if (_this.status != undefined) {
                            var statusEl = new api.dom.SpanEl().setHtml(CompareStatusFormatter.formatStatus(_this.status).toLocaleUpperCase());
                            statusEl.addClass(CompareStatus[_this.status].toLowerCase().replace("_", "-") || "unknown");
                            _this.appendChild(statusEl);
                        }
                    });
                };
                StatusWidgetItemView.debug = false;
                return StatusWidgetItemView;
            })(detail.WidgetItemView);
            detail.StatusWidgetItemView = StatusWidgetItemView;
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var DateTimeFormatter = api.ui.treegrid.DateTimeFormatter;
            var PropertiesWidgetItemView = (function (_super) {
                __extends(PropertiesWidgetItemView, _super);
                function PropertiesWidgetItemView() {
                    _super.call(this, "properties-widget-item-view");
                }
                PropertiesWidgetItemView.prototype.setContent = function (content) {
                    if (detail.AttachmentsWidgetItemView.debug) {
                        console.debug('PropertiesWidgetItemView.setContent: ', content);
                    }
                    if (!api.ObjectHelper.equals(content, this.content)) {
                        this.content = content;
                        return this.layout();
                    }
                    return wemQ(null);
                };
                PropertiesWidgetItemView.prototype.layout = function () {
                    var _this = this;
                    if (PropertiesWidgetItemView.debug) {
                        console.debug('PropertiesWidgetItemView.layout');
                    }
                    this.removeChildren();
                    return _super.prototype.layout.call(this).then(function () {
                        if (_this.content != undefined) {
                            var applicationKey = _this.content.getType().getApplicationKey();
                            if (!applicationKey.isSystemReserved()) {
                                return new api.application.GetApplicationRequest(applicationKey).sendAndParse().then(function (application) {
                                    _this.layoutApplication(application);
                                }).catch(function () {
                                    _this.layoutApplication();
                                });
                            }
                            else {
                                _this.layoutApplication();
                            }
                        }
                    });
                };
                PropertiesWidgetItemView.prototype.layoutApplication = function (application) {
                    var _this = this;
                    if (this.hasChild(this.list)) {
                        this.removeChild(this.list);
                    }
                    this.list = new api.dom.DlEl();
                    var strings;
                    strings = [
                        new FieldString().setName("Type").setValue(this.content.getType().getLocalName()
                            ? this.content.getType().getLocalName() : this.content.getType().toString()),
                        new FieldString().setName("Application").setValue(application ? application.getDisplayName() :
                            this.content.getType().getApplicationKey().getName()),
                        this.content.getLanguage() ? new FieldString().setName("Language").setValue(this.content.getLanguage()) : null,
                        this.content.getOwner() ? new FieldString().setName("Owner").setValue(this.content.getOwner().getId()) : null,
                        this.content.getModifiedTime() ? new FieldString().setName("Modified").
                            setValue(DateTimeFormatter.createHtmlNoTimestamp(this.content.getModifiedTime())) : null,
                        new FieldString().setName("Created").setValue(DateTimeFormatter.createHtmlNoTimestamp(this.content.getCreatedTime())),
                        new FieldString().setName("Id").setValue(this.content.getId())
                    ];
                    strings.forEach(function (stringItem) {
                        if (stringItem) {
                            stringItem.layout(_this.list);
                        }
                    });
                    this.appendChild(this.list);
                };
                PropertiesWidgetItemView.debug = false;
                return PropertiesWidgetItemView;
            })(detail.WidgetItemView);
            detail.PropertiesWidgetItemView = PropertiesWidgetItemView;
            var FieldString = (function () {
                function FieldString() {
                }
                FieldString.prototype.setName = function (name) {
                    this.fieldName = name;
                    return this;
                };
                FieldString.prototype.setValue = function (value) {
                    this.value = value;
                    return this;
                };
                FieldString.prototype.layout = function (parentEl) {
                    var valueEl = new api.dom.DdDtEl("dt").setHtml(this.value);
                    var spanEl = new api.dom.DdDtEl("dd").setHtml(this.fieldName + ": ");
                    parentEl.appendChildren(spanEl, valueEl);
                };
                return FieldString;
            })();
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view_2) {
        var detail;
        (function (detail) {
            var Access = api.ui.security.acl.Access;
            var AccessControlEntryView = api.ui.security.acl.AccessControlEntryView;
            var UserAccessListView = api.ui.security.acl.UserAccessListView;
            var UserAccessListItemView = api.ui.security.acl.UserAccessListItemView;
            var UserAccessWidgetItemView = (function (_super) {
                __extends(UserAccessWidgetItemView, _super);
                function UserAccessWidgetItemView() {
                    _super.call(this, "user-access-widget-item-view");
                    this.accessListView = new UserAccessListView();
                }
                UserAccessWidgetItemView.prototype.setContentId = function (contentId) {
                    if (UserAccessWidgetItemView.debug) {
                        console.debug('UserAccessWidgetItemView.setContentId: ', contentId);
                    }
                    this.contentId = contentId;
                    return this.layout();
                };
                UserAccessWidgetItemView.prototype.layoutHeader = function (content) {
                    var entry = content.getPermissions().getEntry(api.security.RoleKeys.EVERYONE);
                    this.everyoneAccessValue = null;
                    if (entry) {
                        this.everyoneAccessValue = AccessControlEntryView.getAccessValueFromEntry(entry);
                        var headerStr = entry.getPrincipalDisplayName() + " " + this.getOptionName(this.everyoneAccessValue) +
                            " this item";
                        var headerStrEl = new api.dom.SpanEl("header-string").setHtml(headerStr);
                        this.headerEl = new api.dom.DivEl("user-access-widget-header");
                        this.headerEl.appendChild(new api.dom.DivEl("icon-menu4"));
                        this.headerEl.appendChild(headerStrEl);
                        this.appendChild(this.headerEl);
                    }
                };
                UserAccessWidgetItemView.prototype.layoutBottom = function (content) {
                    if (this.hasChild(this.bottomEl)) {
                        this.removeChild(this.bottomEl);
                    }
                    this.bottomEl = new api.dom.AEl("edit-permissions-link").setHtml("Edit Permissions");
                    this.appendChild(this.bottomEl);
                    this.bottomEl.onClicked(function (event) {
                        new api.content.OpenEditPermissionsDialogEvent(content).fire();
                        event.stopPropagation();
                        event.preventDefault();
                        return false;
                    });
                };
                UserAccessWidgetItemView.prototype.layoutList = function (content) {
                    var _this = this;
                    var deferred = wemQ.defer();
                    var request = new api.content.GetEffectivePermissions(content.getContentId());
                    request.sendAndParse().then(function (results) {
                        if (_this.hasChild(_this.accessListView)) {
                            _this.removeChild(_this.accessListView);
                        }
                        var userAccessList = _this.getUserAccessList(results);
                        _this.accessListView = new UserAccessListView();
                        _this.accessListView.setItemViews(userAccessList);
                        _this.appendChild(_this.accessListView);
                        deferred.resolve(true);
                    }).done();
                    return deferred.promise;
                };
                UserAccessWidgetItemView.prototype.layout = function () {
                    if (UserAccessWidgetItemView.debug) {
                        console.debug('UserAccessWidgetItemView.layout');
                    }
                    return _super.prototype.layout.call(this).then(this.layoutUserAccess.bind(this));
                };
                UserAccessWidgetItemView.prototype.layoutUserAccess = function () {
                    var _this = this;
                    return new api.security.auth.IsAuthenticatedRequest().sendAndParse().then(function (loginResult) {
                        _this.currentUser = loginResult.getUser();
                        if (_this.contentId) {
                            return new api.content.GetContentByIdRequest(_this.contentId).sendAndParse().
                                then(function (content) {
                                _this.removeChildren();
                                if (content) {
                                    _this.layoutHeader(content);
                                    return _this.layoutList(content).then(function () {
                                        if (content.isAnyPrincipalAllowed(loginResult.getPrincipals(), api.security.acl.Permission.WRITE_PERMISSIONS)) {
                                            _this.layoutBottom(content);
                                        }
                                    });
                                }
                            });
                        }
                    });
                };
                UserAccessWidgetItemView.prototype.getUserAccessList = function (results) {
                    var _this = this;
                    return results.
                        filter(function (item) { return item.getAccess() != _this.everyoneAccessValue &&
                        item.getPermissionAccess().getCount() > 0; }).
                        map(function (item) {
                        var view = new UserAccessListItemView();
                        view.setObject(item);
                        view.setCurrentUser(_this.currentUser);
                        return view;
                    });
                };
                UserAccessWidgetItemView.prototype.getOptionName = function (access) {
                    var currentOption = UserAccessWidgetItemView.OPTIONS.filter(function (option) {
                        return option.value == access;
                    });
                    if (currentOption && currentOption.length > 0) {
                        return currentOption[0].name;
                    }
                };
                UserAccessWidgetItemView.debug = false;
                UserAccessWidgetItemView.OPTIONS = [
                    { value: Access.FULL, name: 'has full access to' },
                    { value: Access.PUBLISH, name: 'can publish' },
                    { value: Access.WRITE, name: 'can write' },
                    { value: Access.READ, name: 'can read' },
                    { value: Access.CUSTOM, name: 'has custom access to' }
                ];
                return UserAccessWidgetItemView;
            })(detail.WidgetItemView);
            detail.UserAccessWidgetItemView = UserAccessWidgetItemView;
        })(detail = view_2.detail || (view_2.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var AttachmentsWidgetItemView = (function (_super) {
                __extends(AttachmentsWidgetItemView, _super);
                function AttachmentsWidgetItemView() {
                    _super.call(this, 'attachments-widget-item-view');
                }
                AttachmentsWidgetItemView.prototype.setContent = function (content) {
                    if (AttachmentsWidgetItemView.debug) {
                        console.debug('AttachmentsWidgetItemView.setContent: ', content);
                    }
                    if (!api.ObjectHelper.equals(content, this.content)) {
                        this.content = content;
                        return this.layout();
                    }
                    return wemQ(null);
                };
                AttachmentsWidgetItemView.prototype.layout = function () {
                    var _this = this;
                    if (AttachmentsWidgetItemView.debug) {
                        console.debug('AttachmentsWidgetItemView.layout');
                    }
                    this.removeChildren();
                    return _super.prototype.layout.call(this).then(function () {
                        if (_this.content != undefined) {
                            return _this.layoutAttachments();
                        }
                    });
                };
                AttachmentsWidgetItemView.prototype.layoutAttachments = function () {
                    var _this = this;
                    return new api.content.GetContentAttachmentsRequest(this.content.getContentId()).sendAndParse().then(function (attachments) {
                        if (_this.hasChild(_this.list)) {
                            _this.removeChild(_this.list);
                        }
                        if (_this.hasChild(_this.placeholder)) {
                            _this.removeChild(_this.placeholder);
                        }
                        if (attachments) {
                            _this.list = new api.dom.UlEl('attachment-list');
                            var contentId = _this.content.getContentId();
                            attachments.forEach(function (attachment) {
                                var attachmentContainer = new api.dom.LiEl('attachment-container');
                                var link = _this.createLinkEl(contentId, attachment.getName());
                                attachmentContainer.appendChild(link);
                                _this.list.appendChild(attachmentContainer);
                            });
                            _this.appendChild(_this.list);
                        }
                        else {
                            _this.placeholder = new api.dom.SpanEl('att-placeholder').setHtml('This item has no attachments');
                            _this.appendChild(_this.placeholder);
                        }
                        return attachments;
                    });
                };
                AttachmentsWidgetItemView.prototype.createLinkEl = function (contentId, attachmentName) {
                    var url = "content/media/" + contentId.toString() + "/" + attachmentName.toString();
                    var link = new api.dom.AEl().setUrl(api.util.UriHelper.getRestUri(url), '_blank');
                    link.setHtml(attachmentName.toString());
                    return link;
                };
                AttachmentsWidgetItemView.debug = false;
                return AttachmentsWidgetItemView;
            })(detail.WidgetItemView);
            detail.AttachmentsWidgetItemView = AttachmentsWidgetItemView;
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var detail;
        (function (detail) {
            var VersionsWidgetItemView = (function (_super) {
                __extends(VersionsWidgetItemView, _super);
                function VersionsWidgetItemView() {
                    _super.call(this, "version-widget-item-view");
                }
                VersionsWidgetItemView.prototype.layout = function () {
                    var _this = this;
                    if (VersionsWidgetItemView.debug) {
                        console.debug('VersionsWidgetItemView.layout');
                    }
                    this.removeChildren();
                    return _super.prototype.layout.call(this).then(function () {
                        _this.allContentVersionsView = new app.view.AllContentVersionsView();
                        _this.allContentVersionsView.onLoaded(function () {
                            if (_this.gridLoadDeferred) {
                                _this.gridLoadDeferred.resolve(null);
                                _this.gridLoadDeferred = null;
                            }
                        });
                        _this.appendChild(_this.allContentVersionsView);
                    });
                };
                VersionsWidgetItemView.prototype.setItem = function (item) {
                    if (VersionsWidgetItemView.debug) {
                        console.debug('VersionsWidgetItemView.setItem: ', item);
                    }
                    if (this.allContentVersionsView) {
                        this.allContentVersionsView.setContentData(item);
                        return this.reloadActivePanel();
                    }
                    return wemQ(null);
                };
                VersionsWidgetItemView.prototype.reloadActivePanel = function () {
                    if (VersionsWidgetItemView.debug) {
                        console.debug('VersionsWidgetItemView.reloadActivePanel');
                    }
                    this.gridLoadDeferred = wemQ.defer();
                    if (this.allContentVersionsView) {
                        this.allContentVersionsView.reload();
                    }
                    else {
                        this.gridLoadDeferred.resolve(null);
                    }
                    return this.gridLoadDeferred.promise;
                };
                VersionsWidgetItemView.debug = false;
                return VersionsWidgetItemView;
            })(detail.WidgetItemView);
            detail.VersionsWidgetItemView = VersionsWidgetItemView;
        })(detail = view.detail || (view.detail = {}));
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
///<reference path='button/_module.ts' />
///<reference path='WidgetsSelectionRow.ts' />
///<reference path='DetailsPanel.ts' />
///<reference path='ActiveDetailsPanelManager.ts' />
///<reference path='NonMobileDetailsPanelsManager.ts' />
///<reference path='WidgetView.ts' />
///<reference path='WidgetItemView.ts' />
///<reference path='StatusWidgetItemView.ts' />
///<reference path='PropertiesWidgetItemView.ts' />
///<reference path='UserAccessWidgetItemView.ts' />
///<reference path='AttachmentsWidgetItemView.ts' />
///<reference path='VersionsWidgetItemView.ts' />
var app;
(function (app) {
    var browse;
    (function (browse) {
        var filter;
        (function (filter) {
            var ContentBrowseResetEvent = (function (_super) {
                __extends(ContentBrowseResetEvent, _super);
                function ContentBrowseResetEvent() {
                    _super.apply(this, arguments);
                }
                ContentBrowseResetEvent.on = function (handler) {
                    api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
                };
                ContentBrowseResetEvent.un = function (handler) {
                    api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
                };
                return ContentBrowseResetEvent;
            })(api.event.Event);
            filter.ContentBrowseResetEvent = ContentBrowseResetEvent;
        })(filter = browse.filter || (browse.filter = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var filter;
        (function (filter) {
            var ContentBrowseSearchEvent = (function (_super) {
                __extends(ContentBrowseSearchEvent, _super);
                function ContentBrowseSearchEvent(contentQueryResult, contentQuery) {
                    _super.call(this);
                    this.contentQueryResult = contentQueryResult;
                    this.contentQuery = contentQuery;
                }
                ContentBrowseSearchEvent.prototype.getContentQueryResult = function () {
                    return this.contentQueryResult;
                };
                ContentBrowseSearchEvent.prototype.getContentQuery = function () {
                    return this.contentQuery;
                };
                ContentBrowseSearchEvent.on = function (handler) {
                    api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
                };
                ContentBrowseSearchEvent.un = function (handler) {
                    api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
                };
                return ContentBrowseSearchEvent;
            })(api.event.Event);
            filter.ContentBrowseSearchEvent = ContentBrowseSearchEvent;
        })(filter = browse.filter || (browse.filter = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var filter;
        (function (filter) {
            var ContentBrowseRefreshEvent = (function (_super) {
                __extends(ContentBrowseRefreshEvent, _super);
                function ContentBrowseRefreshEvent() {
                    _super.apply(this, arguments);
                }
                ContentBrowseRefreshEvent.on = function (handler) {
                    api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
                };
                ContentBrowseRefreshEvent.un = function (handler) {
                    api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
                };
                return ContentBrowseRefreshEvent;
            })(api.event.Event);
            filter.ContentBrowseRefreshEvent = ContentBrowseRefreshEvent;
        })(filter = browse.filter || (browse.filter = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var filter;
        (function (filter) {
            var ContentQueryRequest = api.content.ContentQueryRequest;
            var ContentTypeName = api.schema.content.ContentTypeName;
            var AggregationGroupView = api.aggregation.AggregationGroupView;
            var ContentTypeAggregationGroupView = api.aggregation.ContentTypeAggregationGroupView;
            var ContentQuery = api.content.query.ContentQuery;
            var TermsAggregationQuery = api.query.aggregation.TermsAggregationQuery;
            var DateRangeAggregationQuery = api.query.aggregation.DateRangeAggregationQuery;
            var DateRange = api.query.aggregation.DateRange;
            var QueryExpr = api.query.expr.QueryExpr;
            var ValueExpr = api.query.expr.ValueExpr;
            var QueryField = api.query.QueryField;
            var ContentBrowseFilterPanel = (function (_super) {
                __extends(ContentBrowseFilterPanel, _super);
                function ContentBrowseFilterPanel() {
                    var _this = this;
                    this.contentTypeAggregation = new ContentTypeAggregationGroupView(ContentBrowseFilterPanel.CONTENT_TYPE_AGGREGATION_NAME, ContentBrowseFilterPanel.CONTENT_TYPE_AGGREGATION_DISPLAY_NAME);
                    this.lastModifiedAggregation = new AggregationGroupView(ContentBrowseFilterPanel.LAST_MODIFIED_AGGREGATION_NAME, ContentBrowseFilterPanel.LAST_MODIFIED_AGGREGATION_DISPLAY_NAME);
                    _super.call(this, null, [this.contentTypeAggregation, this.lastModifiedAggregation]);
                    this.initAggregationGroupView([this.contentTypeAggregation, this.lastModifiedAggregation]);
                    this.onReset(function () {
                        _this.resetFacets();
                    });
                    this.onRefresh(this.refreshFacets);
                    this.onSearch(this.searchFacets);
                }
                ContentBrowseFilterPanel.prototype.searchFacets = function (event) {
                    if (!this.hasFilterSet()) {
                        this.handleEmptyFilterInput();
                        return;
                    }
                    this.searchDataAndHandleResponse(this.createContentQuery(event));
                };
                ContentBrowseFilterPanel.prototype.refreshFacets = function (event) {
                    if (!this.hasFilterSet()) {
                        this.handleEmptyFilterInput(true);
                        return;
                    }
                    this.refreshDataAndHandleResponse(this.createContentQuery(event));
                };
                ContentBrowseFilterPanel.prototype.handleEmptyFilterInput = function (isRefreshEvent) {
                    if (isRefreshEvent) {
                        this.resetFacets(true, true).then(function () {
                            new filter.ContentBrowseRefreshEvent().fire();
                        }).catch(function (reason) {
                            api.DefaultErrorHandler.handle(reason);
                        }).done();
                    }
                    else {
                        this.reset();
                    }
                };
                ContentBrowseFilterPanel.prototype.createContentQuery = function (event) {
                    var contentQuery = new ContentQuery();
                    this.appendFulltextSearch(event.getSearchInputValues(), contentQuery);
                    this.appendContentTypeFilter(event.getSearchInputValues(), contentQuery);
                    var lastModifiedFilter = this.appendLastModifiedQuery(event.getSearchInputValues());
                    if (lastModifiedFilter != null) {
                        contentQuery.addQueryFilter(lastModifiedFilter);
                    }
                    contentQuery.setSize(ContentQuery.POSTLOAD_SIZE);
                    this.appendContentTypesAggregationQuery(contentQuery);
                    this.appendLastModifiedAggregationQuery(contentQuery);
                    return contentQuery;
                };
                ContentBrowseFilterPanel.prototype.searchDataAndHandleResponse = function (contentQuery) {
                    var _this = this;
                    new ContentQueryRequest(contentQuery).
                        setExpand(api.rest.Expand.SUMMARY).
                        sendAndParse().then(function (contentQueryResult) {
                        _this.handleDataSearchResult(contentQuery, contentQueryResult);
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                };
                ContentBrowseFilterPanel.prototype.refreshDataAndHandleResponse = function (contentQuery) {
                    var _this = this;
                    new ContentQueryRequest(contentQuery).
                        setExpand(api.rest.Expand.SUMMARY).
                        sendAndParse().then(function (contentQueryResult) {
                        if (contentQueryResult.getMetadata().getTotalHits() > 0) {
                            _this.handleDataSearchResult(contentQuery, contentQueryResult);
                        }
                        else {
                            _this.handleNoSearchResultOnRefresh(contentQuery);
                        }
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                };
                ContentBrowseFilterPanel.prototype.handleDataSearchResult = function (contentQuery, contentQueryResult) {
                    var _this = this;
                    this.getAggregations(contentQuery, contentQueryResult).then(function (aggregations) {
                        _this.updateAggregations(aggregations, true);
                        _this.updateHitsCounter(contentQueryResult.getMetadata().getTotalHits());
                        _this.toggleAggregationsVisibility(contentQueryResult.getAggregations());
                        new filter.ContentBrowseSearchEvent(contentQueryResult, contentQuery).fire();
                    });
                };
                ContentBrowseFilterPanel.prototype.handleNoSearchResultOnRefresh = function (contentQuery) {
                    if (contentQuery.getContentTypes().length > 0) {
                        this.refreshDataAndHandleResponse(this.cloneContentQueryNoContentTypes(contentQuery));
                    }
                    else if (this.hasSearchStringSet()) {
                        this.deselectAll();
                        this.searchDataAndHandleResponse(this.cloneContentQueryNoAggregations(contentQuery));
                    }
                    else {
                        this.reset();
                    }
                };
                ContentBrowseFilterPanel.prototype.cloneContentQueryNoContentTypes = function (contentQuery) {
                    var newContentQuery = new ContentQuery().
                        setContentTypeNames([]).
                        setFrom(contentQuery.getFrom()).
                        setQueryExpr(contentQuery.getQueryExpr()).
                        setSize(contentQuery.getSize()).
                        setAggregationQueries(contentQuery.getAggregationQueries()).
                        setQueryFilters(contentQuery.getQueryFilters());
                    return newContentQuery;
                };
                ContentBrowseFilterPanel.prototype.cloneContentQueryNoAggregations = function (contentQuery) {
                    return this.cloneContentQueryNoContentTypes(contentQuery).setQueryFilters([]);
                };
                ContentBrowseFilterPanel.prototype.getAggregations = function (contentQuery, contentQueryResult) {
                    var _this = this;
                    return new ContentQueryRequest(this.cloneContentQueryNoContentTypes(contentQuery)).
                        setExpand(api.rest.Expand.SUMMARY).
                        sendAndParse().then(function (contentQueryResultNoContentTypesSelected) {
                        return _this.combineAggregations(contentQueryResult, contentQueryResultNoContentTypesSelected);
                    });
                };
                ContentBrowseFilterPanel.prototype.combineAggregations = function (contentQueryResult, contentQueryResultNoContentTypesSelected) {
                    var contentTypesAggr = contentQueryResultNoContentTypesSelected.getAggregations().filter(function (aggregation) {
                        return aggregation.getName() === ContentBrowseFilterPanel.CONTENT_TYPE_AGGREGATION_NAME;
                    });
                    var dateModifiedAggr = contentQueryResult.getAggregations().filter(function (aggregation) {
                        return aggregation.getName() !== ContentBrowseFilterPanel.CONTENT_TYPE_AGGREGATION_NAME;
                    });
                    var aggregations = [contentTypesAggr[0], dateModifiedAggr[0]];
                    return aggregations;
                };
                ContentBrowseFilterPanel.prototype.initAggregationGroupView = function (aggregationGroupView) {
                    var _this = this;
                    var contentQuery = this.buildAggregationsQuery(new QueryExpr(null));
                    new ContentQueryRequest(contentQuery).
                        sendAndParse().then(function (contentQueryResult) {
                        _this.updateAggregations(contentQueryResult.getAggregations(), false);
                        _this.updateHitsCounter(contentQueryResult.getMetadata().getTotalHits(), true);
                        _this.toggleAggregationsVisibility(contentQueryResult.getAggregations());
                        aggregationGroupView.forEach(function (aggregationGroupView) {
                            aggregationGroupView.initialize();
                        });
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                };
                ContentBrowseFilterPanel.prototype.resetFacets = function (suppressEvent, doResetAll) {
                    var _this = this;
                    var contentQuery = this.buildAggregationsQuery(new QueryExpr(null));
                    return new ContentQueryRequest(contentQuery).
                        sendAndParse().then(function (contentQueryResult) {
                        _this.updateAggregations(contentQueryResult.getAggregations(), doResetAll);
                        _this.updateHitsCounter(contentQueryResult.getMetadata().getTotalHits(), true);
                        _this.toggleAggregationsVisibility(contentQueryResult.getAggregations());
                        if (!suppressEvent) {
                            new filter.ContentBrowseResetEvent().fire();
                        }
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    });
                };
                ContentBrowseFilterPanel.prototype.buildAggregationsQuery = function (queryExpr) {
                    var contentQuery = new ContentQuery();
                    contentQuery.setQueryExpr(queryExpr);
                    contentQuery.setSize(0);
                    this.appendContentTypesAggregationQuery(contentQuery);
                    this.appendLastModifiedAggregationQuery(contentQuery);
                    return contentQuery;
                };
                ContentBrowseFilterPanel.prototype.appendFulltextSearch = function (searchInputValues, contentQuery) {
                    var searchString = searchInputValues.getTextSearchFieldValue();
                    var fulltextSearchExpression = new api.query.FulltextSearchExpressionBuilder().
                        setSearchString(searchString).
                        addField(new QueryField(QueryField.DISPLAY_NAME, 5)).
                        addField(new QueryField(QueryField.NAME, 3)).
                        addField(new QueryField(QueryField.ALL)).
                        build();
                    var query = new QueryExpr(fulltextSearchExpression);
                    contentQuery.setQueryExpr(query);
                };
                ContentBrowseFilterPanel.prototype.appendContentTypeFilter = function (searchInputValues, contentQuery) {
                    var selectedBuckets = searchInputValues.getSelectedValuesForAggregationName(ContentBrowseFilterPanel.CONTENT_TYPE_AGGREGATION_NAME);
                    var contentTypeNames = this.parseContentTypeNames(selectedBuckets);
                    contentQuery.setContentTypeNames(contentTypeNames);
                };
                ContentBrowseFilterPanel.prototype.appendLastModifiedQuery = function (searchInputValues) {
                    var lastModifiedSelectedBuckets = searchInputValues.getSelectedValuesForAggregationName(ContentBrowseFilterPanel.LAST_MODIFIED_AGGREGATION_NAME);
                    if (lastModifiedSelectedBuckets == null || lastModifiedSelectedBuckets.length == 0) {
                        return null;
                    }
                    if (lastModifiedSelectedBuckets.length == 1) {
                        var dateRangeBucket = lastModifiedSelectedBuckets.pop();
                        return new api.query.filter.RangeFilter(QueryField.MODIFIED_TIME, ValueExpr.dateTime(dateRangeBucket.getFrom()).getValue(), null);
                    }
                    var booleanFilter = new api.query.filter.BooleanFilter();
                    lastModifiedSelectedBuckets.forEach(function (selectedBucket) {
                        var rangeFilter = new api.query.filter.RangeFilter(QueryField.MODIFIED_TIME, ValueExpr.dateTime(selectedBucket.getFrom()).getValue(), null);
                        booleanFilter.addShould(rangeFilter);
                    });
                    return booleanFilter;
                };
                ContentBrowseFilterPanel.prototype.parseContentTypeNames = function (buckets) {
                    var contentTypeNames = [];
                    if (buckets) {
                        for (var i = 0; i < buckets.length; i++) {
                            var bucket = buckets[i];
                            contentTypeNames.push(new ContentTypeName(bucket.getKey()));
                        }
                    }
                    return contentTypeNames;
                };
                ContentBrowseFilterPanel.prototype.appendContentTypesAggregationQuery = function (contentQuery) {
                    contentQuery.addAggregationQuery(this.createTermsAggregation((ContentBrowseFilterPanel.CONTENT_TYPE_AGGREGATION_NAME), QueryField.CONTENT_TYPE, 30));
                };
                ContentBrowseFilterPanel.prototype.createTermsAggregation = function (name, fieldName, size) {
                    var termsAggregation = new TermsAggregationQuery(name);
                    termsAggregation.setFieldName(fieldName);
                    termsAggregation.setSize(size);
                    termsAggregation.setOrderByType(api.query.aggregation.TermsAggregationOrderType.DOC_COUNT);
                    termsAggregation.setOrderByDirection(api.query.aggregation.TermsAggregationOrderDirection.DESC);
                    return termsAggregation;
                };
                ContentBrowseFilterPanel.prototype.appendLastModifiedAggregationQuery = function (contentQuery) {
                    var dateRangeAgg = new DateRangeAggregationQuery((ContentBrowseFilterPanel.LAST_MODIFIED_AGGREGATION_NAME));
                    dateRangeAgg.setFieldName(QueryField.MODIFIED_TIME);
                    dateRangeAgg.addRange(new DateRange("now-1h", null, "< 1 hour"));
                    dateRangeAgg.addRange(new DateRange("now-1d", null, "< 1 day"));
                    dateRangeAgg.addRange(new DateRange("now-1w", null, "< 1 week"));
                    contentQuery.addAggregationQuery(dateRangeAgg);
                };
                ContentBrowseFilterPanel.prototype.toggleAggregationsVisibility = function (aggregations) {
                    var _this = this;
                    aggregations.forEach(function (aggregation) {
                        var aggregationIsEmpty = !aggregation.getBuckets().some(function (bucket) {
                            if (bucket.docCount > 0) {
                                return true;
                            }
                        });
                        var aggregationGroupView = aggregation.getName() == ContentBrowseFilterPanel.CONTENT_TYPE_AGGREGATION_NAME
                            ? _this.contentTypeAggregation
                            : _this.lastModifiedAggregation;
                        if (aggregationIsEmpty) {
                            aggregationGroupView.hide();
                        }
                        else {
                            aggregationGroupView.show();
                        }
                    });
                };
                ContentBrowseFilterPanel.CONTENT_TYPE_AGGREGATION_NAME = "contentTypes";
                ContentBrowseFilterPanel.LAST_MODIFIED_AGGREGATION_NAME = "lastModified";
                ContentBrowseFilterPanel.CONTENT_TYPE_AGGREGATION_DISPLAY_NAME = "Content Types";
                ContentBrowseFilterPanel.LAST_MODIFIED_AGGREGATION_DISPLAY_NAME = "Last Modified";
                return ContentBrowseFilterPanel;
            })(api.app.browse.filter.BrowseFilterPanel);
            filter.ContentBrowseFilterPanel = ContentBrowseFilterPanel;
        })(filter = browse.filter || (browse.filter = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
///<reference path='ContentBrowseResetEvent.ts' />
///<reference path='ContentBrowseSearchEvent.ts' />
///<reference path='ContentBrowseRefreshEvent.ts' />
///<reference path='ContentBrowseFilterPanel.ts' />
var app;
(function (app) {
    var action;
    (function (action) {
        var Action = api.ui.Action;
        var RenderingMode = api.rendering.RenderingMode;
        var BasePreviewAction = (function (_super) {
            __extends(BasePreviewAction, _super);
            function BasePreviewAction() {
                _super.apply(this, arguments);
            }
            BasePreviewAction.prototype.openWindows = function (contents) {
                var targetWindows = this.openBlankWindows(contents);
                for (var key in targetWindows) {
                    this.updateLocation(targetWindows[key], contents[key], false);
                }
            };
            BasePreviewAction.prototype.openBlankWindows = function (contents) {
                var _this = this;
                return contents.map(function (content) { return _this.openBlankWindow(content); });
            };
            BasePreviewAction.prototype.openBlankWindow = function (content) {
                return window.open('', content.getId());
            };
            BasePreviewAction.prototype.updateLocation = function (targetWindow, content, focus) {
                if (focus === void 0) { focus = true; }
                targetWindow.location.href = api.rendering.UriHelper.getPortalUri(content.getPath().toString(), RenderingMode.PREVIEW, api.content.Branch.DRAFT);
                if (focus) {
                    targetWindow.focus();
                }
            };
            return BasePreviewAction;
        })(Action);
        action.BasePreviewAction = BasePreviewAction;
    })(action = app.action || (app.action = {}));
})(app || (app = {}));
///<reference path='BasePreviewAction.ts' />
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var ShowNewContentDialogAction = (function (_super) {
                __extends(ShowNewContentDialogAction, _super);
                function ShowNewContentDialogAction(grid) {
                    _super.call(this, "New", "alt+n");
                    this.setEnabled(true);
                    this.onExecuted(function () {
                        var contents = grid.getSelectedDataList();
                        new browse.ShowNewContentDialogEvent(contents.length > 0 ? contents[0] : null).fire();
                    });
                }
                return ShowNewContentDialogAction;
            })(Action);
            action.ShowNewContentDialogAction = ShowNewContentDialogAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var PreviewContentAction = (function (_super) {
                __extends(PreviewContentAction, _super);
                function PreviewContentAction(grid) {
                    var _this = this;
                    _super.call(this, "Preview", "");
                    this.setEnabled(false);
                    this.previewContentHandler = new action.PreviewContentHandler();
                    this.onExecuted(function () {
                        if (!_this.previewContentHandler.isBlocked()) {
                            var contentSummaries = grid.getSelectedDataList().
                                map(function (data) { return data.getContentSummary(); }).
                                filter(function (contentSummary) { return _this.previewContentHandler.getRenderableIds().
                                indexOf(contentSummary.getContentId().toString()) >= 0; });
                            _this.openWindows(contentSummaries);
                        }
                        else {
                            api.notify.showWarning("Number of selected items exceeds maximum number allowed for preview ("
                                + action.PreviewContentHandler.BLOCK_COUNT + "). Please deselect some of the items.");
                        }
                    });
                }
                PreviewContentAction.prototype.getPreviewHandler = function () {
                    return this.previewContentHandler;
                };
                return PreviewContentAction;
            })(app.action.BasePreviewAction);
            action.PreviewContentAction = PreviewContentAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var EditContentAction = (function (_super) {
                __extends(EditContentAction, _super);
                function EditContentAction(grid) {
                    _super.call(this, "Edit", "mod+e");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        var contents = grid.getSelectedDataList();
                        new api.content.event.EditContentEvent(contents).fire();
                    });
                }
                return EditContentAction;
            })(Action);
            action.EditContentAction = EditContentAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var CompareStatus = api.content.CompareStatus;
            var Action = api.ui.Action;
            var DeleteContentAction = (function (_super) {
                __extends(DeleteContentAction, _super);
                function DeleteContentAction(grid) {
                    _super.call(this, "Delete", "mod+del");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        var contents = grid.getSelectedDataList();
                        new browse.ContentDeletePromptEvent(contents)
                            .setNoCallback(null)
                            .setYesCallback(function () {
                            var excludeStatuses = [CompareStatus.EQUAL, CompareStatus.PENDING_DELETE, CompareStatus.NEWER], deselected = [];
                            grid.getSelectedDataList().forEach(function (content) {
                                if (excludeStatuses.indexOf(content.getCompareStatus()) < 0) {
                                    deselected.push(content.getId());
                                }
                            });
                            grid.deselectNodes(deselected);
                        }).fire();
                    });
                }
                return DeleteContentAction;
            })(Action);
            action.DeleteContentAction = DeleteContentAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var DuplicateContentAction = (function (_super) {
                __extends(DuplicateContentAction, _super);
                function DuplicateContentAction(grid) {
                    var _this = this;
                    _super.call(this, "Duplicate");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        grid.getSelectedDataList().forEach(function (elem) {
                            _this.duplicate(elem.getContentSummary());
                        });
                    });
                }
                DuplicateContentAction.prototype.duplicate = function (source) {
                    new api.content.DuplicateContentRequest(source.getContentId()).
                        sendAndParse().then(function (content) {
                        api.notify.showFeedback('\"' + source.getDisplayName() + '\" duplicated');
                    });
                };
                return DuplicateContentAction;
            })(Action);
            action.DuplicateContentAction = DuplicateContentAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var MoveContentAction = (function (_super) {
                __extends(MoveContentAction, _super);
                function MoveContentAction(grid) {
                    _super.call(this, "Move");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        var contents = grid.getSelectedDataList();
                        new browse.MoveContentEvent(contents).fire();
                    });
                }
                return MoveContentAction;
            })(Action);
            action.MoveContentAction = MoveContentAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var SortContentAction = (function (_super) {
                __extends(SortContentAction, _super);
                function SortContentAction(grid) {
                    _super.call(this, "Sort");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        var contents = grid.getSelectedDataList();
                        new app.browse.SortContentEvent(contents).fire();
                    });
                }
                return SortContentAction;
            })(Action);
            action.SortContentAction = SortContentAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var PublishContentAction = (function (_super) {
                __extends(PublishContentAction, _super);
                function PublishContentAction(grid) {
                    _super.call(this, "Publish");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        var contents = grid.getSelectedDataList();
                        new browse.ContentPublishPromptEvent(contents).fire();
                    });
                }
                return PublishContentAction;
            })(Action);
            action.PublishContentAction = PublishContentAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var SaveSortedContentAction = (function (_super) {
                __extends(SaveSortedContentAction, _super);
                function SaveSortedContentAction(dialog) {
                    _super.call(this, "Save");
                    this.setEnabled(true);
                    this.onExecuted(function () {
                        new browse.SaveSortedContentEvent(dialog.getContent().getContentSummary()).fire();
                    });
                }
                return SaveSortedContentAction;
            })(api.ui.Action);
            action.SaveSortedContentAction = SaveSortedContentAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var Action = api.ui.Action;
            var ToggleSearchPanelAction = (function (_super) {
                __extends(ToggleSearchPanelAction, _super);
                function ToggleSearchPanelAction() {
                    _super.call(this, "");
                    this.onExecuted(function () {
                        new browse.ToggleSearchPanelEvent().fire();
                    });
                    this.setIconClass("icon-search3");
                }
                return ToggleSearchPanelAction;
            })(Action);
            action.ToggleSearchPanelAction = ToggleSearchPanelAction;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var PermissionHelper = api.security.acl.PermissionHelper;
            var ContentTreeGridActions = (function () {
                function ContentTreeGridActions(grid) {
                    var _this = this;
                    this.actions = [];
                    this.TOGGLE_SEARCH_PANEL = new action.ToggleSearchPanelAction();
                    this.SHOW_NEW_CONTENT_DIALOG_ACTION = new action.ShowNewContentDialogAction(grid);
                    this.PREVIEW_CONTENT = new action.PreviewContentAction(grid);
                    this.EDIT_CONTENT = new action.EditContentAction(grid);
                    this.DELETE_CONTENT = new action.DeleteContentAction(grid);
                    this.DUPLICATE_CONTENT = new action.DuplicateContentAction(grid);
                    this.MOVE_CONTENT = new action.MoveContentAction(grid);
                    this.SORT_CONTENT = new action.SortContentAction(grid);
                    this.PUBLISH_CONTENT = new action.PublishContentAction(grid);
                    this.actions.push(this.SHOW_NEW_CONTENT_DIALOG_ACTION, this.EDIT_CONTENT, this.DELETE_CONTENT, this.DUPLICATE_CONTENT, this.MOVE_CONTENT, this.SORT_CONTENT, this.PREVIEW_CONTENT, this.PUBLISH_CONTENT);
                    var previewHandler = this.PREVIEW_CONTENT.getPreviewHandler();
                    previewHandler.onPreviewStateChanged(function (value) {
                        _this.PREVIEW_CONTENT.setEnabled(value);
                    });
                }
                ContentTreeGridActions.prototype.getAllActions = function () {
                    return this.actions;
                };
                ContentTreeGridActions.prototype.updateActionsEnabledState = function (contentBrowseItems, changes) {
                    this.TOGGLE_SEARCH_PANEL.setVisible(false);
                    var contentSummaries = contentBrowseItems.map(function (elem) {
                        return elem.getModel().getContentSummary();
                    });
                    var deferred = wemQ.defer();
                    var parallelPromises;
                    var previewHandler = this.PREVIEW_CONTENT.getPreviewHandler();
                    switch (contentBrowseItems.length) {
                        case 0:
                            this.SHOW_NEW_CONTENT_DIALOG_ACTION.setEnabled(true);
                            this.EDIT_CONTENT.setEnabled(false);
                            this.DELETE_CONTENT.setEnabled(false);
                            this.DUPLICATE_CONTENT.setEnabled(false);
                            this.MOVE_CONTENT.setEnabled(false);
                            this.SORT_CONTENT.setEnabled(false);
                            this.PUBLISH_CONTENT.setEnabled(false);
                            parallelPromises = [
                                previewHandler.updateState(contentBrowseItems, changes),
                                this.updateActionsEnabledStateByPermissions(contentBrowseItems)
                            ];
                            wemQ.all(parallelPromises).spread(function () {
                                deferred.resolve(contentBrowseItems);
                                return wemQ(null);
                            }).catch(api.DefaultErrorHandler.handle);
                            break;
                        case 1:
                            var contentSummary = contentSummaries[0];
                            this.SHOW_NEW_CONTENT_DIALOG_ACTION.setEnabled(true);
                            this.EDIT_CONTENT.setEnabled(!contentSummary ? false : contentSummary.isEditable());
                            this.DELETE_CONTENT.setEnabled(!contentSummary ? false : contentSummary.isDeletable());
                            this.DUPLICATE_CONTENT.setEnabled(true);
                            this.MOVE_CONTENT.setEnabled(true);
                            this.PUBLISH_CONTENT.setEnabled(true);
                            this.SORT_CONTENT.setEnabled(true);
                            parallelPromises = [
                                previewHandler.updateState(contentBrowseItems, changes),
                                this.updateActionsEnabledStateByPermissions(contentBrowseItems)
                            ];
                            wemQ.all(parallelPromises).spread(function () {
                                deferred.resolve(contentBrowseItems);
                                return wemQ(null);
                            }).catch(api.DefaultErrorHandler.handle);
                            break;
                        default:
                            this.SHOW_NEW_CONTENT_DIALOG_ACTION.setEnabled(false);
                            this.EDIT_CONTENT.setEnabled(this.anyEditable(contentSummaries));
                            this.DELETE_CONTENT.setEnabled(this.anyDeletable(contentSummaries));
                            this.DUPLICATE_CONTENT.setEnabled(false);
                            this.MOVE_CONTENT.setEnabled(true);
                            this.SORT_CONTENT.setEnabled(false);
                            this.PUBLISH_CONTENT.setEnabled(true);
                            parallelPromises = [
                                previewHandler.updateState(contentBrowseItems, changes),
                                this.updateActionsEnabledStateByPermissions(contentBrowseItems)
                            ];
                            wemQ.all(parallelPromises).spread(function () {
                                deferred.resolve(contentBrowseItems);
                                return wemQ(null);
                            }).catch(api.DefaultErrorHandler.handle);
                    }
                    return deferred.promise;
                };
                ContentTreeGridActions.prototype.updateActionsEnabledStateByPermissions = function (contentBrowseItems) {
                    var _this = this;
                    return new api.security.auth.IsAuthenticatedRequest().
                        sendAndParse().
                        then(function (loginResult) {
                        if (contentBrowseItems.length === 0) {
                            new api.content.GetContentRootPermissionsRequest().
                                sendAndParse().
                                then(function (accessControlList) {
                                var hasCreatePermission = PermissionHelper.hasPermission(api.security.acl.Permission.CREATE, loginResult, accessControlList);
                                if (!hasCreatePermission) {
                                    _this.SHOW_NEW_CONTENT_DIALOG_ACTION.setEnabled(false);
                                }
                            });
                        }
                        else {
                            var contentTypesAllowChildren = true;
                            var hasCreatePermission = true;
                            var hasDeletePermission = true;
                            var hasPublishPermission = true;
                            function updatePermissions(acl) {
                                hasCreatePermission = hasCreatePermission &&
                                    PermissionHelper.hasPermission(api.security.acl.Permission.CREATE, loginResult, acl);
                                hasDeletePermission = hasDeletePermission &&
                                    PermissionHelper.hasPermission(api.security.acl.Permission.DELETE, loginResult, acl);
                                hasPublishPermission = hasPublishPermission &&
                                    PermissionHelper.hasPermission(api.security.acl.Permission.PUBLISH, loginResult, acl);
                            }
                            var parallelPromises = [];
                            if (contentBrowseItems.length == 1) {
                                var contentBrowseItem = contentBrowseItems[0];
                                var contentSummary = contentBrowseItem.getModel().getContentSummary();
                                _this.checkIsChildrenAllowedByPermissions(contentSummary).then(function (result) {
                                    contentTypesAllowChildren = result;
                                });
                                _this.checkIsDuplicateAllowedByPermissions(contentSummary, loginResult).then(function (result) {
                                    _this.DUPLICATE_CONTENT.setEnabled(result);
                                });
                            }
                            contentBrowseItems.forEach(function (contentBrowseItem, index) {
                                var accessControlList = contentBrowseItem.getAccessControlList();
                                if (accessControlList) {
                                    updatePermissions(accessControlList);
                                }
                                else {
                                    var contentSummary = contentBrowseItem.getModel();
                                    parallelPromises.push(new api.content.GetContentPermissionsByIdRequest(contentSummary.getContentId()).
                                        sendAndParse().
                                        then(function (accessControlList) {
                                        contentBrowseItem.setAccessControlList(accessControlList);
                                        updatePermissions(accessControlList);
                                    }).catch(api.DefaultErrorHandler.handle));
                                }
                            });
                            wemQ.all(parallelPromises).spread(function () {
                                if (!contentTypesAllowChildren || !hasCreatePermission) {
                                    _this.SHOW_NEW_CONTENT_DIALOG_ACTION.setEnabled(false);
                                    _this.SORT_CONTENT.setEnabled(false);
                                }
                                if (!hasDeletePermission) {
                                    _this.DELETE_CONTENT.setEnabled(false);
                                    _this.MOVE_CONTENT.setEnabled(false);
                                }
                                if (!hasPublishPermission) {
                                    _this.PUBLISH_CONTENT.setEnabled(false);
                                }
                                return wemQ(null);
                            }).done();
                        }
                    });
                };
                ContentTreeGridActions.prototype.checkIsChildrenAllowedByPermissions = function (contentSummary) {
                    var deferred = wemQ.defer();
                    new api.schema.content.GetContentTypeByNameRequest(contentSummary.getType()).
                        sendAndParse().
                        then(function (contentType) {
                        return deferred.resolve(contentType && contentType.isAllowChildContent());
                    });
                    return deferred.promise;
                };
                ContentTreeGridActions.prototype.checkIsDuplicateAllowedByPermissions = function (contentSummary, loginResult) {
                    var deferred = wemQ.defer();
                    if (contentSummary.hasParent()) {
                        new api.content.GetContentByPathRequest(contentSummary.getPath().getParentPath()).
                            sendAndParse().
                            then(function (parent) {
                            deferred.resolve(PermissionHelper.hasPermission(api.security.acl.Permission.CREATE, loginResult, parent.getPermissions()));
                        });
                    }
                    else {
                        new api.content.GetContentRootPermissionsRequest().
                            sendAndParse().
                            then(function (accessControlList) {
                            deferred.resolve(PermissionHelper.hasPermission(api.security.acl.Permission.CREATE, loginResult, accessControlList));
                        });
                    }
                    return deferred.promise;
                };
                ContentTreeGridActions.prototype.anyEditable = function (contentSummaries) {
                    for (var i = 0; i < contentSummaries.length; i++) {
                        var content = contentSummaries[i];
                        if (!!content && content.isEditable()) {
                            return true;
                        }
                    }
                    return false;
                };
                ContentTreeGridActions.prototype.anyDeletable = function (contentSummaries) {
                    for (var i = 0; i < contentSummaries.length; i++) {
                        var content = contentSummaries[i];
                        if (!!content && content.isDeletable()) {
                            return true;
                        }
                    }
                    return false;
                };
                return ContentTreeGridActions;
            })();
            action.ContentTreeGridActions = ContentTreeGridActions;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var MobileContentTreeGridActions = (function () {
                function MobileContentTreeGridActions(grid) {
                    this.actions = [];
                    this.SHOW_NEW_CONTENT_DIALOG_ACTION = new action.ShowNewContentDialogAction(grid);
                    this.EDIT_CONTENT = new action.EditContentAction(grid);
                    this.DELETE_CONTENT = new action.DeleteContentAction(grid);
                    this.DUPLICATE_CONTENT = new action.DuplicateContentAction(grid);
                    this.MOVE_CONTENT = new action.MoveContentAction(grid);
                    this.SORT_CONTENT = new action.SortContentAction(grid);
                    this.PUBLISH_CONTENT = new action.PublishContentAction(grid);
                    this.actions.push(this.SHOW_NEW_CONTENT_DIALOG_ACTION, this.DELETE_CONTENT, this.DUPLICATE_CONTENT, this.MOVE_CONTENT, this.SORT_CONTENT, this.PUBLISH_CONTENT);
                }
                MobileContentTreeGridActions.prototype.getAllActions = function () {
                    return this.actions;
                };
                MobileContentTreeGridActions.prototype.updateActionsEnabledState = function (contentBrowseItems) {
                    var _this = this;
                    var contentSummaries = contentBrowseItems.map(function (elem) {
                        return elem.getModel().getContentSummary();
                    });
                    var deferred = wemQ.defer();
                    switch (contentBrowseItems.length) {
                        case 0:
                            this.EDIT_CONTENT.setEnabled(false);
                            this.DELETE_CONTENT.setEnabled(false);
                            this.DUPLICATE_CONTENT.setEnabled(false);
                            this.MOVE_CONTENT.setEnabled(false);
                            this.SORT_CONTENT.setEnabled(false);
                            this.PUBLISH_CONTENT.setEnabled(false);
                            deferred.resolve(contentBrowseItems);
                            break;
                        case 1:
                            var contentSummary = contentSummaries[0];
                            this.EDIT_CONTENT.setEnabled(!contentSummary ? false : contentSummary.isEditable());
                            this.DELETE_CONTENT.setEnabled(!contentSummary ? false : contentSummary.isDeletable());
                            this.DUPLICATE_CONTENT.setEnabled(true);
                            this.MOVE_CONTENT.setEnabled(true);
                            this.PUBLISH_CONTENT.setEnabled(true);
                            var parallelPromises = [
                                new api.schema.content.GetContentTypeByNameRequest(contentSummary.getType()).
                                    sendAndParse().
                                    then(function (contentType) {
                                    var allowsChildren = (contentType && contentType.isAllowChildContent());
                                    _this.SORT_CONTENT.setEnabled(allowsChildren);
                                    var hasCreatePermission = false;
                                    new api.security.auth.IsAuthenticatedRequest().
                                        sendAndParse().
                                        then(function (loginResult) {
                                        new api.content.GetContentPermissionsByIdRequest(contentSummary.getContentId()).
                                            sendAndParse().
                                            then(function (accessControlList) {
                                            hasCreatePermission =
                                                _this.hasPermission(api.security.acl.Permission.CREATE, loginResult, accessControlList);
                                            _this.SHOW_NEW_CONTENT_DIALOG_ACTION.setEnabled(allowsChildren && hasCreatePermission);
                                        });
                                    });
                                })
                            ];
                            wemQ.all(parallelPromises).spread(function () {
                                deferred.resolve(contentBrowseItems);
                                return wemQ(null);
                            }).done();
                            break;
                        default:
                            this.SHOW_NEW_CONTENT_DIALOG_ACTION.setEnabled(false);
                            this.EDIT_CONTENT.setEnabled(this.anyEditable(contentSummaries));
                            this.DELETE_CONTENT.setEnabled(this.anyDeletable(contentSummaries));
                            this.DUPLICATE_CONTENT.setEnabled(false);
                            this.MOVE_CONTENT.setEnabled(true);
                            this.SORT_CONTENT.setEnabled(false);
                            this.PUBLISH_CONTENT.setEnabled(true);
                            deferred.resolve(contentBrowseItems);
                    }
                    return deferred.promise;
                };
                MobileContentTreeGridActions.prototype.anyEditable = function (contentSummaries) {
                    for (var i = 0; i < contentSummaries.length; i++) {
                        var content = contentSummaries[i];
                        if (!!content && content.isEditable()) {
                            return true;
                        }
                    }
                    return false;
                };
                MobileContentTreeGridActions.prototype.anyDeletable = function (contentSummaries) {
                    for (var i = 0; i < contentSummaries.length; i++) {
                        var content = contentSummaries[i];
                        if (!!content && content.isDeletable()) {
                            return true;
                        }
                    }
                    return false;
                };
                MobileContentTreeGridActions.prototype.isPrincipalPresent = function (principalKey, accessEntriesToCheck) {
                    return accessEntriesToCheck.some(function (entry) {
                        return entry.getPrincipalKey().equals(principalKey);
                    });
                };
                MobileContentTreeGridActions.prototype.hasPermission = function (permission, loginResult, accessControlList) {
                    var _this = this;
                    var entries = accessControlList.getEntries();
                    var accessEntriesWithGivenPermissions = entries.filter(function (item) {
                        return item.isAllowed(permission);
                    });
                    return loginResult.getPrincipals().some(function (principalKey) {
                        return api.security.RoleKeys.ADMIN.equals(principalKey) ||
                            _this.isPrincipalPresent(principalKey, accessEntriesWithGivenPermissions);
                    });
                };
                return MobileContentTreeGridActions;
            })();
            action.MobileContentTreeGridActions = MobileContentTreeGridActions;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
///<reference path='ShowNewContentDialogAction.ts' />
///<reference path='PreviewContentAction.ts' />
///<reference path='EditContentAction.ts' />
///<reference path='DeleteContentAction.ts' />
///<reference path='DuplicateContentAction.ts' />
///<reference path='MoveContentAction.ts' />
///<reference path='SortContentAction.ts' />
///<reference path='PublishContentAction.ts' />
///<reference path='SaveSortedContentAction.ts' />
///<reference path='ToggleSearchPanelAction.ts' />
///<reference path='ContentTreeGridActions.ts' />
///<reference path='MobileContentTreeGridActions.ts' />
var app;
(function (app) {
    var browse;
    (function (browse) {
        var action;
        (function (action) {
            var PreviewContentHandler = (function () {
                function PreviewContentHandler() {
                    this.renderableIds = [];
                    this.previewStateChangedListeners = [];
                    this.blocked = false;
                }
                PreviewContentHandler.prototype.updateState = function (contentBrowseItems, changes) {
                    if (PreviewContentHandler.BLOCK_COUNT < contentBrowseItems.length) {
                        this.setBlocked(true);
                        return;
                    }
                    else {
                        if (this.isBlocked()) {
                            this.setRenderableIds([]);
                            if (changes) {
                                changes.setAdded(contentBrowseItems);
                            }
                        }
                        this.setBlocked(false);
                    }
                    return this.getRenderablePromise(contentBrowseItems, changes);
                };
                PreviewContentHandler.prototype.getRenderablePromise = function (contentBrowseItems, changes) {
                    var _this = this;
                    return wemQ.all(this.makeRenderableRequests(contentBrowseItems, changes))
                        .then(function (values) {
                        if (changes && changes.getRemoved().length > 0) {
                            _this.removeRenderableIds(changes.getRemoved().map(function (item) { return item.getModel().getContentId(); }));
                        }
                        else {
                            _this.notifyPreviewStateChangedIfNeeded();
                        }
                    }).catch(function (reason) { return api.DefaultErrorHandler.handle(reason); });
                };
                PreviewContentHandler.prototype.makeRenderableRequests = function (contentBrowseItems, changes) {
                    var _this = this;
                    var browseItems = changes && changes.getAdded().length > 0 ? changes.getAdded() : contentBrowseItems;
                    return browseItems.map(function (contentBrowseItem) {
                        var contentSummary = contentBrowseItem.getModel().getContentSummary();
                        return new api.content.page.IsRenderableRequest(contentSummary.getContentId()).sendAndParse()
                            .then(function (value) {
                            contentBrowseItem.setRenderable(value);
                            if (value) {
                                _this.addRenderableIds([contentSummary.getContentId()]);
                            }
                            else {
                                _this.removeRenderableIds([contentSummary.getContentId()], true);
                            }
                            return value;
                        }).catch(function (reason) { return api.DefaultErrorHandler.handle(reason); });
                    });
                };
                PreviewContentHandler.prototype.setBlocked = function (blocked) {
                    this.blocked = blocked;
                    this.notifyPreviewStateChangedIfNeeded();
                };
                PreviewContentHandler.prototype.isBlocked = function () {
                    return this.blocked;
                };
                PreviewContentHandler.prototype.setRenderableIds = function (contentIds, silent) {
                    this.renderableIds = contentIds ? contentIds.map(function (contentId) { return contentId.toString(); }) : null;
                    if (!silent) {
                        this.notifyPreviewStateChangedIfNeeded();
                    }
                };
                PreviewContentHandler.prototype.getRenderableIds = function () {
                    return this.renderableIds;
                };
                PreviewContentHandler.prototype.addRenderableIds = function (contentIds, silent) {
                    var _this = this;
                    if (contentIds) {
                        contentIds.forEach(function (contentId) {
                            if (_this.renderableIds.indexOf(contentId.toString()) == -1) {
                                _this.renderableIds.push(contentId.toString());
                            }
                        });
                        if (!silent) {
                            this.notifyPreviewStateChangedIfNeeded();
                        }
                    }
                };
                PreviewContentHandler.prototype.removeRenderableIds = function (contentIds, silent) {
                    var _this = this;
                    if (contentIds) {
                        contentIds.forEach(function (contentId) {
                            var index = _this.renderableIds.indexOf(contentId.toString());
                            if (index >= 0) {
                                _this.renderableIds.splice(index, 1);
                            }
                        });
                        if (!silent) {
                            this.notifyPreviewStateChangedIfNeeded();
                        }
                    }
                };
                PreviewContentHandler.prototype.notifyPreviewStateChangedIfNeeded = function () {
                    var newRenderable = this.isBlocked() || this.renderableIds.length > 0;
                    if (newRenderable != this.anyRenderable) {
                        this.notifyPreviewStateChanged(newRenderable);
                        this.anyRenderable = newRenderable;
                    }
                };
                PreviewContentHandler.prototype.onPreviewStateChanged = function (listener) {
                    this.previewStateChangedListeners.push(listener);
                };
                PreviewContentHandler.prototype.unPreviewStateChanged = function (listener) {
                    this.previewStateChangedListeners = this.previewStateChangedListeners.filter(function (curr) {
                        return curr !== listener;
                    });
                };
                PreviewContentHandler.prototype.notifyPreviewStateChanged = function (active) {
                    this.previewStateChangedListeners.forEach(function (listener) {
                        listener(active);
                    });
                };
                PreviewContentHandler.BLOCK_COUNT = 10;
                return PreviewContentHandler;
            })();
            action.PreviewContentHandler = PreviewContentHandler;
        })(action = browse.action || (browse.action = {}));
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
///<reference path='PreviewContentHandler.ts' /> 
var app;
(function (app) {
    var browse;
    (function (browse) {
        var BaseContentModelEvent = (function (_super) {
            __extends(BaseContentModelEvent, _super);
            function BaseContentModelEvent(model) {
                this.model = model;
                _super.call(this);
            }
            BaseContentModelEvent.prototype.getModels = function () {
                return this.model;
            };
            return BaseContentModelEvent;
        })(api.event.Event);
        browse.BaseContentModelEvent = BaseContentModelEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var Event = api.event.Event;
        var CloseContentEvent = (function (_super) {
            __extends(CloseContentEvent, _super);
            function CloseContentEvent(panel, checkCanRemovePanel) {
                if (checkCanRemovePanel === void 0) { checkCanRemovePanel = true; }
                _super.call(this);
                this.panel = panel;
                this.checkCanRemovePanel = checkCanRemovePanel;
            }
            CloseContentEvent.prototype.getPanel = function () {
                return this.panel;
            };
            CloseContentEvent.prototype.isCheckCanRemovePanel = function () {
                return this.checkCanRemovePanel;
            };
            CloseContentEvent.on = function (handler) {
                Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            CloseContentEvent.un = function (handler) {
                Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return CloseContentEvent;
        })(Event);
        browse.CloseContentEvent = CloseContentEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ContentDeletePromptEvent = (function (_super) {
            __extends(ContentDeletePromptEvent, _super);
            function ContentDeletePromptEvent() {
                _super.apply(this, arguments);
            }
            ContentDeletePromptEvent.prototype.setYesCallback = function (callback) {
                this.yesCallback = callback;
                return this;
            };
            ContentDeletePromptEvent.prototype.setNoCallback = function (callback) {
                this.noCallback = callback;
                return this;
            };
            ContentDeletePromptEvent.prototype.getYesCallback = function () {
                return this.yesCallback;
            };
            ContentDeletePromptEvent.prototype.getNoCallback = function () {
                return this.noCallback;
            };
            ContentDeletePromptEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ContentDeletePromptEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ContentDeletePromptEvent;
        })(browse.BaseContentModelEvent);
        browse.ContentDeletePromptEvent = ContentDeletePromptEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var GridSelectionChangeEvent = (function (_super) {
            __extends(GridSelectionChangeEvent, _super);
            function GridSelectionChangeEvent() {
                _super.apply(this, arguments);
            }
            GridSelectionChangeEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            GridSelectionChangeEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return GridSelectionChangeEvent;
        })(browse.BaseContentModelEvent);
        browse.GridSelectionChangeEvent = GridSelectionChangeEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var MoveContentEvent = (function (_super) {
            __extends(MoveContentEvent, _super);
            function MoveContentEvent() {
                _super.apply(this, arguments);
            }
            MoveContentEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            MoveContentEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return MoveContentEvent;
        })(browse.BaseContentModelEvent);
        browse.MoveContentEvent = MoveContentEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ShowContextMenuEvent = (function (_super) {
            __extends(ShowContextMenuEvent, _super);
            function ShowContextMenuEvent(x, y) {
                this.x = x;
                this.y = y;
                _super.call(this);
            }
            ShowContextMenuEvent.prototype.getX = function () {
                return this.x;
            };
            ShowContextMenuEvent.prototype.getY = function () {
                return this.y;
            };
            ShowContextMenuEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ShowContextMenuEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ShowContextMenuEvent;
        })(api.event.Event);
        browse.ShowContextMenuEvent = ShowContextMenuEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ShowDetailsEvent = (function (_super) {
            __extends(ShowDetailsEvent, _super);
            function ShowDetailsEvent() {
                _super.apply(this, arguments);
            }
            ShowDetailsEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ShowDetailsEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ShowDetailsEvent;
        })(browse.BaseContentModelEvent);
        browse.ShowDetailsEvent = ShowDetailsEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ShowNewContentDialogEvent = (function (_super) {
            __extends(ShowNewContentDialogEvent, _super);
            function ShowNewContentDialogEvent(parentContent) {
                _super.call(this, [parentContent]);
                this.parentContent = parentContent;
            }
            ShowNewContentDialogEvent.prototype.getParentContent = function () {
                return this.parentContent;
            };
            ShowNewContentDialogEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ShowNewContentDialogEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ShowNewContentDialogEvent;
        })(browse.BaseContentModelEvent);
        browse.ShowNewContentDialogEvent = ShowNewContentDialogEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ShowNewContentGridEvent = (function (_super) {
            __extends(ShowNewContentGridEvent, _super);
            function ShowNewContentGridEvent() {
                _super.apply(this, arguments);
            }
            ShowNewContentGridEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ShowNewContentGridEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ShowNewContentGridEvent;
        })(api.event.Event);
        browse.ShowNewContentGridEvent = ShowNewContentGridEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ShowPreviewEvent = (function (_super) {
            __extends(ShowPreviewEvent, _super);
            function ShowPreviewEvent() {
                _super.apply(this, arguments);
            }
            ShowPreviewEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ShowPreviewEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ShowPreviewEvent;
        })(browse.BaseContentModelEvent);
        browse.ShowPreviewEvent = ShowPreviewEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ToggleSearchPanelEvent = (function (_super) {
            __extends(ToggleSearchPanelEvent, _super);
            function ToggleSearchPanelEvent() {
                _super.apply(this, arguments);
            }
            ToggleSearchPanelEvent.on = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            ToggleSearchPanelEvent.un = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            return ToggleSearchPanelEvent;
        })(api.event.Event);
        browse.ToggleSearchPanelEvent = ToggleSearchPanelEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ViewContentEvent = (function (_super) {
            __extends(ViewContentEvent, _super);
            function ViewContentEvent() {
                _super.apply(this, arguments);
            }
            ViewContentEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ViewContentEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ViewContentEvent;
        })(browse.BaseContentModelEvent);
        browse.ViewContentEvent = ViewContentEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ContentBrowseToolbar = (function (_super) {
            __extends(ContentBrowseToolbar, _super);
            function ContentBrowseToolbar(actions) {
                _super.call(this);
                this.addClass("content-browse-toolbar");
                this.addActions(actions.getAllActions());
            }
            return ContentBrowseToolbar;
        })(api.ui.toolbar.Toolbar);
        browse.ContentBrowseToolbar = ContentBrowseToolbar;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ContentBrowseItemPanel = (function (_super) {
            __extends(ContentBrowseItemPanel, _super);
            function ContentBrowseItemPanel() {
                _super.apply(this, arguments);
            }
            ContentBrowseItemPanel.prototype.createItemSelectionPanel = function () {
                return new browse.ContentBrowseItemsSelectionPanel();
            };
            ContentBrowseItemPanel.prototype.createItemStatisticsPanel = function () {
                return new app.view.ContentItemStatisticsPanel();
            };
            ContentBrowseItemPanel.prototype.setItems = function (items) {
                return _super.prototype.setItems.call(this, items);
            };
            ContentBrowseItemPanel.prototype.getItems = function () {
                return _super.prototype.getItems.call(this);
            };
            return ContentBrowseItemPanel;
        })(api.app.browse.BrowseItemPanel);
        browse.ContentBrowseItemPanel = ContentBrowseItemPanel;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ContentSummaryAndCompareStatusViewer = api.content.ContentSummaryAndCompareStatusViewer;
        var ContentBrowseItemsSelectionPanel = (function (_super) {
            __extends(ContentBrowseItemsSelectionPanel, _super);
            function ContentBrowseItemsSelectionPanel() {
                _super.apply(this, arguments);
            }
            ContentBrowseItemsSelectionPanel.prototype.createItemViewer = function (item) {
                var viewer = new ContentSummaryAndCompareStatusViewer();
                viewer.setObject(item.getModel());
                return viewer;
            };
            return ContentBrowseItemsSelectionPanel;
        })(api.app.browse.BrowseItemsSelectionPanel);
        browse.ContentBrowseItemsSelectionPanel = ContentBrowseItemsSelectionPanel;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var BrowseItem = api.app.browse.BrowseItem;
        var ResponsiveManager = api.ui.responsive.ResponsiveManager;
        var ResponsiveRanges = api.ui.responsive.ResponsiveRanges;
        var ContentIconUrlResolver = api.content.ContentIconUrlResolver;
        var DetailsPanel = app.view.detail.DetailsPanel;
        var ActiveDetailsPanelsManager = app.view.detail.ActiveDetailsPanelManager;
        var NonMobileDetailsPanelsManager = app.view.detail.NonMobileDetailsPanelsManager;
        var ContentServerEventsHandler = api.content.event.ContentServerEventsHandler;
        var ContentBrowsePanel = (function (_super) {
            __extends(ContentBrowsePanel, _super);
            function ContentBrowsePanel() {
                var _this = this;
                this.contentTreeGrid = new app.browse.ContentTreeGrid();
                this.contentBrowseItemPanel = components.detailPanel = new browse.ContentBrowseItemPanel();
                this.contentFilterPanel = new app.browse.filter.ContentBrowseFilterPanel();
                this.browseActions = this.contentTreeGrid.getContextMenu().getActions();
                this.toolbar = new browse.ContentBrowseToolbar(this.browseActions);
                this.defaultDockedDetailsPanel = DetailsPanel.create().setUseSplitter(false).build();
                _super.call(this, {
                    browseToolbar: this.toolbar,
                    treeGrid: this.contentTreeGrid,
                    browseItemPanel: this.contentBrowseItemPanel,
                    filterPanel: this.contentFilterPanel,
                    hasDetailsPanel: true
                });
                var showMask = function () {
                    if (_this.isVisible()) {
                        _this.contentTreeGrid.mask();
                    }
                };
                this.contentFilterPanel.onSearch(showMask);
                this.contentFilterPanel.onReset(showMask);
                this.contentFilterPanel.onRefresh(showMask);
                this.getTreeGrid().onDataChanged(function (event) {
                    if (event.getType() === 'updated') {
                        var browseItems = _this.treeNodesToBrowseItems(event.getTreeNodes());
                        _this.getBrowseItemPanel().updateItemViewers(browseItems);
                    }
                });
                this.onShown(function () {
                    app.Router.setHash("browse");
                });
                ResponsiveManager.onAvailableSizeChanged(this, function (item) {
                    _this.browseActions.TOGGLE_SEARCH_PANEL.setVisible(item.isInRangeOrSmaller(ResponsiveRanges._360_540));
                });
                this.handleGlobalEvents();
            }
            ContentBrowsePanel.prototype.doRender = function () {
                _super.prototype.doRender.call(this);
                var nonMobileDetailsPanelsManagerBuilder = NonMobileDetailsPanelsManager.create();
                this.initSplitPanelWithDockedDetails(nonMobileDetailsPanelsManagerBuilder);
                this.initFloatingDetailsPanel(nonMobileDetailsPanelsManagerBuilder);
                this.initItemStatisticsPanelForMobile();
                var nonMobileDetailsPanelsManager = nonMobileDetailsPanelsManagerBuilder.build();
                if (nonMobileDetailsPanelsManager.requiresCollapsedDetailsPanel()) {
                    nonMobileDetailsPanelsManager.hideDockedDetailsPanel();
                }
                nonMobileDetailsPanelsManager.ensureButtonHasCorrectState();
                this.setActiveDetailsPanel(nonMobileDetailsPanelsManager);
                this.subscribeDetailsPanelsOnEvents(nonMobileDetailsPanelsManager);
                this.onShown(function () {
                    if (!!nonMobileDetailsPanelsManager.getActivePanel().getActiveWidget()) {
                        nonMobileDetailsPanelsManager.getActivePanel().getActiveWidget().slideIn();
                    }
                });
                this.toolbar.appendChild(nonMobileDetailsPanelsManager.getToggleButton());
                return true;
            };
            ContentBrowsePanel.prototype.subscribeDetailsPanelsOnEvents = function (nonMobileDetailsPanelsManager) {
                var _this = this;
                this.getTreeGrid().onSelectionChanged(function (currentSelection, fullSelection) {
                    var browseItems = _this.getBrowseItemPanel().getItems(), item = null;
                    if (browseItems.length > 0) {
                        item = browseItems[browseItems.length - 1];
                    }
                    _this.updateDetailsPanel(item ? item.getModel() : null);
                });
                ResponsiveManager.onAvailableSizeChanged(this.getFilterAndGridSplitPanel(), function (item) {
                    nonMobileDetailsPanelsManager.handleResizeEvent();
                });
                ResponsiveManager.onAvailableSizeChanged(this, function (item) {
                    if (ResponsiveRanges._540_720.isFitOrBigger(item.getOldRangeValue()) &&
                        item.isInRangeOrSmaller(ResponsiveRanges._360_540)) {
                        nonMobileDetailsPanelsManager.hideActivePanel();
                        ActiveDetailsPanelsManager.setActiveDetailsPanel(_this.mobileContentItemStatisticsPanel.getDetailsPanel());
                    }
                });
            };
            ContentBrowsePanel.prototype.initSplitPanelWithDockedDetails = function (nonMobileDetailsPanelsManagerBuilder) {
                var contentPanelsAndDetailPanel = new api.ui.panel.SplitPanelBuilder(this.getFilterAndGridSplitPanel(), this.defaultDockedDetailsPanel).
                    setAlignment(api.ui.panel.SplitPanelAlignment.VERTICAL).
                    setSecondPanelSize(280, api.ui.panel.SplitPanelUnit.PIXEL).
                    setSecondPanelMinSize(280, api.ui.panel.SplitPanelUnit.PIXEL).
                    setAnimationDelay(600).
                    setSecondPanelShouldSlideRight(true).
                    build();
                contentPanelsAndDetailPanel.addClass("split-panel-with-details");
                contentPanelsAndDetailPanel.setSecondPanelSize(280, api.ui.panel.SplitPanelUnit.PIXEL);
                this.appendChild(contentPanelsAndDetailPanel);
                nonMobileDetailsPanelsManagerBuilder.setSplitPanelWithGridAndDetails(contentPanelsAndDetailPanel);
                nonMobileDetailsPanelsManagerBuilder.setDefaultDetailsPanel(this.defaultDockedDetailsPanel);
            };
            ContentBrowsePanel.prototype.initFloatingDetailsPanel = function (nonMobileDetailsPanelsManagerBuilder) {
                this.floatingDetailsPanel = DetailsPanel.create().build();
                this.floatingDetailsPanel.addClass("floating-details-panel");
                nonMobileDetailsPanelsManagerBuilder.setFloatingDetailsPanel(this.floatingDetailsPanel);
                this.appendChild(this.floatingDetailsPanel);
            };
            ContentBrowsePanel.prototype.initItemStatisticsPanelForMobile = function () {
                var _this = this;
                this.mobileBrowseActions = new app.browse.action.MobileContentTreeGridActions(this.contentTreeGrid);
                this.mobileContentItemStatisticsPanel = new app.view.MobileContentItemStatisticsPanel(this.mobileBrowseActions);
                var updateItem = function () {
                    if (ActiveDetailsPanelsManager.getActiveDetailsPanel() == _this.mobileContentItemStatisticsPanel.getDetailsPanel()) {
                        var browseItems = _this.getBrowseItemPanel().getItems();
                        if (browseItems.length == 1) {
                            new api.content.page.IsRenderableRequest(new api.content.ContentId(browseItems[0].getId())).sendAndParse().
                                then(function (renderable) {
                                var item = browseItems[0].toViewItem();
                                item.setRenderable(renderable);
                                _this.mobileContentItemStatisticsPanel.setItem(item);
                                _this.mobileBrowseActions.updateActionsEnabledState(browseItems);
                            });
                        }
                    }
                };
                this.contentTreeGrid.onSelectionChanged(updateItem);
                api.content.TreeGridItemClickedEvent.on(function (event) {
                    if (event.isRepeatedSelection()) {
                        updateItem();
                    }
                });
                this.appendChild(this.mobileContentItemStatisticsPanel);
            };
            ContentBrowsePanel.prototype.setActiveDetailsPanel = function (nonMobileDetailsPanelsManager) {
                if (this.mobileContentItemStatisticsPanel.isVisible()) {
                    ActiveDetailsPanelsManager.setActiveDetailsPanel(this.mobileContentItemStatisticsPanel.getDetailsPanel());
                }
                else {
                    ActiveDetailsPanelsManager.setActiveDetailsPanel(nonMobileDetailsPanelsManager.getActivePanel());
                }
            };
            ContentBrowsePanel.prototype.treeNodesToBrowseItems = function (nodes) {
                var browseItems = [];
                nodes.forEach(function (node, index) {
                    for (var i = 0; i <= index; i++) {
                        if (nodes[i].getData().getId() === node.getData().getId()) {
                            break;
                        }
                    }
                    if (i === index) {
                        var data = node.getData();
                        if (!!data && !!data.getContentSummary()) {
                            var item = new browse.ContentBrowseItem(data).
                                setId(data.getId()).
                                setDisplayName(data.getContentSummary().getDisplayName()).
                                setPath(data.getContentSummary().getPath().toString()).
                                setIconUrl(new ContentIconUrlResolver().setContent(data.getContentSummary()).resolve());
                            browseItems.push(item);
                        }
                    }
                });
                return browseItems;
            };
            ContentBrowsePanel.prototype.handleGlobalEvents = function () {
                var _this = this;
                browse.ToggleSearchPanelEvent.on(function () {
                    _this.toggleFilterPanel();
                });
                app.create.NewMediaUploadEvent.on(function (event) {
                    _this.handleNewMediaUpload(event);
                });
                this.subscribeOnContentEvents();
                app.view.ContentPreviewPathChangedEvent.on(function (event) {
                    _this.selectPreviewedContentInGrid(event.getPreviewPath());
                });
                app.view.ContentPreviewPathChangedEvent.on(function (event) {
                    _this.selectPreviewedContentInGrid(event.getPreviewPath());
                });
            };
            ContentBrowsePanel.prototype.selectPreviewedContentInGrid = function (contentPreviewPath) {
                var path = this.getPathFromPreviewPath(contentPreviewPath);
                if (path) {
                    var contentPath = api.content.ContentPath.fromString(path);
                    if (this.isSingleItemSelectedInGrid() && !this.isGivenPathSelectedInGrid(contentPath)) {
                        this.selectContentInGridByPath(contentPath);
                    }
                }
            };
            ContentBrowsePanel.prototype.selectContentInGridByPath = function (path) {
                this.contentTreeGrid.expandTillNodeWithGivenPath(path, this.contentTreeGrid.getSelectedNodes()[0]);
            };
            ContentBrowsePanel.prototype.isGivenPathSelectedInGrid = function (path) {
                var contentSummary = this.contentTreeGrid.getSelectedNodes()[0].getData();
                return contentSummary.getPath().equals(path);
            };
            ContentBrowsePanel.prototype.isSingleItemSelectedInGrid = function () {
                return this.contentTreeGrid.getSelectedNodes() && this.contentTreeGrid.getSelectedNodes().length == 1;
            };
            ContentBrowsePanel.prototype.getPathFromPreviewPath = function (contentPreviewPath) {
                return api.rendering.UriHelper.getPathFromPortalPreviewUri(contentPreviewPath, api.rendering.RenderingMode.PREVIEW, api.content.Branch.DRAFT);
            };
            ContentBrowsePanel.prototype.subscribeOnContentEvents = function () {
                var _this = this;
                var handler = ContentServerEventsHandler.getInstance();
                handler.onContentCreated(function (data) { return _this.handleContentCreated(data); });
                handler.onContentUpdated(function (data) { return _this.handleContentUpdated(data); });
                handler.onContentRenamed(function (data, oldPaths) {
                    _this.handleContentCreated(data, oldPaths);
                });
                handler.onContentDeleted(function (data) {
                    var paths = data.map(function (changeItem) { return changeItem.getContentPath(); });
                    _this.handleContentDeleted(paths);
                });
                handler.onContentPending(function (data) { return _this.handleContentPending(data); });
                handler.onContentDuplicated(function (data) { return _this.handleContentCreated(data); });
                handler.onContentPublished(function (data) { return _this.handleContentPublished(data); });
                handler.onContentMoved(function (data, oldPaths) {
                    _this.handleContentDeleted(oldPaths);
                    _this.handleContentCreated(data);
                });
                handler.onContentSorted(function (data) { return _this.handleContentSorted(data); });
            };
            ContentBrowsePanel.prototype.handleContentCreated = function (data, oldPaths) {
                var _this = this;
                if (ContentBrowsePanel.debug) {
                    console.debug("ContentBrowsePanel: created", data, oldPaths);
                }
                var paths = data.map(function (d) { return d.getContentSummary().getPath(); });
                var createResult = this.contentTreeGrid.findByPaths(paths, true);
                var isFiltered = this.contentTreeGrid.getRoot().isFiltered(), nodes = [];
                data.forEach(function (el) {
                    for (var i = 0; i < createResult.length; i++) {
                        if (el.getContentSummary().getPath().isChildOf(createResult[i].getPath())) {
                            if (oldPaths && oldPaths.length > 0) {
                                var renameResult = _this.contentTreeGrid.findByPaths(oldPaths);
                                var premerged = renameResult.map(function (el) {
                                    return el.getNodes();
                                });
                                nodes = nodes.concat.apply(nodes, premerged);
                                nodes.forEach(function (node) {
                                    if (node.getDataId() === el.getId()) {
                                        node.setData(el);
                                        node.clearViewers();
                                        _this.contentTreeGrid.xUpdatePathsInChildren(node);
                                    }
                                });
                            }
                            else {
                                _this.contentTreeGrid.xAppendContentNodes(createResult[i].getNodes().map(function (node) {
                                    return new api.content.TreeNodeParentOfContent(el, node);
                                }), !isFiltered).then(function (results) {
                                    nodes = nodes.concat(results);
                                });
                            }
                            break;
                        }
                    }
                });
                this.contentTreeGrid.initAndRender();
                isFiltered = true;
                if (isFiltered) {
                    this.setFilterPanelRefreshNeeded(true);
                    window.setTimeout(function () {
                        _this.refreshFilter();
                    }, 1000);
                }
            };
            ContentBrowsePanel.prototype.handleContentUpdated = function (data) {
                var _this = this;
                if (ContentBrowsePanel.debug) {
                    console.debug("ContentBrowsePanel: updated", data);
                }
                var paths = data.map(function (d) { return d.getContentSummary().getPath(); });
                var treeNodes = this.contentTreeGrid.findByPaths(paths);
                var results = [];
                data.forEach(function (el) {
                    for (var i = 0; i < treeNodes.length; i++) {
                        if (treeNodes[i].getId() === el.getId()) {
                            treeNodes[i].updateNodeData(el);
                            _this.updateStatisticsPreview(el);
                            _this.updateItemInDetailsPanelIfNeeded(el);
                            results.push(treeNodes[i]);
                            break;
                        }
                    }
                });
                this.browseActions.updateActionsEnabledState(this.getBrowseItemPanel().getItems());
                this.mobileBrowseActions.updateActionsEnabledState(this.getBrowseItemPanel().getItems());
                return this.contentTreeGrid.xPlaceContentNodes(results);
            };
            ContentBrowsePanel.prototype.handleContentDeleted = function (paths) {
                var _this = this;
                if (ContentBrowsePanel.debug) {
                    console.debug("ContentBrowsePanel: deleted", paths);
                }
                var nodes = this.contentTreeGrid.findByPaths(paths).map(function (el) { return el.getNodes(); });
                var merged = [];
                merged = merged.concat.apply(merged, nodes);
                merged.forEach(function (node) {
                    var contentSummary = node.getData().getContentSummary();
                    if (node.getData() && !!contentSummary) {
                        _this.updateDetailsPanel(null);
                    }
                });
                this.contentTreeGrid.xDeleteContentNodes(merged);
                var uniqueParents = paths.map(function (path) { return path.getParentPath(); }).filter(function (parent, index, self) {
                    return self.indexOf(parent) === index;
                });
                var parentNodes = this.contentTreeGrid.findByPaths(uniqueParents).map(function (parentNode) { return parentNode.getNodes(); });
                var mergedParentNodes = [];
                mergedParentNodes = mergedParentNodes.concat.apply(mergedParentNodes, parentNodes);
                mergedParentNodes.forEach(function (parentNode) {
                    if (parentNode.getChildren().length == 0) {
                        _this.contentTreeGrid.refreshNodeData(parentNode);
                    }
                });
                this.setFilterPanelRefreshNeeded(true);
                window.setTimeout(function () {
                    _this.refreshFilter();
                }, 1000);
            };
            ContentBrowsePanel.prototype.handleContentPending = function (data) {
                var _this = this;
                if (ContentBrowsePanel.debug) {
                    console.debug("ContentBrowsePanel: pending", data);
                }
                var paths = data.map(function (d) { return d.getContentSummary().getPath(); });
                var treeNodes = this.contentTreeGrid.findByPaths(paths);
                data.forEach(function (el) {
                    for (var i = 0; i < treeNodes.length; i++) {
                        if (treeNodes[i].getId() === el.getId()) {
                            treeNodes[i].updateNodeData(el);
                            _this.updateItemInDetailsPanelIfNeeded(el);
                            break;
                        }
                    }
                });
                this.contentTreeGrid.invalidate();
            };
            ContentBrowsePanel.prototype.handleContentPublished = function (data) {
                var _this = this;
                if (ContentBrowsePanel.debug) {
                    console.debug("ContentBrowsePanel: published", data);
                }
                var paths = data.map(function (d) { return d.getContentSummary().getPath(); });
                var treeNodes = this.contentTreeGrid.findByPaths(paths);
                data.forEach(function (el) {
                    for (var i = 0; i < treeNodes.length; i++) {
                        if (treeNodes[i].getId() === el.getId()) {
                            treeNodes[i].updateNodeData(el);
                            _this.updateItemInDetailsPanelIfNeeded(el);
                            break;
                        }
                    }
                });
                this.contentTreeGrid.invalidate();
            };
            ContentBrowsePanel.prototype.handleContentSorted = function (data) {
                var _this = this;
                if (ContentBrowsePanel.debug) {
                    console.debug("ContentBrowsePanel: sorted", data);
                }
                var paths = data.map(function (d) { return d.getContentSummary().getPath(); });
                var sortResult = this.contentTreeGrid.findByPaths(paths);
                var nodes = sortResult.map(function (el) {
                    return el.getNodes();
                });
                var merged = [];
                merged = merged.concat.apply(merged, nodes);
                this.contentTreeGrid.xSortNodesChildren(merged).then(function () { return _this.contentTreeGrid.invalidate(); });
            };
            ContentBrowsePanel.prototype.handleNewMediaUpload = function (event) {
                var _this = this;
                event.getUploadItems().forEach(function (item) {
                    _this.contentTreeGrid.appendUploadNode(item);
                });
            };
            ContentBrowsePanel.prototype.updateStatisticsPreview = function (el) {
                var _this = this;
                var content = el, previewItem = this.getBrowseItemPanel().getStatisticsItem();
                if (!!content && !!previewItem && content.getPath().toString() === previewItem.getPath()) {
                    new api.content.page.IsRenderableRequest(el.getContentId()).sendAndParse().
                        then(function (renderable) {
                        var item = new BrowseItem(content).
                            setId(content.getId()).
                            setDisplayName(content.getDisplayName()).
                            setPath(content.getPath().toString()).
                            setIconUrl(new ContentIconUrlResolver().setContent(content.getContentSummary()).resolve()).
                            setRenderable(renderable);
                        _this.getBrowseItemPanel().setStatisticsItem(item);
                    });
                }
            };
            ContentBrowsePanel.prototype.updateDetailsPanel = function (item) {
                var detailsPanel = ActiveDetailsPanelsManager.getActiveDetailsPanel();
                return detailsPanel ? detailsPanel.setItem(item) : wemQ(null);
            };
            ContentBrowsePanel.prototype.updateItemInDetailsPanelIfNeeded = function (item) {
                var detailsPanelItem = ActiveDetailsPanelsManager.getActiveDetailsPanel().getItem();
                if (detailsPanelItem && (detailsPanelItem.getId() == item.getId())) {
                    this.updateDetailsPanel(item);
                }
            };
            ContentBrowsePanel.prototype.getBrowseItemPanel = function () {
                return _super.prototype.getBrowseItemPanel.call(this);
            };
            return ContentBrowsePanel;
        })(api.app.browse.BrowsePanel);
        browse.ContentBrowsePanel = ContentBrowsePanel;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ElementHelper = api.dom.ElementHelper;
        var GridColumnBuilder = api.ui.grid.GridColumnBuilder;
        var TreeGrid = api.ui.treegrid.TreeGrid;
        var TreeGridBuilder = api.ui.treegrid.TreeGridBuilder;
        var DateTimeFormatter = api.ui.treegrid.DateTimeFormatter;
        var TreeGridContextMenu = api.ui.treegrid.TreeGridContextMenu;
        var ContentPath = api.content.ContentPath;
        var ContentSummaryBuilder = api.content.ContentSummaryBuilder;
        var ContentSummaryAndCompareStatusViewer = api.content.ContentSummaryAndCompareStatusViewer;
        var CompareContentRequest = api.content.CompareContentRequest;
        var ContentSummaryAndCompareStatus = api.content.ContentSummaryAndCompareStatus;
        var ContentSummaryAndCompareStatusFetcher = api.content.ContentSummaryAndCompareStatusFetcher;
        var TreeNodesOfContentPath = api.content.TreeNodesOfContentPath;
        var ContentBrowseSearchEvent = app.browse.filter.ContentBrowseSearchEvent;
        var ContentBrowseResetEvent = app.browse.filter.ContentBrowseResetEvent;
        var ContentBrowseRefreshEvent = app.browse.filter.ContentBrowseRefreshEvent;
        var ContentVersionSetEvent = api.content.event.ActiveContentVersionSetEvent;
        var ContentQueryRequest = api.content.ContentQueryRequest;
        var ContentTreeGridActions = app.browse.action.ContentTreeGridActions;
        var CompareStatus = api.content.CompareStatus;
        var ResponsiveRanges = api.ui.responsive.ResponsiveRanges;
        var ContentTreeGrid = (function (_super) {
            __extends(ContentTreeGrid, _super);
            function ContentTreeGrid() {
                var _this = this;
                var nameColumn = new GridColumnBuilder().
                    setName("Name").
                    setId("displayName").
                    setField("contentSummary.displayName").
                    setMinWidth(130).
                    setFormatter(this.nameFormatter).
                    build();
                var compareStatusColumn = new GridColumnBuilder().
                    setName("CompareStatus").
                    setId("compareStatus").
                    setField("compareStatus").
                    setFormatter(this.statusFormatter).
                    setCssClass("status").
                    setMinWidth(75).
                    setMaxWidth(75).
                    build();
                var orderColumn = new GridColumnBuilder().
                    setName("Order").
                    setId("order").
                    setField("contentSummary.order").
                    setCssClass("order").
                    setMinWidth(25).
                    setMaxWidth(40).
                    setFormatter(this.orderFormatter).
                    build();
                var modifiedTimeColumn = new GridColumnBuilder().
                    setName("ModifiedTime").
                    setId("modifiedTime").
                    setField("contentSummary.modifiedTime").
                    setCssClass("modified").
                    setMinWidth(135).
                    setMaxWidth(135).
                    setFormatter(DateTimeFormatter.format).
                    build();
                _super.call(this, new TreeGridBuilder().
                    setColumns([
                    nameColumn,
                    orderColumn,
                    compareStatusColumn,
                    modifiedTimeColumn
                ]).
                    setShowContextMenu(new TreeGridContextMenu(new ContentTreeGridActions(this))).
                    setPartialLoadEnabled(true).
                    setLoadBufferSize(20).
                    prependClasses("content-tree-grid"));
                var updateColumns = function (force) {
                    if (force) {
                        var width = _this.getEl().getWidth();
                        if (ResponsiveRanges._240_360.isFitOrSmaller(width)) {
                            _this.getGrid().setColumns([nameColumn, orderColumn]);
                        }
                        else if (ResponsiveRanges._360_540.isFitOrSmaller(width)) {
                            _this.getGrid().setColumns([nameColumn, orderColumn, compareStatusColumn]);
                        }
                        else {
                            if (ResponsiveRanges._540_720.isFitOrSmaller(width)) {
                                modifiedTimeColumn.setMaxWidth(90);
                                modifiedTimeColumn.setFormatter(DateTimeFormatter.formatNoTimestamp);
                            }
                            else {
                                modifiedTimeColumn.setMaxWidth(135);
                                modifiedTimeColumn.setFormatter(DateTimeFormatter.format);
                            }
                            _this.getGrid().setColumns([nameColumn, orderColumn, compareStatusColumn, modifiedTimeColumn]);
                        }
                    }
                    else {
                        _this.getGrid().resizeCanvas();
                    }
                };
                var onBecameActive = function (active) {
                    if (active) {
                        updateColumns(true);
                        _this.unActiveChanged(onBecameActive);
                    }
                };
                this.onActiveChanged(onBecameActive);
                api.ui.responsive.ResponsiveManager.onAvailableSizeChanged(this, function (item) {
                    if (_this.isInRenderingView()) {
                        updateColumns(item.isRangeSizeChanged());
                    }
                });
                this.getGrid().subscribeOnClick(function (event, data) {
                    var elem = new ElementHelper(event.target);
                    if (elem.hasClass("sort-dialog-trigger")) {
                        _this.sortIconClickCallback();
                    }
                });
                this.getGrid().subscribeOnDblClick(function (event, data) {
                    if (_this.isActive()) {
                        var node = _this.getGrid().getDataView().getItem(data.row);
                        if (!!_this.getDataId(node.getData())) {
                            new api.content.event.EditContentEvent([node.getData()]).fire();
                        }
                    }
                });
                ContentBrowseSearchEvent.on(function (event) {
                    var contentQueryResult = event.getContentQueryResult();
                    var contentSummaries = contentQueryResult.getContents(), compareRequest = CompareContentRequest.fromContentSummaries(contentSummaries);
                    _this.filterQuery = event.getContentQuery();
                    compareRequest.sendAndParse().then(function (compareResults) {
                        var contents = ContentSummaryAndCompareStatusFetcher.updateCompareStatus(contentSummaries, compareResults);
                        var metadata = contentQueryResult.getMetadata();
                        if (metadata.getTotalHits() > metadata.getHits()) {
                            contents.push(new ContentSummaryAndCompareStatus());
                        }
                        _this.filter(contents);
                        _this.getRoot().getCurrentRoot().setMaxChildren(metadata.getTotalHits());
                        _this.notifyLoaded();
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                });
                ContentBrowseResetEvent.on(function (event) {
                    _this.resetFilter();
                });
                ContentBrowseRefreshEvent.on(function (event) {
                    _this.notifyLoaded();
                });
                ContentVersionSetEvent.on(function (event) {
                    _this.updateContentNode(event.getContentId());
                });
            }
            ContentTreeGrid.prototype.orderFormatter = function (row, cell, value, columnDef, node) {
                var wrapper = new api.dom.SpanEl();
                if (!api.util.StringHelper.isBlank(value)) {
                    wrapper.getEl().setTitle(value);
                }
                if (node.getData().getContentSummary()) {
                    var childOrder = node.getData().getContentSummary().getChildOrder();
                    var icon;
                    if (!childOrder.isDefault()) {
                        if (!childOrder.isManual()) {
                            if (childOrder.isDesc()) {
                                icon = new api.dom.DivEl("icon-arrow-up4 sort-dialog-trigger");
                            }
                            else {
                                icon = new api.dom.DivEl("icon-arrow-down4 sort-dialog-trigger");
                            }
                        }
                        else {
                            icon = new api.dom.DivEl("icon-menu3 sort-dialog-trigger");
                        }
                        wrapper.getEl().setInnerHtml(icon.toString(), false);
                    }
                }
                return wrapper.toString();
            };
            ContentTreeGrid.prototype.sortIconClickCallback = function () {
                new app.browse.SortContentEvent(this.getSelectedDataList()).fire();
            };
            ContentTreeGrid.prototype.statusFormatter = function (row, cell, value, columnDef, node) {
                var data = node.getData(), status, statusEl = new api.dom.SpanEl();
                if (!!data.getContentSummary()) {
                    var compareStatus = CompareStatus[CompareStatus[value]];
                    status = api.content.CompareStatusFormatter.formatStatus(compareStatus);
                    if (!!CompareStatus[value]) {
                        statusEl.addClass(CompareStatus[value].toLowerCase().replace("_", "-") || "unknown");
                    }
                    statusEl.getEl().setText(status);
                }
                else if (!!data.getUploadItem()) {
                    status = new api.ui.ProgressBar(data.getUploadItem().getProgress());
                    statusEl.appendChild(status);
                }
                return statusEl.toString();
            };
            ContentTreeGrid.prototype.nameFormatter = function (row, cell, value, columnDef, node) {
                var data = node.getData();
                if (!!data.getContentSummary() || !!data.getUploadItem()) {
                    var viewer = node.getViewer("name");
                    if (!viewer) {
                        viewer = new ContentSummaryAndCompareStatusViewer();
                        node.setViewer("name", viewer);
                    }
                    viewer.setObject(node.getData(), node.calcLevel() > 1);
                    return viewer.toString();
                }
                else {
                    var content = new api.dom.DivEl("children-to-load"), parent = node.getParent();
                    content.setHtml((parent.getMaxChildren() - parent.getChildren().length + 1) + " children left to load.");
                    return content.toString();
                }
            };
            ContentTreeGrid.prototype.fetch = function (node, dataId) {
                return this.fetchById(node.getData().getContentId());
            };
            ContentTreeGrid.prototype.fetchById = function (id) {
                return ContentSummaryAndCompareStatusFetcher.fetch(id);
            };
            ContentTreeGrid.prototype.fetchChildren = function (parentNode) {
                var parentContentId = null;
                if (parentNode) {
                    parentContentId = parentNode.getData() ? parentNode.getData().getContentId() : parentContentId;
                }
                else {
                    parentNode = this.getRoot().getCurrentRoot();
                }
                var from = parentNode.getChildren().length;
                if (from > 0 && !parentNode.getChildren()[from - 1].getData().getContentSummary()) {
                    parentNode.getChildren().pop();
                    from--;
                }
                if (!this.isFiltered() || parentNode != this.getRoot().getCurrentRoot()) {
                    return ContentSummaryAndCompareStatusFetcher.fetchChildren(parentContentId, from, ContentTreeGrid.MAX_FETCH_SIZE).
                        then(function (data) {
                        var contents = parentNode.getChildren().map(function (el) {
                            return el.getData();
                        }).slice(0, from).concat(data.getContents());
                        var meta = data.getMetadata();
                        parentNode.setMaxChildren(meta.getTotalHits());
                        if (from + meta.getHits() < meta.getTotalHits()) {
                            contents.push(new ContentSummaryAndCompareStatus());
                        }
                        return contents;
                    });
                }
                else {
                    this.filterQuery.setFrom(from);
                    this.filterQuery.setSize(ContentTreeGrid.MAX_FETCH_SIZE);
                    return new ContentQueryRequest(this.filterQuery).
                        setExpand(api.rest.Expand.SUMMARY).
                        sendAndParse().
                        then(function (contentQueryResult) {
                        var contentSummaries = contentQueryResult.getContents();
                        var compareRequest = CompareContentRequest.fromContentSummaries(contentSummaries);
                        return compareRequest.sendAndParse().
                            then(function (compareResults) {
                            var list = parentNode.getChildren().map(function (el) {
                                return el.getData();
                            }).slice(0, from).concat(ContentSummaryAndCompareStatusFetcher.updateCompareStatus(contentSummaries, compareResults));
                            var meta = contentQueryResult.getMetadata();
                            if (from + meta.getHits() < meta.getTotalHits()) {
                                list.push(new ContentSummaryAndCompareStatus());
                            }
                            parentNode.setMaxChildren(meta.getTotalHits());
                            return list;
                        });
                    });
                }
            };
            ContentTreeGrid.prototype.fetchChildrenIds = function (parentNode) {
                var parentContentId = null;
                if (parentNode) {
                    parentContentId = parentNode.getData() ? parentNode.getData().getContentId() : parentContentId;
                }
                else {
                    parentNode = this.getRoot().getCurrentRoot();
                }
                var size = parentNode.getChildren().length;
                if (size > 0 && !parentNode.getChildren()[size - 1].getData().getContentSummary()) {
                    parentNode.getChildren().pop();
                    size--;
                }
                if (!this.isFiltered() || parentNode != this.getRoot().getCurrentRoot()) {
                    return ContentSummaryAndCompareStatusFetcher.fetchChildrenIds(parentContentId, 0, size + 1).
                        then(function (response) {
                        return response.getContents();
                    });
                }
                else {
                    this.filterQuery.setFrom(0);
                    this.filterQuery.setSize(size + 1);
                    return new ContentQueryRequest(this.filterQuery).
                        setExpand(api.rest.Expand.SUMMARY).
                        sendAndParse().
                        then(function (contentQueryResult) {
                        return contentQueryResult.getContents();
                    });
                }
            };
            ContentTreeGrid.prototype.hasChildren = function (data) {
                return data.hasChildren();
            };
            ContentTreeGrid.prototype.getDataId = function (data) {
                return data.getId();
            };
            ContentTreeGrid.prototype.deleteNodes = function (dataList) {
                var _this = this;
                var root = this.getRoot().getCurrentRoot(), node;
                dataList = dataList.filter(function (data) {
                    node = root.findNode(_this.getDataId(data));
                    if (node.getData().getCompareStatus() !== CompareStatus.NEW) {
                        node.clearViewers();
                        return false;
                    }
                    return true;
                });
                _super.prototype.deleteNodes.call(this, dataList);
            };
            ContentTreeGrid.prototype.updateContentNode = function (contentId) {
                var root = this.getRoot().getCurrentRoot();
                var treeNode = root.findNode(contentId.toString());
                if (treeNode) {
                    var content = treeNode.getData();
                    this.updateNode(ContentSummaryAndCompareStatus.fromContentSummary(content.getContentSummary()));
                }
            };
            ContentTreeGrid.prototype.appendContentNode = function (contentId, nextToSelection) {
                var _this = this;
                this.fetchById(contentId)
                    .then(function (data) {
                    _this.appendNode(data, nextToSelection);
                }).catch(function (reason) {
                    api.DefaultErrorHandler.handle(reason);
                });
            };
            ContentTreeGrid.prototype.appendUploadNode = function (item) {
                var _this = this;
                var data = ContentSummaryAndCompareStatus.fromUploadItem(item);
                var parent = this.getRoot().getCurrentSelection()[0];
                this.appendNode(data, false).then(function () {
                    if (parent) {
                        var parentData = parent.getData();
                        var contentSummary = new ContentSummaryBuilder(parentData.getContentSummary()).setHasChildren(true).build();
                        _this.updateNode(parentData.setContentSummary(contentSummary));
                        _this.expandNode(parent);
                    }
                }).done();
                item.onProgress(function (progress) {
                    _this.invalidate();
                });
                item.onUploaded(function (model) {
                    var nodeToRemove = _this.getRoot().getCurrentRoot().findNode(item.getId());
                    if (nodeToRemove) {
                        nodeToRemove.remove();
                        _this.invalidate();
                    }
                    api.notify.showFeedback(data.getContentSummary().getType().toString() + " \"" + item.getName() + "\" created successfully");
                });
                item.onFailed(function () {
                    _this.deleteNode(data);
                });
            };
            ContentTreeGrid.prototype.refreshNodeData = function (parentNode) {
                var _this = this;
                return ContentSummaryAndCompareStatusFetcher.fetch(parentNode.getData().getContentId()).then(function (content) {
                    parentNode.setData(content);
                    _this.refreshNode(parentNode);
                    return parentNode;
                });
            };
            ContentTreeGrid.prototype.sortNodeChildren = function (node) {
                var _this = this;
                var rootNode = this.getRoot().getCurrentRoot();
                if (node != rootNode) {
                    if (node.hasChildren()) {
                        node.setChildren([]);
                        node.setMaxChildren(0);
                        this.fetchChildren(node)
                            .then(function (dataList) {
                            var parentNode = _this.getRoot().getCurrentRoot().findNode(node.getDataId());
                            parentNode.setChildren(_this.dataToTreeNodes(dataList, parentNode));
                            var rootList = _this.getRoot().getCurrentRoot().treeToList();
                            _this.initData(rootList);
                        }).catch(function (reason) {
                            api.DefaultErrorHandler.handle(reason);
                        }).done();
                    }
                }
            };
            ContentTreeGrid.prototype.findByPaths = function (paths, useParent) {
                if (useParent === void 0) { useParent = false; }
                var root = this.getRoot().getDefaultRoot().treeToList(false, false), filter = this.getRoot().getFilteredRoot().treeToList(false, false), all = root.concat(filter), result = [];
                for (var i = 0; i < paths.length; i++) {
                    var node = useParent
                        ? new TreeNodesOfContentPath(paths[i].getParentPath(), paths[i])
                        : new TreeNodesOfContentPath(paths[i]);
                    if (useParent && node.getPath().isRoot()) {
                        node.getNodes().push(this.getRoot().getDefaultRoot());
                        if (this.isFiltered()) {
                            node.getNodes().push(this.getRoot().getFilteredRoot());
                        }
                    }
                    else {
                        for (var j = 0; j < all.length; j++) {
                            var treeNode = all[j], path = (treeNode.getData() && treeNode.getData().getContentSummary())
                                ? treeNode.getData().getContentSummary().getPath()
                                : null;
                            if (path && path.equals(node.getPath())) {
                                node.getNodes().push(treeNode);
                            }
                        }
                    }
                    if (node.hasNodes()) {
                        result.push(node);
                    }
                }
                return result;
            };
            ContentTreeGrid.prototype.expandTillNodeWithGivenPath = function (path, startExpandingFromNode) {
                var node;
                if (startExpandingFromNode && path.isDescendantOf(startExpandingFromNode.getData().getPath())) {
                    node = startExpandingFromNode;
                }
                else {
                    node = this.getRoot().getCurrentRoot();
                }
                this.expandNodeAndCheckTargetReached(node, path);
            };
            ContentTreeGrid.prototype.expandNodeAndCheckTargetReached = function (nodeToExpand, targetPathToExpand) {
                var _this = this;
                if (!!nodeToExpand.getData() && targetPathToExpand.equals(nodeToExpand.getData().getPath())) {
                    return;
                }
                if (nodeToExpand) {
                    nodeToExpand.setExpanded(true);
                    if (nodeToExpand.hasChildren()) {
                        this.initData(this.getRoot().getCurrentRoot().treeToList());
                        this.updateExpanded();
                        this.expandMoreOrSelectTargetIfReached(nodeToExpand, targetPathToExpand);
                    }
                    else {
                        this.mask();
                        this.fetchChildrenData(nodeToExpand)
                            .then(function (dataList) {
                            nodeToExpand.setChildren(_this.dataToTreeNodes(dataList, nodeToExpand));
                            _this.initData(_this.getRoot().getCurrentRoot().treeToList());
                            _this.updateExpanded();
                            _this.expandMoreOrSelectTargetIfReached(nodeToExpand, targetPathToExpand);
                        }).catch(function (reason) {
                            api.DefaultErrorHandler.handle(reason);
                        }).finally(function () {
                        }).done(function () { return _this.notifyLoaded(); });
                    }
                }
            };
            ContentTreeGrid.prototype.expandMoreOrSelectTargetIfReached = function (nodeToExpand, targetPathToExpand) {
                var nextChildPath = targetPathToExpand.getPathAtLevel(!!nodeToExpand.getData()
                    ? nodeToExpand.getData().getPath().getLevel() + 1
                    : 1);
                var children = nodeToExpand.getChildren();
                for (var i = 0; i < children.length; i++) {
                    var child = children[i], childPath = child.getData().getPath();
                    if (childPath && childPath.equals(targetPathToExpand)) {
                        this.selectNode(child.getDataId());
                        this.scrollToRow(this.getGrid().getDataView().getRowById(child.getId()));
                        break;
                    }
                    else if (childPath && childPath.equals(nextChildPath)) {
                        this.expandNodeAndCheckTargetReached(child, targetPathToExpand);
                    }
                }
            };
            ContentTreeGrid.prototype.fetchChildrenData = function (parentNode) {
                return this.fetchChildren(parentNode);
            };
            ContentTreeGrid.prototype.xAppendContentNode = function (relationship, update) {
                var _this = this;
                if (update === void 0) { update = true; }
                var appendedNode = this.dataToTreeNode(relationship.getData(), relationship.getNode()), data = relationship.getNode().getData();
                return this.fetchChildrenIds(relationship.getNode()).then(function (result) {
                    var map = result.map(function (el) {
                        return el.getId();
                    });
                    var index = map.indexOf(appendedNode.getData().getId());
                    if (!relationship.getNode().hasParent() ||
                        (data && relationship.getNode().hasChildren()) ||
                        (data && !relationship.getNode().hasChildren() && !data.getContentSummary().hasChildren())) {
                        relationship.getNode().insertChild(appendedNode, index);
                    }
                    if (data && !data.getContentSummary().hasChildren()) {
                        data.setContentSummary(new ContentSummaryBuilder(data.getContentSummary()).setHasChildren(true).build());
                    }
                    relationship.getNode().clearViewers();
                    if (update) {
                        _this.initAndRender();
                    }
                    return appendedNode;
                });
            };
            ContentTreeGrid.prototype.xAppendContentNodes = function (relationships, update) {
                var _this = this;
                if (update === void 0) { update = true; }
                var nodes = [];
                var parallelPromises = [];
                this.xUpdateNodesData(relationships.map(function (el) {
                    return el.getNode();
                }));
                relationships.forEach(function (relationship) {
                    parallelPromises.push(_this.xAppendContentNode(relationship, false));
                });
                return wemQ.allSettled(parallelPromises).then(function (results) {
                    var rootList = _this.getRoot().getCurrentRoot().treeToList();
                    _this.initData(rootList);
                    _this.invalidate();
                    return results;
                });
            };
            ContentTreeGrid.prototype.xPlaceContentNode = function (parent, child) {
                return this.fetchChildrenIds(parent).then(function (result) {
                    var map = result.map(function (el) {
                        return el.getId();
                    });
                    var index = map.indexOf(child.getData().getId());
                    if (!parent.hasParent() ||
                        (child.getData() && parent.hasChildren()) ||
                        (child.getData() && !parent.hasChildren() && !child.getData().getContentSummary().hasChildren())) {
                        var parentExpanded = parent.isExpanded();
                        parent.moveChild(child, index);
                        parent.setExpanded(parentExpanded);
                    }
                    child.clearViewers();
                    return child;
                });
            };
            ContentTreeGrid.prototype.xPlaceContentNodes = function (results) {
                var _this = this;
                var parallelPromises = [];
                var nodes = results.map(function (el) {
                    return el.getNodes();
                });
                var merged = [];
                merged = merged.concat.apply(merged, nodes);
                merged.forEach(function (node) {
                    parallelPromises.push(_this.xPlaceContentNode(node.getParent(), node));
                });
                return wemQ.allSettled(parallelPromises).then(function (results) {
                    var rootList = _this.getRoot().getCurrentRoot().treeToList();
                    _this.initData(rootList);
                    _this.invalidate();
                    return results;
                });
            };
            ContentTreeGrid.prototype.xDeleteContentNode = function (node, update) {
                if (update === void 0) { update = true; }
                var parentNode = node.getParent();
                node.remove();
                var data = !!parentNode ? parentNode.getData() : null;
                if (data && !parentNode.hasChildren() && data.getContentSummary().hasChildren()) {
                    data.setContentSummary(new ContentSummaryBuilder(data.getContentSummary()).setHasChildren(false).build());
                }
                if (update) {
                    this.initAndRender();
                }
                return parentNode;
            };
            ContentTreeGrid.prototype.xDeleteContentNodes = function (nodes, update) {
                var _this = this;
                if (update === void 0) { update = true; }
                nodes.forEach(function (node) {
                    _this.xDeleteContentNode(node, false);
                });
                if (update) {
                    this.initAndRender();
                }
            };
            ContentTreeGrid.prototype.xPopulateWithChildren = function (source, dest) {
                dest.setChildren(source.getChildren());
                dest.setExpanded(source.isExpanded());
                if (dest.getData() && dest.getData().getContentSummary()) {
                    dest.getData().setContentSummary(new ContentSummaryBuilder(dest.getData().getContentSummary()).setHasChildren(dest.hasChildren()).build());
                    this.xUpdatePathsInChildren(dest);
                }
                dest.clearViewers();
            };
            ContentTreeGrid.prototype.xUpdatePathsInChildren = function (node) {
                var _this = this;
                node.getChildren().forEach(function (child) {
                    var nodeSummary = node.getData() ? node.getData().getContentSummary() : null, childSummary = child.getData() ? child.getData().getContentSummary() : null;
                    if (nodeSummary && childSummary) {
                        var path = ContentPath.fromParent(nodeSummary.getPath(), childSummary.getPath().getName());
                        child.getData().setContentSummary(new ContentSummaryBuilder(childSummary).setPath(path).build());
                        child.clearViewers();
                        _this.xUpdatePathsInChildren(child);
                    }
                });
            };
            ContentTreeGrid.prototype.xUpdateNodesData = function (nodes) {
                var _this = this;
                nodes = this.xFilterParentNodes(nodes);
                var parallelPromises = [];
                nodes.forEach(function (node) {
                    if (!node.hasChildren()) {
                        if (!!node.getData()) {
                            parallelPromises.push(new api.content.GetContentByIdRequest(node.getData().getContentSummary().getContentId()).
                                sendAndParse().
                                then(function (content) {
                                node.getData().setContentSummary(content);
                            }));
                        }
                    }
                });
                wemQ.all(parallelPromises).spread(function () {
                    _this.triggerSelectionChangedListeners();
                    return wemQ(null);
                }).
                    catch(function (reason) { return api.DefaultErrorHandler.handle(reason); }).
                    done();
                return nodes;
            };
            ContentTreeGrid.prototype.xFilterParentNodes = function (nodes) {
                return nodes.filter(function (node, index) {
                    var result = true;
                    var path = node.getData() && node.getData().getContentSummary()
                        ? node.getData().getContentSummary().getPath()
                        : null;
                    if (path) {
                        for (var i = 0; i < nodes.length; i++) {
                            if (index === i) {
                                continue;
                            }
                            var nodePath = nodes[i].getData() && nodes[i].getData().getContentSummary()
                                ? nodes[i].getData().getContentSummary().getPath()
                                : null;
                            if (nodePath && (path.isChildOf(nodePath) || path.toString() === nodePath.toString())) {
                                return false;
                            }
                        }
                    }
                    return result;
                });
            };
            ContentTreeGrid.prototype.xSortNodesChildren = function (nodes) {
                var _this = this;
                var parallelPromises = [];
                nodes.sort(function (a, b) {
                    return a.getDataId().localeCompare(b.getDataId());
                });
                var groups = [], group = [];
                groups.push(group);
                for (var i = 0; i < nodes.length; i++) {
                    if (!!group[group.length - 1] &&
                        nodes[i].getDataId() !== group[group.length - 1].getDataId()) {
                        group = [];
                        groups.push(group);
                    }
                    group.push(nodes[i]);
                }
                groups.forEach(function (grp) {
                    if (grp.length > 0) {
                        parallelPromises.push(_this.updateNodes(grp[0].getData()).then(function () {
                            var hasChildren = grp[0].hasChildren();
                            grp[0].setChildren([]);
                            return _this.fetchChildren(grp[0]).
                                then(function (dataList) {
                                grp.forEach(function (el) {
                                    if (hasChildren) {
                                        el.setChildren(_this.dataToTreeNodes(dataList, el));
                                    }
                                });
                            }).catch(function (reason) {
                                api.DefaultErrorHandler.handle(reason);
                            });
                        }).then(function () {
                            var rootList = _this.getRoot().getCurrentRoot().treeToList();
                            _this.initData(rootList);
                        }));
                    }
                });
                return wemQ.all(parallelPromises).spread(function () {
                    return wemQ(null);
                }).catch(function (reason) { return api.DefaultErrorHandler.handle(reason); });
            };
            ContentTreeGrid.MAX_FETCH_SIZE = 10;
            return ContentTreeGrid;
        })(TreeGrid);
        browse.ContentTreeGrid = ContentTreeGrid;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var SortContentEvent = (function (_super) {
            __extends(SortContentEvent, _super);
            function SortContentEvent() {
                _super.apply(this, arguments);
            }
            SortContentEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            SortContentEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return SortContentEvent;
        })(browse.BaseContentModelEvent);
        browse.SortContentEvent = SortContentEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var OpenSortDialogEvent = (function (_super) {
            __extends(OpenSortDialogEvent, _super);
            function OpenSortDialogEvent(content) {
                _super.call(this);
                this.content = content;
            }
            OpenSortDialogEvent.prototype.getContent = function () {
                return this.content;
            };
            OpenSortDialogEvent.on = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            OpenSortDialogEvent.un = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            return OpenSortDialogEvent;
        })(api.event.Event);
        browse.OpenSortDialogEvent = OpenSortDialogEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var OpenMoveDialogEvent = (function (_super) {
            __extends(OpenMoveDialogEvent, _super);
            function OpenMoveDialogEvent(content) {
                _super.call(this);
                this.content = content;
            }
            OpenMoveDialogEvent.prototype.getContentSummaries = function () {
                return this.content;
            };
            OpenMoveDialogEvent.on = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            OpenMoveDialogEvent.un = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            return OpenMoveDialogEvent;
        })(api.event.Event);
        browse.OpenMoveDialogEvent = OpenMoveDialogEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var SaveSortedContentAction = browse.action.SaveSortedContentAction;
        var TabMenuItemBuilder = api.ui.tab.TabMenuItemBuilder;
        var SortContentDialog = (function (_super) {
            __extends(SortContentDialog, _super);
            function SortContentDialog() {
                var _this = this;
                _super.call(this, {
                    title: new api.ui.dialog.ModalDialogHeader("Sort items")
                });
                this.initTabMenu();
                this.initSortContentMenu();
                this.getEl().addClass("sort-content-dialog");
                this.initSortContentGrid();
                this.initGridDragHandler();
                this.populateContentPanel();
                this.initSaveButtonWithAction();
                browse.OpenSortDialogEvent.on(function (event) {
                    _this.handleOpenSortDialogEvent(event);
                });
                this.addCancelButtonToBottom();
            }
            SortContentDialog.prototype.open = function () {
                if (!this.isOpen) {
                    if (this.contentGrid.getGrid().getDataView().getLength() > 0) {
                        this.contentGrid.getGrid().getEl().setHeightPx(45);
                    }
                    this.contentGrid.getGrid().resizeCanvas();
                    _super.prototype.open.call(this);
                    this.isOpen = true;
                }
            };
            SortContentDialog.prototype.show = function () {
                api.dom.Body.get().appendChild(this);
                _super.prototype.show.call(this);
            };
            SortContentDialog.prototype.close = function () {
                this.remove();
                _super.prototype.close.call(this);
                this.isOpen = false;
                this.contentGrid.setChildOrder(null);
                this.gridDragHandler.clearContentMovements();
            };
            SortContentDialog.prototype.getContent = function () {
                return this.parentContent;
            };
            SortContentDialog.prototype.initSortContentGrid = function () {
                var _this = this;
                this.contentGrid = new app.browse.SortContentTreeGrid();
                this.contentGrid.getEl().addClass("sort-content-grid");
                this.contentGrid.onLoaded(function () {
                    _this.contentGrid.render(true);
                    if (_this.contentGrid.getContentId()) {
                        _this.open();
                    }
                });
            };
            SortContentDialog.prototype.initGridDragHandler = function () {
                var _this = this;
                this.gridDragHandler = new browse.ContentGridDragHandler(this.contentGrid);
                this.gridDragHandler.onPositionChanged(function () {
                    _this.sortContentMenu.selectManualSortingItem();
                });
            };
            SortContentDialog.prototype.initTabMenu = function () {
                var menu = new api.ui.tab.TabMenu();
                var tabMenuItem = new TabMenuItemBuilder().setLabel("(sorting type)").build();
                tabMenuItem.setActive(true);
                menu.addNavigationItem(tabMenuItem);
                menu.selectNavigationItem(0);
                menu.show();
            };
            SortContentDialog.prototype.initSortContentMenu = function () {
                var _this = this;
                this.sortContentMenu = new browse.SortContentTabMenu();
                this.sortContentMenu.show();
                this.appendChildToTitle(this.sortContentMenu);
                this.sortContentMenu.onSortOrderChanged(function () {
                    _this.handleOnSortOrderChangedEvent();
                });
            };
            SortContentDialog.prototype.initSaveButtonWithAction = function () {
                var _this = this;
                this.sortAction = new SaveSortedContentAction(this);
                this.saveButton = this.addAction(this.sortAction);
                this.saveButton.addClass("save-button");
                this.sortAction.onExecuted(function () {
                    _this.handleSortAction();
                });
            };
            SortContentDialog.prototype.populateContentPanel = function () {
                var header = new api.dom.H6El();
                header.setHtml("Sort content by selecting default sort above, or drag and drop for manual sorting");
                this.appendChildToContentPanel(header);
                this.appendChildToContentPanel(this.contentGrid);
            };
            SortContentDialog.prototype.handleSortAction = function () {
                var _this = this;
                if (this.curChildOrder.equals(this.getParentChildOrder()) && !this.curChildOrder.isManual()) {
                    this.close();
                }
                else {
                    this.showLoadingSpinner();
                    if (this.curChildOrder.isManual()) {
                        this.setManualReorder(this.hasChangedPrevChildOrder() ? this.prevChildOrder : null, this.gridDragHandler.getContentMovements()).done(function () { return _this.onAfterSetOrder(); });
                    }
                    else {
                        this.setContentChildOrder(this.curChildOrder).done(function () { return _this.onAfterSetOrder(); });
                    }
                }
            };
            SortContentDialog.prototype.handleOpenSortDialogEvent = function (event) {
                this.parentContent = event.getContent();
                this.curChildOrder = this.getParentChildOrder();
                this.prevChildOrder = undefined;
                this.sortContentMenu.selectNavigationItemByOrder(this.curChildOrder);
                this.contentGrid.reload(this.parentContent);
                if (!this.parentContent.hasChildren()) {
                    this.contentGrid.getEl().setAttribute("data-content", event.getContent().getPath().toString());
                    this.contentGrid.addClass("no-content");
                }
                else {
                    this.contentGrid.removeClass("no-content");
                    this.contentGrid.getEl().removeAttribute("data-content");
                }
            };
            SortContentDialog.prototype.handleOnSortOrderChangedEvent = function () {
                var newOrder = this.sortContentMenu.getSelectedNavigationItem().getChildOrder();
                if (!this.curChildOrder.equals(newOrder)) {
                    if (!newOrder.isManual()) {
                        this.curChildOrder = newOrder;
                        this.contentGrid.setChildOrder(this.curChildOrder);
                        this.contentGrid.reload(this.parentContent);
                        this.gridDragHandler.clearContentMovements();
                    }
                    else {
                        this.prevChildOrder = this.curChildOrder;
                        this.curChildOrder = newOrder;
                        this.contentGrid.setChildOrder(this.curChildOrder);
                    }
                }
            };
            SortContentDialog.prototype.onAfterSetOrder = function () {
                this.hideLoadingSpinner();
                this.close();
            };
            SortContentDialog.prototype.hasChangedPrevChildOrder = function () {
                return this.prevChildOrder && !this.prevChildOrder.equals(this.getParentChildOrder());
            };
            SortContentDialog.prototype.showLoadingSpinner = function () {
                this.saveButton.addClass("spinner");
            };
            SortContentDialog.prototype.hideLoadingSpinner = function () {
                this.saveButton.removeClass("spinner");
            };
            SortContentDialog.prototype.setContentChildOrder = function (order, silent) {
                if (silent === void 0) { silent = false; }
                return new api.content.OrderContentRequest().
                    setSilent(silent).
                    setContentId(this.parentContent.getContentId()).
                    setChildOrder(order).
                    sendAndParse();
            };
            SortContentDialog.prototype.setManualReorder = function (order, movements, silent) {
                if (silent === void 0) { silent = false; }
                return new api.content.OrderChildContentRequest().
                    setSilent(silent).
                    setManualOrder(true).
                    setContentId(this.parentContent.getContentId()).
                    setChildOrder(order).
                    setContentMovements(movements).
                    sendAndParse();
            };
            SortContentDialog.prototype.getParentChildOrder = function () {
                if (this.parentContent && this.parentContent.getContentSummary()) {
                    return this.parentContent.getContentSummary().getChildOrder();
                }
                return null;
            };
            return SortContentDialog;
        })(api.ui.dialog.ModalDialog);
        browse.SortContentDialog = SortContentDialog;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ContentPath = api.content.ContentPath;
        var GetContentTypeByNameRequest = api.schema.content.GetContentTypeByNameRequest;
        var ContentIds = api.content.ContentIds;
        var MoveContentDialog = (function (_super) {
            __extends(MoveContentDialog, _super);
            function MoveContentDialog() {
                var _this = this;
                _super.call(this, {
                    title: new api.ui.dialog.ModalDialogHeader("Move item with children")
                });
                this.getEl().addClass("move-content-dialog");
                this.contentPath = new api.dom.H6El().addClass("content-path");
                var descMessage = new api.dom.H6El().addClass("desc-message").
                    setHtml("Moves selected items with all children and current permissions to selected destination");
                this.appendChildToContentPanel(this.contentPath);
                this.appendChildToContentPanel(descMessage);
                this.contentComboBox = new api.content.ContentMoveComboBox();
                this.contentComboBox.addClass("content-selector");
                this.appendChildToContentPanel(this.contentComboBox);
                this.initializeActions();
                this.contentMoveMask = new api.ui.mask.LoadMask(this);
                this.appendChildToContentPanel(this.contentMoveMask);
                browse.OpenMoveDialogEvent.on(function (event) {
                    _this.movedContentSummaries = event.getContentSummaries();
                    _this.contentComboBox.clearCombobox();
                    if (event.getContentSummaries().length == 1) {
                        var contentToMove = event.getContentSummaries()[0];
                        new GetContentTypeByNameRequest(contentToMove.getType()).sendAndParse().then(function (contentType) {
                            _this.contentComboBox.setFilterContentPath(contentToMove.getPath());
                            _this.contentComboBox.setFilterSourceContentType(contentType);
                            _this.contentPath.setHtml(contentToMove.getPath().toString());
                            _this.open();
                        }).catch(function (reason) {
                            api.notify.showError(reason.getMessage());
                        }).done();
                    }
                    else {
                        _this.contentComboBox.setFilterContentPath(null);
                        _this.contentPath.setHtml("");
                        _this.open();
                    }
                });
                this.addCancelButtonToBottom();
            }
            MoveContentDialog.prototype.initializeActions = function () {
                var _this = this;
                this.addAction(new api.ui.Action("Move", "").onExecuted(function () {
                    _this.contentMoveMask.show();
                    var parentContent = _this.getParentContent();
                    _this.moveContent(parentContent);
                }));
            };
            MoveContentDialog.prototype.moveContent = function (parentContent) {
                var _this = this;
                var parentRoot = (!!parentContent) ? parentContent.getPath() : ContentPath.ROOT;
                var contentIds = ContentIds.create().
                    fromContentIds(this.movedContentSummaries.map(function (summary) { return summary.getContentId(); })).
                    build();
                new api.content.MoveContentRequest(contentIds, parentRoot).
                    sendAndParse().then(function (response) {
                    if (parentContent) {
                        _this.contentComboBox.deselect(parentContent);
                    }
                    _this.contentMoveMask.hide();
                    if (response.getMoved().length > 0) {
                        if (response.getMoved().length > 1) {
                            api.notify.showFeedback(response.getMoved().length + ' items moved');
                        }
                        else {
                            api.notify.showFeedback("\"" + response.getMoved()[0] + '\" moved');
                        }
                    }
                    response.getMoveFailures().forEach(function (failure) {
                        api.notify.showWarning(failure.getReason());
                    });
                    _this.close();
                }).catch(function (reason) {
                    api.notify.showWarning(reason.getMessage());
                    _this.close();
                    _this.contentComboBox.deselect(_this.getParentContent());
                }).done();
            };
            MoveContentDialog.prototype.getParentContent = function () {
                return this.contentComboBox.getSelectedDisplayValues()[0];
            };
            MoveContentDialog.prototype.open = function () {
                _super.prototype.open.call(this);
            };
            MoveContentDialog.prototype.show = function () {
                api.dom.Body.get().appendChild(this);
                _super.prototype.show.call(this);
                this.contentComboBox.giveFocus();
            };
            MoveContentDialog.prototype.close = function () {
                _super.prototype.close.call(this);
            };
            return MoveContentDialog;
        })(api.ui.dialog.ModalDialog);
        browse.MoveContentDialog = MoveContentDialog;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var GridColumnBuilder = api.ui.grid.GridColumnBuilder;
        var TreeGrid = api.ui.treegrid.TreeGrid;
        var TreeGridBuilder = api.ui.treegrid.TreeGridBuilder;
        var DateTimeFormatter = api.ui.treegrid.DateTimeFormatter;
        var ContentSummaryViewer = api.content.ContentSummaryViewer;
        var ContentSummaryAndCompareStatus = api.content.ContentSummaryAndCompareStatus;
        var ContentSummaryAndCompareStatusFetcher = api.content.ContentSummaryAndCompareStatusFetcher;
        var CompareStatus = api.content.CompareStatus;
        var CompareStatusFormatter = api.content.CompareStatusFormatter;
        var SortContentTreeGrid = (function (_super) {
            __extends(SortContentTreeGrid, _super);
            function SortContentTreeGrid() {
                var nameColumn = new GridColumnBuilder().
                    setName("Name").
                    setId("displayName").
                    setField("contentSummary.displayName").
                    setMinWidth(130).
                    setFormatter(this.nameFormatter).
                    setBehavior("selectAndMove").
                    build();
                var modifiedTimeColumn = new GridColumnBuilder().
                    setName("ModifiedTime").
                    setId("modifiedTime").
                    setField("contentSummary.modifiedTime").
                    setCssClass("modified").
                    setMinWidth(150).
                    setMaxWidth(170).
                    setFormatter(DateTimeFormatter.format).
                    setBehavior("selectAndMove").
                    build();
                _super.call(this, new TreeGridBuilder().
                    setColumns([
                    nameColumn,
                    modifiedTimeColumn
                ]).
                    setPartialLoadEnabled(true).
                    setCheckableRows(false).
                    setShowToolbar(false).
                    setDragAndDrop(true).
                    disableMultipleSelection(true).
                    prependClasses("content-tree-grid").
                    setSelectedCellCssClass("selected-sort-row"));
            }
            SortContentTreeGrid.prototype.statusFormatter = function (row, cell, value, columnDef, node) {
                if (!node.getData().getContentSummary()) {
                    return "";
                }
                var compareLabel = api.content.CompareStatus[value];
                return CompareStatusFormatter.formatStatus(CompareStatus[compareLabel]);
            };
            SortContentTreeGrid.prototype.dragFormatter = function (row, cell, value, columnDef, node) {
                var wrapper = new api.dom.SpanEl();
                if (!api.util.StringHelper.isBlank(value)) {
                    wrapper.getEl().setTitle(value);
                }
                var icon = new api.dom.DivEl("icon-menu3 drag-icon");
                wrapper.getEl().setInnerHtml(icon.toString(), false);
                return wrapper.toString();
            };
            SortContentTreeGrid.prototype.nameFormatter = function (row, cell, value, columnDef, node) {
                if (!!node.getData().getContentSummary()) {
                    var viewer = node.getViewer("name");
                    if (!viewer) {
                        viewer = new ContentSummaryViewer();
                        viewer.setObject(node.getData().getContentSummary(), node.calcLevel() > 1);
                        node.setViewer("name", viewer);
                    }
                    return viewer.toString();
                }
                else {
                    var content = new api.dom.DivEl("children-to-load"), parent = node.getParent();
                    content.setHtml((parent.getMaxChildren() - parent.getChildren().length + 1) + " children left to load.");
                    return content.toString();
                }
            };
            SortContentTreeGrid.prototype.sortNodeChildren = function (node) {
                this.initData(this.getRoot().getCurrentRoot().treeToList());
            };
            SortContentTreeGrid.prototype.fetchChildren = function () {
                var parentContentId;
                var parentNode = this.getRoot().getCurrentRoot();
                if (parentNode.getData()) {
                    parentContentId = parentNode.getData().getContentSummary().getContentId();
                    this.contentId = parentContentId;
                    parentNode.setData(null);
                }
                else {
                    parentContentId = this.contentId;
                }
                var from = parentNode.getChildren().length;
                if (from > 0 && !parentNode.getChildren()[from - 1].getData().getContentSummary()) {
                    parentNode.getChildren().pop();
                    from--;
                }
                return ContentSummaryAndCompareStatusFetcher.fetchChildren(parentContentId, from, SortContentTreeGrid.MAX_FETCH_SIZE, this.curChildOrder).
                    then(function (data) {
                    var contents = parentNode.getChildren().map(function (el) {
                        return el.getData();
                    }).slice(0, from).concat(data.getContents());
                    var meta = data.getMetadata();
                    parentNode.setMaxChildren(meta.getTotalHits());
                    if (from + meta.getHits() < meta.getTotalHits()) {
                        contents.push(new ContentSummaryAndCompareStatus());
                    }
                    return contents;
                });
            };
            SortContentTreeGrid.prototype.hasChildren = function (data) {
                return data.hasChildren();
            };
            SortContentTreeGrid.prototype.getDataId = function (data) {
                return data.getId();
            };
            SortContentTreeGrid.prototype.getContentId = function () {
                return this.contentId;
            };
            SortContentTreeGrid.prototype.getChildOrder = function () {
                return this.curChildOrder;
            };
            SortContentTreeGrid.prototype.setChildOrder = function (value) {
                this.curChildOrder = value;
            };
            SortContentTreeGrid.MAX_FETCH_SIZE = 30;
            return SortContentTreeGrid;
        })(TreeGrid);
        browse.SortContentTreeGrid = SortContentTreeGrid;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var DropdownHandle = api.ui.selector.DropdownHandle;
        var SortContentTabMenu = (function (_super) {
            __extends(SortContentTabMenu, _super);
            function SortContentTabMenu() {
                var _this = this;
                _super.call(this, "sort-tab-menu");
                this.sortOrderChangedListeners = [];
                this.navigationItems = new browse.SortContentTabMenuItems();
                this.addNavigationItems(this.navigationItems.getAllItems());
                this.selectNavigationItem(0);
                this.dropdownHandle = new DropdownHandle();
                this.appendChild(this.dropdownHandle);
                this.dropdownHandle.up();
                this.dropdownHandle.onClicked(function (event) {
                    if (_this.isMenuVisible()) {
                        _this.hideMenu();
                    }
                    else {
                        _this.showMenu();
                    }
                });
            }
            SortContentTabMenu.prototype.hideMenu = function () {
                _super.prototype.hideMenu.call(this);
                this.dropdownHandle.up();
            };
            SortContentTabMenu.prototype.showMenu = function () {
                _super.prototype.showMenu.call(this);
                this.dropdownHandle.down();
            };
            SortContentTabMenu.prototype.selectNavigationItem = function (tabIndex) {
                _super.prototype.selectNavigationItem.call(this, tabIndex);
                this.notifySortOrderChanged();
            };
            SortContentTabMenu.prototype.getSelectedNavigationItem = function () {
                return _super.prototype.getSelectedNavigationItem.call(this);
            };
            SortContentTabMenu.prototype.getSortMenuNavigationItems = function () {
                return this.navigationItems;
            };
            SortContentTabMenu.prototype.addNavigationItems = function (items) {
                var _this = this;
                if (items) {
                    items.forEach(function (item) {
                        _this.addNavigationItem(item);
                    });
                }
            };
            SortContentTabMenu.prototype.selectNavigationItemByOrder = function (order) {
                var items = this.navigationItems.getAllItems();
                for (var key in items) {
                    if (items[key].getChildOrder().equals(order)) {
                        var item = items.splice(key, 1)[0];
                        this.removeNavigationItems();
                        this.addNavigationItem(item);
                        this.addNavigationItems(items);
                        this.selectNavigationItem(0);
                        break;
                    }
                }
            };
            SortContentTabMenu.prototype.selectManualSortingItem = function () {
                this.selectNavigationItemByOrder(this.navigationItems.SORT_MANUAL_ITEM.getChildOrder());
            };
            SortContentTabMenu.prototype.onSortOrderChanged = function (listener) {
                this.sortOrderChangedListeners.push(listener);
            };
            SortContentTabMenu.prototype.unSortOrderChanged = function (listener) {
                this.sortOrderChangedListeners = this.sortOrderChangedListeners.filter(function (currentListener) {
                    return listener != currentListener;
                });
            };
            SortContentTabMenu.prototype.notifySortOrderChanged = function () {
                var _this = this;
                this.sortOrderChangedListeners.forEach(function (listener) {
                    listener.call(_this);
                });
            };
            return SortContentTabMenu;
        })(api.ui.tab.TabMenu);
        browse.SortContentTabMenu = SortContentTabMenu;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var TabMenuItemBuilder = api.ui.tab.TabMenuItemBuilder;
        var SortContentTabMenuItem = (function (_super) {
            __extends(SortContentTabMenuItem, _super);
            function SortContentTabMenuItem(builder) {
                _super.call(this, new TabMenuItemBuilder().
                    setLabel(builder.label));
                this.childOrder = builder.childOrder;
            }
            SortContentTabMenuItem.prototype.getChildOrder = function () {
                return this.childOrder;
            };
            return SortContentTabMenuItem;
        })(api.ui.tab.TabMenuItem);
        browse.SortContentTabMenuItem = SortContentTabMenuItem;
        var SortContentTabMenuItemBuilder = (function () {
            function SortContentTabMenuItemBuilder() {
            }
            SortContentTabMenuItemBuilder.prototype.setLabel = function (label) {
                this.label = label;
                return this;
            };
            SortContentTabMenuItemBuilder.prototype.setChildOrder = function (value) {
                this.childOrder = value;
                return this;
            };
            SortContentTabMenuItemBuilder.prototype.build = function () {
                return new SortContentTabMenuItem(this);
            };
            return SortContentTabMenuItemBuilder;
        })();
        browse.SortContentTabMenuItemBuilder = SortContentTabMenuItemBuilder;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ChildOrder = api.content.ChildOrder;
        var FieldOrderExprBuilder = api.content.FieldOrderExprBuilder;
        var SortContentTabMenuItems = (function () {
            function SortContentTabMenuItems() {
                this.items = [];
                var order = new ChildOrder();
                order.addOrderExpr(new FieldOrderExprBuilder().
                    setFieldName(api.query.QueryField.DISPLAY_NAME).
                    setDirection(ChildOrder.ASC_ORDER_DIRECTION_VALUE).
                    build());
                this.SORT_ASC_DISPALAY_NAME_ITEM = new browse.SortContentTabMenuItemBuilder().setLabel("DisplayName - Ascending").
                    setChildOrder(order).build();
                order = new ChildOrder();
                order.addOrderExpr(new FieldOrderExprBuilder().
                    setFieldName(api.query.QueryField.DISPLAY_NAME).
                    setDirection(ChildOrder.DESC_ORDER_DIRECTION_VALUE).
                    build());
                this.SORT_DESC_DISPALAY_NAME_ITEM = new browse.SortContentTabMenuItemBuilder().setLabel("DisplayName - Descending").
                    setChildOrder(order).build();
                order = new ChildOrder();
                order.addOrderExpr(new FieldOrderExprBuilder().
                    setFieldName(api.query.QueryField.MODIFIED_TIME).
                    setDirection(ChildOrder.ASC_ORDER_DIRECTION_VALUE).
                    build());
                this.SORT_ASC_MODIFIED_ITEM = new browse.SortContentTabMenuItemBuilder().setLabel("Modified - Ascending").
                    setChildOrder(order).build();
                order = new ChildOrder();
                order.addOrderExpr(new FieldOrderExprBuilder().
                    setFieldName(api.query.QueryField.MODIFIED_TIME).
                    setDirection(ChildOrder.DESC_ORDER_DIRECTION_VALUE).
                    build());
                this.SORT_DESC_MODIFIED_ITEM = new browse.SortContentTabMenuItemBuilder().setLabel("Modified - Descending (default)").
                    setChildOrder(order).build();
                order = new ChildOrder();
                order.addOrderExpr(new FieldOrderExprBuilder().
                    setFieldName(api.query.QueryField.MANUAL_ORDER_VALUE).
                    setDirection(ChildOrder.DESC_ORDER_DIRECTION_VALUE).
                    build());
                this.SORT_MANUAL_ITEM = new browse.SortContentTabMenuItemBuilder().setLabel("Manually Sorted").
                    setChildOrder(order).build();
                this.items.push(this.SORT_ASC_DISPALAY_NAME_ITEM, this.SORT_DESC_DISPALAY_NAME_ITEM, this.SORT_ASC_MODIFIED_ITEM, this.SORT_DESC_MODIFIED_ITEM, this.SORT_MANUAL_ITEM);
            }
            SortContentTabMenuItems.prototype.getAllItems = function () {
                return this.items.slice(0, this.items.length);
            };
            return SortContentTabMenuItems;
        })();
        browse.SortContentTabMenuItems = SortContentTabMenuItems;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var SaveSortedContentEvent = (function (_super) {
            __extends(SaveSortedContentEvent, _super);
            function SaveSortedContentEvent(content) {
                this.content = content;
                _super.call(this);
            }
            SaveSortedContentEvent.prototype.getContent = function () {
                return this.content;
            };
            SaveSortedContentEvent.on = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            SaveSortedContentEvent.un = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            return SaveSortedContentEvent;
        })(api.event.Event);
        browse.SaveSortedContentEvent = SaveSortedContentEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var GridDragHandler = api.ui.grid.GridDragHandler;
        var OrderChildMovement = api.content.OrderChildMovement;
        var OrderChildMovements = api.content.OrderChildMovements;
        var ContentGridDragHandler = (function (_super) {
            __extends(ContentGridDragHandler, _super);
            function ContentGridDragHandler(treeGrid) {
                _super.call(this, treeGrid);
                this.movements = new OrderChildMovements();
            }
            ContentGridDragHandler.prototype.getContentMovements = function () {
                return this.movements;
            };
            ContentGridDragHandler.prototype.clearContentMovements = function () {
                this.movements = new OrderChildMovements();
            };
            ContentGridDragHandler.prototype.handleMovements = function (rowDataId, moveBeforeRowDataId) {
                this.movements.addChildMovement(new OrderChildMovement(rowDataId, moveBeforeRowDataId));
            };
            ContentGridDragHandler.prototype.getModelId = function (model) {
                return model ? model.getContentId() : null;
            };
            return ContentGridDragHandler;
        })(GridDragHandler);
        browse.ContentGridDragHandler = ContentGridDragHandler;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ContentPublishPromptEvent = (function (_super) {
            __extends(ContentPublishPromptEvent, _super);
            function ContentPublishPromptEvent() {
                _super.apply(this, arguments);
            }
            ContentPublishPromptEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ContentPublishPromptEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ContentPublishPromptEvent;
        })(browse.BaseContentModelEvent);
        browse.ContentPublishPromptEvent = ContentPublishPromptEvent;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var FoldButton = api.ui.toolbar.FoldButton;
        var MobileContentBrowseToolbar = (function (_super) {
            __extends(MobileContentBrowseToolbar, _super);
            function MobileContentBrowseToolbar(actions) {
                _super.call(this, "toolbar");
                this.actions = [];
                var foldButton = this.initFoldButton();
                this.addActions(actions.getAllActions(), foldButton);
                this.initEditButton(actions.EDIT_CONTENT);
            }
            MobileContentBrowseToolbar.prototype.initFoldButton = function () {
                var fold = new FoldButton();
                fold.setLabel('More...');
                this.appendChild(fold);
                return fold;
            };
            MobileContentBrowseToolbar.prototype.initEditButton = function (editAction) {
                var editButton = new api.ui.button.ActionButton(editAction);
                editButton.addClass("mobile-edit-action");
                this.appendChild(editButton);
            };
            MobileContentBrowseToolbar.prototype.addActions = function (actions, foldButton) {
                this.actions = this.actions.concat(actions);
                actions.forEach(function (action) {
                    var actionButton = new api.ui.button.ActionButton(action);
                    var buttonWidth = actionButton.getEl().getWidthWithBorder();
                    foldButton.push(actionButton, buttonWidth);
                });
            };
            MobileContentBrowseToolbar.prototype.getActions = function () {
                return this.actions;
            };
            return MobileContentBrowseToolbar;
        })(api.dom.DivEl);
        browse.MobileContentBrowseToolbar = MobileContentBrowseToolbar;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
var app;
(function (app) {
    var browse;
    (function (browse) {
        var ContentBrowseItem = (function (_super) {
            __extends(ContentBrowseItem, _super);
            function ContentBrowseItem(model) {
                _super.call(this, model);
                this.accessControlList = null;
            }
            ContentBrowseItem.prototype.getAccessControlList = function () {
                return this.accessControlList;
            };
            ContentBrowseItem.prototype.setAccessControlList = function (accessControlList) {
                this.accessControlList = accessControlList;
            };
            ContentBrowseItem.prototype.equals = function (o) {
                if (!api.ObjectHelper.iFrameSafeInstanceOf(o, ContentBrowseItem)) {
                    return false;
                }
                var other = o;
                return _super.prototype.equals.call(this, o) &&
                    api.ObjectHelper.equals(this.accessControlList, other.getAccessControlList());
            };
            return ContentBrowseItem;
        })(api.app.browse.BrowseItem);
        browse.ContentBrowseItem = ContentBrowseItem;
    })(browse = app.browse || (app.browse = {}));
})(app || (app = {}));
///<reference path='BaseContentModelEvent.ts' />
///<reference path='CloseContentEvent.ts' />
///<reference path='ContentDeletePromptEvent.ts' />
///<reference path='GridSelectionChangedEvent.ts' />
///<reference path='MoveContentEvent.ts' />
///<reference path='ShowContextMenuEvent.ts' />
///<reference path='ShowDetailsEvent.ts' />
///<reference path='ShowNewContentDialogEvent.ts' />
///<reference path='ShowNewContentGridEvent.ts' />
///<reference path='ShowPreviewEvent.ts' />
///<reference path='ToggleSearchPanelEvent.ts' />
///<reference path='ViewContentEvent.ts' />
///<reference path='ContentBrowseToolbar.ts' />
///<reference path='ContentBrowseItemPanel.ts' />
///<reference path='ContentBrowseItemsSelectionPanel.ts' />
///<reference path='ContentBrowsePanel.ts' />
///<reference path='ContentTreeGrid.ts' />
///<reference path='SortContentEvent.ts' />
///<reference path='OpenSortDialogEvent.ts' />
///<reference path='OpenMoveDialogEvent.ts' />
///<reference path='SortContentDialog.ts' />
///<reference path='MoveContentDialog.ts' />
///<reference path='SortContentTreeGrid.ts' />
///<reference path='SortContentTabMenu.ts' />
///<reference path='SortContentTabMenuItem.ts' />
///<reference path='SortContentTabMenuItems.ts' />
///<reference path='SaveSortedContentEvent.ts' />
///<reference path='ContentGridDragHandler.ts' />
///<reference path='ContentPublishPromptEvent.ts' />
///<reference path='MobileContentBrowseToolbar.ts' />
///<reference path='ContentBrowseItem.ts' />
var app;
(function (app) {
    var remove;
    (function (remove) {
        var ContentIconUrlResolver = api.content.ContentIconUrlResolver;
        var BrowseItem = api.app.browse.BrowseItem;
        var ContentPath = api.content.ContentPath;
        var ContentDeleteDialog = (function (_super) {
            __extends(ContentDeleteDialog, _super);
            function ContentDeleteDialog() {
                _super.call(this, "item");
                this.deleteButton = this.setDeleteAction(new remove.ContentDeleteDialogAction());
                this.addDeleteActionHandler();
                this.addDescendantsContainer();
                this.addCancelButtonToBottom();
            }
            ContentDeleteDialog.prototype.setContentToDelete = function (contents) {
                var _this = this;
                this.selectedItems = [];
                contents.forEach(function (content) {
                    _this.selectedItems.push(_this.createSelectionItemForDelete(content));
                });
                this.renderSelectedItems(this.selectedItems);
                this.updateSubTitle();
                if (this.selectedItems.length === 1) {
                    this.selectedItems[0].hideRemoveButton();
                }
                this.descendantsContainer.hide();
                if (this.atLeastOneInitialItemHasChild()) {
                    this.descendantsContainer.loadData(this.selectedItems).then(function () {
                        _this.descendantsContainer.show();
                        _this.centerMyself();
                    });
                }
                this.countItemsToDeleteAndUpdateButtonCounter();
                return this;
            };
            ContentDeleteDialog.prototype.setYesCallback = function (callback) {
                this.yesCallback = callback;
                return this;
            };
            ContentDeleteDialog.prototype.setNoCallback = function (callback) {
                this.noCallback = callback;
                return this;
            };
            ContentDeleteDialog.prototype.addDescendantsContainer = function () {
                this.descendantsContainer = new DescendantsToBeDeletedList("descendants-to-delete-list");
                this.appendChildToContentPanel(this.descendantsContainer);
            };
            ContentDeleteDialog.prototype.indexOf = function (item) {
                for (var i = 0; i < this.selectedItems.length; i++) {
                    if (item.getBrowseItem().getPath() == this.selectedItems[i].getBrowseItem().getPath()) {
                        return i;
                    }
                }
                return -1;
            };
            ContentDeleteDialog.prototype.addDeleteActionHandler = function () {
                var _this = this;
                this.getDeleteAction().onExecuted(function () {
                    if (!!_this.yesCallback) {
                        _this.yesCallback();
                    }
                    _this.deleteButton.setEnabled(false);
                    _this.showLoadingSpinner();
                    _this.createDeleteRequest().sendAndParse().then(function (result) {
                        _this.close();
                        app.view.DeleteAction.showDeleteResult(result);
                    }).catch(function (reason) {
                        if (reason && reason.message) {
                            api.notify.showError(reason.message);
                        }
                        else {
                            api.notify.showError('Content could not be deleted.');
                        }
                    }).finally(function () {
                        _this.deleteButton.setEnabled(true);
                        _this.hideLoadingSpinner();
                    }).done();
                });
            };
            ContentDeleteDialog.prototype.createSelectionItemForDelete = function (content) {
                var _this = this;
                var deleteItemViewer = new api.content.ContentSummaryAndCompareStatusViewer();
                deleteItemViewer.setObject(content);
                var browseItem = new BrowseItem(content).
                    setId(content.getId()).
                    setDisplayName(content.getDisplayName()).
                    setPath(content.getPath().toString()).
                    setIconUrl(new ContentIconUrlResolver().setContent(content.getContentSummary()).resolve());
                var selectionItem = new remove.ContentDeleteSelectionItem(deleteItemViewer, browseItem, function () {
                    var index = _this.indexOf(selectionItem);
                    if (index < 0) {
                        return;
                    }
                    _this.selectedItems[index].remove();
                    _this.selectedItems.splice(index, 1);
                    if (_this.selectedItems.length == 0) {
                        _this.close();
                    }
                    else {
                        _this.updateSubTitle();
                        if (_this.selectedItems.length === 1) {
                            _this.selectedItems[0].hideRemoveButton();
                        }
                        if (_this.atLeastOneInitialItemHasChild()) {
                            _this.descendantsContainer.loadData(_this.selectedItems).then(function () {
                                _this.centerMyself();
                            });
                        }
                        else {
                            _this.descendantsContainer.hide();
                            _this.centerMyself();
                        }
                        _this.countItemsToDeleteAndUpdateButtonCounter();
                    }
                });
                return selectionItem;
            };
            ContentDeleteDialog.prototype.countItemsToDeleteAndUpdateButtonCounter = function () {
                var _this = this;
                this.cleanDeleteButtonText();
                this.showLoadingSpinner();
                this.createRequestForCountingItemsToDelete().sendAndParse().then(function (itemsToDeleteCounter) {
                    _this.hideLoadingSpinner();
                    _this.updateDeleteButtonCounter(itemsToDeleteCounter);
                }).finally(function () {
                    _this.hideLoadingSpinner();
                }).done();
            };
            ContentDeleteDialog.prototype.createRequestForCountingItemsToDelete = function () {
                var countContentChildrenRequest = new api.content.CountContentsWithDescendantsRequest();
                for (var j = 0; j < this.selectedItems.length; j++) {
                    countContentChildrenRequest.addContentPath(ContentPath.fromString(this.selectedItems[j].getBrowseItem().getPath()));
                }
                return countContentChildrenRequest;
            };
            ContentDeleteDialog.prototype.createDeleteRequest = function () {
                var deleteRequest = new api.content.DeleteContentRequest();
                for (var i = 0; i < this.selectedItems.length; i++) {
                    deleteRequest.addContentPath(ContentPath.fromString(this.selectedItems[i].getBrowseItem().getPath()));
                }
                return deleteRequest;
            };
            ContentDeleteDialog.prototype.updateDeleteButtonCounter = function (count) {
                var showCounter = this.selectedItems.length > 1 || this.atLeastOneInitialItemHasChild();
                this.deleteButton.setLabel("Delete" + (showCounter ? " (" + count + ")" : ""));
            };
            ContentDeleteDialog.prototype.showLoadingSpinner = function () {
                this.deleteButton.addClass("spinner");
            };
            ContentDeleteDialog.prototype.hideLoadingSpinner = function () {
                this.deleteButton.removeClass("spinner");
            };
            ContentDeleteDialog.prototype.cleanDeleteButtonText = function () {
                this.deleteButton.setLabel("Delete ");
            };
            ContentDeleteDialog.prototype.atLeastOneInitialItemHasChild = function () {
                return this.selectedItems.some(function (obj) {
                    return obj.getBrowseItem().getModel().hasChildren();
                });
            };
            ContentDeleteDialog.prototype.updateSubTitle = function () {
                if (!this.atLeastOneInitialItemHasChild()) {
                    this.updateSubTitleText("");
                }
                else if (this.selectedItems.length > 1) {
                    this.updateSubTitleText("Delete selected items and their child content");
                }
                else {
                    this.updateSubTitleText("Delete selected item and its child content");
                }
            };
            return ContentDeleteDialog;
        })(api.app.remove.DeleteDialog);
        remove.ContentDeleteDialog = ContentDeleteDialog;
        var DescendantsToBeDeletedList = (function (_super) {
            __extends(DescendantsToBeDeletedList, _super);
            function DescendantsToBeDeletedList(className) {
                _super.call(this, className);
            }
            DescendantsToBeDeletedList.prototype.loadData = function (selectedItems) {
                var _this = this;
                return this.createRequestForGettingItemsDescendants(selectedItems).sendAndParse().then(function (result) {
                    _this.setItems(result.getContents());
                    _this.prependChild(new api.dom.H6El("descendants-header").setHtml("Other items that will be deleted"));
                });
            };
            DescendantsToBeDeletedList.prototype.createItemView = function (item, readOnly) {
                return new DescendantView(item);
            };
            DescendantsToBeDeletedList.prototype.getItemId = function (item) {
                return item.getId();
            };
            DescendantsToBeDeletedList.prototype.createRequestForGettingItemsDescendants = function (selectedItems) {
                var getDescendantsOfContentsRequest = new api.content.GetDescendantsOfContents();
                for (var j = 0; j < selectedItems.length; j++) {
                    getDescendantsOfContentsRequest.addContentPath(ContentPath.fromString(selectedItems[j].getBrowseItem().getPath()));
                }
                return getDescendantsOfContentsRequest;
            };
            return DescendantsToBeDeletedList;
        })(api.ui.selector.list.ListBox);
        remove.DescendantsToBeDeletedList = DescendantsToBeDeletedList;
        var DescendantView = (function (_super) {
            __extends(DescendantView, _super);
            function DescendantView(content) {
                _super.call(this, "names-and-icon-view descendant-view small");
                this.wrapperDivEl = new api.dom.DivEl("wrapper");
                this.appendChild(this.wrapperDivEl);
                if (!content.getType().isImage()) {
                    this.iconImageEl = new api.dom.ImgEl(null, "font-icon-default");
                    this.wrapperDivEl.appendChild(this.iconImageEl);
                    this.iconImageEl.setSrc(this.resolveIconUrl(content));
                }
                else {
                    this.iconDivEl = new api.dom.DivEl("font-icon-default image");
                    this.wrapperDivEl.appendChild(this.iconDivEl);
                }
                this.namesView = new api.app.NamesView(false).setMainName(this.resolveDisplayName(content));
                this.appendChild(this.namesView);
            }
            DescendantView.prototype.resolveDisplayName = function (object) {
                var contentName = object.getName(), invalid = !object.isValid() || !object.getDisplayName() || contentName.isUnnamed();
                this.toggleClass("invalid", invalid);
                return object.getPath().toString();
            };
            DescendantView.prototype.resolveIconUrl = function (object) {
                return new ContentIconUrlResolver().setContent(object).resolve();
            };
            return DescendantView;
        })(api.dom.DivEl);
        remove.DescendantView = DescendantView;
    })(remove = app.remove || (app.remove = {}));
})(app || (app = {}));
var app;
(function (app) {
    var remove;
    (function (remove) {
        var ContentDeleteDialogAction = (function (_super) {
            __extends(ContentDeleteDialogAction, _super);
            function ContentDeleteDialogAction() {
                _super.call(this, "Delete");
                this.setIconClass("delete-action");
            }
            return ContentDeleteDialogAction;
        })(api.ui.Action);
        remove.ContentDeleteDialogAction = ContentDeleteDialogAction;
    })(remove = app.remove || (app.remove = {}));
})(app || (app = {}));
var app;
(function (app) {
    var remove;
    (function (remove) {
        var CompareStatus = api.content.CompareStatus;
        var ContentDeleteSelectionItem = (function (_super) {
            __extends(ContentDeleteSelectionItem, _super);
            function ContentDeleteSelectionItem(viewer, item, removeCallback) {
                _super.call(this, viewer, item, removeCallback);
                this.initStatusDiv(item.getModel().getCompareStatus());
            }
            ContentDeleteSelectionItem.prototype.doRender = function () {
                _super.prototype.doRender.call(this);
                this.appendChild(this.statusDiv);
                return true;
            };
            ContentDeleteSelectionItem.prototype.initStatusDiv = function (status) {
                this.statusDiv = new api.dom.DivEl("status");
                this.statusDiv.setHtml(api.content.CompareStatusFormatter.formatStatus(status));
                var statusClass = "" + CompareStatus[status];
                this.statusDiv.addClass(statusClass.toLowerCase());
            };
            return ContentDeleteSelectionItem;
        })(api.app.browse.SelectionItem);
        remove.ContentDeleteSelectionItem = ContentDeleteSelectionItem;
    })(remove = app.remove || (app.remove = {}));
})(app || (app = {}));
///<reference path='ContentDeleteDialog.ts' />
///<reference path='ContentDeleteDialogAction.ts' />
///<reference path='ContentDeleteSelectionItem.ts' />
var app;
(function (app) {
    var create;
    (function (create) {
        var NewContentEvent = (function (_super) {
            __extends(NewContentEvent, _super);
            function NewContentEvent(contentType, parentContent) {
                _super.call(this);
                this.contentType = contentType;
                this.parentContent = parentContent;
            }
            NewContentEvent.prototype.getContentType = function () {
                return this.contentType;
            };
            NewContentEvent.prototype.getParentContent = function () {
                return this.parentContent;
            };
            NewContentEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            NewContentEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return NewContentEvent;
        })(api.event.Event);
        create.NewContentEvent = NewContentEvent;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var NewMediaUploadEvent = (function (_super) {
            __extends(NewMediaUploadEvent, _super);
            function NewMediaUploadEvent(items, parentContent) {
                _super.call(this);
                this.uploadItems = items;
                this.parentContent = parentContent;
            }
            NewMediaUploadEvent.prototype.getUploadItems = function () {
                return this.uploadItems;
            };
            NewMediaUploadEvent.prototype.getParentContent = function () {
                return this.parentContent;
            };
            NewMediaUploadEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            NewMediaUploadEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return NewMediaUploadEvent;
        })(api.event.Event);
        create.NewMediaUploadEvent = NewMediaUploadEvent;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var GetAllContentTypesRequest = api.schema.content.GetAllContentTypesRequest;
        var GetNearestSiteRequest = api.content.GetNearestSiteRequest;
        var ContentPath = api.content.ContentPath;
        var ListContentByPathRequest = api.content.ListContentByPathRequest;
        var NewContentDialog = (function (_super) {
            __extends(NewContentDialog, _super);
            function NewContentDialog() {
                this.contentDialogTitle = new NewContentDialogTitle("Create Content", "");
                _super.call(this, {
                    title: this.contentDialogTitle
                });
                this.uploaderEnabled = true;
                this.listItems = [];
                this.addClass("new-content-dialog hidden");
                this.initContentList();
                this.initMostPopularItemsBlock();
                this.initFileInput();
                this.initAndAppendContentSection();
                this.initAndAppendRecentItemsBlock();
                this.initMediaUploader();
                this.initLoadingMasks();
                api.dom.Body.get().appendChild(this);
            }
            NewContentDialog.prototype.initContentList = function () {
                var _this = this;
                this.contentList = new app.create.NewContentDialogList();
                this.contentList.onSelected(function (event) {
                    _this.closeAndFireEventFromContentType(event.getItem());
                });
            };
            NewContentDialog.prototype.initMostPopularItemsBlock = function () {
                var _this = this;
                this.mostPopularItemsBlock = new create.MostPopularItemsBlock();
                this.mostPopularItemsBlock.hide();
                this.mostPopularItems = [];
                this.mostPopularItemsBlock.getMostPopularList().onSelected(function (event) {
                    _this.closeAndFireEventFromContentType(event.getItem());
                });
            };
            NewContentDialog.prototype.initFileInput = function () {
                var _this = this;
                this.fileInput = new api.ui.text.FileInput('large').setPlaceholder("Search for content types").setUploaderParams({
                    parent: ContentPath.ROOT.toString()
                });
                this.fileInput.onUploadStarted(function (event) {
                    _this.closeAndFireEventFromMediaUpload(event.getUploadItems());
                });
                this.fileInput.onInput(function (event) {
                    if (api.util.StringHelper.isEmpty(_this.fileInput.getValue()) && _this.mostPopularItems.length > 0) {
                        _this.mostPopularItemsBlock.show();
                    }
                    else {
                        _this.mostPopularItemsBlock.hide();
                    }
                    _this.filterList();
                });
                this.fileInput.onKeyUp(function (event) {
                    if (event.keyCode === 27) {
                        _this.getCancelAction().execute();
                    }
                });
            };
            NewContentDialog.prototype.initAndAppendContentSection = function () {
                var section = new api.dom.SectionEl().setClass("column");
                this.appendChildToContentPanel(section);
                var contentTypesListDiv = new api.dom.DivEl("content-types-content");
                contentTypesListDiv.appendChildren(this.mostPopularItemsBlock, this.contentList);
                section.appendChildren(this.fileInput, contentTypesListDiv);
            };
            NewContentDialog.prototype.initAndAppendRecentItemsBlock = function () {
                var _this = this;
                this.recentItemsBlock = new create.RecentItemsBlock();
                this.appendChildToContentPanel(this.recentItemsBlock);
                this.recentItemsBlock.getRecentItemsList().onSelected(function (event) {
                    _this.closeAndFireEventFromContentType(event.getItem());
                });
            };
            NewContentDialog.prototype.initMediaUploader = function () {
                var _this = this;
                var uploaderContainer = new api.dom.DivEl('uploader-container');
                this.appendChild(uploaderContainer);
                var uploaderMask = new api.dom.DivEl('uploader-mask');
                uploaderContainer.appendChild(uploaderMask);
                this.mediaUploaderEl = new api.content.MediaUploaderEl({
                    operation: api.content.MediaUploaderElOperation.create,
                    params: {
                        parent: ContentPath.ROOT.toString()
                    },
                    name: 'new-content-uploader',
                    showResult: false,
                    showReset: false,
                    showCancel: false,
                    allowMultiSelection: true,
                    deferred: true
                });
                uploaderContainer.appendChild(this.mediaUploaderEl);
                this.mediaUploaderEl.onUploadStarted(function (event) {
                    _this.closeAndFireEventFromMediaUpload(event.getUploadItems());
                });
                var dragOverEl;
                this.onDragEnter(function (event) {
                    if (_this.uploaderEnabled) {
                        var target = event.target;
                        if (!!dragOverEl || dragOverEl == _this.getHTMLElement()) {
                            uploaderContainer.show();
                        }
                        dragOverEl = target;
                    }
                });
                this.onDragLeave(function (event) {
                    if (_this.uploaderEnabled) {
                        var targetEl = event.target;
                        if (dragOverEl == targetEl) {
                            uploaderContainer.hide();
                        }
                    }
                });
                this.onDrop(function (event) {
                    if (_this.uploaderEnabled) {
                        uploaderContainer.hide();
                    }
                });
            };
            NewContentDialog.prototype.initLoadingMasks = function () {
                this.contentListMask = new api.ui.mask.LoadMask(this.contentList);
                this.recentListMask = new api.ui.mask.LoadMask(this.recentItemsBlock.getRecentItemsList());
            };
            NewContentDialog.prototype.closeAndFireEventFromMediaUpload = function (items) {
                this.close();
                new create.NewMediaUploadEvent(items, this.parentContent).fire();
            };
            NewContentDialog.prototype.closeAndFireEventFromContentType = function (item) {
                this.close();
                new create.NewContentEvent(item.getContentType(), this.parentContent).fire();
            };
            NewContentDialog.prototype.filterList = function () {
                var inputValue = this.fileInput.getValue();
                var inputValueLowerCase = inputValue ? inputValue.toLowerCase() : undefined;
                var filteredItems = this.listItems.filter(function (item) {
                    return (!inputValueLowerCase || (item.getDisplayName().toLowerCase().indexOf(inputValueLowerCase) != -1) ||
                        (item.getName().toLowerCase().indexOf(inputValueLowerCase) != -1));
                });
                this.contentList.setItems(filteredItems);
            };
            NewContentDialog.prototype.filterByParentContent = function (items, siteApplicationKeys) {
                var _this = this;
                var createContentFilter = new api.content.CreateContentFilter().siteApplicationsFilter(siteApplicationKeys);
                return items.filter(function (item) {
                    return createContentFilter.isCreateContentAllowed(_this.parentContent, item.getContentType());
                });
            };
            NewContentDialog.prototype.setParentContent = function (parent) {
                this.parentContent = parent;
                var params = {
                    parent: parent ? parent.getPath().toString() : api.content.ContentPath.ROOT.toString()
                };
                this.mediaUploaderEl.setParams(params);
                this.fileInput.setUploaderParams(params);
            };
            NewContentDialog.prototype.open = function () {
                _super.prototype.open.call(this);
                var keyBindings = [
                    new api.ui.KeyBinding('up', function () {
                        api.dom.FormEl.moveFocusToPrevFocusable(api.dom.Element.fromHtmlElement(document.activeElement), "input,li");
                    }).setGlobal(true),
                    new api.ui.KeyBinding('down', function () {
                        api.dom.FormEl.moveFocusToNextFocusable(api.dom.Element.fromHtmlElement(document.activeElement), "input,li");
                    }).setGlobal(true)];
                api.ui.KeyBindings.get().bindKeys(keyBindings);
            };
            NewContentDialog.prototype.show = function () {
                this.updateDialogTitlePath();
                this.toggleUploaderEnabled();
                this.resetFileInputWithUploader();
                _super.prototype.show.call(this);
                this.fileInput.giveFocus();
                if (this.mockModalDialog == null) {
                    this.createMockDialog();
                }
                this.loadContentTypes();
            };
            NewContentDialog.prototype.hide = function () {
                _super.prototype.hide.call(this);
                this.mediaUploaderEl.stop();
                this.addClass("hidden");
                this.removeClass("animated");
                this.mostPopularItemsBlock.hide();
            };
            NewContentDialog.prototype.close = function () {
                this.fileInput.reset();
                _super.prototype.close.call(this);
            };
            NewContentDialog.prototype.loadContentTypes = function () {
                var _this = this;
                this.showLoadingMasks();
                wemQ.all(this.prepareRequestsToFetchContentData())
                    .spread(function (contentTypes, directChilds, parentSite) {
                    _this.listItems = _this.createListOfContentTypeItems(contentTypes, parentSite);
                    _this.mostPopularItems =
                        _this.createMostPopularItemList(_this.listItems.map(function (el) { return el.getContentType(); }), directChilds.getContents());
                    _this.resetNewContentDialogContent();
                    _this.toggleMostPopularBlockShown();
                }).catch(function (reason) {
                    api.DefaultErrorHandler.handle(reason);
                }).finally(function () {
                    _this.filterList();
                    _this.hideLoadingMasks();
                    _this.handleModalDialogAnimation();
                }).done();
            };
            NewContentDialog.prototype.showLoadingMasks = function () {
                this.contentList.insertChild(this.contentListMask, 0);
                this.recentItemsBlock.getRecentItemsList().insertChild(this.recentListMask, 0);
                this.contentListMask.show();
                this.recentListMask.show();
            };
            NewContentDialog.prototype.hideLoadingMasks = function () {
                this.contentListMask.hide();
                this.recentListMask.hide();
            };
            NewContentDialog.prototype.prepareRequestsToFetchContentData = function () {
                var requests = [];
                requests.push(new GetAllContentTypesRequest().sendAndParse());
                if (this.parentContent) {
                    requests.push(new ListContentByPathRequest(this.parentContent.getPath()).sendAndParse());
                    requests.push(new GetNearestSiteRequest(this.parentContent.getContentId()).sendAndParse());
                }
                else {
                    requests.push(new ListContentByPathRequest(ContentPath.ROOT).sendAndParse());
                }
                return requests;
            };
            NewContentDialog.prototype.showMockDialog = function () {
                wemjq(this.getEl().getHTMLElement()).show();
            };
            NewContentDialog.prototype.handleModalDialogAnimation = function () {
                this.mockModalDialog.mostPopularItemsBlock.getMostPopularList().setItems(this.mostPopularItems);
                this.toggleMockDialogMostPopularBlockShown();
                this.mockModalDialog.contentList.setItems(this.listItems);
                this.updateMockDialogTitlePath();
                this.mockModalDialog.showMockDialog();
                this.addClass("animated");
                this.removeClass("hidden");
                this.alignDialogWindowVertically();
            };
            NewContentDialog.prototype.toggleMockDialogMostPopularBlockShown = function () {
                if (this.mostPopularItems.length > 0) {
                    this.mockModalDialog.mostPopularItemsBlock.show();
                }
                else {
                    this.mockModalDialog.mostPopularItemsBlock.hide();
                }
            };
            NewContentDialog.prototype.toggleMostPopularBlockShown = function () {
                if (this.mostPopularItems.length > 0) {
                    this.mostPopularItemsBlock.getMostPopularList().setItems(this.mostPopularItems);
                    this.mostPopularItemsBlock.show();
                }
            };
            NewContentDialog.prototype.updateMockDialogTitlePath = function () {
                if (this.parentContent) {
                    this.mockModalDialog.contentDialogTitle.setPath(this.parentContent.getPath().toString());
                }
                else {
                    this.mockModalDialog.contentDialogTitle.setPath('');
                }
            };
            NewContentDialog.prototype.updateDialogTitlePath = function () {
                if (this.parentContent) {
                    this.contentDialogTitle.setPath(this.parentContent.getPath().toString());
                }
                else {
                    this.contentDialogTitle.setPath('');
                }
            };
            NewContentDialog.prototype.resetNewContentDialogContent = function () {
                if (this.listItems.length > 0) {
                    this.contentList.setItems(this.listItems);
                    this.recentItemsBlock.getRecentItemsList().setItems(this.listItems);
                    this.mostPopularItemsBlock.getMostPopularList().setItems(this.mostPopularItems);
                }
                else {
                    this.mostPopularItemsBlock.getMostPopularList().clearItems();
                    this.contentList.clearItems();
                    this.recentItemsBlock.getRecentItemsList().clearItems();
                }
            };
            NewContentDialog.prototype.toggleUploaderEnabled = function () {
                this.uploaderEnabled = !this.parentContent || !this.parentContent.getType().isTemplateFolder();
                this.toggleClass("no-uploader-el", !this.uploaderEnabled);
            };
            NewContentDialog.prototype.resetFileInputWithUploader = function () {
                this.mediaUploaderEl.reset();
                this.fileInput.reset();
                this.mediaUploaderEl.setEnabled(this.uploaderEnabled);
                this.fileInput.getUploader().setEnabled(this.uploaderEnabled);
            };
            NewContentDialog.prototype.createMockDialog = function () {
                this.mockModalDialog = new NewContentDialog();
                this.mockModalDialog.close = function () {
                    wemjq(this.getEl().getHTMLElement()).hide();
                };
                this.getParentElement().appendChild(this.mockModalDialog);
                this.mockModalDialog.addClass("mock-modal-dialog");
                this.mockModalDialog.removeClass("hidden");
            };
            NewContentDialog.prototype.createListItems = function (contentTypes) {
                var contentTypesByName = {};
                var items = [];
                contentTypes.forEach(function (contentType) {
                    var contentTypeName = contentType.getContentTypeName();
                    if (!contentTypeName.isMedia() && !contentTypeName.isDescendantOfMedia() && !contentTypeName.isFragment()) {
                        contentTypesByName[contentType.getName()] = contentType;
                        items.push(create.NewContentDialogListItem.fromContentType(contentType));
                    }
                });
                items.sort(this.compareListItems);
                return items;
            };
            NewContentDialog.prototype.createListOfContentTypeItems = function (allContentTypes, parentSite) {
                var allListItems = this.createListItems(allContentTypes);
                var siteApplications = parentSite ? parentSite.getApplicationKeys() : [];
                return this.filterByParentContent(allListItems, siteApplications);
            };
            NewContentDialog.prototype.findElementByFieldValue = function (array, field, value) {
                var result;
                array.every(function (element) {
                    if (element[field] == value) {
                        result = element;
                        return false;
                    }
                    return true;
                });
                return result;
            };
            NewContentDialog.prototype.sortByCountAndDate = function (contentType1, contentType2) {
                if (contentType2.count == contentType1.count) {
                    return contentType2.lastModified > contentType1.lastModified ? 1 : -1;
                }
                return contentType2.count - contentType1.count;
            };
            NewContentDialog.prototype.getAggregatedItemList = function (contentTypes) {
                var _this = this;
                var aggregatedList = [];
                contentTypes.forEach(function (content) {
                    var contentType = content.getType().toString();
                    var existingContent = _this.findElementByFieldValue(aggregatedList, "contentType", contentType);
                    if (existingContent) {
                        existingContent.count++;
                        if (content.getModifiedTime() > existingContent.lastModified) {
                            existingContent.lastModified = content.getModifiedTime();
                        }
                    }
                    else {
                        aggregatedList.push({ contentType: contentType, count: 1, lastModified: content.getModifiedTime() });
                    }
                });
                aggregatedList.sort(this.sortByCountAndDate);
                return aggregatedList;
            };
            NewContentDialog.prototype.createMostPopularItemList = function (allowedContentTypes, directChildContents) {
                var _this = this;
                var mostPopularItems = [], filteredList = directChildContents.filter(function (content) {
                    return _this.isAllowedContentType(allowedContentTypes, content);
                }), aggregatedList = this.getAggregatedItemList(filteredList);
                for (var i = 0; i < aggregatedList.length && i < create.MostPopularItemsBlock.DEFAULT_MAX_ITEMS; i++) {
                    var contentType = this.findElementByFieldValue(allowedContentTypes, "name", aggregatedList[i].contentType);
                    mostPopularItems.push(new create.MostPopularItem(contentType, aggregatedList[i].count));
                }
                return mostPopularItems;
            };
            NewContentDialog.prototype.compareListItems = function (item1, item2) {
                if (item1.getDisplayName().toLowerCase() > item2.getDisplayName().toLowerCase()) {
                    return 1;
                }
                else if (item1.getDisplayName().toLowerCase() < item2.getDisplayName().toLowerCase()) {
                    return -1;
                }
                else if (item1.getName() > item2.getName()) {
                    return 1;
                }
                else if (item1.getName() < item2.getName()) {
                    return -1;
                }
                else {
                    return 0;
                }
            };
            NewContentDialog.prototype.isAllowedContentType = function (allowedContentTypes, content) {
                return !content.getType().isMedia() && !content.getType().isDescendantOfMedia() &&
                    Boolean(this.findElementByFieldValue(allowedContentTypes, "id", content.getType().toString()));
            };
            NewContentDialog.prototype.alignDialogWindowVertically = function () {
                this.getEl().setMarginTop("-" + (this.mockModalDialog.getEl().getHeightWithBorder() / 2) + "px");
            };
            return NewContentDialog;
        })(api.ui.dialog.ModalDialog);
        create.NewContentDialog = NewContentDialog;
        var NewContentDialogTitle = (function (_super) {
            __extends(NewContentDialogTitle, _super);
            function NewContentDialogTitle(title, path) {
                _super.call(this, title);
                this.pathEl = new api.dom.PEl('path');
                this.pathEl.setHtml(path);
                this.appendChild(this.pathEl);
            }
            NewContentDialogTitle.prototype.setPath = function (path) {
                this.pathEl.setHtml(path).setVisible(!api.util.StringHelper.isBlank(path));
            };
            return NewContentDialogTitle;
        })(api.ui.dialog.ModalDialogHeader);
        create.NewContentDialogTitle = NewContentDialogTitle;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var NewContentDialogList = (function (_super) {
            __extends(NewContentDialogList, _super);
            function NewContentDialogList(className) {
                if (className === void 0) { className = 'content-types-list'; }
                _super.call(this, className);
                this.selectedListeners = [];
            }
            NewContentDialogList.prototype.onSelected = function (listener) {
                this.selectedListeners.push(listener);
            };
            NewContentDialogList.prototype.unSelected = function (listener) {
                this.selectedListeners = this.selectedListeners.filter(function (currentListener) {
                    return currentListener != listener;
                });
            };
            NewContentDialogList.prototype.notifySelected = function (listItem) {
                var _this = this;
                this.selectedListeners.forEach(function (listener) {
                    listener.call(_this, new create.NewContentDialogItemSelectedEvent(listItem));
                });
            };
            NewContentDialogList.prototype.createItemView = function (item) {
                var _this = this;
                var namesAndIconView = new api.app.NamesAndIconViewBuilder().setSize(api.app.NamesAndIconViewSize.small).build();
                namesAndIconView
                    .setIconUrl(item.getIconUrl())
                    .setMainName(item.getDisplayName())
                    .setSubName(item.getName())
                    .setDisplayIconLabel(item.isSite());
                var itemEl = new api.dom.LiEl('content-types-list-item' + (item.isSite() ? ' site' : ''));
                itemEl.getEl().setTabIndex(0);
                itemEl.appendChild(namesAndIconView);
                itemEl.onClicked(function (event) { return _this.notifySelected(item); });
                itemEl.onKeyPressed(function (event) {
                    if (event.keyCode == 13) {
                        _this.notifySelected(item);
                    }
                });
                return itemEl;
            };
            NewContentDialogList.prototype.getItemId = function (item) {
                return item.getName();
            };
            return NewContentDialogList;
        })(api.ui.selector.list.ListBox);
        create.NewContentDialogList = NewContentDialogList;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var NewContentDialogListItem = (function () {
            function NewContentDialogListItem(contentType) {
                this.contentType = contentType;
                this.name = contentType.getName();
                this.displayName = contentType.getDisplayName();
                this.iconUrl = contentType.getIconUrl();
            }
            NewContentDialogListItem.fromContentType = function (contentType) {
                return new NewContentDialogListItem(contentType);
            };
            NewContentDialogListItem.prototype.getContentType = function () {
                return this.contentType;
            };
            NewContentDialogListItem.prototype.isSite = function () {
                return this.contentType.isSite();
            };
            NewContentDialogListItem.prototype.getName = function () {
                return this.name;
            };
            NewContentDialogListItem.prototype.getDisplayName = function () {
                return this.displayName;
            };
            NewContentDialogListItem.prototype.getIconUrl = function () {
                return this.iconUrl;
            };
            return NewContentDialogListItem;
        })();
        create.NewContentDialogListItem = NewContentDialogListItem;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var NewContentDialogItemSelectedEvent = (function () {
            function NewContentDialogItemSelectedEvent(item) {
                this.item = item;
            }
            NewContentDialogItemSelectedEvent.prototype.getItem = function () {
                return this.item;
            };
            return NewContentDialogItemSelectedEvent;
        })();
        create.NewContentDialogItemSelectedEvent = NewContentDialogItemSelectedEvent;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        create.NewContentEvent.on(function (event) {
            RecentItems.get().addItemName(event.getContentType());
        });
        var RecentItems = (function () {
            function RecentItems() {
                this.maximum = 7;
                this.cookieKey = 'app.browse.RecentItemsList';
                this.cookieExpire = 30;
                this.valueSeparator = '|';
            }
            RecentItems.get = function () {
                return RecentItems.INSTANCE;
            };
            RecentItems.prototype.addItemName = function (contentType) {
                var itemsNames = this.getRecentItemsNames();
                var name = contentType.getName();
                itemsNames = itemsNames.filter(function (storedName) { return storedName != name; });
                itemsNames.unshift(name);
                itemsNames = itemsNames.slice(0, this.maximum);
                api.util.CookieHelper.setCookie(this.cookieKey, itemsNames.join(this.valueSeparator), this.cookieExpire);
            };
            RecentItems.prototype.getRecentItemsNames = function () {
                var cookies = api.util.CookieHelper.getCookie(this.cookieKey);
                return cookies ? cookies.split(this.valueSeparator) : [];
            };
            RecentItems.INSTANCE = new RecentItems();
            return RecentItems;
        })();
        create.RecentItems = RecentItems;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var RecentItemsList = (function (_super) {
            __extends(RecentItemsList, _super);
            function RecentItemsList() {
                _super.call(this, "recent-content-types-list");
            }
            RecentItemsList.prototype.setItems = function (items) {
                var itemsByName = {};
                items.forEach(function (item) {
                    itemsByName[item.getName()] = item;
                });
                var recentItemsNames = create.RecentItems.get().getRecentItemsNames();
                var recentItems = [];
                recentItemsNames.forEach(function (name) {
                    if (itemsByName[name]) {
                        recentItems.push(itemsByName[name]);
                    }
                });
                _super.prototype.setItems.call(this, recentItems);
            };
            return RecentItemsList;
        })(create.NewContentDialogList);
        create.RecentItemsList = RecentItemsList;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var RecentItemsBlock = (function (_super) {
            __extends(RecentItemsBlock, _super);
            function RecentItemsBlock(title) {
                if (title === void 0) { title = "Recently Used"; }
                _super.call(this, "column");
                this.title = new api.dom.H1El();
                this.title.setHtml(title);
                this.recentItemsList = new create.RecentItemsList();
                this.appendChildren(this.title, this.recentItemsList);
            }
            RecentItemsBlock.prototype.getRecentItemsList = function () {
                return this.recentItemsList;
            };
            RecentItemsBlock.prototype.setTitle = function (newTitle) {
                this.title.setHtml(newTitle);
            };
            return RecentItemsBlock;
        })(api.dom.AsideEl);
        create.RecentItemsBlock = RecentItemsBlock;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var MostPopularItemsList = (function (_super) {
            __extends(MostPopularItemsList, _super);
            function MostPopularItemsList() {
                _super.call(this, "most-popular-content-types-list");
            }
            MostPopularItemsList.prototype.createItemView = function (item) {
                var _this = this;
                var namesAndIconView = new api.app.NamesAndIconViewBuilder().setSize(api.app.NamesAndIconViewSize.small).build();
                namesAndIconView
                    .setIconUrl(item.getIconUrl())
                    .setMainName(item.getDisplayName() + " (" + item.getHits() + ")")
                    .setSubName(item.getName())
                    .setDisplayIconLabel(item.isSite());
                var itemEl = new api.dom.LiEl('content-types-list-item' + (item.isSite() ? ' site' : ''));
                itemEl.getEl().setTabIndex(0);
                itemEl.appendChild(namesAndIconView);
                itemEl.onClicked(function (event) { return _this.notifySelected(item); });
                itemEl.onKeyPressed(function (event) {
                    if (event.keyCode == 13) {
                        _this.notifySelected(item);
                    }
                });
                return itemEl;
            };
            return MostPopularItemsList;
        })(create.NewContentDialogList);
        create.MostPopularItemsList = MostPopularItemsList;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var MostPopularItem = (function (_super) {
            __extends(MostPopularItem, _super);
            function MostPopularItem(contentType, hits) {
                _super.call(this, contentType);
                this.hits = hits;
            }
            MostPopularItem.prototype.getHits = function () {
                return this.hits;
            };
            return MostPopularItem;
        })(create.NewContentDialogListItem);
        create.MostPopularItem = MostPopularItem;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
var app;
(function (app) {
    var create;
    (function (create) {
        var MostPopularItemsBlock = (function (_super) {
            __extends(MostPopularItemsBlock, _super);
            function MostPopularItemsBlock(title) {
                if (title === void 0) { title = "Most Popular"; }
                _super.call(this, "most-popular-content-types-container");
                this.title = new api.dom.H2El();
                this.title.setHtml(title);
                this.mostPopularItemsList = new create.MostPopularItemsList();
                this.appendChildren(this.title, this.mostPopularItemsList);
            }
            MostPopularItemsBlock.prototype.getMostPopularList = function () {
                return this.mostPopularItemsList;
            };
            MostPopularItemsBlock.prototype.setTitle = function (newTitle) {
                this.title.setHtml(newTitle);
            };
            MostPopularItemsBlock.DEFAULT_MAX_ITEMS = 2;
            return MostPopularItemsBlock;
        })(api.dom.DivEl);
        create.MostPopularItemsBlock = MostPopularItemsBlock;
    })(create = app.create || (app.create = {}));
})(app || (app = {}));
///<reference path='NewContentEvent.ts' />
///<reference path='NewMediaUploadEvent.ts' />
///<reference path='NewContentDialog.ts' />
///<reference path='NewContentDialogList.ts' />
///<reference path='NewContentDialogListItem.ts' />
///<reference path='NewContentDialogItemSelectedEvent.ts' />
///<reference path='RecentItems.ts' />
///<reference path='RecentItemsList.ts' />
///<reference path='RecentItemsBlock.ts' />
///<reference path='MostPopularItemsList.ts' />
///<reference path='MostPopularItem.ts' />
///<reference path='MostPopularItemsBlock.ts' /> 
var app;
(function (app) {
    var view;
    (function (view) {
        var CloseAction = (function (_super) {
            __extends(CloseAction, _super);
            function CloseAction(itemViewPanel, checkCanRemovePanel) {
                if (checkCanRemovePanel === void 0) { checkCanRemovePanel = true; }
                _super.call(this, "Close", "mod+alt+f4");
                this.onExecuted(function () {
                    itemViewPanel.close(checkCanRemovePanel);
                });
            }
            return CloseAction;
        })(api.ui.Action);
        view.CloseAction = CloseAction;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var DeleteAction = (function (_super) {
            __extends(DeleteAction, _super);
            function DeleteAction(itemViewPanel) {
                _super.call(this, "Delete", "mod+del");
                this.onExecuted(function () {
                    var contentToDelete = itemViewPanel.getItem().getModel().getContentSummary();
                    api.ui.dialog.ConfirmationDialog.get()
                        .setQuestion("Are you sure you want to delete this content?")
                        .setNoCallback(null)
                        .setYesCallback(function () {
                        itemViewPanel.close();
                        new api.content.DeleteContentRequest()
                            .addContentPath(contentToDelete.getPath())
                            .sendAndParse()
                            .then(function (result) {
                            DeleteAction.showDeleteResult(result);
                        }).catch(function (reason) {
                            if (reason && reason.message) {
                                api.notify.showError(reason.message);
                            }
                            else {
                                api.notify.showError('Content could not be deleted.');
                            }
                        }).done();
                    }).open();
                });
            }
            DeleteAction.showDeleteResult = function (result) {
                if (result.getPendings().length == 1) {
                    api.notify.showFeedback("\"" + result.getPendings()[0].getName() + "\" marked for deletion");
                }
                else if (result.getPendings().length > 1) {
                    api.notify.showFeedback(result.getPendings().length + " items marked for deletion");
                }
                if (result.getDeleted().length == 1) {
                    var deleted = result.getDeleted()[0];
                    var name_1 = deleted.getName() ||
                        "Unnamed " + api.util.StringHelper.capitalizeAll(deleted.getType().replace(/-/g, " ").trim());
                    api.notify.showFeedback("\"" + name_1 + "\" deleted");
                }
                else if (result.getDeleted().length > 1) {
                    api.notify.showFeedback(result.getDeleted().length + ' items deleted');
                }
                if (result.getDeleteFailures().length > 0) {
                    api.notify.showWarning("Content could not be deleted. " + result.getDeleteFailures()[0].getReason());
                }
            };
            return DeleteAction;
        })(api.ui.Action);
        view.DeleteAction = DeleteAction;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var EditAction = (function (_super) {
            __extends(EditAction, _super);
            function EditAction(panel) {
                _super.call(this, "Edit");
                this.onExecuted(function () {
                    new api.content.event.EditContentEvent([panel.getItem().getModel()]).fire();
                });
            }
            return EditAction;
        })(api.ui.Action);
        view.EditAction = EditAction;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var ContentItemViewToolbar = (function (_super) {
            __extends(ContentItemViewToolbar, _super);
            function ContentItemViewToolbar(params) {
                _super.call(this);
                _super.prototype.addAction.call(this, params.editAction);
                _super.prototype.addAction.call(this, params.deleteAction);
            }
            return ContentItemViewToolbar;
        })(api.ui.toolbar.Toolbar);
        view.ContentItemViewToolbar = ContentItemViewToolbar;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var ContentPreviewPathChangedEvent = (function (_super) {
            __extends(ContentPreviewPathChangedEvent, _super);
            function ContentPreviewPathChangedEvent(previewPath) {
                _super.call(this);
                this.previewPath = previewPath;
            }
            ContentPreviewPathChangedEvent.prototype.getPreviewPath = function () {
                return this.previewPath;
            };
            ContentPreviewPathChangedEvent.on = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            ContentPreviewPathChangedEvent.un = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            return ContentPreviewPathChangedEvent;
        })(api.event.Event);
        view.ContentPreviewPathChangedEvent = ContentPreviewPathChangedEvent;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var RenderingMode = api.rendering.RenderingMode;
        var ContentImageUrlResolver = api.content.ContentImageUrlResolver;
        var UriHelper = api.util.UriHelper;
        var ContentTypeName = api.schema.content.ContentTypeName;
        var ContentItemPreviewPanel = (function (_super) {
            __extends(ContentItemPreviewPanel, _super);
            function ContentItemPreviewPanel() {
                var _this = this;
                _super.call(this, "content-item-preview-panel");
                this.skipNextSetItemCall = false;
                this.image = new api.dom.ImgEl();
                this.image.onLoaded(function (event) {
                    _this.mask.hide();
                    var imgEl = _this.image.getEl();
                    var myEl = _this.getEl();
                    _this.centerImage(imgEl.getWidth(), imgEl.getHeight(), myEl.getWidth(), myEl.getHeight());
                });
                this.image.onError(function (event) {
                    _this.setNoPreview();
                });
                this.appendChild(this.image);
                api.ui.responsive.ResponsiveManager.onAvailableSizeChanged(this, function (item) {
                    if (_this.hasClass("image-preview")) {
                        var imgEl = _this.image.getEl(), el = _this.getEl();
                        _this.centerImage(imgEl.getWidth(), imgEl.getHeight(), el.getWidth(), el.getHeight());
                    }
                });
                this.onShown(function (event) {
                    if (_this.item && _this.hasClass("image-preview")) {
                        _this.addImageSizeToUrl(_this.item);
                    }
                });
                this.frame.onLoaded(function (event) {
                    var frameWindow = _this.frame.getHTMLElement()["contentWindow"];
                    try {
                        if (frameWindow) {
                            var pathname = frameWindow.location.pathname;
                            if (pathname && pathname !== 'blank') {
                                new view.ContentPreviewPathChangedEvent(pathname).fire();
                            }
                            frameWindow.addEventListener("click", _this.frameClickHandler.bind(_this));
                        }
                    }
                    catch (reason) { }
                });
            }
            ContentItemPreviewPanel.prototype.frameClickHandler = function (event) {
                var _this = this;
                if (this.isLinkClicked(event)) {
                    var href = event.target.href, frameWindow = this.frame.getHTMLElement()["contentWindow"];
                    if (!!frameWindow && !UriHelper.isNavigatingOutsideOfXP(href, frameWindow)) {
                        var contentPreviewPath = UriHelper.trimUrlParams(UriHelper.trimAnchor(UriHelper.trimWindowProtocolAndPortFromHref(href, frameWindow)));
                        if (!this.isNavigatingWithinSamePage(contentPreviewPath, frameWindow)) {
                            event.preventDefault();
                            var clickedLinkRelativePath = "/" + UriHelper.trimWindowProtocolAndPortFromHref(href, frameWindow);
                            this.skipNextSetItemCall = true;
                            new view.ContentPreviewPathChangedEvent(contentPreviewPath).fire();
                            this.showMask();
                            setTimeout(function () {
                                _this.skipNextSetItemCall = false;
                                _this.frame.setSrc(clickedLinkRelativePath);
                            }, 500);
                        }
                    }
                }
            };
            ContentItemPreviewPanel.prototype.isLinkClicked = function (event) {
                return event.target && event.target.tagName.toLowerCase() === 'a';
            };
            ContentItemPreviewPanel.prototype.isNavigatingWithinSamePage = function (contentPreviewPath, frameWindow) {
                var href = frameWindow.location.href;
                return contentPreviewPath === UriHelper.trimAnchor(UriHelper.trimWindowProtocolAndPortFromHref(href, frameWindow));
            };
            ContentItemPreviewPanel.prototype.centerImage = function (imgWidth, imgHeight, myWidth, myHeight) {
                var imgMarginTop = 0;
                if (imgHeight < myHeight) {
                    imgMarginTop = (myHeight - imgHeight) / 2;
                }
                this.image.getEl().setMarginTop(imgMarginTop + "px");
            };
            ContentItemPreviewPanel.prototype.addImageSizeToUrl = function (item) {
                var imgSize = Math.max(this.getEl().getWidth(), this.getEl().getHeight());
                var imgUrl = new ContentImageUrlResolver().
                    setContentId(item.getModel().getContentId()).
                    setTimestamp(item.getModel().getContentSummary().getModifiedTime()).
                    setSize(imgSize).resolve();
                this.image.setSrc(imgUrl);
            };
            ContentItemPreviewPanel.prototype.setItem = function (item) {
                if (item && !item.equals(this.item) && !this.skipNextSetItemCall) {
                    if (typeof item.isRenderable() === "undefined") {
                        return;
                    }
                    if (item.getModel().getContentSummary().getType().isImage() ||
                        item.getModel().getContentSummary().getType().isVectorMedia()) {
                        this.getEl().removeClass("no-preview page-preview").addClass("image-preview");
                        if (this.isVisible()) {
                            if (item.getModel().getContentSummary().getType().equals(ContentTypeName.MEDIA_VECTOR)) {
                                this.getEl().addClass("svg-preview");
                                var imgUrl = new ContentImageUrlResolver().
                                    setContentId(item.getModel().getContentId()).
                                    setTimestamp(item.getModel().getContentSummary().getModifiedTime()).
                                    resolve();
                                this.image.setSrc(imgUrl);
                            }
                            else {
                                this.addImageSizeToUrl(item);
                            }
                        }
                        if (!this.image.isLoaded()) {
                            this.showMask();
                        }
                    }
                    else {
                        this.showMask();
                        if (item.isRenderable()) {
                            this.getEl().removeClass("image-preview no-preview svg-preview").addClass('page-preview');
                            var src = api.rendering.UriHelper.getPortalUri(item.getPath(), RenderingMode.PREVIEW, api.content.Branch.DRAFT);
                            this.frame.setSrc(src);
                        }
                        else {
                            this.setNoPreview();
                        }
                    }
                }
                this.item = item;
            };
            ContentItemPreviewPanel.prototype.getItem = function () {
                return this.item;
            };
            ContentItemPreviewPanel.prototype.setNoPreview = function () {
                this.getEl().removeClass("image-preview page-preview svg-preview").addClass('no-preview');
                this.frame.setSrc("about:blank");
                this.mask.hide();
            };
            ContentItemPreviewPanel.prototype.showMask = function () {
                if (this.isVisible()) {
                    this.mask.show();
                }
            };
            return ContentItemPreviewPanel;
        })(api.app.view.ItemPreviewPanel);
        view.ContentItemPreviewPanel = ContentItemPreviewPanel;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var AllContentVersionsView = (function (_super) {
            __extends(AllContentVersionsView, _super);
            function AllContentVersionsView() {
                _super.call(this, "all-content-versions");
                this.loadedListeners = [];
            }
            AllContentVersionsView.prototype.setContentData = function (item) {
                this.contentId = item.getContentId();
                this.status = item.getCompareStatus();
            };
            AllContentVersionsView.prototype.reload = function () {
                var _this = this;
                return this.loadData().then(function (contentVersions) {
                    _this.updateView(contentVersions);
                    _this.notifyLoaded();
                });
            };
            AllContentVersionsView.prototype.createItemView = function (item, readOnly) {
                var itemEl = new api.dom.LiEl("content-version-item");
                var contentVersionStatus = this.getStatus(item);
                if (!!contentVersionStatus) {
                    var statusDiv = new api.dom.DivEl("status " + contentVersionStatus.workspace);
                    statusDiv.setHtml(contentVersionStatus.status);
                    itemEl.appendChild(statusDiv);
                }
                var descriptionDiv = this.createDescriptionBlock(item), versionInfoDiv = this.createVersionInfoBlock(item), closeButton = this.createCloseButton(versionInfoDiv);
                itemEl.appendChildren(closeButton, descriptionDiv, versionInfoDiv);
                itemEl.onClicked(function () {
                    versionInfoDiv.toggleClass("hidden");
                    closeButton.toggleClass("hidden");
                });
                return itemEl;
            };
            AllContentVersionsView.prototype.getItemId = function (item) {
                return item.id;
            };
            AllContentVersionsView.prototype.onLoaded = function (listener) {
                this.loadedListeners.push(listener);
            };
            AllContentVersionsView.prototype.unLoaded = function (listener) {
                this.loadedListeners = this.loadedListeners.filter(function (curr) {
                    return curr !== listener;
                });
            };
            AllContentVersionsView.prototype.notifyLoaded = function () {
                this.loadedListeners.forEach(function (listener) {
                    listener();
                });
            };
            AllContentVersionsView.prototype.loadData = function () {
                var _this = this;
                if (this.contentId) {
                    return new api.content.GetContentVersionsForViewRequest(this.contentId).sendAndParse().then(function (contentVersions) {
                        _this.activeVersion = contentVersions.getActiveVersion();
                        return contentVersions.getContentVersions();
                    });
                }
                else {
                    throw new Error("Required contentId not set for ActiveContentVersionsTreeGrid");
                }
            };
            AllContentVersionsView.prototype.updateView = function (contentVersions) {
                this.clearItems();
                this.setItems(contentVersions);
                this.getItemView(this.activeVersion).addClass("active");
            };
            AllContentVersionsView.prototype.getStatus = function (contentVersion) {
                var _this = this;
                if (this.status == undefined) {
                    return null;
                }
                var result = null;
                var hasMaster = contentVersion.workspaces.some(function (workspace) {
                    return workspace == AllContentVersionsView.branchMaster;
                });
                contentVersion.workspaces.some(function (workspace) {
                    if (!hasMaster || workspace == AllContentVersionsView.branchMaster) {
                        result = { workspace: workspace, status: _this.getState(workspace) };
                        return true;
                    }
                });
                return result;
            };
            AllContentVersionsView.prototype.getState = function (workspace) {
                if (workspace == AllContentVersionsView.branchMaster) {
                    return api.content.CompareStatusFormatter.formatStatus(api.content.CompareStatus.EQUAL);
                }
                else {
                    return api.content.CompareStatusFormatter.formatStatus(this.status);
                }
            };
            AllContentVersionsView.prototype.createCloseButton = function (elementToHide) {
                return new api.dom.DivEl("close-version-info-button hidden");
            };
            AllContentVersionsView.prototype.createDescriptionBlock = function (item) {
                var descriptionDiv = new api.content.ContentVersionViewer();
                descriptionDiv.addClass("description");
                descriptionDiv.setObject(item);
                return descriptionDiv;
            };
            AllContentVersionsView.prototype.createVersionInfoBlock = function (item) {
                var _this = this;
                var versionInfoDiv = new api.dom.DivEl("version-info hidden");
                var timestampDiv = new api.dom.DivEl("version-info-timestamp");
                timestampDiv.appendChildren(new api.dom.SpanEl("label").setHtml("Timestamp: "), new api.dom.SpanEl().setHtml(api.ui.treegrid.DateTimeFormatter.createHtml(item.modified)));
                var versionIdDiv = new api.dom.DivEl("version-info-version-id");
                versionIdDiv.appendChildren(new api.dom.SpanEl("label").setHtml("Version Id: "), new api.dom.SpanEl().setHtml(item.id));
                var displayNameDiv = new api.dom.DivEl("version-info-display-name");
                displayNameDiv.appendChildren(new api.dom.SpanEl("label").setHtml("Display name: "), new api.dom.SpanEl().setHtml(item.displayName));
                var isActive = item.id === this.activeVersion.id;
                var restoreButton = new api.ui.button.ActionButton(new api.ui.Action(isActive
                    ? "This version is active"
                    : "Restore this version").onExecuted(function (action) {
                    if (!isActive) {
                        new api.content.SetActiveContentVersionRequest(item.id, _this.contentId).sendAndParse().then(function (contentId) {
                            api.notify.NotifyManager.get().showFeedback("Version successfully changed to " + item.id);
                            new api.content.event.ActiveContentVersionSetEvent(_this.contentId, item.id).fire();
                        });
                    }
                }), false);
                if (isActive) {
                    restoreButton.addClass("active");
                }
                restoreButton.onClicked(function (event) {
                    event.preventDefault();
                    event.stopPropagation();
                });
                versionInfoDiv.appendChildren(timestampDiv, versionIdDiv, displayNameDiv, restoreButton);
                return versionInfoDiv;
            };
            AllContentVersionsView.branchMaster = "master";
            AllContentVersionsView.branchDraft = "draft";
            return AllContentVersionsView;
        })(api.ui.selector.list.ListBox);
        view.AllContentVersionsView = AllContentVersionsView;
        var ContentVersionStatus = (function () {
            function ContentVersionStatus() {
            }
            return ContentVersionStatus;
        })();
        view.ContentVersionStatus = ContentVersionStatus;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var ContentItemStatisticsPanel = (function (_super) {
            __extends(ContentItemStatisticsPanel, _super);
            function ContentItemStatisticsPanel() {
                _super.call(this, "content-item-statistics-panel");
                this.previewPanel = new view.ContentItemPreviewPanel();
                this.previewPanel.setDoOffset(false);
                this.appendChild(this.previewPanel);
            }
            ContentItemStatisticsPanel.prototype.setItem = function (item) {
                if (this.getItem() != item) {
                    _super.prototype.setItem.call(this, item);
                    this.previewPanel.setItem(item);
                }
            };
            return ContentItemStatisticsPanel;
        })(api.app.view.ItemStatisticsPanel);
        view.ContentItemStatisticsPanel = ContentItemStatisticsPanel;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var ContentItemViewPanel = (function (_super) {
            __extends(ContentItemViewPanel, _super);
            function ContentItemViewPanel() {
                var _this = this;
                this.deckPanel = new api.ui.panel.DeckPanel();
                this.editAction = new view.EditAction(this);
                this.deleteAction = new view.DeleteAction(this);
                this.closeAction = new view.CloseAction(this, true);
                this.actions = [this.editAction, this.deleteAction, this.closeAction];
                var toolbar = new view.ContentItemViewToolbar({
                    editAction: this.editAction,
                    deleteAction: this.deleteAction
                });
                _super.call(this, toolbar, this.deckPanel);
                this.statisticsPanel = new view.ContentItemStatisticsPanel();
                this.previewPanel = new view.ContentItemPreviewPanel();
                this.statisticsPanelIndex = this.deckPanel.addPanel(this.statisticsPanel);
                this.previewPanelIndex = this.deckPanel.addPanel(this.previewPanel);
                this.showPreview(false);
                app.browse.ShowPreviewEvent.on(function (event) {
                    _this.showPreview(true);
                });
                app.browse.ShowDetailsEvent.on(function (event) {
                    _this.showPreview(false);
                });
                this.onShown(function (event) {
                    if (_this.getItem()) {
                        app.Router.setHash("view/" + _this.getItem().getModel().getId());
                    }
                });
            }
            ContentItemViewPanel.prototype.setItem = function (item) {
                _super.prototype.setItem.call(this, item);
                this.statisticsPanel.setItem(item);
                this.previewPanel.setItem(item);
            };
            ContentItemViewPanel.prototype.showPreview = function (enabled) {
                this.previewMode = enabled;
                if (enabled) {
                    this.deckPanel.showPanelByIndex(this.previewPanelIndex);
                }
                else {
                    this.deckPanel.showPanelByIndex(this.statisticsPanelIndex);
                }
            };
            ContentItemViewPanel.prototype.getCloseAction = function () {
                return this.closeAction;
            };
            ContentItemViewPanel.prototype.getActions = function () {
                return this.actions;
            };
            return ContentItemViewPanel;
        })(api.app.view.ItemViewPanel);
        view.ContentItemViewPanel = ContentItemViewPanel;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
var app;
(function (app) {
    var view;
    (function (view) {
        var DetailsPanel = app.view.detail.DetailsPanel;
        var StringHelper = api.util.StringHelper;
        var ResponsiveManager = api.ui.responsive.ResponsiveManager;
        var MobileContentBrowseToolbar = app.browse.MobileContentBrowseToolbar;
        var MobileDetailsPanelToggleButton = app.view.detail.button.MobileDetailsPanelToggleButton;
        var MobileContentItemStatisticsPanel = (function (_super) {
            __extends(MobileContentItemStatisticsPanel, _super);
            function MobileContentItemStatisticsPanel(mobileBrowseActions) {
                var _this = this;
                _super.call(this, "mobile-content-item-statistics-panel");
                this.itemHeader = new api.dom.DivEl("mobile-content-item-statistics-header");
                this.headerLabel = new api.dom.SpanEl();
                this.detailsPanel = DetailsPanel.create().
                    setUseSplitter(false).
                    setUseViewer(false).
                    setSlideFrom(app.view.detail.SLIDE_FROM.BOTTOM).
                    build();
                this.mobileBrowseActions = mobileBrowseActions;
                this.setDoOffset(false);
                this.initHeader();
                this.initPreviewPanel();
                this.initDetailsPanel();
                this.initToolbar();
                this.onRendered(function () {
                    _this.slideAllOut();
                });
                ResponsiveManager.onAvailableSizeChanged(this, function (item) {
                    _this.slideAllOut();
                });
            }
            MobileContentItemStatisticsPanel.prototype.initToolbar = function () {
                this.toolbar = new MobileContentBrowseToolbar(this.mobileBrowseActions);
                this.appendChild(this.toolbar);
            };
            MobileContentItemStatisticsPanel.prototype.initHeader = function () {
                var _this = this;
                this.itemHeader.appendChild(this.headerLabel);
                this.detailsToggleButton = new MobileDetailsPanelToggleButton(this.detailsPanel, function () {
                    _this.calcAndSetDetailsPanelTopOffset();
                });
                var backButton = new api.dom.DivEl("back-button");
                backButton.onClicked(function (event) {
                    _this.slideAllOut();
                });
                this.itemHeader.appendChild(backButton);
                this.itemHeader.appendChild(this.detailsToggleButton);
                this.appendChild(this.itemHeader);
            };
            MobileContentItemStatisticsPanel.prototype.initDetailsPanel = function () {
                this.detailsPanel.addClass("mobile");
                this.appendChild(this.detailsPanel);
            };
            MobileContentItemStatisticsPanel.prototype.initPreviewPanel = function () {
                this.previewPanel = new view.ContentItemPreviewPanel();
                this.previewPanel.setDoOffset(false);
                this.appendChild(this.previewPanel);
            };
            MobileContentItemStatisticsPanel.prototype.setItem = function (item) {
                if (!this.getItem() || !this.getItem().equals(item)) {
                    _super.prototype.setItem.call(this, item);
                    this.previewPanel.setItem(item);
                    this.detailsPanel.setItem(item ? item.getModel() : null);
                    if (item) {
                        this.setName(this.makeDisplayName(item));
                    }
                }
                this.slideIn();
            };
            MobileContentItemStatisticsPanel.prototype.makeDisplayName = function (item) {
                var localName = item.getModel().getType().getLocalName() || "";
                return StringHelper.isEmpty(item.getDisplayName())
                    ? api.content.ContentUnnamed.prettifyUnnamed(localName)
                    : item.getDisplayName();
            };
            MobileContentItemStatisticsPanel.prototype.getDetailsPanel = function () {
                return this.detailsPanel;
            };
            MobileContentItemStatisticsPanel.prototype.setName = function (name) {
                this.headerLabel.setHtml(name);
            };
            MobileContentItemStatisticsPanel.prototype.slideAllOut = function () {
                this.slideOut();
                this.detailsPanel.slideOut();
                this.detailsToggleButton.removeClass("expanded");
            };
            MobileContentItemStatisticsPanel.prototype.slideOut = function () {
                this.getEl().setRightPx(-this.getEl().getWidthWithBorder());
            };
            MobileContentItemStatisticsPanel.prototype.slideIn = function () {
                this.getEl().setRightPx(0);
            };
            MobileContentItemStatisticsPanel.prototype.calcAndSetDetailsPanelTopOffset = function () {
                this.detailsPanel.getEl().setTopPx(this.itemHeader.getEl().getHeightWithMargin());
            };
            return MobileContentItemStatisticsPanel;
        })(api.app.view.ItemStatisticsPanel);
        view.MobileContentItemStatisticsPanel = MobileContentItemStatisticsPanel;
    })(view = app.view || (app.view = {}));
})(app || (app = {}));
///<reference path='CloseAction.ts' />
///<reference path='DeleteAction.ts' />
///<reference path='EditAction.ts' />
///<reference path='ContentItemViewToolbar.ts' />
///<reference path='ContentPreviewPathChangedEvent.ts' />
///<reference path='ContentItemPreviewPanel.ts' />
///<reference path='AllContentVersionsView.ts' />
///<reference path='ContentItemStatisticsPanel.ts' />
///<reference path='ContentItemViewPanel.ts' />
///<reference path='MobileContentItemStatisticsPanel.ts' /> 
var app;
(function (app) {
    var publish;
    (function (publish) {
        var PublishContentRequest = api.content.PublishContentRequest;
        var CompareStatus = api.content.CompareStatus;
        var ContentId = api.content.ContentId;
        var ContentPublishDialog = (function (_super) {
            __extends(ContentPublishDialog, _super);
            function ContentPublishDialog() {
                var _this = this;
                _super.call(this, {
                    title: new api.ui.dialog.ModalDialogHeader("Publishing Wizard")
                });
                this.selectionItems = [];
                this.initialItemsView = new PublishDialogItemList();
                this.dependenciesItemsView = new PublishDialogDependantsItemList();
                this.subheaderMessage = new api.dom.H6El("publish-dialog-subheader");
                this.initialContentsResolvedWithChildren = new ContentsResolved();
                this.initialContentsResolvedWithoutChildren = new ContentsResolved();
                this.dependenciesContentsResolvedWithChildren = new ContentsResolved();
                this.dependenciesContentsResolvedWithoutChildren = new ContentsResolved();
                this.modelName = "item";
                this.initIncludeChildrenCheckbox();
                this.getEl().addClass("publish-dialog");
                this.appendChildToContentPanel(this.initialItemsView);
                this.appendChildToContentPanel(this.dependenciesItemsView);
                this.initSubheaderMessage();
                this.publishButton = this.setPublishAction(new ContentPublishDialogAction());
                this.publishButton.setEnabled(false);
                this.getPublishAction().onExecuted(function () {
                    _this.doPublish();
                });
                this.addCancelButtonToBottom();
                this.appendChildToContentPanel(this.includeChildItemsCheck);
            }
            ContentPublishDialog.prototype.initAndOpen = function () {
                var _this = this;
                this.renderSelectedContentsWhileItemsGettingResolved();
                if (!this.atLeastOneInitialItemHasChild()) {
                    this.includeChildItemsCheck.setVisible(false);
                    this.getButtonRow().addClass("no-checkbox");
                }
                this.runResolveTasks(this.getResolveTasks(), function () { return _this.centerMyself(); });
                this.open();
            };
            ContentPublishDialog.prototype.runResolveTasks = function (resolveTasks, doneCallback) {
                var _this = this;
                this.showLoadingSpinnerAtButton();
                this.publishButton.setEnabled(false);
                wemQ.all(resolveTasks).done(function () {
                    if (doneCallback) {
                        doneCallback();
                    }
                    _this.hideLoadingSpinnerAtButton();
                    _this.countItemsToPublishAndUpdateCounterElements();
                });
            };
            ContentPublishDialog.prototype.getResolveTasks = function () {
                return [this.resolvePublishDependenciesIfNeededAndUpdateView()];
            };
            ContentPublishDialog.prototype.show = function () {
                api.dom.Body.get().appendChild(this);
                _super.prototype.show.call(this);
            };
            ContentPublishDialog.prototype.close = function () {
                _super.prototype.close.call(this);
                this.remove();
            };
            ContentPublishDialog.prototype.setPublishAction = function (action) {
                this.publishAction = action;
                return this.addAction(action, true, true);
            };
            ContentPublishDialog.prototype.getPublishAction = function () {
                return this.publishAction;
            };
            ContentPublishDialog.prototype.setSelectedContents = function (contents) {
                this.selectedContents = contents;
            };
            ContentPublishDialog.prototype.renderSelectedContentsWhileItemsGettingResolved = function () {
                var _this = this;
                var initiallySelectedContents = publish.ContentPublishItem.buildPublishItemsFromContentSummaryAndCompareStatuses(this.sortContentSummariesArrayByPath(this.selectedContents).slice(0, 15));
                initiallySelectedContents.forEach(function (content) {
                    var item = new publish.SelectionPublishItemBuilder().create().
                        setViewer(new app.publish.ResolvedPublishContentViewer()).
                        setContent(content).
                        setIsCheckBoxEnabled(false).
                        setRemovable(true).
                        build();
                    _this.initialItemsView.appendChild(item);
                });
            };
            ContentPublishDialog.prototype.sortContentSummariesArrayByPath = function (arrayToSort) {
                arrayToSort.sort(function (contentA, contentB) {
                    var pathA = contentA.getPath().toString(), pathB = contentB.getPath().toString();
                    return (pathA < pathB) ? -1 : (pathA > pathB) ? 1 : 0;
                });
                return arrayToSort;
            };
            ContentPublishDialog.prototype.renderResolvedPublishItems = function () {
                var _this = this;
                this.initSelectionItems();
                this.initialItemsView.clear();
                this.selectionItems.forEach(function (item) {
                    if (!item.isHidden()) {
                        _this.initialItemsView.appendChild(item);
                    }
                });
            };
            ContentPublishDialog.prototype.initSubheaderMessage = function () {
                this.appendChildToTitle(this.subheaderMessage);
                this.subheaderMessage.setHtml("Resolving items...");
            };
            ContentPublishDialog.prototype.initIncludeChildrenCheckbox = function () {
                var _this = this;
                var resolveTasks = [];
                this.includeChildrenCheckedListener = function () {
                    resolveTasks.push(_this.resolvePublishDependenciesIfNeededAndUpdateView());
                    _this.runResolveTasks(resolveTasks);
                };
                this.includeChildItemsCheck = new api.ui.Checkbox();
                this.includeChildItemsCheck.addClass('include-child-check');
                this.includeChildItemsCheck.onValueChanged(this.includeChildrenCheckedListener);
                this.includeChildItemsCheck.setLabel('Include child items');
                this.overwriteDefaultArrows(this.includeChildItemsCheck);
            };
            ContentPublishDialog.prototype.initSelectionItems = function () {
                var _this = this;
                this.selectionItems = [];
                var pushRequestedItems = this.includeChildItemsCheck.isChecked()
                    ? this.initialContentsResolvedWithChildren.getContentsResolved()
                    : this.initialContentsResolvedWithoutChildren.getContentsResolved();
                pushRequestedItems.forEach(function (content) {
                    var item = new publish.SelectionPublishItemBuilder().create().
                        setViewer(new app.publish.ResolvedPublishContentViewer()).
                        setContent(content).
                        setIsCheckBoxEnabled(false).
                        setRemovable(true).
                        setRemoveCallback(function () {
                        if (_this.selectionItems.length == 1) {
                            _this.close();
                            return;
                        }
                        _this.removeFromInitialSelection(item);
                        _this.initialContentsResolvedWithChildren.setAlreadyResolved(false);
                        _this.initialContentsResolvedWithoutChildren.setAlreadyResolved(false);
                        _this.dependenciesContentsResolvedWithChildren.setAlreadyResolved(false);
                        _this.dependenciesContentsResolvedWithoutChildren.setAlreadyResolved(false);
                        _this.runResolveTasks(_this.getResolveTasks());
                    }).
                        build();
                    _this.selectionItems.push(item);
                    if (_this.isInvalidContent(content)) {
                        _this.addOnClickedListener(item);
                        item.addClass("invalid");
                    }
                });
            };
            ContentPublishDialog.prototype.removeSelectionItem = function (item) {
                var index = this.indexOf(item);
                if (index < 0) {
                    return;
                }
                this.selectionItems[index].remove();
                this.selectionItems.splice(index, 1);
                if (this.selectionItems.length == 0) {
                    this.close();
                }
            };
            ContentPublishDialog.prototype.indexOf = function (item) {
                for (var i = 0; i < this.selectionItems.length; i++) {
                    if (item.getBrowseItem().getId() == this.selectionItems[i].getBrowseItem().getId()) {
                        return i;
                    }
                }
                return -1;
            };
            ContentPublishDialog.prototype.removeFromInitialSelection = function (item) {
                for (var i = 0; i < this.selectedContents.length; i++) {
                    if (item.getBrowseItem().getId() == this.selectedContents[i].getId()) {
                        this.selectedContents.splice(i, 1);
                        break;
                    }
                }
            };
            ContentPublishDialog.prototype.getSelectedContentsIds = function () {
                return this.selectedContents.
                    filter(function (el) {
                    return (typeof el !== "undefined");
                }).
                    map(function (el) {
                    return new ContentId(el.getId());
                });
            };
            ContentPublishDialog.prototype.restoreUncheckedState = function (unCheckedRequestedContentsIds, publishRequestedSelectionItems) {
                publishRequestedSelectionItems.forEach(function (item) {
                    if (unCheckedRequestedContentsIds.indexOf(item.getBrowseItem().getId()) > -1) {
                        item.setChecked(false);
                    }
                });
            };
            ContentPublishDialog.prototype.resolvePublishDependenciesIfNeededAndUpdateView = function () {
                var _this = this;
                if ((this.includeChildItemsCheck.isChecked() && !this.dependenciesContentsResolvedWithChildren.isAlreadyResolved()) ||
                    (!this.includeChildItemsCheck.isChecked() && !this.dependenciesContentsResolvedWithoutChildren.isAlreadyResolved())) {
                    var resolveDependenciesRequest = new api.content.ResolvePublishDependenciesRequest(this.getSelectedContentsIds(), this.includeChildItemsCheck.isChecked());
                    return resolveDependenciesRequest.send().then(function (jsonResponse) {
                        _this.initResolvedPublishItems(jsonResponse.getResult());
                        _this.renderResolvedPublishItems();
                        _this.initResolvedDependenciesItems(jsonResponse.getResult());
                        _this.renderResolvedDependenciesItems();
                    });
                }
                else {
                    this.renderResolvedDependenciesItems();
                    return wemQ(null);
                }
            };
            ContentPublishDialog.prototype.renderResolvedDependenciesItems = function () {
                var _this = this;
                this.dependenciesItemsView.clear();
                var dependenciesItems = this.includeChildItemsCheck.isChecked() ?
                    this.dependenciesContentsResolvedWithChildren :
                    this.dependenciesContentsResolvedWithoutChildren;
                if (dependenciesItems.getContentsResolved().length > 0) {
                    var dependenciesHeader = new api.dom.H6El("dependencies-header");
                    dependenciesHeader.setHtml("Other items that will be published");
                    this.dependenciesItemsView.appendChild(dependenciesHeader);
                }
                dependenciesItems.getContentsResolved().forEach(function (dependency) {
                    var dependencyView = new publish.SelectionPublishItemBuilder().create().
                        setViewer(new app.publish.ResolvedDependantContentViewer()).
                        setContent(dependency).
                        setIsCheckBoxEnabled(false).
                        setIsCheckboxHidden(true).
                        setShowStatus(false).
                        build();
                    _this.dependenciesItemsView.appendDependency(dependencyView);
                    if (_this.isInvalidContent(dependency)) {
                        _this.addOnClickedListener(dependencyView);
                        dependencyView.addClass("invalid");
                    }
                });
                if (this.extendsWindowHeightSize()) {
                    this.centerMyself();
                }
            };
            ContentPublishDialog.prototype.addOnClickedListener = function (dependencyView) {
                var _this = this;
                dependencyView.onClicked(function () {
                    var contentId = new api.content.ContentId(dependencyView.getBrowseItem().getId());
                    api.content.ContentSummaryAndCompareStatusFetcher.fetch(contentId).then(function (contentSummary) {
                        _this.close();
                        new api.content.event.EditContentEvent([contentSummary]).fire();
                    });
                });
            };
            ContentPublishDialog.prototype.isInvalidContent = function (item) {
                return !item.isValid() || !item.getDisplayName() || item.getName().isUnnamed();
            };
            ContentPublishDialog.prototype.extendsWindowHeightSize = function () {
                if (this.getResponsiveItem().isInRangeOrBigger(api.ui.responsive.ResponsiveRanges._540_720)) {
                    var el = this.getEl(), bottomPosition = (el.getTopPx() || parseFloat(el.getComputedProperty('top')) || 0) +
                        el.getMarginTop() +
                        el.getHeightWithBorder() +
                        el.getMarginBottom();
                    if (window.innerHeight < bottomPosition) {
                        return true;
                    }
                }
                return false;
            };
            ContentPublishDialog.prototype.initResolvedPublishItems = function (json) {
                if (this.includeChildItemsCheck.isChecked()) {
                    this.initialContentsResolvedWithChildren.setContentsResolved(publish.ContentPublishItem.fromNewContentPublishItems(json.requestedContents));
                }
                else {
                    this.initialContentsResolvedWithoutChildren.setContentsResolved(publish.ContentPublishItem.fromNewContentPublishItems(json.requestedContents));
                }
            };
            ContentPublishDialog.prototype.initResolvedDependenciesItems = function (json) {
                if (this.includeChildItemsCheck.isChecked()) {
                    this.dependenciesContentsResolvedWithChildren.setContentsResolved(publish.ContentPublishItem.fromNewContentPublishItems(json.dependentContents));
                }
                else {
                    this.dependenciesContentsResolvedWithoutChildren.setContentsResolved(publish.ContentPublishItem.fromNewContentPublishItems(json.dependentContents));
                }
            };
            ContentPublishDialog.prototype.doPublish = function () {
                var _this = this;
                this.showLoadingSpinnerAtButton();
                this.publishButton.setEnabled(false);
                var selectedIds = this.getSelectedContentsIds();
                new PublishContentRequest().
                    setIncludeChildren(this.includeChildItemsCheck.isChecked()).
                    setIds(selectedIds).send().done(function (jsonResponse) {
                    _this.close();
                    PublishContentRequest.feedback(jsonResponse);
                    new api.content.event.ContentsPublishedEvent(selectedIds).fire();
                });
            };
            ContentPublishDialog.prototype.countItemsToPublishAndUpdateCounterElements = function () {
                var totalCountToPublish = this.getTotalCountToPublish();
                this.updateSubheaderMessage(totalCountToPublish);
                this.updatePublishButton(totalCountToPublish);
            };
            ContentPublishDialog.prototype.getTotalCountToPublish = function () {
                var result = 0;
                result += this.getCountToPublish(this.includeChildItemsCheck.isChecked()
                    ? this.initialContentsResolvedWithChildren
                    : this.initialContentsResolvedWithoutChildren);
                result += this.getCountToPublish(this.includeChildItemsCheck.isChecked()
                    ? this.dependenciesContentsResolvedWithChildren
                    : this.dependenciesContentsResolvedWithoutChildren);
                return result;
            };
            ContentPublishDialog.prototype.getCountToPublish = function (contentsResolved) {
                var result = 0;
                contentsResolved.getContentsResolved().forEach(function (contentPublishItem) {
                    if (contentPublishItem.getCompareStatus() != api.content.CompareStatus.EQUAL) {
                        result++;
                    }
                });
                return result;
            };
            ContentPublishDialog.prototype.updateSubheaderMessage = function (count) {
                var allValid = this.allResolvedItemsAreValid();
                this.subheaderMessage.setHtml(count == 0 ? "No items to publish" :
                    allValid ? "Your changes are ready for publishing" : "Invalid content(s) prevent publish");
                this.subheaderMessage.toggleClass("invalid", !allValid);
            };
            ContentPublishDialog.prototype.updatePublishButton = function (count) {
                this.cleanPublishButtonText();
                this.publishButton.setLabel(count > 0 ? "Publish (" + count + ")" : "Publish");
                var canPublish = count > 0 && this.allResolvedItemsAreValid();
                this.publishButton.setEnabled(canPublish);
                if (canPublish) {
                    this.getButtonRow().focusDefaultAction();
                    this.updateTabbable();
                }
            };
            ContentPublishDialog.prototype.contentItemsAreValid = function (contentPublishItems) {
                return contentPublishItems.getContentsResolved().every(function (content) {
                    return content.getCompareStatus() == CompareStatus.PENDING_DELETE ||
                        (content.isValid() && !api.util.StringHelper.isBlank(content.getDisplayName()) && !content.getName().isUnnamed());
                });
            };
            ContentPublishDialog.prototype.atLeastOneInitialItemHasChild = function () {
                return this.selectedContents.some(function (obj) {
                    return obj.hasChildren();
                });
            };
            ContentPublishDialog.prototype.allResolvedItemsAreValid = function () {
                var includeChildItems = this.includeChildItemsCheck.isChecked();
                var initialValid = this.contentItemsAreValid(includeChildItems
                    ? this.initialContentsResolvedWithChildren
                    : this.initialContentsResolvedWithoutChildren);
                var dependenciesValid = this.contentItemsAreValid(includeChildItems
                    ? this.dependenciesContentsResolvedWithChildren
                    : this.dependenciesContentsResolvedWithoutChildren);
                return initialValid && dependenciesValid;
            };
            ContentPublishDialog.prototype.showLoadingSpinnerAtButton = function () {
                this.publishButton.addClass("spinner");
            };
            ContentPublishDialog.prototype.hideLoadingSpinnerAtButton = function () {
                this.publishButton.removeClass("spinner");
            };
            ContentPublishDialog.prototype.cleanPublishButtonText = function () {
                this.publishButton.setLabel("Publish");
            };
            return ContentPublishDialog;
        })(api.ui.dialog.ModalDialog);
        publish.ContentPublishDialog = ContentPublishDialog;
        var PublishDialogItemList = (function (_super) {
            __extends(PublishDialogItemList, _super);
            function PublishDialogItemList() {
                _super.call(this);
                this.getEl().addClass("item-list");
                this.getEl().addClass("initial-items");
            }
            PublishDialogItemList.prototype.clear = function () {
                this.removeChildren();
            };
            return PublishDialogItemList;
        })(api.dom.DivEl);
        publish.PublishDialogItemList = PublishDialogItemList;
        var PublishDialogDependantsItemList = (function (_super) {
            __extends(PublishDialogDependantsItemList, _super);
            function PublishDialogDependantsItemList() {
                _super.call(this);
                this.selectionDependenciesItems = [];
                this.getEl().addClass("item-list");
                this.getEl().addClass("dependant-items");
            }
            PublishDialogDependantsItemList.prototype.appendDependency = function (dependencyView) {
                this.appendChild(dependencyView);
                this.selectionDependenciesItems.push(dependencyView);
            };
            PublishDialogDependantsItemList.prototype.clear = function () {
                this.selectionDependenciesItems = [];
                this.removeChildren();
            };
            return PublishDialogDependantsItemList;
        })(api.dom.DivEl);
        publish.PublishDialogDependantsItemList = PublishDialogDependantsItemList;
        var ContentPublishDialogAction = (function (_super) {
            __extends(ContentPublishDialogAction, _super);
            function ContentPublishDialogAction() {
                _super.call(this, "Publish");
                this.setIconClass("publish-action");
            }
            return ContentPublishDialogAction;
        })(api.ui.Action);
        publish.ContentPublishDialogAction = ContentPublishDialogAction;
        var ContentsResolved = (function () {
            function ContentsResolved() {
                this.alreadyResolved = false;
                this.contentsResolved = [];
            }
            ContentsResolved.prototype.isAlreadyResolved = function () {
                return this.alreadyResolved;
            };
            ContentsResolved.prototype.setAlreadyResolved = function (value) {
                this.alreadyResolved = value;
            };
            ContentsResolved.prototype.setContentsResolved = function (contentsResolvedWithChildren) {
                this.contentsResolved = contentsResolvedWithChildren;
                this.alreadyResolved = true;
            };
            ContentsResolved.prototype.getContentsResolved = function () {
                return this.contentsResolved;
            };
            ContentsResolved.prototype.removeItemWithId = function (id) {
                if (this.alreadyResolved) {
                    for (var i = 0; i < this.contentsResolved.length; i++) {
                        if (id == this.contentsResolved[i].getId()) {
                            this.contentsResolved.splice(i, 1);
                            break;
                        }
                    }
                }
            };
            return ContentsResolved;
        })();
    })(publish = app.publish || (app.publish = {}));
})(app || (app = {}));
var app;
(function (app) {
    var publish;
    (function (publish) {
        var ContentPath = api.content.ContentPath;
        var CompareStatus = api.content.CompareStatus;
        var ContentName = api.content.ContentName;
        var ContentTypeName = api.schema.content.ContentTypeName;
        var ContentPublishItem = (function () {
            function ContentPublishItem(builder) {
                this.displayName = builder.displayName;
                this.path = builder.path;
                this.iconUrl = builder.iconUrl;
                this.id = builder.id;
                this.name = builder.name;
                this.type = builder.type;
                this.valid = builder.valid;
                this.compareStatus = builder.compareStatus;
            }
            ContentPublishItem.prototype.getDisplayName = function () {
                return this.displayName;
            };
            ContentPublishItem.prototype.getCompareStatus = function () {
                return this.compareStatus;
            };
            ContentPublishItem.prototype.hasParent = function () {
                return this.path.hasParentContent();
            };
            ContentPublishItem.prototype.getPath = function () {
                return this.path;
            };
            ContentPublishItem.prototype.getIconUrl = function () {
                return this.iconUrl;
            };
            ContentPublishItem.prototype.getId = function () {
                return this.id;
            };
            ContentPublishItem.prototype.getName = function () {
                return this.name;
            };
            ContentPublishItem.prototype.getType = function () {
                return this.type;
            };
            ContentPublishItem.prototype.isValid = function () {
                return this.valid;
            };
            ContentPublishItem.prototype.isImage = function () {
                return this.type.isImage();
            };
            ContentPublishItem.prototype.equals = function (o) {
                if (!api.ObjectHelper.iFrameSafeInstanceOf(o, ContentPublishItem)) {
                    return false;
                }
                var other = o;
                if (!api.ObjectHelper.stringEquals(this.id, other.id)) {
                    return false;
                }
                if (!api.ObjectHelper.stringEquals(this.displayName, other.displayName)) {
                    return false;
                }
                if (!api.ObjectHelper.equals(this.path, other.path)) {
                    return false;
                }
                if (!api.ObjectHelper.stringEquals(this.iconUrl, other.iconUrl)) {
                    return false;
                }
                if (this.compareStatus != other.compareStatus) {
                    return false;
                }
                if (!api.ObjectHelper.equals(this.name, other.name)) {
                    return false;
                }
                if (!api.ObjectHelper.equals(this.type, other.type)) {
                    return false;
                }
                if (!api.ObjectHelper.booleanEquals(this.valid, other.valid)) {
                    return false;
                }
                return true;
            };
            ContentPublishItem.fromNewContentPublishItems = function (jsonItems) {
                var array = [];
                jsonItems.forEach(function (obj) {
                    array.push(new ContentPublishItemBuilder().fromJson(obj).build());
                });
                return array;
            };
            ContentPublishItem.buildPublishItemsFromContentSummaryAndCompareStatuses = function (items) {
                var array = [];
                items.forEach(function (obj) {
                    array.push(new ContentPublishItemBuilder().fromContentSummary(obj.getContentSummary()).build());
                });
                return array;
            };
            ContentPublishItem.buildPublishItemFromContentSummary = function (item) {
                return new ContentPublishItemBuilder().fromContentSummary(item).build();
            };
            return ContentPublishItem;
        })();
        publish.ContentPublishItem = ContentPublishItem;
        var ContentPublishItemBuilder = (function () {
            function ContentPublishItemBuilder(source) {
                if (source) {
                    this.id = source.getId();
                    this.displayName = source.getDisplayName();
                    this.path = source.getPath();
                    this.iconUrl = source.getIconUrl();
                    this.compareStatus = source.getCompareStatus();
                    this.name = source.getName();
                    this.type = source.getType();
                    this.valid = source.isValid();
                }
            }
            ContentPublishItemBuilder.prototype.fromJson = function (json) {
                this.id = json.id;
                this.path = ContentPath.fromString(json.path);
                this.compareStatus = CompareStatus[json.compareStatus];
                this.displayName = json.displayName;
                this.iconUrl = json.iconUrl;
                this.name = ContentName.fromString(json.name);
                this.type = new ContentTypeName(json.type);
                this.valid = json.valid;
                return this;
            };
            ContentPublishItemBuilder.prototype.fromContentSummary = function (contentSummary) {
                this.id = contentSummary.getId();
                this.path = contentSummary.getPath();
                this.compareStatus = contentSummary.getContentState().isDefault() ? CompareStatus.NEW : CompareStatus.PENDING_DELETE;
                this.displayName = contentSummary.getDisplayName();
                this.iconUrl = contentSummary.getIconUrl();
                this.name = contentSummary.getName();
                this.type = contentSummary.getType();
                this.valid = contentSummary.isValid();
                return this;
            };
            ContentPublishItemBuilder.prototype.setId = function (value) {
                this.id = value;
                return this;
            };
            ContentPublishItemBuilder.prototype.setCompareStatus = function (value) {
                this.compareStatus = value;
                return this;
            };
            ContentPublishItemBuilder.prototype.setPath = function (path) {
                this.path = path;
                return this;
            };
            ContentPublishItemBuilder.prototype.setDisplayName = function (value) {
                this.displayName = value;
                return this;
            };
            ContentPublishItemBuilder.prototype.build = function () {
                return new ContentPublishItem(this);
            };
            return ContentPublishItemBuilder;
        })();
        publish.ContentPublishItemBuilder = ContentPublishItemBuilder;
    })(publish = app.publish || (app.publish = {}));
})(app || (app = {}));
var app;
(function (app) {
    var publish;
    (function (publish) {
        var ContentPath = api.content.ContentPath;
        var ContentIconUrlResolver = api.content.ContentIconUrlResolver;
        var CompareStatus = api.content.CompareStatus;
        var ResolvedPublishContentViewer = (function (_super) {
            __extends(ResolvedPublishContentViewer, _super);
            function ResolvedPublishContentViewer() {
                _super.call(this, "content-resolved-publish-viewer");
            }
            ResolvedPublishContentViewer.prototype.resolveDisplayName = function (object) {
                var contentName = object.getName(), invalid = !object.isValid() || !object.getDisplayName() || contentName.isUnnamed(), pendingDelete = CompareStatus.PENDING_DELETE == object.getCompareStatus() ? true : false;
                this.toggleClass("invalid", invalid);
                this.toggleClass("pending-delete", pendingDelete);
                return object.getDisplayName();
            };
            ResolvedPublishContentViewer.prototype.resolveUnnamedDisplayName = function (object) {
                return object.getType() ? object.getType().getLocalName() : "";
            };
            ResolvedPublishContentViewer.prototype.resolveSubName = function (object, relativePath) {
                if (relativePath === void 0) { relativePath = false; }
                var contentName = object.getName();
                if (relativePath) {
                    return !contentName.isUnnamed() ? object.getName().toString() :
                        api.content.ContentUnnamed.prettifyUnnamed();
                }
                else {
                    return !contentName.isUnnamed() ? object.getPath().toString() :
                        ContentPath.fromParent(object.getPath().getParentPath(), api.content.ContentUnnamed.prettifyUnnamed()).toString();
                }
            };
            ResolvedPublishContentViewer.prototype.resolveSubTitle = function (object) {
                return object.getPath().toString();
            };
            ResolvedPublishContentViewer.prototype.resolveIconUrl = function (object) {
                return new ContentIconUrlResolver().setContent(object).resolve();
            };
            return ResolvedPublishContentViewer;
        })(api.ui.NamesAndIconViewer);
        publish.ResolvedPublishContentViewer = ResolvedPublishContentViewer;
        var ResolvedDependantContentViewer = (function (_super) {
            __extends(ResolvedDependantContentViewer, _super);
            function ResolvedDependantContentViewer(className, size) {
                if (size === void 0) { size = api.app.NamesAndIconViewSize.small; }
                _super.call(this, className);
                this.size = size;
                this.addClass("content-resolved-dependant-viewer");
            }
            ResolvedDependantContentViewer.prototype.setObject = function (object, relativePath) {
                if (relativePath === void 0) { relativePath = false; }
                _super.prototype.setObject.call(this, object);
                var displayName = this.resolveDisplayName(object), iconUrl = this.resolveIconUrl(object);
                if (!!object.getType() && !!object.getType().isImage()) {
                    this.namesAndIconView = new DependantView(this.size, true);
                }
                else if (!!iconUrl) {
                    this.namesAndIconView = new DependantView(this.size);
                    this.namesAndIconView.setIconUrl(iconUrl);
                }
                this.namesAndIconView.setMainName(displayName);
                this.render();
            };
            ResolvedDependantContentViewer.prototype.resolveDisplayName = function (object) {
                var contentName = object.getName(), invalid = !object.isValid() || !object.getDisplayName() || contentName.isUnnamed(), pendingDelete = CompareStatus.PENDING_DELETE == object.getCompareStatus() ? true : false;
                this.toggleClass("invalid", invalid);
                this.toggleClass("pending-delete", pendingDelete);
                return object.getPath().toString();
            };
            ResolvedDependantContentViewer.prototype.resolveIconUrl = function (object) {
                return new ContentIconUrlResolver().setContent(object).resolve();
            };
            ResolvedDependantContentViewer.prototype.getPreferredHeight = function () {
                return 50;
            };
            ResolvedDependantContentViewer.prototype.doRender = function () {
                this.removeChildren();
                this.appendChild(this.namesAndIconView);
                return true;
            };
            return ResolvedDependantContentViewer;
        })(api.ui.Viewer);
        publish.ResolvedDependantContentViewer = ResolvedDependantContentViewer;
        var DependantView = (function (_super) {
            __extends(DependantView, _super);
            function DependantView(size, isForImageContent) {
                if (isForImageContent === void 0) { isForImageContent = false; }
                _super.call(this, "names-and-icon-view");
                var sizeClassName = api.app.NamesAndIconViewSize[size];
                if (size) {
                    this.addClass(sizeClassName);
                }
                this.wrapperDivEl = new api.dom.DivEl("wrapper");
                this.appendChild(this.wrapperDivEl);
                if (!isForImageContent) {
                    this.iconImageEl = new api.dom.ImgEl(null, "font-icon-default");
                    this.wrapperDivEl.appendChild(this.iconImageEl);
                }
                else {
                    this.iconDivEl = new api.dom.DivEl("font-icon-default image");
                    this.wrapperDivEl.appendChild(this.iconDivEl);
                }
                this.namesView = new api.app.NamesView(false);
                this.appendChild(this.namesView);
            }
            DependantView.prototype.setMainName = function (value) {
                this.namesView.setMainName(value);
                return this;
            };
            DependantView.prototype.setIconUrl = function (value) {
                this.iconImageEl.setSrc(value);
                return this;
            };
            return DependantView;
        })(api.dom.DivEl);
        publish.DependantView = DependantView;
    })(publish = app.publish || (app.publish = {}));
})(app || (app = {}));
var app;
(function (app) {
    var publish;
    (function (publish) {
        var BrowseItem = api.app.browse.BrowseItem;
        var CompareStatus = api.content.CompareStatus;
        var SelectionPublishItem = (function (_super) {
            __extends(SelectionPublishItem, _super);
            function SelectionPublishItem(viewer, item, status, isCheckboxHidden, showStatus, changeCallback, toggleCallback, isCheckBoxEnabled, isHidden, isChecked, expandable, removable, removeCallback) {
                if (isCheckBoxEnabled === void 0) { isCheckBoxEnabled = true; }
                if (isHidden === void 0) { isHidden = false; }
                if (isChecked === void 0) { isChecked = true; }
                if (expandable === void 0) { expandable = false; }
                if (removable === void 0) { removable = false; }
                _super.call(this, "browse-selection-publish-item");
                this.childrenDiv = new DependantsItemList();
                this.dependants = [];
                this.viewer = viewer;
                this.item = item;
                this.hidden = isHidden;
                this.isCheckboxHidden = isCheckboxHidden;
                this.expandable = expandable;
                this.removable = removable;
                this.showStatus = showStatus;
                this.initStatusDiv(status);
                this.initCheckBox(isCheckBoxEnabled, isChecked, changeCallback);
                this.initChildrenSwitch(expandable, toggleCallback);
                this.initRemoveButton(removeCallback);
            }
            SelectionPublishItem.prototype.initStatusDiv = function (status) {
                if (this.showStatus) {
                    this.statusDiv = new api.dom.DivEl("status");
                    this.statusDiv.setHtml(api.content.CompareStatusFormatter.formatStatus(status));
                    var statusClass = "" + CompareStatus[status];
                    this.statusDiv.addClass(statusClass.toLowerCase());
                }
            };
            SelectionPublishItem.prototype.initChildrenSwitch = function (expandable, toggleCallback) {
                var _this = this;
                if (expandable) {
                    this.childrenSwitch = new api.dom.SpanEl("toggle icon expand");
                    this.childrenSwitch.onClicked(function (event) {
                        var isExpand = _this.childrenSwitch.hasClass("expand");
                        _this.childrenSwitch.toggleClass("expand");
                        _this.childrenSwitch.toggleClass("collapse");
                        toggleCallback(isExpand);
                    });
                }
            };
            SelectionPublishItem.prototype.initCheckBox = function (isCheckBoxEnabled, isChecked, callback) {
                if (!this.isCheckboxHidden) {
                    this.checkBox = new api.ui.Checkbox();
                    this.checkBox.addClass("checkbox");
                    this.checkBox.setChecked(isChecked);
                    if (!isCheckBoxEnabled) {
                        this.checkBox.setDisabled(true);
                        this.checkBox.addClass("disabled");
                    }
                    else {
                        this.checkBox.onValueChanged(function (event) {
                            if (callback) {
                                callback();
                            }
                        });
                    }
                }
            };
            SelectionPublishItem.prototype.initRemoveButton = function (callback) {
                if (this.removable) {
                    this.removeEl = new api.dom.DivEl("icon remove");
                    this.removeEl.onClicked(function (event) {
                        event.preventDefault();
                        event.stopPropagation();
                        if (callback) {
                            callback();
                        }
                    });
                }
            };
            SelectionPublishItem.prototype.getBrowseItem = function () {
                return this.item;
            };
            SelectionPublishItem.prototype.isChecked = function () {
                return this.checkBox.isChecked();
            };
            SelectionPublishItem.prototype.isHidden = function () {
                return this.hidden;
            };
            SelectionPublishItem.prototype.isExpandable = function () {
                return this.expandable;
            };
            SelectionPublishItem.prototype.setChecked = function (value) {
                this.checkBox.setChecked(value);
            };
            SelectionPublishItem.prototype.updateViewer = function (viewer) {
                this.viewer = viewer;
                this.render();
            };
            SelectionPublishItem.prototype.appendDependant = function (dependant) {
                this.dependants.push(dependant);
                this.childrenDiv.appendChild(dependant);
                dependant.doRender();
            };
            SelectionPublishItem.prototype.showDependants = function () {
                this.dependants.forEach(function (item) {
                    item.show();
                });
                ;
            };
            SelectionPublishItem.prototype.hideDependants = function () {
                this.dependants.forEach(function (item) {
                    item.hide();
                });
            };
            SelectionPublishItem.prototype.hasDependants = function () {
                return this.dependants.length > 0;
            };
            SelectionPublishItem.prototype.doRender = function () {
                this.removeChildren();
                if (this.expandable) {
                    this.appendChild(this.childrenSwitch);
                }
                if (this.removable) {
                    this.appendChild(this.removeEl);
                }
                if (!this.isCheckboxHidden) {
                    this.appendChild(this.checkBox);
                }
                this.appendChild(this.viewer);
                if (this.showStatus) {
                    this.appendChild(this.statusDiv);
                }
                if (this.expandable) {
                    this.appendChild(this.childrenDiv);
                }
                return true;
            };
            return SelectionPublishItem;
        })(api.dom.DivEl);
        publish.SelectionPublishItem = SelectionPublishItem;
        var DependantsItemList = (function (_super) {
            __extends(DependantsItemList, _super);
            function DependantsItemList() {
                _super.call(this);
                this.getEl().addClass("item-list");
                this.getEl().addClass("dependant-items");
            }
            DependantsItemList.prototype.clear = function () {
                this.removeChildren();
            };
            return DependantsItemList;
        })(api.dom.DivEl);
        publish.DependantsItemList = DependantsItemList;
        var SelectionPublishItemBuilder = (function () {
            function SelectionPublishItemBuilder() {
                this.isCheckBoxEnabled = true;
                this.isHidden = false;
                this.isCheckboxHidden = false;
                this.isChecked = true;
                this.expandable = false;
                this.removable = false;
                this.showStatus = true;
            }
            SelectionPublishItemBuilder.prototype.setViewer = function (viewer) {
                this.viewer = viewer;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setItem = function (item) {
                this.browseItem = item;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setContent = function (content) {
                this.content = content;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setChangeCallback = function (changeCallback) {
                this.changeCallback = changeCallback;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setRemoveCallback = function (removeCallback) {
                this.removeCallback = removeCallback;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setToggleCallback = function (toggleCallback) {
                this.toggleCallback = toggleCallback;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setIsCheckBoxEnabled = function (isCheckBoxEnabled) {
                this.isCheckBoxEnabled = isCheckBoxEnabled;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setIsHidden = function (isHidden) {
                this.isHidden = isHidden;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setShowStatus = function (showStatus) {
                this.showStatus = showStatus;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setIsCheckboxHidden = function (isCheckboxHidden) {
                this.isCheckboxHidden = isCheckboxHidden;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setIsChecked = function (isChecked) {
                this.isChecked = isChecked;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setExpandable = function (expandable) {
                this.expandable = expandable;
                return this;
            };
            SelectionPublishItemBuilder.prototype.setRemovable = function (removable) {
                this.removable = removable;
                return this;
            };
            SelectionPublishItemBuilder.prototype.create = function () {
                return new SelectionPublishItemBuilder();
            };
            SelectionPublishItemBuilder.prototype.build = function () {
                this.viewer.setObject(this.content);
                this.browseItem = new BrowseItem(this.content).
                    setId(this.content.getId()).
                    setDisplayName(this.content.getDisplayName()).
                    setPath(this.content.getPath().toString()).
                    setIconUrl(this.content.getIconUrl());
                return new SelectionPublishItem(this.viewer, this.browseItem, this.content.getCompareStatus(), this.isCheckboxHidden, this.showStatus, this.changeCallback, this.toggleCallback, this.isCheckBoxEnabled, this.isHidden, this.isChecked, this.expandable, this.removable, this.removeCallback);
            };
            return SelectionPublishItemBuilder;
        })();
        publish.SelectionPublishItemBuilder = SelectionPublishItemBuilder;
    })(publish = app.publish || (app.publish = {}));
})(app || (app = {}));
///<reference path='ContentPublishDialog.ts' />
///<reference path='ContentPublishItem.ts' />
///<reference path='ResolvedPublishContentViewer.ts' />
///<reference path='SelectionPublishItem.ts' /> 
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var action;
        (function (action) {
            var ContentSummaryAndCompareStatus = api.content.ContentSummaryAndCompareStatus;
            var DeleteContentAction = (function (_super) {
                __extends(DeleteContentAction, _super);
                function DeleteContentAction(wizardPanel) {
                    _super.call(this, "Delete", "mod+del", true);
                    this.onExecuted(function () {
                        new app.remove.ContentDeleteDialog()
                            .setContentToDelete([new ContentSummaryAndCompareStatus().
                                setContentSummary(wizardPanel.getPersistedItem()).
                                setCompareStatus(wizardPanel.getContentCompareStatus())
                        ])
                            .open();
                    });
                }
                return DeleteContentAction;
            })(api.ui.Action);
            action.DeleteContentAction = DeleteContentAction;
        })(action = wizard.action || (wizard.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var action;
        (function (action) {
            var DuplicateContentAction = (function (_super) {
                __extends(DuplicateContentAction, _super);
                function DuplicateContentAction(wizardPanel) {
                    _super.call(this, "Duplicate");
                    this.onExecuted(function () {
                        var source = wizardPanel.getPersistedItem();
                        new api.content.DuplicateContentRequest(source.getContentId()).
                            sendAndParse().then(function (content) {
                            api.notify.showFeedback('\"' + source.getDisplayName() + '\" duplicated');
                        });
                    });
                }
                return DuplicateContentAction;
            })(api.ui.Action);
            action.DuplicateContentAction = DuplicateContentAction;
        })(action = wizard.action || (wizard.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_1) {
        var action;
        (function (action) {
            var ContentSummaryAndCompareStatus = api.content.ContentSummaryAndCompareStatus;
            var PublishAction = (function (_super) {
                __extends(PublishAction, _super);
                function PublishAction(wizard) {
                    var _this = this;
                    _super.call(this, "Publish");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        if (wizard.checkContentCanBePublished(true)) {
                            wizard.setRequireValid(true);
                            if (wizard.hasUnsavedChanges()) {
                                _this.setEnabled(false);
                                wizard.saveChanges().
                                    then(function (content) {
                                    if (content) {
                                        new app.browse.ContentPublishPromptEvent([ContentSummaryAndCompareStatus.fromContentSummary(content)]).fire();
                                    }
                                }).catch(function (reason) {
                                    api.DefaultErrorHandler.handle(reason);
                                }).finally(function () { return _this.setEnabled(true); }).done();
                            }
                            else {
                                new app.browse.ContentPublishPromptEvent([ContentSummaryAndCompareStatus.fromContentSummary(wizard.getPersistedItem())]).fire();
                            }
                        }
                        else {
                            api.notify.showWarning('The content cannot be published yet. One or more form values are not valid.');
                        }
                    });
                }
                return PublishAction;
            })(api.ui.Action);
            action.PublishAction = PublishAction;
        })(action = wizard_1.action || (wizard_1.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_2) {
        var action;
        (function (action) {
            var PreviewAction = (function (_super) {
                __extends(PreviewAction, _super);
                function PreviewAction(wizard) {
                    var _this = this;
                    _super.call(this, "Preview");
                    this.onExecuted(function () {
                        var previewWindow = _this.openBlankWindow(wizard.getPersistedItem());
                        if (wizard.hasUnsavedChanges()) {
                            wizard.setRequireValid(true);
                            wizard.saveChanges().
                                then(function (content) { return _this.updateLocation(previewWindow, content); }).
                                catch(function (reason) { return api.DefaultErrorHandler.handle(reason); }).
                                done();
                        }
                        else {
                            _this.updateLocation(previewWindow, wizard.getPersistedItem());
                        }
                    });
                }
                return PreviewAction;
            })(app.action.BasePreviewAction);
            action.PreviewAction = PreviewAction;
        })(action = wizard_2.action || (wizard_2.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_3) {
        var action;
        (function (action) {
            var ShowFormAction = (function (_super) {
                __extends(ShowFormAction, _super);
                function ShowFormAction(wizard) {
                    _super.call(this, "Form");
                    this.setEnabled(true);
                    this.setTitle("Hide Page Editor");
                    this.onExecuted(function () {
                        wizard.showForm();
                        new wizard_3.ShowContentFormEvent().fire();
                    });
                }
                return ShowFormAction;
            })(api.ui.Action);
            action.ShowFormAction = ShowFormAction;
        })(action = wizard_3.action || (wizard_3.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_4) {
        var action;
        (function (action) {
            var ShowLiveEditAction = (function (_super) {
                __extends(ShowLiveEditAction, _super);
                function ShowLiveEditAction(wizard) {
                    _super.call(this, "Live");
                    this.setEnabled(false);
                    this.setTitle("Show Page Editor");
                    this.onExecuted(function () {
                        wizard.showLiveEdit();
                        new wizard_4.ShowLiveEditEvent().fire();
                    });
                }
                return ShowLiveEditAction;
            })(api.ui.Action);
            action.ShowLiveEditAction = ShowLiveEditAction;
        })(action = wizard_4.action || (wizard_4.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_5) {
        var action;
        (function (action) {
            var ShowSplitEditAction = (function (_super) {
                __extends(ShowSplitEditAction, _super);
                function ShowSplitEditAction(wizard) {
                    _super.call(this, "Split");
                    this.setEnabled(false);
                    this.onExecuted(function () {
                        wizard.showSplitEdit();
                        new wizard_5.ShowSplitEditEvent().fire();
                    });
                }
                return ShowSplitEditAction;
            })(api.ui.Action);
            action.ShowSplitEditAction = ShowSplitEditAction;
        })(action = wizard_5.action || (wizard_5.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var action;
        (function (action) {
            var ContentWizardActions = (function (_super) {
                __extends(ContentWizardActions, _super);
                function ContentWizardActions(wizardPanel) {
                    this.save = new api.app.wizard.SaveAction(wizardPanel, "Save draft");
                    this.duplicate = new action.DuplicateContentAction(wizardPanel);
                    this.delete = new action.DeleteContentAction(wizardPanel);
                    this.close = new api.app.wizard.CloseAction(wizardPanel);
                    this.saveAndClose = new api.app.wizard.SaveAndCloseAction(wizardPanel);
                    this.publish = new action.PublishAction(wizardPanel);
                    this.preview = new action.PreviewAction(wizardPanel);
                    this.showLiveEditAction = new action.ShowLiveEditAction(wizardPanel);
                    this.showFormAction = new action.ShowFormAction(wizardPanel);
                    this.showSplitEditAction = new action.ShowSplitEditAction(wizardPanel);
                    _super.call(this, this.save, this.delete, this.duplicate, this.preview, this.publish, this.close, this.showLiveEditAction, this.showFormAction, this.showSplitEditAction, this.saveAndClose);
                }
                ContentWizardActions.prototype.enableActionsForNew = function () {
                    this.save.setEnabled(true);
                    this.duplicate.setEnabled(false);
                    this.delete.setEnabled(true);
                };
                ContentWizardActions.prototype.enableActionsForExisting = function (existing) {
                    this.save.setEnabled(existing.isEditable());
                    this.duplicate.setEnabled(true);
                    this.delete.setEnabled(existing.isDeletable());
                    this.enableActionsForExistingByPermissions(existing);
                };
                ContentWizardActions.prototype.enableDeleteOnly = function () {
                    this.save.setEnabled(false);
                    this.duplicate.setEnabled(false);
                    this.delete.setEnabled(true);
                };
                ContentWizardActions.prototype.enableActionsForExistingByPermissions = function (existing) {
                    var _this = this;
                    new api.security.auth.IsAuthenticatedRequest().
                        sendAndParse().
                        then(function (loginResult) {
                        var hasModifyPermission = api.security.acl.PermissionHelper.hasPermission(api.security.acl.Permission.MODIFY, loginResult, existing.getPermissions());
                        var hasDeletePermission = api.security.acl.PermissionHelper.hasPermission(api.security.acl.Permission.DELETE, loginResult, existing.getPermissions());
                        var hasPublishPermission = api.security.acl.PermissionHelper.hasPermission(api.security.acl.Permission.PUBLISH, loginResult, existing.getPermissions());
                        if (!hasModifyPermission) {
                            _this.save.setEnabled(false);
                            _this.saveAndClose.setEnabled(false);
                        }
                        if (!hasDeletePermission) {
                            _this.delete.setEnabled(false);
                        }
                        if (!hasPublishPermission) {
                            _this.publish.setEnabled(false);
                        }
                        if (existing.hasParent()) {
                            new api.content.GetContentByPathRequest(existing.getPath().getParentPath()).
                                sendAndParse().
                                then(function (parent) {
                                new api.content.GetContentPermissionsByIdRequest(parent.getContentId()).
                                    sendAndParse().
                                    then(function (accessControlList) {
                                    var hasParentCreatePermission = api.security.acl.PermissionHelper.hasPermission(api.security.acl.Permission.CREATE, loginResult, accessControlList);
                                    if (!hasParentCreatePermission) {
                                        _this.duplicate.setEnabled(false);
                                    }
                                });
                            });
                        }
                        else {
                            new api.content.GetContentRootPermissionsRequest().
                                sendAndParse().
                                then(function (accessControlList) {
                                var hasParentCreatePermission = api.security.acl.PermissionHelper.hasPermission(api.security.acl.Permission.CREATE, loginResult, accessControlList);
                                if (!hasParentCreatePermission) {
                                    _this.duplicate.setEnabled(false);
                                }
                            });
                        }
                    });
                };
                ContentWizardActions.prototype.getDeleteAction = function () {
                    return this.delete;
                };
                ContentWizardActions.prototype.getSaveAction = function () {
                    return this.save;
                };
                ContentWizardActions.prototype.getDuplicateAction = function () {
                    return this.duplicate;
                };
                ContentWizardActions.prototype.getCloseAction = function () {
                    return this.close;
                };
                ContentWizardActions.prototype.getPublishAction = function () {
                    return this.publish;
                };
                ContentWizardActions.prototype.getPreviewAction = function () {
                    return this.preview;
                };
                ContentWizardActions.prototype.getShowLiveEditAction = function () {
                    return this.showLiveEditAction;
                };
                ContentWizardActions.prototype.getShowFormAction = function () {
                    return this.showFormAction;
                };
                ContentWizardActions.prototype.getShowSplitEditAction = function () {
                    return this.showSplitEditAction;
                };
                return ContentWizardActions;
            })(api.app.wizard.WizardActions);
            action.ContentWizardActions = ContentWizardActions;
        })(action = wizard.action || (wizard.action = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='DeleteContentAction.ts' />
///<reference path='DuplicateContentAction.ts' />
///<reference path='PublishAction.ts' />
///<reference path='PreviewAction.ts' />
///<reference path='ShowFormAction.ts' />
///<reference path='ShowLiveEditAction.ts' />
///<reference path='ShowSplitEditAction.ts' />
///<reference path='ContentWizardActions.ts' /> 
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var insert;
                (function (insert) {
                    var Insertable = (function () {
                        function Insertable() {
                        }
                        Insertable.prototype.setName = function (value) {
                            this.name = value;
                            return this;
                        };
                        Insertable.prototype.getName = function () {
                            return this.name;
                        };
                        Insertable.prototype.setDescription = function (value) {
                            this.description = value;
                            return this;
                        };
                        Insertable.prototype.getDescription = function () {
                            return this.description;
                        };
                        Insertable.prototype.setDisplayName = function (value) {
                            this.displayName = value;
                            return this;
                        };
                        Insertable.prototype.getDisplayName = function () {
                            return this.displayName;
                        };
                        Insertable.prototype.setIconCls = function (value) {
                            this.iconCls = api.StyleHelper.getCommonIconCls(value);
                            return this;
                        };
                        Insertable.prototype.getIconCls = function () {
                            return this.iconCls;
                        };
                        return Insertable;
                    })();
                    insert.Insertable = Insertable;
                })(insert = contextwindow.insert || (contextwindow.insert = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var insert;
                (function (insert) {
                    var Insertables = (function () {
                        function Insertables() {
                        }
                        Insertables.IMAGE = new insert.Insertable().
                            setName("image").
                            setDisplayName("Image").
                            setDescription("Upload or use existing images").
                            setIconCls("image");
                        Insertables.PART = new insert.Insertable().
                            setName("part").
                            setDisplayName("Part").
                            setDescription("Advanced components").
                            setIconCls("part");
                        Insertables.LAYOUT = new insert.Insertable().
                            setName("layout").
                            setDisplayName("Layout").
                            setDescription("Customize page layout").
                            setIconCls("layout");
                        Insertables.TEXT = new insert.Insertable().
                            setName("text").
                            setDisplayName("Text").
                            setDescription("Write directly on the page").
                            setIconCls("text");
                        Insertables.FRAGMENT = new insert.Insertable().
                            setName("fragment").
                            setDisplayName("Fragment").
                            setDescription("Reusable components").
                            setIconCls("fragment");
                        Insertables.ALL = [Insertables.IMAGE, Insertables.PART, Insertables.LAYOUT,
                            Insertables.TEXT, Insertables.FRAGMENT];
                        Insertables.ALLOWED_IN_FRAGMENT = [Insertables.IMAGE, Insertables.PART, Insertables.TEXT, Insertables.FRAGMENT];
                        return Insertables;
                    })();
                    insert.Insertables = Insertables;
                })(insert = contextwindow.insert || (contextwindow.insert = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var insert;
                (function (insert) {
                    var DragHelper = api.ui.DragHelper;
                    var PageMode = api.content.page.PageMode;
                    var InsertablesPanel = (function (_super) {
                        __extends(InsertablesPanel, _super);
                        function InsertablesPanel(config) {
                            var _this = this;
                            _super.call(this, "insertables-panel");
                            this.hideContextWindowRequestListeners = [];
                            this.overIFrame = false;
                            this.liveEditPageProxy = config.liveEditPage;
                            var topDescription = new api.dom.PEl();
                            topDescription.getEl().setInnerHtml('Drag and drop components into the page');
                            this.insertablesDataView = new api.ui.grid.DataView();
                            this.insertablesGrid = new insert.InsertablesGrid(this.insertablesDataView, { draggableRows: true, rowClass: "comp" });
                            this.insertablesDataView.setItems(insert.Insertables.ALL, "name");
                            this.componentsView = new app.wizard.PageComponentsView(config.liveEditPage);
                            this.componentsView.onShown(function () {
                                if (!_this.componentsView.getParentElement()) {
                                    var offset = config.contentWizardPanel.getLiveFormPanel().getEl().getOffsetToParent();
                                    _this.componentsView.getEl().setOffset(offset);
                                    config.contentWizardPanel.appendChild(_this.componentsView);
                                }
                            });
                            this.appendChildren(topDescription, this.insertablesGrid);
                            this.liveEditPageProxy.onLiveEditPageViewReady(function (event) {
                                _this.pageView = event.getPageView();
                                if (_this.pageView && _this.pageView.getLiveEditModel().getPageModel().getMode() === PageMode.FRAGMENT) {
                                    _this.destroyDraggables();
                                    _this.insertablesDataView.setItems(insert.Insertables.ALLOWED_IN_FRAGMENT, "name");
                                    _this.initializeDraggables();
                                }
                            });
                            this.liveEditPageProxy.onComponentViewDragStopped(function () {
                                if (_this.contextWindowDraggable) {
                                    if (InsertablesPanel.debug) {
                                        console.log('Simulating mouse up for', _this.contextWindowDraggable);
                                    }
                                    _this.iFrameDraggable = null;
                                    _this.contextWindowDraggable.simulate('mouseup');
                                }
                            });
                            this.onRendered(this.initializeDraggables.bind(this));
                            this.onRemoved(this.destroyDraggables.bind(this));
                        }
                        InsertablesPanel.prototype.getComponentsView = function () {
                            return this.componentsView;
                        };
                        InsertablesPanel.prototype.setPageView = function (pageView) {
                            this.componentsView.setPageView(pageView);
                        };
                        InsertablesPanel.prototype.setContent = function (content) {
                            this.componentsView.setContent(content);
                        };
                        InsertablesPanel.prototype.initializeDraggables = function () {
                            var _this = this;
                            var components = wemjq('[data-context-window-draggable="true"]:not(.ui-draggable)');
                            if (InsertablesPanel.debug) {
                                console.log('InsertablesPanel.initializeDraggables', components);
                            }
                            components.draggable({
                                cursorAt: DragHelper.CURSOR_AT,
                                appendTo: 'body',
                                cursor: 'move',
                                revert: 'true',
                                distance: 10,
                                scope: 'component',
                                helper: function (event, ui) { return DragHelper.get().getHTMLElement(); },
                                start: function (event, ui) { return _this.handleDragStart(event, ui); },
                                drag: function (event, ui) { return _this.handleDrag(event, ui); },
                                stop: function (event, ui) { return _this.handleDragStop(event, ui); }
                            });
                        };
                        InsertablesPanel.prototype.destroyDraggables = function () {
                            var components = wemjq('[data-context-window-draggable="true"]:not(.ui-draggable)');
                            components.draggable('destroy');
                        };
                        InsertablesPanel.prototype.handleDragStart = function (event, ui) {
                            if (InsertablesPanel.debug) {
                                console.log('InsertablesPanel.handleDragStart', event, ui);
                            }
                            ui.helper.show();
                            this.liveEditPageProxy.getDragMask().show();
                            this.contextWindowDraggable = wemjq(event.target);
                        };
                        InsertablesPanel.prototype.handleDrag = function (event, ui) {
                            if (!this.pageView) {
                                return;
                            }
                            var over = this.isOverIFrame(event);
                            if (this.overIFrame != over) {
                                if (over) {
                                    this.onEnterIFrame(event, ui);
                                }
                                else {
                                    this.onLeftIFrame(event, ui);
                                }
                                this.overIFrame = over;
                            }
                        };
                        InsertablesPanel.prototype.handleDragStop = function (event, ui) {
                            if (InsertablesPanel.debug) {
                                console.log('InsertablesPanel.handleDragStop', event, ui);
                            }
                            this.liveEditPageProxy.getDragMask().hide();
                            this.contextWindowDraggable = null;
                            if (this.iFrameDraggable) {
                                this.liveEditPageProxy.destroyDraggable(this.iFrameDraggable);
                                this.iFrameDraggable.simulate('mouseup');
                                this.iFrameDraggable.remove();
                                this.iFrameDraggable = null;
                            }
                        };
                        InsertablesPanel.prototype.isOverIFrame = function (event) {
                            return event.originalEvent.target == this.liveEditPageProxy.getDragMask().getHTMLElement();
                        };
                        InsertablesPanel.prototype.onLeftIFrame = function (event, ui) {
                            if (InsertablesPanel.debug) {
                                console.log('InsertablesPanel.onLeftIFrame');
                            }
                            this.liveEditPageProxy.getDragMask().show();
                            if (this.iFrameDraggable) {
                                var livejq = this.liveEditPageProxy.getJQuery();
                                livejq(this.iFrameDraggable.draggable("option", "helper")()).hide();
                            }
                            ui.helper.show();
                        };
                        InsertablesPanel.prototype.onEnterIFrame = function (event, ui) {
                            if (InsertablesPanel.debug) {
                                console.log('InsertablesPanel.onEnterIFrame');
                            }
                            this.liveEditPageProxy.getDragMask().hide();
                            var livejq = this.liveEditPageProxy.getJQuery();
                            var iFrame = this.liveEditPageProxy.getIFrame().getHTMLElement();
                            var hasBody = iFrame && iFrame.contentDocument && iFrame.contentDocument.body;
                            if (!hasBody) {
                                if (InsertablesPanel.debug) {
                                    console.warn('InsertablesPanel.onEnterIFrame, skip due to missing body in document');
                                }
                                return;
                            }
                            if (!this.iFrameDraggable) {
                                this.iFrameDraggable = livejq(event.target).clone();
                                livejq('body').append(this.iFrameDraggable);
                                this.liveEditPageProxy.createDraggable(this.iFrameDraggable);
                                this.iFrameDraggable.simulate('mousedown').hide();
                            }
                            livejq(this.iFrameDraggable.draggable("option", "helper")()).show();
                            ui.helper.hide();
                            this.notifyHideContextWindowRequest();
                        };
                        InsertablesPanel.prototype.onHideContextWindowRequest = function (listener) {
                            this.hideContextWindowRequestListeners.push(listener);
                        };
                        InsertablesPanel.prototype.unHideContextWindowRequest = function (listener) {
                            this.hideContextWindowRequestListeners = this.hideContextWindowRequestListeners.filter(function (curr) {
                                return curr != listener;
                            });
                        };
                        InsertablesPanel.prototype.notifyHideContextWindowRequest = function () {
                            this.hideContextWindowRequestListeners.forEach(function (listener) {
                                listener();
                            });
                        };
                        InsertablesPanel.debug = false;
                        return InsertablesPanel;
                    })(api.ui.panel.Panel);
                    insert.InsertablesPanel = InsertablesPanel;
                })(insert = contextwindow.insert || (contextwindow.insert = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var insert;
                (function (insert) {
                    var InsertablesGrid = (function (_super) {
                        __extends(InsertablesGrid, _super);
                        function InsertablesGrid(dataView, options) {
                            var _this = this;
                            if (options === void 0) { options = {}; }
                            _super.call(this, dataView, this.createColumns(), this.createOptions());
                            this.componentDataView = dataView;
                            this.componentGridOptions = options;
                            this.onRendered(function (event) {
                                if (_this.componentGridOptions.onClick) {
                                    _this.setOnClick(_this.componentGridOptions.onClick);
                                }
                            });
                        }
                        InsertablesGrid.prototype.createOptions = function () {
                            return new api.ui.grid.GridOptionsBuilder().
                                setHideColumnHeaders(true).
                                setRowHeight(50).
                                setHeight(400).
                                setWidth(320)
                                .build();
                        };
                        InsertablesGrid.prototype.createColumns = function () {
                            var _this = this;
                            return [new api.ui.grid.GridColumnBuilder().
                                    setName("component").
                                    setField("component").
                                    setId("component").
                                    setWidth(320).
                                    setCssClass("grid-row").
                                    setFormatter(function (row, cell, value, columnDef, dataContext) {
                                    return _this.buildRow(row, cell, value, columnDef, dataContext).toString();
                                }).
                                    build()
                            ];
                        };
                        InsertablesGrid.prototype.buildRow = function (row, cell, value, columnDef, insertable) {
                            var rowEl = new api.dom.DivEl();
                            rowEl.getEl().setData('portal-component-type', insertable.getName());
                            if (this.componentGridOptions.draggableRows) {
                                rowEl.getEl().setData('context-window-draggable', 'true');
                            }
                            if (this.componentGridOptions.rowClass) {
                                rowEl.addClass(this.componentGridOptions.rowClass);
                            }
                            var icon = new api.ui.FontIcon(insertable.getIconCls());
                            var title = new api.dom.H5El();
                            title.getEl().setInnerHtml(insertable.getDisplayName());
                            var subtitle = new api.dom.H6El();
                            subtitle.getEl().setInnerHtml(insertable.getDescription());
                            rowEl.appendChild(icon);
                            rowEl.appendChild(title);
                            rowEl.appendChild(subtitle);
                            return rowEl;
                        };
                        return InsertablesGrid;
                    })(api.ui.grid.Grid);
                    insert.InsertablesGrid = InsertablesGrid;
                })(insert = contextwindow.insert || (contextwindow.insert = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='Insertable.ts' />
///<reference path='Insertables.ts' />
///<reference path='InsertablesPanel.ts' />
///<reference path='InsertablesGrid.ts' />
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var BaseInspectionPanel = (function (_super) {
                        __extends(BaseInspectionPanel, _super);
                        function BaseInspectionPanel() {
                            var _this = this;
                            _super.call(this, "inspection-panel");
                            this.onRendered(function (event) {
                                wemjq(_this.getHTMLElement()).slimScroll({
                                    height: '100%'
                                });
                            });
                        }
                        return BaseInspectionPanel;
                    })(api.ui.panel.Panel);
                    inspect.BaseInspectionPanel = BaseInspectionPanel;
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var NoSelectionInspectionPanel = (function (_super) {
                        __extends(NoSelectionInspectionPanel, _super);
                        function NoSelectionInspectionPanel() {
                            _super.call(this, "inspection-panel");
                            this.header = new api.app.NamesView().setMainName("No item selected");
                            this.appendChild(this.header);
                        }
                        return NoSelectionInspectionPanel;
                    })(api.ui.panel.Panel);
                    inspect.NoSelectionInspectionPanel = NoSelectionInspectionPanel;
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var ContentInspectionPanel = (function (_super) {
                        __extends(ContentInspectionPanel, _super);
                        function ContentInspectionPanel() {
                            _super.call(this);
                            this.namesAndIcon = new api.app.NamesAndIconView(new api.app.NamesAndIconViewBuilder().
                                setSize(api.app.NamesAndIconViewSize.medium)).
                                setIconClass(api.liveedit.ItemViewIconClassResolver.resolveByType("content", "icon-xlarge"));
                            this.appendChild(this.namesAndIcon);
                        }
                        ContentInspectionPanel.prototype.setContent = function (content) {
                            this.content = content;
                            if (content) {
                                this.namesAndIcon.setMainName(content.getDisplayName());
                                this.namesAndIcon.setSubName(content.getPath().toString());
                            }
                            else {
                                this.namesAndIcon.setMainName("[No Content given]");
                                this.namesAndIcon.setSubName("");
                            }
                        };
                        return ContentInspectionPanel;
                    })(inspect.BaseInspectionPanel);
                    inspect.ContentInspectionPanel = ContentInspectionPanel;
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var InspectionsPanel = (function (_super) {
                        __extends(InspectionsPanel, _super);
                        function InspectionsPanel(config) {
                            _super.call(this, 'inspections-panel');
                            this.saveRequestListeners = [];
                            this.deck = new api.ui.panel.DeckPanel();
                            this.noSelectionPanel = new inspect.NoSelectionInspectionPanel();
                            this.imageInspectionPanel = config.imageInspectionPanel;
                            this.partInspectionPanel = config.partInspectionPanel;
                            this.layoutInspectionPanel = config.layoutInspectionPanel;
                            this.contentInspectionPanel = config.contentInspectionPanel;
                            this.pageInspectionPanel = config.pageInspectionPanel;
                            this.regionInspectionPanel = config.regionInspectionPanel;
                            this.fragmentInspectionPanel = config.fragmentInspectionPanel;
                            this.textInspectionPanel = config.textInspectionPanel;
                            this.deck.addPanel(this.imageInspectionPanel);
                            this.deck.addPanel(this.partInspectionPanel);
                            this.deck.addPanel(this.layoutInspectionPanel);
                            this.deck.addPanel(this.contentInspectionPanel);
                            this.deck.addPanel(this.regionInspectionPanel);
                            this.deck.addPanel(this.pageInspectionPanel);
                            this.deck.addPanel(this.fragmentInspectionPanel);
                            this.deck.addPanel(this.textInspectionPanel);
                            this.deck.addPanel(this.noSelectionPanel);
                            this.deck.showPanel(this.pageInspectionPanel);
                            this.buttons = new api.dom.DivEl('button-bar');
                            var saveButton = new api.ui.button.ActionButton(config.saveAction);
                            this.buttons.appendChild(saveButton);
                            this.appendChildren(this.deck, this.buttons);
                        }
                        InspectionsPanel.prototype.showInspectionPanel = function (panel) {
                            this.deck.showPanel(panel);
                            var showButtons = !(api.ObjectHelper.iFrameSafeInstanceOf(panel, inspect.region.RegionInspectionPanel) ||
                                api.ObjectHelper.iFrameSafeInstanceOf(panel, inspect.NoSelectionInspectionPanel));
                            this.buttons.setVisible(showButtons);
                        };
                        InspectionsPanel.prototype.clearInspection = function () {
                            this.showInspectionPanel(this.pageInspectionPanel);
                        };
                        InspectionsPanel.prototype.isInspecting = function () {
                            return this.deck.getPanelShown() != this.noSelectionPanel;
                        };
                        return InspectionsPanel;
                    })(api.ui.panel.Panel);
                    inspect.InspectionsPanel = InspectionsPanel;
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='BaseInspectionPanel.ts' />
///<reference path='NoSelectionInspectionPanel.ts' />
///<reference path='ContentInspectionPanel.ts' />
///<reference path='InspectionsPanel.ts' />
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page_1) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var page;
                    (function (page) {
                        var PageTemplateOption = (function () {
                            function PageTemplateOption(template, pageModel) {
                                this.template = template;
                                this.pageModel = pageModel;
                            }
                            PageTemplateOption.prototype.getPageTemplate = function () {
                                return this.template;
                            };
                            PageTemplateOption.prototype.getPageModel = function () {
                                return this.pageModel;
                            };
                            PageTemplateOption.prototype.isCustom = function () {
                                var pageTemplateDisplayName = api.content.page.PageTemplateDisplayName;
                                return this.template && this.template.getDisplayName() == pageTemplateDisplayName[pageTemplateDisplayName.Custom];
                            };
                            return PageTemplateOption;
                        })();
                        page.PageTemplateOption = PageTemplateOption;
                    })(page = inspect.page || (inspect.page = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page_1.contextwindow || (page_1.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page_2) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var page;
                    (function (page) {
                        var PageTemplateOptionViewer = (function (_super) {
                            __extends(PageTemplateOptionViewer, _super);
                            function PageTemplateOptionViewer() {
                                _super.call(this);
                            }
                            PageTemplateOptionViewer.prototype.resolveDisplayName = function (object) {
                                var pageTemplateDisplayName = api.content.page.PageTemplateDisplayName;
                                return !!object.getPageTemplate() ?
                                    (object.isCustom() ? pageTemplateDisplayName[pageTemplateDisplayName.Custom] : object.getPageTemplate().getDisplayName())
                                    : pageTemplateDisplayName[pageTemplateDisplayName.Automatic];
                            };
                            PageTemplateOptionViewer.prototype.resolveSubName = function (object, relativePath) {
                                if (relativePath === void 0) { relativePath = false; }
                                if (!!object.getPageTemplate()) {
                                    if (object.isCustom()) {
                                        return "Set up your own page";
                                    }
                                    else {
                                        return object.getPageTemplate().getPath().toString();
                                    }
                                }
                                else if (!!object.getPageModel().getDefaultPageTemplate()) {
                                    return "(" + object.getPageModel().getDefaultPageTemplate().getDisplayName().toString() + ")";
                                }
                                else {
                                    return "( no default template found )";
                                }
                            };
                            PageTemplateOptionViewer.prototype.resolveIconClass = function (object) {
                                var iconClass = !!object.getPageTemplate() ? (object.isCustom() ? "icon-cog" : "icon-newspaper") : "icon-wand";
                                return iconClass + " icon-large";
                            };
                            PageTemplateOptionViewer.prototype.getPreferredHeight = function () {
                                return 50;
                            };
                            return PageTemplateOptionViewer;
                        })(api.ui.NamesAndIconViewer);
                        page.PageTemplateOptionViewer = PageTemplateOptionViewer;
                    })(page = inspect.page || (inspect.page = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page_2.contextwindow || (page_2.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page_3) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var page;
                    (function (page) {
                        var GetPageTemplatesByCanRenderRequest = api.content.page.GetPageTemplatesByCanRenderRequest;
                        var PageTemplateLoader = api.content.page.PageTemplateLoader;
                        var PageTemplateOptions = (function () {
                            function PageTemplateOptions(siteId, contentType, pageModel) {
                                this.siteId = siteId;
                                this.contentType = contentType;
                                this.pageModel = pageModel;
                                this.defaultPageTemplateOption = { value: "__auto__", displayValue: new page.PageTemplateOption(null, pageModel) };
                            }
                            PageTemplateOptions.prototype.getDefault = function () {
                                return this.defaultPageTemplateOption;
                            };
                            PageTemplateOptions.prototype.getOptions = function () {
                                var _this = this;
                                var deferred = wemQ.defer();
                                var options = [];
                                options.push(this.defaultPageTemplateOption);
                                var loader = new PageTemplateLoader(new GetPageTemplatesByCanRenderRequest(this.siteId, this.contentType));
                                loader.setComparator(new api.content.page.PageTemplateByDisplayNameComparator());
                                loader.onLoadedData(function (event) {
                                    event.getData().forEach(function (pageTemplate) {
                                        var indices = [];
                                        indices.push(pageTemplate.getName().toString());
                                        indices.push(pageTemplate.getDisplayName());
                                        indices.push(pageTemplate.getController().toString());
                                        var option = {
                                            value: pageTemplate.getId().toString(),
                                            displayValue: new page.PageTemplateOption(pageTemplate, _this.pageModel),
                                            indices: indices
                                        };
                                        options.push(option);
                                    });
                                    deferred.resolve(options);
                                });
                                loader.load();
                                return deferred.promise;
                            };
                            return PageTemplateOptions;
                        })();
                        page.PageTemplateOptions = PageTemplateOptions;
                    })(page = inspect.page || (inspect.page = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page_3.contextwindow || (page_3.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page_4) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var page;
                    (function (page) {
                        var PageModel = api.content.page.PageModel;
                        var PageControllerSelector = (function (_super) {
                            __extends(PageControllerSelector, _super);
                            function PageControllerSelector(model) {
                                var _this = this;
                                _super.call(this, model);
                                this.pageModel = model.getPageModel();
                                this.onLoadedData(function (event) {
                                    if (_this.pageModel.hasController()) {
                                        _this.selectController(_this.pageModel.getController().getKey());
                                    }
                                });
                                this.pageModel.onPropertyChanged(function (event) {
                                    if (event.getPropertyName() == PageModel.PROPERTY_CONTROLLER && _this !== event.getSource()) {
                                        var descriptorKey = event.getNewValue();
                                        if (descriptorKey) {
                                            _this.selectController(descriptorKey);
                                        }
                                    }
                                });
                            }
                            PageControllerSelector.prototype.selectController = function (descriptorKey) {
                                var optionToSelect = this.getOptionByValue(descriptorKey.toString());
                                if (optionToSelect) {
                                    this.selectOption(optionToSelect, true);
                                }
                            };
                            return PageControllerSelector;
                        })(api.content.page.PageDescriptorDropdown);
                        page.PageControllerSelector = PageControllerSelector;
                    })(page = inspect.page || (inspect.page = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page_4.contextwindow || (page_4.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page_5) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var page;
                    (function (page) {
                        var PageTemplateBuilder = api.content.page.PageTemplateBuilder;
                        var Dropdown = api.ui.selector.dropdown.Dropdown;
                        var PageModel = api.content.page.PageModel;
                        var PageTemplateSelector = (function (_super) {
                            __extends(PageTemplateSelector, _super);
                            function PageTemplateSelector() {
                                _super.call(this, "pageTemplate", {
                                    optionDisplayValueViewer: new page.PageTemplateOptionViewer()
                                });
                                this.selectionListeners = [];
                                this.customizedSelectedListeners = [];
                            }
                            PageTemplateSelector.prototype.setModel = function (liveEditModel) {
                                var _this = this;
                                this.pageModel = liveEditModel.getPageModel();
                                var pageTemplateOptions = new page.PageTemplateOptions(liveEditModel.getSiteModel().getSiteId(), liveEditModel.getContent().getType(), this.pageModel);
                                pageTemplateOptions.getOptions().
                                    then(function (options) {
                                    options.forEach(function (option) {
                                        _this.addOption(option);
                                    });
                                    _this.customizedOption = _this.createCustomizedOption();
                                    _this.addOption(_this.customizedOption);
                                    if (_this.pageModel.isCustomized()) {
                                        _this.selectRow(options.length);
                                    }
                                    else if (_this.pageModel.hasTemplate()) {
                                        _this.selectTemplate(_this.pageModel.getTemplateKey());
                                    }
                                    else {
                                        _this.selectOption(pageTemplateOptions.getDefault(), true);
                                    }
                                    _this.onOptionSelected(function (event) {
                                        var selectedOption = event.getOption().displayValue;
                                        if (selectedOption.getPageTemplate() && selectedOption.isCustom()) {
                                            _this.notifyCustomizedSelected();
                                        }
                                        else {
                                            _this.notifySelection(selectedOption.getPageTemplate());
                                        }
                                    });
                                    _this.pageModel.onPropertyChanged(function (event) {
                                        if (event.getPropertyName() == PageModel.PROPERTY_TEMPLATE && _this !== event.getSource()) {
                                            var pageTemplateKey = event.getNewValue();
                                            if (pageTemplateKey) {
                                                _this.selectTemplate(pageTemplateKey);
                                            }
                                            else {
                                                _this.selectOption(pageTemplateOptions.getDefault(), true);
                                            }
                                        }
                                        else if (event.getPropertyName() == PageModel.PROPERTY_CONTROLLER && event.getNewValue()) {
                                            _this.selectCustomized();
                                        }
                                    });
                                    _this.pageModel.onReset(function () {
                                        _this.selectOption(pageTemplateOptions.getDefault(), true);
                                    });
                                }).catch(function (reason) {
                                    api.DefaultErrorHandler.handle(reason);
                                }).done();
                            };
                            PageTemplateSelector.prototype.selectTemplate = function (template) {
                                var optionToSelect = this.getOptionByValue(template.toString());
                                if (optionToSelect) {
                                    this.selectOption(optionToSelect, true);
                                }
                            };
                            PageTemplateSelector.prototype.selectCustomized = function () {
                                this.selectOption(this.customizedOption, true);
                            };
                            PageTemplateSelector.prototype.onSelection = function (listener) {
                                this.selectionListeners.push(listener);
                            };
                            PageTemplateSelector.prototype.unSelection = function (listener) {
                                this.selectionListeners.filter(function (currentListener) {
                                    return listener != currentListener;
                                });
                            };
                            PageTemplateSelector.prototype.notifySelection = function (item) {
                                this.selectionListeners.forEach(function (listener) {
                                    listener(item);
                                });
                            };
                            PageTemplateSelector.prototype.onCustomizedSelected = function (listener) {
                                this.customizedSelectedListeners.push(listener);
                            };
                            PageTemplateSelector.prototype.notifyCustomizedSelected = function () {
                                this.customizedSelectedListeners.forEach(function (listener) {
                                    listener();
                                });
                            };
                            PageTemplateSelector.prototype.createCustomizedOption = function () {
                                var pageTemplateDisplayName = api.content.page.PageTemplateDisplayName;
                                var pageTemplate = new PageTemplateBuilder()
                                    .setData(new api.data.PropertyTree())
                                    .setDisplayName(pageTemplateDisplayName[pageTemplateDisplayName.Custom])
                                    .build();
                                var option = {
                                    value: "Customized",
                                    displayValue: new page.PageTemplateOption(pageTemplate, this.pageModel)
                                };
                                return option;
                            };
                            return PageTemplateSelector;
                        })(Dropdown);
                        page.PageTemplateSelector = PageTemplateSelector;
                    })(page = inspect.page || (inspect.page = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page_5.contextwindow || (page_5.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page_6) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var page;
                    (function (page) {
                        var PageControllerForm = (function (_super) {
                            __extends(PageControllerForm, _super);
                            function PageControllerForm(controllerSelector) {
                                _super.call(this, 'page-controller-form');
                                this.controllerSelector = controllerSelector;
                                var fieldSet = new api.ui.form.Fieldset();
                                fieldSet.add(new api.ui.form.FormItemBuilder(controllerSelector).setLabel("Page Controller").build());
                                this.add(fieldSet);
                            }
                            PageControllerForm.prototype.getSelector = function () {
                                return this.controllerSelector;
                            };
                            return PageControllerForm;
                        })(api.ui.form.Form);
                        page.PageControllerForm = PageControllerForm;
                    })(page = inspect.page || (inspect.page = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page_6.contextwindow || (page_6.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page_7) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var page;
                    (function (page) {
                        var PageTemplateForm = (function (_super) {
                            __extends(PageTemplateForm, _super);
                            function PageTemplateForm(templateSelector) {
                                _super.call(this, 'page-template-form');
                                this.templateSelector = templateSelector;
                                var fieldSet = new api.ui.form.Fieldset();
                                fieldSet.add(new api.ui.form.FormItemBuilder(templateSelector).setLabel("Page Template").build());
                                this.add(fieldSet);
                            }
                            PageTemplateForm.prototype.getSelector = function () {
                                return this.templateSelector;
                            };
                            return PageTemplateForm;
                        })(api.ui.form.Form);
                        page.PageTemplateForm = PageTemplateForm;
                    })(page = inspect.page || (inspect.page = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page_7.contextwindow || (page_7.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page_8) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var page;
                    (function (page) {
                        var FormContextBuilder = api.form.FormContextBuilder;
                        var FormView = api.form.FormView;
                        var SetTemplate = api.content.page.SetTemplate;
                        var PageModel = api.content.page.PageModel;
                        var PageMode = api.content.page.PageMode;
                        var GetPageDescriptorByKeyRequest = api.content.page.GetPageDescriptorByKeyRequest;
                        var PageInspectionPanel = (function (_super) {
                            __extends(PageInspectionPanel, _super);
                            function PageInspectionPanel() {
                                _super.call(this);
                            }
                            PageInspectionPanel.prototype.setModel = function (liveEditModel) {
                                var _this = this;
                                this.liveEditModel = liveEditModel;
                                this.pageModel = liveEditModel.getPageModel();
                                this.siteModel = liveEditModel.getSiteModel();
                                this.pageTemplateSelector = new page.PageTemplateSelector();
                                this.pageTemplateForm = new page.PageTemplateForm(this.pageTemplateSelector);
                                this.pageTemplateForm.hide();
                                this.appendChild(this.pageTemplateForm);
                                this.pageControllerSelector = new page.PageControllerSelector(liveEditModel);
                                this.pageControllerForm = new page.PageControllerForm(this.pageControllerSelector);
                                this.pageControllerForm.hide();
                                this.appendChild(this.pageControllerForm);
                                this.inspectionHandler = this.pageModel.isPageTemplate() ? new PageTemplateInspectionHandler() : new ContentInspectionHandler();
                                if (!this.pageModel.isPageTemplate()) {
                                    this.pageControllerSelector.load();
                                    if (this.pageModel.isCustomized()) {
                                        this.addClass("customized");
                                    }
                                    if (this.pageModeImpliesPageControllerShown()) {
                                        this.pageControllerForm.show();
                                    }
                                }
                                this.inspectionHandler.
                                    setPageModel(this.pageModel).
                                    setPageInspectionPanel(this).
                                    setPageControllerForm(this.pageControllerForm).
                                    setPageTemplateForm(this.pageTemplateForm).
                                    setModel(liveEditModel);
                                this.pageTemplateForm.getSelector().onSelection(function (pageTemplate) {
                                    _this.removeClass("customized");
                                    _this.pageModel.setCustomized(false);
                                    if (pageTemplate) {
                                        _this.pageControllerForm.hide();
                                        new GetPageDescriptorByKeyRequest(pageTemplate.getController()).sendAndParse().
                                            then(function (pageDescriptor) {
                                            var setTemplate = new SetTemplate(_this).
                                                setTemplate(pageTemplate, pageDescriptor);
                                            _this.pageModel.setTemplate(setTemplate, true);
                                        }).catch(function (reason) {
                                            api.DefaultErrorHandler.handle(reason);
                                        }).done();
                                    }
                                    else if (_this.pageModel.hasDefaultPageTemplate()) {
                                        _this.pageControllerForm.hide();
                                        _this.pageModel.setAutomaticTemplate(_this, true);
                                    }
                                    else {
                                        _this.pageModel.reset(_this);
                                    }
                                });
                                this.pageTemplateForm.getSelector().onCustomizedSelected(function () {
                                    _this.addClass("customized");
                                    _this.pageControllerForm.getSelector().reset();
                                    _this.pageControllerForm.show();
                                    _this.pageModel.setCustomized(true);
                                });
                                this.pageModel.onReset(function () {
                                    _this.pageControllerForm.getSelector().reset();
                                    if (!_this.pageModel.isPageTemplate() && !(_this.pageModel.isCustomized() && _this.pageModel.hasController())) {
                                        _this.pageControllerForm.hide();
                                    }
                                });
                            };
                            PageInspectionPanel.prototype.refreshInspectionHandler = function (liveEditModel) {
                                this.inspectionHandler.refreshConfigView(liveEditModel);
                            };
                            PageInspectionPanel.prototype.pageModeImpliesPageControllerShown = function () {
                                return (this.pageModel.isCustomized() && this.pageModel.hasController()) ||
                                    this.pageModel.getMode() == PageMode.FORCED_CONTROLLER;
                            };
                            return PageInspectionPanel;
                        })(app.wizard.page.contextwindow.inspect.BaseInspectionPanel);
                        page.PageInspectionPanel = PageInspectionPanel;
                        var BaseInspectionHandler = (function () {
                            function BaseInspectionHandler() {
                            }
                            BaseInspectionHandler.prototype.setPageModel = function (value) {
                                this.pageModel = value;
                                return this;
                            };
                            BaseInspectionHandler.prototype.setPageInspectionPanel = function (value) {
                                this.pageInspectionPanel = value;
                                return this;
                            };
                            BaseInspectionHandler.prototype.setPageControllerForm = function (value) {
                                this.pageControllerForm = value;
                                return this;
                            };
                            BaseInspectionHandler.prototype.setPageTemplateForm = function (value) {
                                this.pageTemplateForm = value;
                                return this;
                            };
                            BaseInspectionHandler.prototype.setModel = function (liveEditModel) {
                                throw new Error("Must be implemented by inheritors");
                            };
                            BaseInspectionHandler.prototype.refreshConfigForm = function (pageDescriptor, config, context) {
                                var _this = this;
                                if (this.configForm) {
                                    this.configForm.remove();
                                    this.configForm = null;
                                }
                                if (!pageDescriptor) {
                                    return;
                                }
                                this.configForm =
                                    new FormView(context ? context : new FormContextBuilder().build(), pageDescriptor.getConfig(), config.getRoot());
                                this.pageInspectionPanel.appendChild(this.configForm);
                                this.pageModel.setIgnorePropertyChanges(true);
                                this.configForm.layout().catch(function (reason) {
                                    api.DefaultErrorHandler.handle(reason);
                                }).finally(function () {
                                    _this.pageModel.setIgnorePropertyChanges(false);
                                }).
                                    done();
                            };
                            BaseInspectionHandler.prototype.refreshConfigView = function (liveEditModel) {
                            };
                            return BaseInspectionHandler;
                        })();
                        var PageTemplateInspectionHandler = (function (_super) {
                            __extends(PageTemplateInspectionHandler, _super);
                            function PageTemplateInspectionHandler() {
                                _super.apply(this, arguments);
                            }
                            PageTemplateInspectionHandler.prototype.setModel = function (liveEditModel) {
                                var _this = this;
                                var pageModel = liveEditModel.getPageModel();
                                this.pageControllerForm.getSelector().load();
                                this.pageControllerForm.show();
                                this.refreshConfigForm(pageModel.getController(), pageModel.getConfig(), liveEditModel.getFormContext());
                                pageModel.onPropertyChanged(function (event) {
                                    if (event.getPropertyName() == PageModel.PROPERTY_CONTROLLER && _this !== event.getSource()) {
                                        _this.pageControllerForm.show();
                                        _this.refreshConfigForm(pageModel.getController(), pageModel.getConfig(), liveEditModel.getFormContext());
                                    }
                                    else if (event.getPropertyName() == PageModel.PROPERTY_CONFIG && _this !== event.getSource()) {
                                        _this.pageControllerForm.show();
                                        var controller = pageModel.getController();
                                        if (controller) {
                                            _this.refreshConfigForm(controller, pageModel.getConfig(), liveEditModel.getFormContext());
                                        }
                                    }
                                });
                            };
                            return PageTemplateInspectionHandler;
                        })(BaseInspectionHandler);
                        var ContentInspectionHandler = (function (_super) {
                            __extends(ContentInspectionHandler, _super);
                            function ContentInspectionHandler() {
                                _super.apply(this, arguments);
                            }
                            ContentInspectionHandler.prototype.refreshConfigView = function (liveEditModel) {
                                var pageModel = liveEditModel.getPageModel();
                                var pageMode = pageModel.getMode();
                                if (pageMode == PageMode.FORCED_TEMPLATE) {
                                    this.showPageConfig(pageModel, liveEditModel.getFormContext());
                                }
                                else if (pageMode == PageMode.AUTOMATIC) {
                                    this.showDefaultPageTemplateConfig(pageModel, liveEditModel.getFormContext());
                                }
                                else {
                                    throw new Error("Unsupported PageMode: " + PageMode[pageMode]);
                                }
                            };
                            ContentInspectionHandler.prototype.setModel = function (liveEditModel) {
                                var pageModel = liveEditModel.getPageModel();
                                if (this.propertyChangedListener) {
                                    pageModel.unPropertyChanged(this.propertyChangedListener);
                                }
                                this.initListener(pageModel, liveEditModel);
                                var pageMode = pageModel.getMode();
                                this.pageTemplateForm.getSelector().setModel(liveEditModel);
                                if (pageMode !== PageMode.FRAGMENT) {
                                    this.pageTemplateForm.show();
                                }
                                if (pageMode == PageMode.AUTOMATIC) {
                                    this.showDefaultPageTemplateConfig(pageModel, liveEditModel.getFormContext());
                                }
                                else {
                                    this.showPageConfig(pageModel, liveEditModel.getFormContext());
                                }
                                pageModel.onPropertyChanged(this.propertyChangedListener);
                            };
                            ContentInspectionHandler.prototype.initListener = function (pageModel, liveEditModel) {
                                var _this = this;
                                this.propertyChangedListener = function (event) {
                                    if (event.getPropertyName() == "controller" && _this !== event.getSource()) {
                                        _this.pageControllerForm.show();
                                        var controller = pageModel.getController();
                                        if (controller) {
                                            _this.refreshConfigForm(controller, pageModel.getConfig(), liveEditModel.getFormContext());
                                        }
                                    }
                                    else if (event.getPropertyName() == PageModel.PROPERTY_CONFIG && _this !== event.getSource()) {
                                        _this.pageTemplateForm.show();
                                        if (pageModel.getMode() == PageMode.AUTOMATIC) {
                                            _this.showDefaultPageTemplateConfig(pageModel, liveEditModel.getFormContext());
                                        }
                                        else {
                                            _this.showPageConfig(pageModel, liveEditModel.getFormContext());
                                        }
                                    }
                                };
                            };
                            ContentInspectionHandler.prototype.showPageConfig = function (pageModel, formContext) {
                                this.refreshConfigForm(pageModel.getTemplateDescriptor(), pageModel.getConfig(), formContext);
                            };
                            ContentInspectionHandler.prototype.showDefaultPageTemplateConfig = function (pageModel, formContext) {
                                var controller = pageModel.getDefaultPageTemplateController();
                                var config = pageModel.getConfig();
                                this.refreshConfigForm(controller, config, formContext);
                            };
                            return ContentInspectionHandler;
                        })(BaseInspectionHandler);
                    })(page = inspect.page || (inspect.page = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page_8.contextwindow || (page_8.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='PageTemplateOption.ts' />
///<reference path='PageTemplateOptionViewer.ts' />
///<reference path='PageTemplateOptions.ts' />
///<reference path='PageControllerSelector.ts' />
///<reference path='PageTemplateSelector.ts' />
///<reference path='PageControllerForm.ts' />
///<reference path='PageTemplateForm.ts' />
///<reference path='PageInspectionPanel.ts' />
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var ComponentInspectionPanel = (function (_super) {
                            __extends(ComponentInspectionPanel, _super);
                            function ComponentInspectionPanel(config) {
                                _super.call(this);
                            }
                            ComponentInspectionPanel.prototype.setModel = function (liveEditModel) {
                                this.liveEditModel = liveEditModel;
                                this.formContext = liveEditModel.getFormContext();
                            };
                            ComponentInspectionPanel.prototype.setComponent = function (component) {
                                this.component = component;
                            };
                            ComponentInspectionPanel.prototype.getComponentView = function () {
                                throw new Error("Must be implemented by inheritors");
                            };
                            ComponentInspectionPanel.prototype.getComponent = function () {
                                return this.component;
                            };
                            return ComponentInspectionPanel;
                        })(app.wizard.page.contextwindow.inspect.BaseInspectionPanel);
                        region.ComponentInspectionPanel = ComponentInspectionPanel;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var FormView = api.form.FormView;
                        var DescriptorBasedComponentInspectionPanel = (function (_super) {
                            __extends(DescriptorBasedComponentInspectionPanel, _super);
                            function DescriptorBasedComponentInspectionPanel(config) {
                                _super.call(this, config);
                                this.formView = null;
                            }
                            DescriptorBasedComponentInspectionPanel.prototype.setupComponentForm = function (component, descriptor) {
                                if (this.formView) {
                                    this.removeChild(this.formView);
                                    this.formView = null;
                                }
                                if (!component || !descriptor) {
                                    return;
                                }
                                var form = descriptor.getConfig();
                                var config = component.getConfig();
                                this.formView = new FormView(this.formContext, form, config.getRoot());
                                this.appendChild(this.formView);
                                component.setDisableEventForwarding(true);
                                this.formView.layout().
                                    catch(function (reason) {
                                    api.DefaultErrorHandler.handle(reason);
                                }).finally(function () {
                                    component.setDisableEventForwarding(false);
                                }).done();
                            };
                            return DescriptorBasedComponentInspectionPanel;
                        })(region.ComponentInspectionPanel);
                        region.DescriptorBasedComponentInspectionPanel = DescriptorBasedComponentInspectionPanel;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var ImageComponent = api.content.page.region.ImageComponent;
                        var GetContentSummaryByIdRequest = api.content.GetContentSummaryByIdRequest;
                        var ContentComboBox = api.content.ContentComboBox;
                        var ContentTypeName = api.schema.content.ContentTypeName;
                        var ImageInspectionPanel = (function (_super) {
                            __extends(ImageInspectionPanel, _super);
                            function ImageInspectionPanel() {
                                var _this = this;
                                _super.call(this, {
                                    iconClass: api.liveedit.ItemViewIconClassResolver.resolveByType("image", "icon-xlarge")
                                });
                                this.handleSelectorEvents = true;
                                var loader = new api.content.ContentSummaryLoader();
                                loader.setAllowedContentTypeNames([ContentTypeName.IMAGE]);
                                this.imageSelector = ContentComboBox.create().
                                    setMaximumOccurrences(1).
                                    setLoader(loader).
                                    build();
                                this.imageSelectorForm = new region.ImageSelectorForm(this.imageSelector, "Image");
                                this.componentPropertyChangedEventHandler = function (event) {
                                    if (event.getPropertyName() == ImageComponent.PROPERTY_IMAGE) {
                                        if (!_this.imageComponent.hasImage()) {
                                            _this.setupComponentForm(_this.imageComponent);
                                            _this.imageSelector.setContent(null);
                                        }
                                    }
                                };
                                this.initSelectorListeners();
                                this.appendChild(this.imageSelectorForm);
                            }
                            ImageInspectionPanel.prototype.setComponent = function (component) {
                                _super.prototype.setComponent.call(this, component);
                            };
                            ImageInspectionPanel.prototype.setImageComponent = function (imageView) {
                                var _this = this;
                                this.imageView = imageView;
                                if (this.imageComponent) {
                                    this.unregisterComponentListeners(this.imageComponent);
                                }
                                this.imageComponent = imageView.getComponent();
                                this.setComponent(this.imageComponent);
                                var contentId = this.imageComponent.getImage();
                                if (contentId) {
                                    var image = this.imageSelector.getContent(contentId);
                                    if (image) {
                                        this.setSelectorValue(image);
                                        this.setupComponentForm(this.imageComponent);
                                    }
                                    else {
                                        new GetContentSummaryByIdRequest(contentId).sendAndParse().then(function (image) {
                                            _this.setSelectorValue(image);
                                            _this.setupComponentForm(_this.imageComponent);
                                        }).catch(function (reason) {
                                            api.DefaultErrorHandler.handle(reason);
                                        }).done();
                                    }
                                }
                                else {
                                    this.setSelectorValue(null);
                                    this.setupComponentForm(this.imageComponent);
                                }
                                this.registerComponentListeners(this.imageComponent);
                            };
                            ImageInspectionPanel.prototype.registerComponentListeners = function (component) {
                                component.onPropertyChanged(this.componentPropertyChangedEventHandler);
                            };
                            ImageInspectionPanel.prototype.unregisterComponentListeners = function (component) {
                                component.unPropertyChanged(this.componentPropertyChangedEventHandler);
                            };
                            ImageInspectionPanel.prototype.setSelectorValue = function (image) {
                                this.handleSelectorEvents = false;
                                this.imageSelector.setContent(image);
                                this.handleSelectorEvents = true;
                            };
                            ImageInspectionPanel.prototype.setupComponentForm = function (imageComponent) {
                                if (this.formView) {
                                    this.removeChild(this.formView);
                                    this.formView = null;
                                }
                                var configData = imageComponent.getConfig();
                                var configForm = imageComponent.getForm();
                                this.formView = new api.form.FormView(this.formContext, configForm, configData.getRoot());
                                this.appendChild(this.formView);
                                imageComponent.setDisableEventForwarding(true);
                                this.formView.layout().catch(function (reason) {
                                    api.DefaultErrorHandler.handle(reason);
                                }).finally(function () {
                                    imageComponent.setDisableEventForwarding(false);
                                }).done();
                            };
                            ImageInspectionPanel.prototype.initSelectorListeners = function () {
                                var _this = this;
                                this.imageSelector.onOptionSelected(function (selectedOption) {
                                    if (_this.handleSelectorEvents) {
                                        var option = selectedOption.getOption();
                                        var imageContent = option.displayValue;
                                        _this.imageComponent.setImage(imageContent.getContentId(), imageContent.getDisplayName());
                                    }
                                });
                                this.imageSelector.onOptionDeselected(function (option) {
                                    if (_this.handleSelectorEvents) {
                                        _this.imageComponent.reset();
                                    }
                                });
                            };
                            ImageInspectionPanel.prototype.getComponentView = function () {
                                return this.imageView;
                            };
                            return ImageInspectionPanel;
                        })(region.ComponentInspectionPanel);
                        region.ImageInspectionPanel = ImageInspectionPanel;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var PartDescriptorLoader = api.content.page.region.PartDescriptorLoader;
                        var GetPartDescriptorsByApplicationsRequest = api.content.page.region.GetPartDescriptorsByApplicationsRequest;
                        var GetPartDescriptorByKeyRequest = api.content.page.region.GetPartDescriptorByKeyRequest;
                        var PartDescriptorDropdown = api.content.page.region.PartDescriptorDropdown;
                        var DescriptorBasedComponent = api.content.page.region.DescriptorBasedComponent;
                        var PartInspectionPanel = (function (_super) {
                            __extends(PartInspectionPanel, _super);
                            function PartInspectionPanel() {
                                _super.call(this, {
                                    iconClass: api.liveedit.ItemViewIconClassResolver.resolveByType("part", "icon-xlarge")
                                });
                                this.handleSelectorEvents = true;
                            }
                            PartInspectionPanel.prototype.setModel = function (liveEditModel) {
                                var _this = this;
                                _super.prototype.setModel.call(this, liveEditModel);
                                var descriptorsRequest = new GetPartDescriptorsByApplicationsRequest(liveEditModel.getSiteModel().getApplicationKeys());
                                var loader = new PartDescriptorLoader(descriptorsRequest);
                                loader.setComparator(new api.content.page.DescriptorByDisplayNameComparator());
                                this.partSelector = new PartDescriptorDropdown("", { loader: loader });
                                this.partForm = new region.DescriptorBasedDropdownForm(this.partSelector, "Part");
                                loader.load();
                                this.componentPropertyChangedEventHandler = function (event) {
                                    if (event.getPropertyName() == DescriptorBasedComponent.PROPERTY_DESCRIPTOR) {
                                        if (!_this.partComponent.hasDescriptor()) {
                                            _this.setupComponentForm(_this.partComponent, null);
                                            _this.partSelector.setDescriptor(null);
                                        }
                                    }
                                };
                                this.initSelectorListeners();
                                this.appendChild(this.partForm);
                            };
                            PartInspectionPanel.prototype.setComponent = function (component, descriptor) {
                                _super.prototype.setComponent.call(this, component);
                                this.partSelector.setDescriptor(descriptor);
                            };
                            PartInspectionPanel.prototype.setSelectorValue = function (descriptor) {
                                this.handleSelectorEvents = false;
                                this.partSelector.setDescriptor(descriptor);
                                this.handleSelectorEvents = true;
                            };
                            PartInspectionPanel.prototype.registerComponentListeners = function (component) {
                                component.onPropertyChanged(this.componentPropertyChangedEventHandler);
                            };
                            PartInspectionPanel.prototype.unregisterComponentListeners = function (component) {
                                component.unPropertyChanged(this.componentPropertyChangedEventHandler);
                            };
                            PartInspectionPanel.prototype.setPartComponent = function (partView) {
                                var _this = this;
                                if (this.partComponent) {
                                    this.unregisterComponentListeners(this.partComponent);
                                }
                                this.partView = partView;
                                this.partComponent = partView.getComponent();
                                this.setComponent(this.partComponent);
                                var key = this.partComponent.getDescriptor();
                                if (key) {
                                    var descriptor = this.partSelector.getDescriptor(key);
                                    if (descriptor) {
                                        this.setSelectorValue(descriptor);
                                        this.setupComponentForm(this.partComponent, descriptor);
                                    }
                                    else {
                                        new GetPartDescriptorByKeyRequest(key).sendAndParse().then(function (descriptor) {
                                            _this.setSelectorValue(descriptor);
                                            _this.setupComponentForm(_this.partComponent, descriptor);
                                        }).catch(function (reason) {
                                            api.DefaultErrorHandler.handle(reason);
                                        }).done();
                                    }
                                }
                                else {
                                    this.setSelectorValue(null);
                                    this.setupComponentForm(this.partComponent, null);
                                }
                                this.registerComponentListeners(this.partComponent);
                            };
                            PartInspectionPanel.prototype.initSelectorListeners = function () {
                                var _this = this;
                                this.partSelector.onOptionSelected(function (event) {
                                    if (_this.handleSelectorEvents) {
                                        var option = event.getOption();
                                        var selectedDescriptorKey = option.displayValue.getKey();
                                        _this.partComponent.setDescriptor(selectedDescriptorKey, option.displayValue);
                                    }
                                });
                            };
                            return PartInspectionPanel;
                        })(region.DescriptorBasedComponentInspectionPanel);
                        region.PartInspectionPanel = PartInspectionPanel;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var SiteModel = api.content.site.SiteModel;
                        var DescriptorByDisplayNameComparator = api.content.page.DescriptorByDisplayNameComparator;
                        var DescriptorBasedComponent = api.content.page.region.DescriptorBasedComponent;
                        var GetLayoutDescriptorByKeyRequest = api.content.page.region.GetLayoutDescriptorByKeyRequest;
                        var GetLayoutDescriptorsByApplicationsRequest = api.content.page.region.GetLayoutDescriptorsByApplicationsRequest;
                        var LayoutDescriptorLoader = api.content.page.region.LayoutDescriptorLoader;
                        var LayoutDescriptorDropdown = api.content.page.region.LayoutDescriptorDropdown;
                        var LayoutInspectionPanel = (function (_super) {
                            __extends(LayoutInspectionPanel, _super);
                            function LayoutInspectionPanel() {
                                _super.call(this, {
                                    iconClass: api.liveedit.ItemViewIconClassResolver.resolveByType("layout", "icon-xlarge")
                                });
                                this.handleSelectorEvents = true;
                            }
                            LayoutInspectionPanel.prototype.setModel = function (liveEditModel) {
                                var _this = this;
                                _super.prototype.setModel.call(this, liveEditModel);
                                var descriptorsRequest = new GetLayoutDescriptorsByApplicationsRequest(liveEditModel.getSiteModel().getApplicationKeys());
                                var loader = new LayoutDescriptorLoader(descriptorsRequest);
                                loader.setComparator(new DescriptorByDisplayNameComparator());
                                this.layoutSelector = new LayoutDescriptorDropdown("", { loader: loader });
                                this.layoutForm = new region.DescriptorBasedDropdownForm(this.layoutSelector, "Layout");
                                loader.load();
                                this.componentPropertyChangedEventHandler = function (event) {
                                    if (event.getPropertyName() == DescriptorBasedComponent.PROPERTY_DESCRIPTOR) {
                                        if (!_this.layoutComponent.hasDescriptor()) {
                                            _this.setupComponentForm(_this.layoutComponent, null);
                                            _this.layoutSelector.setDescriptor(null);
                                        }
                                    }
                                };
                                this.initSelectorListeners();
                                this.appendChild(this.layoutForm);
                                liveEditModel.getSiteModel().onPropertyChanged(function (event) {
                                    if (event.getPropertyName() == SiteModel.PROPERTY_NAME_SITE_CONFIGS) {
                                        descriptorsRequest.setApplicationKeys(liveEditModel.getSiteModel().getApplicationKeys());
                                        loader.load();
                                    }
                                });
                            };
                            LayoutInspectionPanel.prototype.registerComponentListeners = function (component) {
                                component.onPropertyChanged(this.componentPropertyChangedEventHandler);
                            };
                            LayoutInspectionPanel.prototype.unregisterComponentListeners = function (component) {
                                component.unPropertyChanged(this.componentPropertyChangedEventHandler);
                            };
                            LayoutInspectionPanel.prototype.setComponent = function (component, descriptor) {
                                _super.prototype.setComponent.call(this, component);
                                this.layoutSelector.setDescriptor(descriptor);
                            };
                            LayoutInspectionPanel.prototype.setLayoutComponent = function (layoutView) {
                                var _this = this;
                                if (this.layoutComponent) {
                                    this.unregisterComponentListeners(this.layoutComponent);
                                }
                                this.layoutView = layoutView;
                                this.layoutComponent = layoutView.getComponent();
                                this.setComponent(this.layoutComponent);
                                var key = this.layoutComponent.getDescriptor();
                                if (key) {
                                    var descriptor = this.layoutSelector.getDescriptor(key);
                                    if (descriptor) {
                                        this.setSelectorValue(descriptor);
                                        this.setupComponentForm(this.layoutComponent, descriptor);
                                    }
                                    else {
                                        new GetLayoutDescriptorByKeyRequest(key).sendAndParse().then(function (descriptor) {
                                            _this.setSelectorValue(descriptor);
                                            _this.setupComponentForm(_this.layoutComponent, descriptor);
                                        }).catch(function (reason) {
                                            api.DefaultErrorHandler.handle(reason);
                                        }).done();
                                    }
                                }
                                else {
                                    this.setSelectorValue(null);
                                    this.setupComponentForm(this.layoutComponent, null);
                                }
                                this.registerComponentListeners(this.layoutComponent);
                            };
                            LayoutInspectionPanel.prototype.setSelectorValue = function (descriptor) {
                                this.handleSelectorEvents = false;
                                this.layoutSelector.setDescriptor(descriptor);
                                this.handleSelectorEvents = true;
                            };
                            LayoutInspectionPanel.prototype.initSelectorListeners = function () {
                                var _this = this;
                                this.layoutSelector.onOptionSelected(function (event) {
                                    if (_this.handleSelectorEvents) {
                                        var option = event.getOption();
                                        var selectedDescriptorKey = option.displayValue.getKey();
                                        _this.layoutComponent.setDescriptor(selectedDescriptorKey, option.displayValue);
                                    }
                                });
                            };
                            return LayoutInspectionPanel;
                        })(region.DescriptorBasedComponentInspectionPanel);
                        region.LayoutInspectionPanel = LayoutInspectionPanel;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region_1) {
                        var RegionInspectionPanel = (function (_super) {
                            __extends(RegionInspectionPanel, _super);
                            function RegionInspectionPanel() {
                                _super.call(this);
                                this.namesAndIcon = new api.app.NamesAndIconView(new api.app.NamesAndIconViewBuilder().
                                    setSize(api.app.NamesAndIconViewSize.medium)).
                                    setIconClass(api.liveedit.ItemViewIconClassResolver.resolveByType("region"));
                                this.appendChild(this.namesAndIcon);
                            }
                            RegionInspectionPanel.prototype.setRegion = function (region) {
                                this.region = region;
                                if (region) {
                                    this.namesAndIcon.setMainName(region.getName());
                                    this.namesAndIcon.setSubName(region.getPath().toString());
                                }
                                else {
                                    this.namesAndIcon.setMainName("[No  Region given]");
                                    this.namesAndIcon.setSubName("");
                                }
                            };
                            return RegionInspectionPanel;
                        })(inspect.BaseInspectionPanel);
                        region_1.RegionInspectionPanel = RegionInspectionPanel;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var DescriptorBasedDropdownForm = (function (_super) {
                            __extends(DescriptorBasedDropdownForm, _super);
                            function DescriptorBasedDropdownForm(templateSelector, title) {
                                _super.call(this, 'descriptor-based-dropdown-form');
                                this.templateSelector = templateSelector;
                                var fieldSet = new api.ui.form.Fieldset();
                                if (!api.util.StringHelper.isBlank(title)) {
                                    fieldSet.add(new api.ui.form.FormItemBuilder(templateSelector).setLabel(title).build());
                                }
                                else {
                                    fieldSet.add(new api.ui.form.FormItemBuilder(templateSelector).build());
                                }
                                this.add(fieldSet);
                            }
                            DescriptorBasedDropdownForm.prototype.getSelector = function () {
                                return this.templateSelector;
                            };
                            return DescriptorBasedDropdownForm;
                        })(api.ui.form.Form);
                        region.DescriptorBasedDropdownForm = DescriptorBasedDropdownForm;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var ImageSelectorForm = (function (_super) {
                            __extends(ImageSelectorForm, _super);
                            function ImageSelectorForm(templateSelector, title) {
                                _super.call(this, 'image-combobox-form');
                                this.imageSelector = templateSelector;
                                var fieldSet = new api.ui.form.Fieldset();
                                if (!api.util.StringHelper.isBlank(title)) {
                                    fieldSet.add(new api.ui.form.FormItemBuilder(templateSelector).setLabel(title).build());
                                }
                                else {
                                    fieldSet.add(new api.ui.form.FormItemBuilder(templateSelector).build());
                                }
                                this.add(fieldSet);
                            }
                            ImageSelectorForm.prototype.getSelector = function () {
                                return this.imageSelector;
                            };
                            return ImageSelectorForm;
                        })(api.ui.form.Form);
                        region.ImageSelectorForm = ImageSelectorForm;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var FragmentComponent = api.content.page.region.FragmentComponent;
                        var GetContentSummaryByIdRequest = api.content.GetContentSummaryByIdRequest;
                        var ContentTypeName = api.schema.content.ContentTypeName;
                        var GetContentByIdRequest = api.content.GetContentByIdRequest;
                        var LayoutComponentType = api.content.page.region.LayoutComponentType;
                        var QueryExpr = api.query.expr.QueryExpr;
                        var CompareExpr = api.query.expr.CompareExpr;
                        var FieldExpr = api.query.expr.FieldExpr;
                        var ValueExpr = api.query.expr.ValueExpr;
                        var FragmentDropdown = api.content.page.region.FragmentDropdown;
                        var FragmentInspectionPanel = (function (_super) {
                            __extends(FragmentInspectionPanel, _super);
                            function FragmentInspectionPanel() {
                                _super.call(this, {
                                    iconClass: api.liveedit.ItemViewIconClassResolver.resolveByType("fragment")
                                });
                                this.handleSelectorEvents = true;
                                this.loader = new api.content.ContentSummaryLoader();
                                this.loader.setAllowedContentTypeNames([ContentTypeName.FRAGMENT]);
                            }
                            FragmentInspectionPanel.prototype.setModel = function (liveEditModel) {
                                var _this = this;
                                _super.prototype.setModel.call(this, liveEditModel);
                                this.loader.setQueryExpr(this.createParentSiteFragmentsOnlyQuery());
                                this.fragmentSelector = new FragmentDropdown("", { loader: this.loader });
                                this.fragmentForm = new region.FragmentSelectorForm(this.fragmentSelector, "Fragment");
                                this.loader.load();
                                this.componentPropertyChangedEventHandler = function (event) {
                                    if (event.getPropertyName() == FragmentComponent.PROPERTY_FRAGMENT) {
                                        if (!_this.fragmentComponent.hasFragment()) {
                                            _this.fragmentSelector.setSelection(null);
                                        }
                                    }
                                };
                                this.initSelectorListeners();
                                this.appendChild(this.fragmentForm);
                            };
                            FragmentInspectionPanel.prototype.setFragmentComponent = function (fragmentView) {
                                var _this = this;
                                this.fragmentView = fragmentView;
                                if (this.fragmentComponent) {
                                    this.unregisterComponentListeners(this.fragmentComponent);
                                }
                                this.fragmentComponent = fragmentView.getComponent();
                                this.setComponent(this.fragmentComponent);
                                var contentId = this.fragmentComponent.getFragment();
                                if (contentId) {
                                    var fragment = this.fragmentSelector.getSelection(contentId);
                                    if (fragment) {
                                        this.setSelectorValue(fragment);
                                    }
                                    else {
                                        new GetContentSummaryByIdRequest(contentId).sendAndParse().then(function (fragment) {
                                            _this.setSelectorValue(fragment);
                                        }).catch(function (reason) {
                                            api.DefaultErrorHandler.handle(reason);
                                        }).done();
                                    }
                                }
                                else {
                                    this.setSelectorValue(null);
                                }
                                this.registerComponentListeners(this.fragmentComponent);
                            };
                            FragmentInspectionPanel.prototype.registerComponentListeners = function (component) {
                                component.onPropertyChanged(this.componentPropertyChangedEventHandler);
                            };
                            FragmentInspectionPanel.prototype.unregisterComponentListeners = function (component) {
                                component.unPropertyChanged(this.componentPropertyChangedEventHandler);
                            };
                            FragmentInspectionPanel.prototype.setSelectorValue = function (fragment) {
                                this.handleSelectorEvents = false;
                                if (fragment) {
                                    var option = this.fragmentSelector.getOptionByValue(fragment.getId().toString());
                                    if (!option) {
                                        this.fragmentSelector.addFragmentOption(fragment);
                                    }
                                }
                                this.fragmentSelector.setSelection(fragment);
                                this.handleSelectorEvents = true;
                            };
                            FragmentInspectionPanel.prototype.initSelectorListeners = function () {
                                var _this = this;
                                this.fragmentSelector.onOptionSelected(function (selectedOption) {
                                    if (_this.handleSelectorEvents) {
                                        var option = selectedOption.getOption();
                                        var fragmentContent = option.displayValue;
                                        if (_this.isInsideLayout()) {
                                            new GetContentByIdRequest(fragmentContent.getContentId()).sendAndParse().done(function (content) {
                                                var fragmentComponent = content.getPage() ? content.getPage().getFragment() : null;
                                                if (fragmentComponent &&
                                                    api.ObjectHelper.iFrameSafeInstanceOf(fragmentComponent.getType(), LayoutComponentType)) {
                                                    api.notify.showWarning("Layout within layout not allowed");
                                                }
                                                else {
                                                    _this.fragmentComponent.setFragment(fragmentContent.getContentId(), fragmentContent.getDisplayName());
                                                }
                                            });
                                        }
                                        else {
                                            _this.fragmentComponent.setFragment(fragmentContent.getContentId(), fragmentContent.getDisplayName());
                                        }
                                    }
                                });
                            };
                            FragmentInspectionPanel.prototype.isInsideLayout = function () {
                                var parentRegion = this.fragmentView.getParentItemView();
                                if (!parentRegion) {
                                    return false;
                                }
                                var parent = parentRegion.getParentItemView();
                                if (!parent) {
                                    return false;
                                }
                                return api.ObjectHelper.iFrameSafeInstanceOf(parent.getType(), api.liveedit.layout.LayoutItemType);
                            };
                            FragmentInspectionPanel.prototype.createParentSiteFragmentsOnlyQuery = function () {
                                var sitePath = this.liveEditModel.getSiteModel().getSite().getPath().toString();
                                var compareExpr = CompareExpr.like(new FieldExpr("_path"), ValueExpr.string("/content" + sitePath + "/*"));
                                return new QueryExpr(compareExpr);
                            };
                            FragmentInspectionPanel.prototype.getComponentView = function () {
                                return this.fragmentView;
                            };
                            return FragmentInspectionPanel;
                        })(region.ComponentInspectionPanel);
                        region.FragmentInspectionPanel = FragmentInspectionPanel;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var FragmentSelectorForm = (function (_super) {
                            __extends(FragmentSelectorForm, _super);
                            function FragmentSelectorForm(fragmentSelector, title) {
                                _super.call(this, 'fragment-dropdown-form');
                                this.fragmentSelector = fragmentSelector;
                                var fieldSet = new api.ui.form.Fieldset();
                                if (!api.util.StringHelper.isBlank(title)) {
                                    fieldSet.add(new api.ui.form.FormItemBuilder(fragmentSelector).setLabel(title).build());
                                }
                                else {
                                    fieldSet.add(new api.ui.form.FormItemBuilder(fragmentSelector).build());
                                }
                                this.add(fieldSet);
                            }
                            FragmentSelectorForm.prototype.getSelector = function () {
                                return this.fragmentSelector;
                            };
                            return FragmentSelectorForm;
                        })(api.ui.form.Form);
                        region.FragmentSelectorForm = FragmentSelectorForm;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var inspect;
                (function (inspect) {
                    var region;
                    (function (region) {
                        var TextInspectionPanel = (function (_super) {
                            __extends(TextInspectionPanel, _super);
                            function TextInspectionPanel() {
                                _super.call(this);
                                this.namesAndIcon = new api.app.NamesAndIconView(new api.app.NamesAndIconViewBuilder().
                                    setSize(api.app.NamesAndIconViewSize.medium)).
                                    setIconClass(api.liveedit.ItemViewIconClassResolver.resolveByType("text"));
                                this.appendChild(this.namesAndIcon);
                            }
                            TextInspectionPanel.prototype.setTextComponent = function (textComponentView) {
                                var textComponent = textComponentView.getComponent();
                                if (textComponent) {
                                    var viewer = textComponentView.getViewer();
                                    this.namesAndIcon.setMainName(viewer.resolveDisplayName(textComponent, textComponentView));
                                    this.namesAndIcon.setSubName(viewer.resolveSubName(textComponent));
                                    this.namesAndIcon.setIconClass(viewer.resolveIconClass(textComponent));
                                }
                            };
                            return TextInspectionPanel;
                        })(inspect.BaseInspectionPanel);
                        region.TextInspectionPanel = TextInspectionPanel;
                    })(region = inspect.region || (inspect.region = {}));
                })(inspect = contextwindow.inspect || (contextwindow.inspect = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='ComponentInspectionPanel.ts' />
///<reference path='DescriptorBasedComponentInspectionPanel.ts' />
///<reference path='ImageInspectionPanel.ts' />
///<reference path='PartInspectionPanel.ts' />
///<reference path='LayoutInspectionPanel.ts' />
///<reference path='RegionInspectionPanel.ts' />
///<reference path='DescriptorBasedDropdownForm.ts' />
///<reference path='ImageSelectorForm.ts' />
///<reference path='FragmentInspectionPanel.ts' />
///<reference path='FragmentSelectorForm.ts' />
///<reference path='TextInspectionPanel.ts' /> 
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var EmulatorGrid = (function (_super) {
                    __extends(EmulatorGrid, _super);
                    function EmulatorGrid(dataView) {
                        _super.call(this, dataView, this.createColumns(), this.createOptions());
                    }
                    EmulatorGrid.prototype.createOptions = function () {
                        return new api.ui.grid.GridOptionsBuilder().
                            setHideColumnHeaders(true).
                            setRowHeight(50).
                            setHeight(450).
                            setWidth(320)
                            .build();
                    };
                    EmulatorGrid.prototype.createColumns = function () {
                        var _this = this;
                        return [new api.ui.grid.GridColumnBuilder().
                                setName("device").
                                setField("device").
                                setId("device").
                                setWidth(320).
                                setCssClass("grid-row").
                                setFormatter(function (row, cell, value, columnDef, dataContext) {
                                return _this.buildRow(row, cell, value).toString();
                            }).
                                build()
                        ];
                    };
                    EmulatorGrid.prototype.buildRow = function (row, cell, data) {
                        var rowEl = new api.dom.DivEl();
                        rowEl.getEl().setData('width', data.width);
                        rowEl.getEl().setData('height', data.height);
                        rowEl.getEl().setData('units', data.units);
                        var icon = new api.ui.FontIcon("icon-" + data.device_type);
                        var title = new api.dom.H5El();
                        title.getEl().setInnerHtml(data.name);
                        var subtitle = new api.dom.H6El();
                        var units = data.display_units ? data.units : "";
                        subtitle.getEl().setInnerHtml(data.width + units + " &times; " + data.height + units, false);
                        rowEl.appendChild(icon);
                        rowEl.appendChild(title);
                        rowEl.appendChild(subtitle);
                        if (data.rotatable == true) {
                            var rotator = new api.dom.DivEl();
                            rotator.addClass('rotate');
                            rotator.addClassEx('icon-loop');
                            rowEl.appendChild(rotator);
                        }
                        return rowEl;
                    };
                    EmulatorGrid.toSlickData = function (data) {
                        var result = [];
                        var i = 1;
                        data["devices"].forEach(function (item, index) {
                            var tmp = {
                                "id": i,
                                "device": item
                            };
                            result.push(tmp);
                            i++;
                        });
                        return result;
                    };
                    return EmulatorGrid;
                })(api.ui.grid.Grid);
                contextwindow.EmulatorGrid = EmulatorGrid;
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var EmulatorPanel = (function (_super) {
                    __extends(EmulatorPanel, _super);
                    function EmulatorPanel(config) {
                        var _this = this;
                        _super.call(this, "emulator-panel");
                        this.liveEditPage = config.liveEditPage;
                        var text = new api.dom.PEl();
                        text.getEl().setInnerHtml("Emulate different client's physical sizes");
                        this.appendChild(text);
                        this.dataView = new api.ui.grid.DataView();
                        this.grid = new contextwindow.EmulatorGrid(this.dataView);
                        this.appendChild(this.grid);
                        this.getData();
                        wemjq(this.getHTMLElement()).on("click", ".grid-row > div", function (event) {
                            var el = wemjq(event.currentTarget), width = el.data("width"), height = el.data("height"), units = el.data("units");
                            _this.liveEditPage.setWidth(width + units);
                            _this.liveEditPage.setHeight(height + units);
                        });
                        wemjq(this.getHTMLElement()).on("click", ".rotate", function (event) {
                            event.stopPropagation();
                            _this.liveEditPage.setHeightPx(_this.liveEditPage.getHeight());
                            _this.liveEditPage.setWidthPx(_this.liveEditPage.getWidth());
                        });
                    }
                    EmulatorPanel.prototype.getData = function () {
                        var _this = this;
                        wemjq.ajax({
                            url: api.util.UriHelper.getAdminUri("apps/content-studio/js/data/context-window/devices.json"),
                            success: function (data, textStatus, jqXHR) {
                                _this.dataView.setItems(contextwindow.EmulatorGrid.toSlickData(data));
                                _this.grid.setActiveCell(0, 0);
                            }
                        });
                    };
                    return EmulatorPanel;
                })(api.ui.panel.Panel);
                contextwindow.EmulatorPanel = EmulatorPanel;
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var ResponsiveManager = api.ui.responsive.ResponsiveManager;
                var ContextWindow = (function (_super) {
                    __extends(ContextWindow, _super);
                    function ContextWindow(config) {
                        var _this = this;
                        _super.call(this);
                        this.contextWindowState = ContextWindowState.HIDDEN;
                        this.minWidth = 280;
                        this.parentMinWidth = 15;
                        this.displayModeChangedListeners = [];
                        this.fixed = false;
                        this.liveFormPanel = config.liveFormPanel;
                        this.inspectionsPanel = config.inspectionPanel;
                        this.emulatorPanel = config.emulatorPanel;
                        this.insertablesPanel = config.insertablesPanel;
                        this.addClass("context-window");
                        this.ghostDragger = new api.dom.DivEl("ghost-dragger");
                        this.splitter = new api.dom.DivEl("splitter");
                        ResponsiveManager.onAvailableSizeChanged(this.liveFormPanel, function (item) {
                            _this.updateFrameSize();
                        });
                        this.appendChild(this.splitter);
                        this.addItem("Insert", false, this.insertablesPanel);
                        this.addItem("Inspect", false, this.inspectionsPanel);
                        this.addItem("Emulator", false, this.emulatorPanel);
                        this.onRendered(function () { return _this.onRenderedHandler(); });
                        this.onRemoved(function (event) {
                            ResponsiveManager.unAvailableSizeChanged(_this);
                            ResponsiveManager.unAvailableSizeChanged(_this.liveFormPanel);
                        });
                        this.insertablesPanel.getComponentsView().onBeforeInsertAction(function () {
                            _this.fixed = true;
                        });
                    }
                    ContextWindow.prototype.getComponentsView = function () {
                        return this.insertablesPanel.getComponentsView();
                    };
                    ContextWindow.prototype.onRenderedHandler = function () {
                        var _this = this;
                        var initialPos = 0;
                        var splitterPosition = 0;
                        var parent = this.getParentElement();
                        this.actualWidth = this.getEl().getWidth();
                        this.mask = new api.ui.mask.DragMask(parent);
                        var dragListener = function (e) {
                            if (_this.splitterWithinBoundaries(initialPos - e.clientX)) {
                                splitterPosition = e.clientX;
                                _this.ghostDragger.getEl().setLeftPx(e.clientX - _this.getEl().getOffsetLeft());
                            }
                        };
                        this.splitter.onMouseDown(function (e) {
                            e.preventDefault();
                            initialPos = e.clientX;
                            splitterPosition = e.clientX;
                            _this.startDrag(dragListener);
                        });
                        this.mask.onMouseUp(function (e) {
                            _this.actualWidth = _this.getEl().getWidth() + initialPos - splitterPosition;
                            _this.stopDrag(dragListener);
                            ResponsiveManager.fireResizeEvent();
                        });
                        this.addClass('hidden');
                    };
                    ContextWindow.prototype.splitterWithinBoundaries = function (offset) {
                        var newWidth = this.actualWidth + offset;
                        return (newWidth >= this.minWidth) && (newWidth <= this.getParentElement().getEl().getWidth() - this.parentMinWidth);
                    };
                    ContextWindow.prototype.startDrag = function (dragListener) {
                        this.mask.show();
                        this.mask.onMouseMove(dragListener);
                        this.ghostDragger.insertBeforeEl(this.splitter);
                        this.ghostDragger.getEl().setLeftPx(this.splitter.getEl().getOffsetLeftRelativeToParent()).setTop(null);
                    };
                    ContextWindow.prototype.stopDrag = function (dragListener) {
                        this.getEl().setWidthPx(this.actualWidth);
                        this.mask.unMouseMove(dragListener);
                        this.mask.hide();
                        this.removeChild(this.ghostDragger);
                    };
                    ContextWindow.prototype.isShown = function () {
                        return this.contextWindowState == ContextWindowState.SHOWN;
                    };
                    ContextWindow.prototype.isSlidingIn = function () {
                        return this.contextWindowState == ContextWindowState.SLIDING_IN;
                    };
                    ContextWindow.prototype.isSlidingOut = function () {
                        return this.contextWindowState == ContextWindowState.SLIDING_OUT;
                    };
                    ContextWindow.prototype.isFixed = function () {
                        return this.fixed;
                    };
                    ContextWindow.prototype.setFixed = function (value) {
                        this.fixed = value;
                    };
                    ContextWindow.prototype.isShownOrAboutToBeShown = function () {
                        return this.isShown() || this.isSlidingIn();
                    };
                    ContextWindow.prototype.slideOut = function () {
                        var _this = this;
                        this.getEl().setRightPx(-this.getEl().getWidthWithBorder());
                        if (this.animationTimer) {
                            clearTimeout(this.animationTimer);
                        }
                        this.contextWindowState = ContextWindowState.SLIDING_OUT;
                        this.animationTimer = setTimeout(function () {
                            _this.getEl().addClass('hidden');
                            _this.contextWindowState = ContextWindowState.HIDDEN;
                            _this.updateFrameSize();
                            _this.animationTimer = null;
                        }, 100);
                    };
                    ContextWindow.prototype.slideIn = function () {
                        var _this = this;
                        this.getEl().removeClass('hidden').setRightPx(0);
                        if (this.animationTimer) {
                            clearTimeout(this.animationTimer);
                        }
                        this.contextWindowState = ContextWindowState.SLIDING_IN;
                        this.animationTimer = setTimeout(function () {
                            _this.contextWindowState = ContextWindowState.SHOWN;
                            _this.updateFrameSize();
                            _this.animationTimer = null;
                        }, 100);
                    };
                    ContextWindow.prototype.showInspectionPanel = function (panel) {
                        this.inspectionsPanel.showInspectionPanel(panel);
                        this.selectPanel(this.inspectionsPanel);
                    };
                    ContextWindow.prototype.clearSelection = function () {
                        this.inspectionsPanel.clearInspection();
                        this.selectPanel(this.insertablesPanel);
                    };
                    ContextWindow.prototype.isInspecting = function () {
                        return this.inspectionsPanel.isInspecting();
                    };
                    ContextWindow.prototype.updateFrameSize = function () {
                        var isFloating = this.isFloating(), displayModeChanged = this.hasClass('floating') && !isFloating, contextWindowWidth = this.actualWidth || this.getEl().getWidth();
                        this.liveFormPanel.updateFrameContainerSize(!isFloating && this.isShown(), contextWindowWidth);
                        this.toggleClass("floating", isFloating);
                        if (displayModeChanged) {
                            this.notifyDisplayModeChanged();
                        }
                    };
                    ContextWindow.prototype.isLiveFormShown = function () {
                        return this.liveFormPanel.isVisible();
                    };
                    ContextWindow.prototype.isFloating = function () {
                        var contextWindowWidth = this.actualWidth || this.getEl().getWidth();
                        var liveFormPanelWidth = this.liveFormPanel.getEl().getWidth();
                        return (liveFormPanelWidth < 1200) || ((liveFormPanelWidth - contextWindowWidth) < 920);
                    };
                    ContextWindow.prototype.notifyDisplayModeChanged = function () {
                        this.displayModeChangedListeners.forEach(function (listener) { return listener(); });
                    };
                    ContextWindow.prototype.onDisplayModeChanged = function (listener) {
                        this.displayModeChangedListeners.push(listener);
                    };
                    ContextWindow.prototype.unDisplayModeChanged = function (listener) {
                        this.displayModeChangedListeners = this.displayModeChangedListeners.filter(function (currentListener) {
                            return listener != currentListener;
                        });
                    };
                    return ContextWindow;
                })(api.ui.panel.DockedPanel);
                contextwindow.ContextWindow = ContextWindow;
                var ContextWindowState;
                (function (ContextWindowState) {
                    ContextWindowState[ContextWindowState["SHOWN"] = 0] = "SHOWN";
                    ContextWindowState[ContextWindowState["HIDDEN"] = 1] = "HIDDEN";
                    ContextWindowState[ContextWindowState["SLIDING_IN"] = 2] = "SLIDING_IN";
                    ContextWindowState[ContextWindowState["SLIDING_OUT"] = 3] = "SLIDING_OUT";
                })(ContextWindowState || (ContextWindowState = {}));
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var contextwindow;
            (function (contextwindow) {
                var ContextWindowController = (function () {
                    function ContextWindowController(contextWindow, contextWindowToggler, componentsViewToggler) {
                        var _this = this;
                        this.togglerOverriden = false;
                        this.contextWindow = contextWindow;
                        this.contextWindowToggler = contextWindowToggler;
                        this.componentsViewToggler = componentsViewToggler;
                        var componentsView = this.contextWindow.getComponentsView();
                        this.contextWindowToggler.onClicked(function (event) {
                            if (_this.contextWindowToggler.isEnabled()) {
                                _this.togglerOverriden = true;
                            }
                        });
                        this.contextWindowToggler.onActiveChanged(function (isActive) {
                            if (isActive) {
                                _this.contextWindow.slideIn();
                            }
                            else {
                                _this.contextWindow.slideOut();
                            }
                        });
                        this.componentsViewToggler.onActiveChanged(function (isActive) {
                            componentsView.setVisible(isActive);
                        });
                        componentsView.onHidden(function (event) {
                            _this.componentsViewToggler.setActive(false, true);
                        });
                        var liveEditShownHandler = function () {
                            if (_this.contextWindow.isLiveFormShown()) {
                                _this.contextWindowToggler.setEnabled(true);
                                _this.componentsViewToggler.setEnabled(true);
                            }
                        };
                        var liveEditHiddenHandler = function () {
                            _this.contextWindowToggler.setEnabled(false);
                            _this.componentsViewToggler.setEnabled(false);
                        };
                        app.wizard.ShowLiveEditEvent.on(liveEditShownHandler);
                        app.wizard.ShowSplitEditEvent.on(liveEditShownHandler);
                        app.wizard.ShowContentFormEvent.on(liveEditHiddenHandler);
                    }
                    return ContextWindowController;
                })();
                contextwindow.ContextWindowController = ContextWindowController;
            })(contextwindow = page.contextwindow || (page.contextwindow = {}));
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='EmulatorGrid.ts' />
///<reference path='EmulatorPanel.ts' />
///<reference path='ContextWindow.ts' />
///<reference path='ContextWindowController.ts' /> 
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var DefaultModels = (function () {
                function DefaultModels(pageTemplate, pageDescriptor) {
                    this.pageTemplate = pageTemplate;
                    this.pageDescriptor = pageDescriptor;
                }
                DefaultModels.prototype.hasPageTemplate = function () {
                    return !!this.pageTemplate;
                };
                DefaultModels.prototype.getPageTemplate = function () {
                    return this.pageTemplate ? this.pageTemplate.clone() : null;
                };
                DefaultModels.prototype.getPageDescriptor = function () {
                    return this.pageDescriptor;
                };
                return DefaultModels;
            })();
            page.DefaultModels = DefaultModels;
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var GetPageDescriptorByKeyRequest = api.content.page.GetPageDescriptorByKeyRequest;
            var GetDefaultPageTemplateRequest = api.content.page.GetDefaultPageTemplateRequest;
            var DefaultModelsFactory = (function () {
                function DefaultModelsFactory() {
                }
                DefaultModelsFactory.create = function (config) {
                    return new GetDefaultPageTemplateRequest(config.siteId, config.contentType).sendAndParse().
                        then(function (defaultPageTemplate) {
                        var defaultPageTemplateDescriptorPromise = null;
                        if (defaultPageTemplate && defaultPageTemplate.isPage()) {
                            defaultPageTemplateDescriptorPromise = new GetPageDescriptorByKeyRequest(defaultPageTemplate.getController()).
                                sendAndParse();
                        }
                        else if (defaultPageTemplate && !defaultPageTemplate.isPage()) {
                            defaultPageTemplate = null;
                        }
                        var deferred = wemQ.defer();
                        if (defaultPageTemplateDescriptorPromise) {
                            defaultPageTemplateDescriptorPromise.then(function (defaultPageTemplateDescriptor) {
                                deferred.resolve(new page.DefaultModels(defaultPageTemplate, defaultPageTemplateDescriptor));
                            }).catch(function (reason) {
                                deferred.reject(new api.Exception("Page descriptor '" + defaultPageTemplate.getController() + "' not found.", api.ExceptionType.WARNING));
                            }).done();
                        }
                        else {
                            deferred.resolve(new page.DefaultModels(defaultPageTemplate, null));
                        }
                        return deferred.promise;
                    });
                };
                return DefaultModelsFactory;
            })();
            page.DefaultModelsFactory = DefaultModelsFactory;
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var ImageUploadDialog = api.content.form.inputtype.image.ImageUploadDialog;
            var RenderingMode = api.rendering.RenderingMode;
            var Workspace = api.content.Branch;
            var ImageOpenUploadDialogEvent = api.liveedit.ImageOpenUploadDialogEvent;
            var ImageUploadedEvent = api.liveedit.ImageUploadedEvent;
            var LiveEditPageViewReadyEvent = api.liveedit.LiveEditPageViewReadyEvent;
            var ComponentViewDragStartedEvent = api.liveedit.ComponentViewDragStartedEvent;
            var ComponentViewDragStoppedEvent = api.liveedit.ComponentViewDragStoppedEvent;
            var ComponentViewDragCanceledEvent = api.liveedit.ComponentViewDragCanceledEvent;
            var ComponentViewDragDroppedEvent = api.liveedit.ComponentViewDragDroppedEvent;
            var PageSelectedEvent = api.liveedit.PageSelectedEvent;
            var PageLockedEvent = api.liveedit.PageLockedEvent;
            var PageUnlockedEvent = api.liveedit.PageUnlockedEvent;
            var PageUnloadedEvent = api.liveedit.PageUnloadedEvent;
            var PageTextModeStartedEvent = api.liveedit.PageTextModeStartedEvent;
            var RegionSelectedEvent = api.liveedit.RegionSelectedEvent;
            var ItemViewSelectedEvent = api.liveedit.ItemViewSelectedEvent;
            var ItemViewDeselectedEvent = api.liveedit.ItemViewDeselectedEvent;
            var ComponentAddedEvent = api.liveedit.ComponentAddedEvent;
            var ComponentRemovedEvent = api.liveedit.ComponentRemovedEvent;
            var ComponentDuplicatedEvent = api.liveedit.ComponentDuplicatedEvent;
            var ComponentInspectedEvent = api.liveedit.ComponentInspectedEvent;
            var PageInspectedEvent = api.liveedit.PageInspectedEvent;
            var ComponentLoadedEvent = api.liveedit.ComponentLoadedEvent;
            var ComponentResetEvent = api.liveedit.ComponentResetEvent;
            var LiveEditPageInitializationErrorEvent = api.liveedit.LiveEditPageInitializationErrorEvent;
            var ComponentFragmentCreatedEvent = api.liveedit.ComponentFragmentCreatedEvent;
            var ShowWarningLiveEditEvent = api.liveedit.ShowWarningLiveEditEvent;
            var EditContentEvent = api.content.event.EditContentEvent;
            var CreateItemViewConfig = api.liveedit.CreateItemViewConfig;
            var CreateHtmlAreaDialogEvent = api.util.htmlarea.dialog.CreateHtmlAreaDialogEvent;
            var LiveEditPageDialogCreatedEvent = api.liveedit.LiveEditPageDialogCreatedEvent;
            var LiveEditPageProxy = (function () {
                function LiveEditPageProxy() {
                    var _this = this;
                    this.loadedListeners = [];
                    this.componentViewDragStartedListeners = [];
                    this.componentViewDragStoppedListeners = [];
                    this.componentViewDragCanceledListeners = [];
                    this.componentViewDragDroppedListeners = [];
                    this.pageSelectedListeners = [];
                    this.pageLockedListeners = [];
                    this.pageUnlockedListeners = [];
                    this.pageUnloadedListeners = [];
                    this.pageTextModeStartedListeners = [];
                    this.regionSelectedListeners = [];
                    this.itemViewSelectedListeners = [];
                    this.itemViewDeselectedListeners = [];
                    this.componentAddedListeners = [];
                    this.componentRemovedListeners = [];
                    this.componentDuplicatedListeners = [];
                    this.componentInspectedListeners = [];
                    this.pageInspectedListeners = [];
                    this.componentLoadedListeners = [];
                    this.componentResetListeners = [];
                    this.liveEditPageViewReadyListeners = [];
                    this.liveEditPageInitErrorListeners = [];
                    this.fragmentCreatedListeners = [];
                    this.showWarningListeners = [];
                    this.editContentListeners = [];
                    this.createHtmlAreaDialogListeners = [];
                    this.liveEditIFrame = new api.dom.IFrameEl("live-edit-frame");
                    this.liveEditIFrame.onLoaded(function () { return _this.handleIFrameLoadedEvent(); });
                    this.loadMask = new api.ui.mask.LoadMask(this.liveEditIFrame);
                    this.dragMask = new api.ui.mask.DragMask(this.liveEditIFrame);
                    this.hideLoadMaskHandler = function () {
                        if (_this.loadMask.isVisible()) {
                            _this.loadMask.hide();
                        }
                    };
                    this.onLiveEditPageViewReady(function () {
                        _this.liveEditPageViewReady = true;
                        _this.hideLoadMaskHandler();
                    });
                    wizard.ShowContentFormEvent.on(this.hideLoadMaskHandler);
                    this.showLoadMaskHandler = function () {
                        if (!_this.liveEditPageViewReady && _this.liveEditIFrame.isVisible()) {
                            _this.loadMask.show();
                        }
                    };
                    wizard.ShowLiveEditEvent.on(this.showLoadMaskHandler);
                    wizard.ShowSplitEditEvent.on(this.showLoadMaskHandler);
                }
                LiveEditPageProxy.prototype.setModel = function (liveEditModel) {
                    this.liveEditModel = liveEditModel;
                };
                LiveEditPageProxy.prototype.setWidth = function (value) {
                    this.liveEditIFrame.getEl().setWidth(value);
                };
                LiveEditPageProxy.prototype.setWidthPx = function (value) {
                    this.liveEditIFrame.getEl().setWidthPx(value);
                };
                LiveEditPageProxy.prototype.setHeight = function (value) {
                    this.liveEditIFrame.getEl().setHeight(value);
                };
                LiveEditPageProxy.prototype.setHeightPx = function (value) {
                    this.liveEditIFrame.getEl().setHeightPx(value);
                };
                LiveEditPageProxy.prototype.getWidth = function () {
                    return this.liveEditIFrame.getEl().getWidth();
                };
                LiveEditPageProxy.prototype.getHeight = function () {
                    return this.liveEditIFrame.getEl().getHeight();
                };
                LiveEditPageProxy.prototype.getIFrame = function () {
                    return this.liveEditIFrame;
                };
                LiveEditPageProxy.prototype.getLoadMask = function () {
                    return this.loadMask;
                };
                LiveEditPageProxy.prototype.getJQuery = function () {
                    return this.livejq;
                };
                LiveEditPageProxy.prototype.createDraggable = function (item) {
                    this.liveEditWindow.api.liveedit.DragAndDrop.get().createDraggable(item);
                };
                LiveEditPageProxy.prototype.destroyDraggable = function (item) {
                    this.liveEditWindow.api.liveedit.DragAndDrop.get().destroyDraggable(item);
                };
                LiveEditPageProxy.prototype.getDragMask = function () {
                    return this.dragMask;
                };
                LiveEditPageProxy.prototype.remove = function () {
                    wizard.ShowLiveEditEvent.un(this.showLoadMaskHandler);
                    wizard.ShowSplitEditEvent.un(this.showLoadMaskHandler);
                    wizard.ShowContentFormEvent.un(this.hideLoadMaskHandler);
                    LiveEditPageViewReadyEvent.un(this.hideLoadMaskHandler);
                    this.dragMask.remove();
                    this.loadMask.remove();
                };
                LiveEditPageProxy.prototype.load = function () {
                    this.liveEditPageViewReady = false;
                    this.showLoadMaskHandler();
                    var contentId = this.liveEditModel.getContent().getContentId().toString();
                    var pageUrl = api.rendering.UriHelper.getPortalUri(contentId, RenderingMode.EDIT, Workspace.DRAFT);
                    if (LiveEditPageProxy.debug) {
                        console.log("LiveEditPageProxy.load pageUrl: " + pageUrl);
                    }
                    if (api.BrowserHelper.isIE()) {
                        this.copyObjectsBeforeFrameReloadForIE();
                    }
                    this.liveEditIFrame.setSrc(pageUrl);
                };
                LiveEditPageProxy.prototype.skipNextReloadConfirmation = function (skip) {
                    new api.liveedit.SkipLiveEditReloadConfirmationEvent(skip).fire(this.liveEditWindow);
                };
                LiveEditPageProxy.prototype.handleIFrameLoadedEvent = function () {
                    var liveEditWindow = this.liveEditIFrame.getHTMLElement()["contentWindow"];
                    if (liveEditWindow) {
                        if (liveEditWindow.wemjq) {
                            liveEditWindow.CONFIG = { baseUri: CONFIG.baseUri, assetsUri: CONFIG.assetsUri };
                            this.livejq = liveEditWindow.wemjq;
                            if (this.liveEditWindow) {
                                this.stopListening(this.liveEditWindow);
                            }
                            this.liveEditWindow = liveEditWindow;
                            this.listenToPage(this.liveEditWindow);
                            if (api.BrowserHelper.isIE()) {
                                this.resetObjectsAfterFrameReloadForIE();
                                this.disableLinksInLiveEditForIE();
                            }
                            new api.liveedit.InitializeLiveEditEvent(this.liveEditModel).fire(this.liveEditWindow);
                        }
                        else {
                            this.notifyLiveEditPageViewReady(new api.liveedit.LiveEditPageViewReadyEvent());
                        }
                    }
                    this.notifyLoaded();
                };
                LiveEditPageProxy.prototype.loadComponent = function (componentView, componentUrl) {
                    var _this = this;
                    var deferred = wemQ.defer();
                    api.util.assertNotNull(componentView, "componentView cannot be null");
                    api.util.assertNotNull(componentUrl, "componentUrl cannot be null");
                    wemjq.ajax({
                        url: componentUrl,
                        type: 'GET',
                        success: function (htmlAsString) {
                            var newElement = api.dom.Element.fromString(htmlAsString);
                            var itemViewIdProducer = componentView.getItemViewIdProducer();
                            var createViewConfig = new CreateItemViewConfig().
                                setItemViewProducer(itemViewIdProducer).
                                setParentView(componentView.getParentItemView()).
                                setData(componentView.getComponent()).
                                setElement(newElement);
                            var newComponentView = componentView.getType().
                                createView(createViewConfig);
                            componentView.replaceWith(newComponentView);
                            var event = new ComponentLoadedEvent(newComponentView, componentView);
                            event.fire(_this.liveEditWindow);
                            newComponentView.select();
                            newComponentView.hideContextMenu();
                            deferred.resolve("");
                        },
                        error: function (jqXHR, textStatus, errorThrow) {
                            var responseHtml = wemjq.parseHTML(jqXHR.responseText);
                            var errorMessage = "";
                            responseHtml.forEach(function (el, i) {
                                if (el.tagName && el.tagName.toLowerCase() == "title") {
                                    errorMessage = el.innerHTML;
                                }
                            });
                            deferred.reject(errorMessage);
                        }
                    });
                    return deferred.promise;
                };
                LiveEditPageProxy.prototype.stopListening = function (contextWindow) {
                    ImageOpenUploadDialogEvent.un(null, contextWindow);
                    ComponentViewDragStartedEvent.un(null, contextWindow);
                    ComponentViewDragStoppedEvent.un(null, contextWindow);
                    ComponentViewDragCanceledEvent.un(null, contextWindow);
                    ComponentViewDragDroppedEvent.un(null, contextWindow);
                    PageSelectedEvent.un(null, contextWindow);
                    PageLockedEvent.un(null, contextWindow);
                    PageUnlockedEvent.un(null, contextWindow);
                    PageUnloadedEvent.un(null, contextWindow);
                    PageTextModeStartedEvent.un(null, contextWindow);
                    RegionSelectedEvent.un(null, contextWindow);
                    ItemViewSelectedEvent.un(null, contextWindow);
                    ItemViewDeselectedEvent.un(null, contextWindow);
                    ComponentAddedEvent.un(null, contextWindow);
                    ComponentRemovedEvent.un(null, contextWindow);
                    ComponentDuplicatedEvent.un(null, contextWindow);
                    ComponentInspectedEvent.un(null, contextWindow);
                    PageInspectedEvent.un(null, contextWindow);
                    ComponentFragmentCreatedEvent.un(null, contextWindow);
                    ShowWarningLiveEditEvent.un(null, contextWindow);
                    ComponentLoadedEvent.un(null, contextWindow);
                    ComponentResetEvent.un(null, contextWindow);
                    LiveEditPageViewReadyEvent.un(null, contextWindow);
                    LiveEditPageInitializationErrorEvent.un(null, contextWindow);
                    CreateHtmlAreaDialogEvent.un(null, contextWindow);
                };
                LiveEditPageProxy.prototype.listenToPage = function (contextWindow) {
                    var _this = this;
                    ImageOpenUploadDialogEvent.on(function (openDialogEvent) {
                        var imageUploadDialog = new ImageUploadDialog(_this.liveEditModel.getContent().getContentId());
                        imageUploadDialog.onImageUploaded(function (event) {
                            new ImageUploadedEvent(event.getUploadItem().getModel(), openDialogEvent.getTargetImagePlaceholder()).fire(contextWindow);
                            imageUploadDialog.close();
                            imageUploadDialog.remove();
                        });
                        imageUploadDialog.open();
                    }, contextWindow);
                    ComponentViewDragStartedEvent.on(this.notifyComponentViewDragStarted.bind(this), contextWindow);
                    ComponentViewDragStoppedEvent.on(this.notifyComponentViewDragStopped.bind(this), contextWindow);
                    ComponentViewDragCanceledEvent.on(this.notifyComponentViewDragCanceled.bind(this), contextWindow);
                    ComponentViewDragDroppedEvent.on(this.notifyComponentViewDragDropped.bind(this), contextWindow);
                    PageSelectedEvent.on(this.notifyPageSelected.bind(this), contextWindow);
                    PageLockedEvent.on(this.notifyPageLocked.bind(this), contextWindow);
                    PageUnlockedEvent.on(this.notifyPageUnlocked.bind(this), contextWindow);
                    PageUnloadedEvent.on(this.notifyPageUnloaded.bind(this), contextWindow);
                    PageTextModeStartedEvent.on(this.notifyPageTextModeStarted.bind(this), contextWindow);
                    RegionSelectedEvent.on(this.notifyRegionSelected.bind(this), contextWindow);
                    ItemViewSelectedEvent.on(this.notifyItemViewSelected.bind(this), contextWindow);
                    ItemViewDeselectedEvent.on(this.notifyItemViewDeselected.bind(this), contextWindow);
                    ComponentAddedEvent.on(this.notifyComponentAdded.bind(this), contextWindow);
                    ComponentRemovedEvent.on(this.notifyComponentRemoved.bind(this), contextWindow);
                    ComponentDuplicatedEvent.on(this.notifyComponentDuplicated.bind(this), contextWindow);
                    ComponentInspectedEvent.on(this.notifyComponentInspected.bind(this), contextWindow);
                    PageInspectedEvent.on(this.notifyPageInspected.bind(this), contextWindow);
                    ComponentFragmentCreatedEvent.on(this.notifyFragmentCreated.bind(this), contextWindow);
                    ShowWarningLiveEditEvent.on(this.notifyShowWarning.bind(this), contextWindow);
                    EditContentEvent.on(this.notifyEditContent.bind(this), contextWindow);
                    ComponentLoadedEvent.on(this.notifyComponentLoaded.bind(this), contextWindow);
                    ComponentResetEvent.on(this.notifyComponentReset.bind(this), contextWindow);
                    LiveEditPageViewReadyEvent.on(this.notifyLiveEditPageViewReady.bind(this), contextWindow);
                    LiveEditPageInitializationErrorEvent.on(this.notifyLiveEditPageInitializationError.bind(this), contextWindow);
                    CreateHtmlAreaDialogEvent.on(this.notifyLiveEditPageDialogCreate.bind(this), contextWindow);
                };
                LiveEditPageProxy.prototype.onLoaded = function (listener) {
                    this.loadedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unLoaded = function (listener) {
                    this.loadedListeners = this.loadedListeners.filter(function (curr) {
                        return curr != listener;
                    });
                };
                LiveEditPageProxy.prototype.notifyLoaded = function () {
                    this.loadedListeners.forEach(function (listener) {
                        listener();
                    });
                };
                LiveEditPageProxy.prototype.onComponentViewDragStarted = function (listener) {
                    this.componentViewDragStartedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentViewDragStarted = function (listener) {
                    this.componentViewDragStartedListeners = this.componentViewDragStartedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentViewDragStarted = function (event) {
                    this.componentViewDragStartedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onComponentViewDragStopped = function (listener) {
                    this.componentViewDragStoppedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentViewDragStopped = function (listener) {
                    this.componentViewDragStoppedListeners = this.componentViewDragStoppedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentViewDragStopped = function (event) {
                    this.componentViewDragStoppedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onComponentViewDragCanceled = function (listener) {
                    this.componentViewDragCanceledListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentViewDragCanceled = function (listener) {
                    this.componentViewDragCanceledListeners = this.componentViewDragCanceledListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentViewDragCanceled = function (event) {
                    this.componentViewDragCanceledListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onComponentViewDragDropped = function (listener) {
                    this.componentViewDragDroppedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentViewDragDropped = function (listener) {
                    this.componentViewDragDroppedListeners = this.componentViewDragDroppedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentViewDragDropped = function (event) {
                    this.componentViewDragDroppedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onPageSelected = function (listener) {
                    this.pageSelectedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unPageSelected = function (listener) {
                    this.pageSelectedListeners = this.pageSelectedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyPageSelected = function (event) {
                    this.pageSelectedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onPageLocked = function (listener) {
                    this.pageLockedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unPageLocked = function (listener) {
                    this.pageLockedListeners = this.pageLockedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyPageLocked = function (event) {
                    this.pageLockedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onPageUnlocked = function (listener) {
                    this.pageUnlockedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unPageUnlocked = function (listener) {
                    this.pageUnlockedListeners = this.pageUnlockedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyPageUnlocked = function (event) {
                    this.pageUnlockedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onPageUnloaded = function (listener) {
                    this.pageUnloadedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unPageUnloaded = function (listener) {
                    this.pageUnloadedListeners = this.pageUnloadedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyPageUnloaded = function (event) {
                    this.pageUnloadedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onPageTextModeStarted = function (listener) {
                    this.pageTextModeStartedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unPageTextModeStarted = function (listener) {
                    this.pageTextModeStartedListeners = this.pageTextModeStartedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyPageTextModeStarted = function (event) {
                    this.pageTextModeStartedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onRegionSelected = function (listener) {
                    this.regionSelectedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unRegionSelected = function (listener) {
                    this.regionSelectedListeners = this.regionSelectedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyRegionSelected = function (event) {
                    this.regionSelectedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onItemViewSelected = function (listener) {
                    this.itemViewSelectedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unItemViewSelected = function (listener) {
                    this.itemViewSelectedListeners = this.itemViewSelectedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyItemViewSelected = function (event) {
                    this.itemViewSelectedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onItemViewDeselected = function (listener) {
                    this.itemViewDeselectedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unItemViewDeselected = function (listener) {
                    this.itemViewDeselectedListeners = this.itemViewDeselectedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyItemViewDeselected = function (event) {
                    this.itemViewDeselectedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onComponentAdded = function (listener) {
                    this.componentAddedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentAdded = function (listener) {
                    this.componentAddedListeners = this.componentAddedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentAdded = function (event) {
                    this.componentAddedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onComponentRemoved = function (listener) {
                    this.componentRemovedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentRemoved = function (listener) {
                    this.componentRemovedListeners = this.componentRemovedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentRemoved = function (event) {
                    this.componentRemovedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onComponentDuplicated = function (listener) {
                    this.componentDuplicatedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentDuplicated = function (listener) {
                    this.componentDuplicatedListeners = this.componentDuplicatedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentDuplicated = function (event) {
                    this.componentDuplicatedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onComponentInspected = function (listener) {
                    this.componentInspectedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentInspected = function (listener) {
                    this.componentInspectedListeners = this.componentInspectedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentInspected = function (event) {
                    this.componentInspectedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onPageInspected = function (listener) {
                    this.pageInspectedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unPageInspected = function (listener) {
                    this.pageInspectedListeners = this.pageInspectedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyPageInspected = function (event) {
                    this.pageInspectedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onComponentLoaded = function (listener) {
                    this.componentLoadedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentLoaded = function (listener) {
                    this.componentLoadedListeners = this.componentLoadedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentLoaded = function (event) {
                    this.componentLoadedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onComponentReset = function (listener) {
                    this.componentResetListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentReset = function (listener) {
                    this.componentResetListeners = this.componentResetListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyComponentReset = function (event) {
                    this.componentResetListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onLiveEditPageViewReady = function (listener) {
                    this.liveEditPageViewReadyListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unLiveEditPageViewReady = function (listener) {
                    this.liveEditPageViewReadyListeners = this.liveEditPageViewReadyListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyLiveEditPageViewReady = function (event) {
                    this.liveEditPageViewReadyListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onLiveEditPageInitializationError = function (listener) {
                    this.liveEditPageInitErrorListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unLiveEditPageInitializationError = function (listener) {
                    this.liveEditPageInitErrorListeners = this.liveEditPageInitErrorListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyLiveEditPageInitializationError = function (event) {
                    this.liveEditPageInitErrorListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onLiveEditPageDialogCreate = function (listener) {
                    this.createHtmlAreaDialogListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unLiveEditPageDialogCreate = function (listener) {
                    this.createHtmlAreaDialogListeners = this.createHtmlAreaDialogListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyLiveEditPageDialogCreate = function (event) {
                    this.createHtmlAreaDialogListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.notifyLiveEditPageDialogCreated = function (modalDialog, config) {
                    new LiveEditPageDialogCreatedEvent(modalDialog, config).fire(this.liveEditWindow);
                };
                LiveEditPageProxy.prototype.onComponentFragmentCreated = function (listener) {
                    this.fragmentCreatedListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unComponentFragmentCreated = function (listener) {
                    this.fragmentCreatedListeners = this.fragmentCreatedListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyFragmentCreated = function (event) {
                    this.fragmentCreatedListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onShowWarning = function (listener) {
                    this.showWarningListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unShowWarning = function (listener) {
                    this.showWarningListeners = this.showWarningListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyShowWarning = function (event) {
                    this.showWarningListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.onEditContent = function (listener) {
                    this.editContentListeners.push(listener);
                };
                LiveEditPageProxy.prototype.unEditContent = function (listener) {
                    this.editContentListeners = this.editContentListeners.filter(function (curr) { return (curr != listener); });
                };
                LiveEditPageProxy.prototype.notifyEditContent = function (event) {
                    this.editContentListeners.forEach(function (listener) { return listener(event); });
                };
                LiveEditPageProxy.prototype.copyObjectsBeforeFrameReloadForIE = function () {
                    this.copyControllerForIE();
                    this.copyRegionsForIE();
                };
                LiveEditPageProxy.prototype.copyControllerForIE = function () {
                    var controller = this.liveEditModel.getPageModel().getController();
                    if (controller) {
                        this.controllerCopyForIE = JSON.parse(JSON.stringify(controller));
                        this.controllerCopyForIE.key = controller.getKey().toString();
                    }
                };
                LiveEditPageProxy.prototype.copyRegionsForIE = function () {
                    var regions = this.liveEditModel.getPageModel().getRegions();
                    if (regions) {
                        this.regionsCopyForIE = JSON.parse(JSON.stringify(regions.toJson()));
                    }
                };
                LiveEditPageProxy.prototype.resetObjectsAfterFrameReloadForIE = function () {
                    this.resetControllerForIE();
                    this.resetRegionsForIE();
                };
                LiveEditPageProxy.prototype.resetControllerForIE = function () {
                    if (this.controllerCopyForIE) {
                        var controller = new api.content.page.PageDescriptorBuilder().fromJson(this.controllerCopyForIE).build();
                        this.liveEditModel.getPageModel().setControllerDescriptor(controller);
                    }
                };
                LiveEditPageProxy.prototype.resetRegionsForIE = function () {
                    if (this.regionsCopyForIE) {
                        var regions = api.content.page.region.Regions.create().fromJson(this.regionsCopyForIE, null).build();
                        this.liveEditModel.getPageModel().setRegions(regions);
                    }
                };
                LiveEditPageProxy.prototype.disableLinksInLiveEditForIE = function () {
                    if (this.livejq) {
                        this.livejq("a").attr("disabled", "disabled");
                    }
                };
                LiveEditPageProxy.debug = false;
                return LiveEditPageProxy;
            })();
            page.LiveEditPageProxy = LiveEditPageProxy;
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var page;
        (function (page) {
            var PageMode = api.content.page.PageMode;
            var PageModel = api.content.page.PageModel;
            var ImageComponent = api.content.page.region.ImageComponent;
            var DescriptorBasedComponent = api.content.page.region.DescriptorBasedComponent;
            var FragmentComponent = api.content.page.region.FragmentComponent;
            var InspectionsPanel = app.wizard.page.contextwindow.inspect.InspectionsPanel;
            var ContentInspectionPanel = app.wizard.page.contextwindow.inspect.ContentInspectionPanel;
            var PageInspectionPanel = app.wizard.page.contextwindow.inspect.page.PageInspectionPanel;
            var RegionInspectionPanel = app.wizard.page.contextwindow.inspect.region.RegionInspectionPanel;
            var ImageInspectionPanel = app.wizard.page.contextwindow.inspect.region.ImageInspectionPanel;
            var PartInspectionPanel = app.wizard.page.contextwindow.inspect.region.PartInspectionPanel;
            var LayoutInspectionPanel = app.wizard.page.contextwindow.inspect.region.LayoutInspectionPanel;
            var FragmentInspectionPanel = app.wizard.page.contextwindow.inspect.region.FragmentInspectionPanel;
            var TextInspectionPanel = app.wizard.page.contextwindow.inspect.region.TextInspectionPanel;
            var ContextWindow = app.wizard.page.contextwindow.ContextWindow;
            var EmulatorPanel = app.wizard.page.contextwindow.EmulatorPanel;
            var InsertablesPanel = app.wizard.page.contextwindow.insert.InsertablesPanel;
            var RenderingMode = api.rendering.RenderingMode;
            var ComponentView = api.liveedit.ComponentView;
            var PageView = api.liveedit.PageView;
            var ImageComponentView = api.liveedit.image.ImageComponentView;
            var PartComponentView = api.liveedit.part.PartComponentView;
            var LayoutComponentView = api.liveedit.layout.LayoutComponentView;
            var TextComponentView = api.liveedit.text.TextComponentView;
            var FragmentComponentView = api.liveedit.fragment.FragmentComponentView;
            var HTMLAreaDialogHandler = api.util.htmlarea.dialog.HTMLAreaDialogHandler;
            var Panel = api.ui.panel.Panel;
            var LiveFormPanel = (function (_super) {
                __extends(LiveFormPanel, _super);
                function LiveFormPanel(config) {
                    var _this = this;
                    _super.call(this, "live-form-panel");
                    this.contentWizardPanel = config.contentWizardPanel;
                    this.defaultModels = config.defaultModels;
                    this.pageLoading = false;
                    this.pageSkipReload = false;
                    this.lockPageAfterProxyLoad = false;
                    this.liveEditPageProxy = new page.LiveEditPageProxy();
                    this.contentInspectionPanel = new ContentInspectionPanel();
                    this.pageInspectionPanel = new PageInspectionPanel();
                    this.regionInspectionPanel = new RegionInspectionPanel();
                    this.imageInspectionPanel = new ImageInspectionPanel();
                    this.partInspectionPanel = new PartInspectionPanel();
                    this.layoutInspectionPanel = new LayoutInspectionPanel();
                    this.fragmentInspectionPanel = new FragmentInspectionPanel();
                    this.textInspectionPanel = new TextInspectionPanel();
                    api.dom.WindowDOM.get().onBeforeUnload(function (event) {
                        console.log("onbeforeunload " + _this.liveEditModel.getContent().getDisplayName());
                        _this.liveEditPageProxy.skipNextReloadConfirmation(true);
                    });
                    var saveAction = new api.ui.Action('Apply');
                    saveAction.onExecuted(function () {
                        if (!_this.pageView) {
                            _this.saveAndReloadPage();
                            return;
                        }
                        var itemView = _this.pageView.getSelectedView();
                        if (api.ObjectHelper.iFrameSafeInstanceOf(itemView, ComponentView)) {
                            _this.saveAndReloadOnlyComponent(itemView);
                        }
                        else if (_this.pageView.isLocked() || api.ObjectHelper.iFrameSafeInstanceOf(itemView, PageView)) {
                            _this.saveAndReloadPage();
                        }
                    });
                    this.inspectionsPanel = new InspectionsPanel({
                        contentInspectionPanel: this.contentInspectionPanel,
                        pageInspectionPanel: this.pageInspectionPanel,
                        regionInspectionPanel: this.regionInspectionPanel,
                        imageInspectionPanel: this.imageInspectionPanel,
                        partInspectionPanel: this.partInspectionPanel,
                        layoutInspectionPanel: this.layoutInspectionPanel,
                        fragmentInspectionPanel: this.fragmentInspectionPanel,
                        textInspectionPanel: this.textInspectionPanel,
                        saveAction: saveAction
                    });
                    this.emulatorPanel = new EmulatorPanel({
                        liveEditPage: this.liveEditPageProxy
                    });
                    this.insertablesPanel = new InsertablesPanel({
                        liveEditPage: this.liveEditPageProxy,
                        contentWizardPanel: config.contentWizardPanel,
                    });
                    this.frameContainer = new Panel("frame-container");
                    this.appendChild(this.frameContainer);
                    this.frameContainer.appendChild(this.liveEditPageProxy.getIFrame());
                    this.frameContainer.appendChild(this.liveEditPageProxy.getDragMask());
                    this.appendChild(this.liveEditPageProxy.getLoadMask());
                    this.contextWindow = new ContextWindow({
                        liveEditPage: this.liveEditPageProxy,
                        liveFormPanel: this,
                        inspectionPanel: this.inspectionsPanel,
                        emulatorPanel: this.emulatorPanel,
                        insertablesPanel: this.insertablesPanel
                    });
                    this.appendChild(this.contextWindow);
                    this.contextWindowController = new app.wizard.page.contextwindow.ContextWindowController(this.contextWindow, this.contentWizardPanel.getContextWindowToggler(), this.contentWizardPanel.getComponentsViewToggler());
                    this.contextWindow.onDisplayModeChanged(function () {
                        if (!_this.contextWindow.isFloating()) {
                            _this.contentWizardPanel.getContextWindowToggler().setActive(true);
                            _this.contextWindow.slideIn();
                        }
                    });
                    this.liveEditListen();
                }
                LiveFormPanel.prototype.remove = function () {
                    this.liveEditPageProxy.remove();
                    _super.prototype.remove.call(this);
                    return this;
                };
                LiveFormPanel.prototype.getPage = function () {
                    return this.pageModel.getPage();
                };
                LiveFormPanel.prototype.setModel = function (liveEditModel) {
                    var _this = this;
                    this.liveEditModel = liveEditModel;
                    this.content = liveEditModel.getContent();
                    this.insertablesPanel.setContent(this.content);
                    this.pageModel = liveEditModel.getPageModel();
                    this.pageModel.setIgnorePropertyChanges(true);
                    this.liveEditPageProxy.setModel(liveEditModel);
                    this.imageInspectionPanel.setModel(liveEditModel);
                    this.pageInspectionPanel.setModel(liveEditModel);
                    this.partInspectionPanel.setModel(liveEditModel);
                    this.layoutInspectionPanel.setModel(liveEditModel);
                    this.imageInspectionPanel.setModel(liveEditModel);
                    this.fragmentInspectionPanel.setModel(liveEditModel);
                    this.pageModel.setIgnorePropertyChanges(false);
                    this.pageModel.onPropertyChanged(function (event) {
                        // NB: To make the event.getSource() check work, all calls from this to PageModel that changes a property must done with this as eventSource argument.
                        if (event.getPropertyName() == PageModel.PROPERTY_CONTROLLER && _this !== event.getSource()) {
                            _this.saveAndReloadPage(false);
                        }
                        else if (event.getPropertyName() == PageModel.PROPERTY_TEMPLATE && _this !== event.getSource()) {
                            if (!(_this.pageModel.getDefaultPageTemplate().equals(_this.pageModel.getTemplate()) && !event.getOldValue() &&
                                !_this.pageModel.hasController())) {
                                _this.pageInspectionPanel.refreshInspectionHandler(liveEditModel);
                                _this.lockPageAfterProxyLoad = true;
                                _this.saveAndReloadPage(false);
                            }
                        }
                    });
                    this.pageModel.onComponentPropertyChangedEvent(function (event) {
                        if (api.ObjectHelper.iFrameSafeInstanceOf(event.getComponent(), DescriptorBasedComponent)) {
                            if (event.getPropertyName() == DescriptorBasedComponent.PROPERTY_DESCRIPTOR) {
                                var componentView = _this.pageView.getComponentViewByPath(event.getPath());
                                if (componentView) {
                                    if (api.ObjectHelper.iFrameSafeInstanceOf(componentView, PartComponentView)) {
                                        var partView = componentView;
                                        var partComponent = partView.getComponent();
                                        if (partComponent.hasDescriptor()) {
                                            _this.saveAndReloadOnlyComponent(componentView);
                                        }
                                    }
                                    else if (api.ObjectHelper.iFrameSafeInstanceOf(componentView, LayoutComponentView)) {
                                        var layoutView = componentView;
                                        var layoutComponent = layoutView.getComponent();
                                        if (layoutComponent.hasDescriptor()) {
                                            _this.saveAndReloadOnlyComponent(componentView);
                                        }
                                    }
                                }
                                else {
                                    console.debug("ComponentView by path not found: " + event.getPath().toString());
                                }
                            }
                        }
                        else if (api.ObjectHelper.iFrameSafeInstanceOf(event.getComponent(), ImageComponent)) {
                            if (event.getPropertyName() == ImageComponent.PROPERTY_IMAGE && !event.getComponent().isEmpty()) {
                                var componentView = _this.pageView.getComponentViewByPath(event.getPath());
                                if (componentView) {
                                    _this.saveAndReloadOnlyComponent(componentView);
                                }
                            }
                        }
                        else if (api.ObjectHelper.iFrameSafeInstanceOf(event.getComponent(), FragmentComponent)) {
                            if (event.getPropertyName() == FragmentComponent.PROPERTY_FRAGMENT && !event.getComponent().isEmpty()) {
                                var componentView = _this.pageView.getComponentViewByPath(event.getPath());
                                if (componentView) {
                                    _this.saveAndReloadOnlyComponent(componentView);
                                }
                            }
                        }
                    });
                };
                LiveFormPanel.prototype.skipNextReloadConfirmation = function (skip) {
                    this.liveEditPageProxy.skipNextReloadConfirmation(skip);
                };
                LiveFormPanel.prototype.loadPage = function () {
                    var _this = this;
                    if (this.pageSkipReload == false && !this.pageLoading) {
                        this.clearSelection();
                        this.pageLoading = true;
                        this.liveEditPageProxy.load();
                        this.liveEditPageProxy.onLoaded(function () {
                            _this.pageLoading = false;
                            if (_this.lockPageAfterProxyLoad) {
                                _this.pageView.setLocked(true);
                                _this.lockPageAfterProxyLoad = false;
                            }
                        });
                    }
                };
                LiveFormPanel.prototype.saveAndReloadPage = function (clearInspection) {
                    var _this = this;
                    if (clearInspection === void 0) { clearInspection = false; }
                    this.pageSkipReload = true;
                    this.contentWizardPanel.saveChanges().
                        then(function () {
                        _this.pageSkipReload = false;
                        if (clearInspection) {
                            _this.contextWindow.clearSelection();
                        }
                        _this.liveEditPageProxy.load();
                    }).
                        catch(function (reason) { return api.DefaultErrorHandler.handle(reason); }).
                        done();
                };
                LiveFormPanel.prototype.saveAndReloadOnlyComponent = function (componentView) {
                    var _this = this;
                    api.util.assertNotNull(componentView, "componentView cannot be null");
                    this.pageSkipReload = true;
                    var componentUrl = api.rendering.UriHelper.getComponentUri(this.content.getContentId().toString(), componentView.getComponentPath(), RenderingMode.EDIT, api.content.Branch.DRAFT);
                    this.contentWizardPanel.saveChanges().
                        then(function () {
                        _this.pageSkipReload = false;
                        componentView.showLoadingSpinner();
                        return _this.liveEditPageProxy.loadComponent(componentView, componentUrl);
                    }).
                        catch(function (errorMessage) {
                        api.DefaultErrorHandler.handle(errorMessage);
                        componentView.hideLoadingSpinner();
                        componentView.showRenderingError(componentUrl, errorMessage);
                    }).done();
                };
                LiveFormPanel.prototype.updateFrameContainerSize = function (contextWindowShown, contextWindowWidth) {
                    if (contextWindowShown && contextWindowWidth) {
                        this.frameContainer.getEl().setWidth("calc(100% - " + (contextWindowWidth - 1) + "px)");
                    }
                    else {
                        this.frameContainer.getEl().setWidth("100%");
                    }
                };
                LiveFormPanel.prototype.liveEditListen = function () {
                    var _this = this;
                    this.liveEditPageProxy.onPageLocked(function (event) {
                        _this.inspectPage();
                    });
                    this.liveEditPageProxy.onPageUnlocked(function (event) {
                        _this.contextWindow.clearSelection();
                    });
                    this.liveEditPageProxy.onLiveEditPageViewReady(function (event) {
                        _this.pageView = event.getPageView();
                        if (_this.pageView) {
                            _this.insertablesPanel.setPageView(_this.pageView);
                        }
                        else {
                            _this.contentWizardPanel.getContextWindowToggler().hide();
                            _this.contentWizardPanel.getComponentsViewToggler().hide();
                        }
                    });
                    this.liveEditPageProxy.onPageSelected(function (event) {
                        _this.inspectPage();
                    });
                    this.liveEditPageProxy.onRegionSelected(function (event) {
                        _this.inspectRegion(event.getRegionView());
                    });
                    this.liveEditPageProxy.onItemViewSelected(function (event) {
                        var itemView = event.getItemView();
                        var toggler = _this.contentWizardPanel.getContextWindowToggler();
                        if (api.ObjectHelper.iFrameSafeInstanceOf(itemView, ComponentView)) {
                            if (!_this.contextWindow.isFixed()) {
                                if (itemView.isEmpty() && event.isSilent()) {
                                    if (_this.contextWindow.isFloating() && _this.contextWindow.isShownOrAboutToBeShown()) {
                                        toggler.setActive(false);
                                    }
                                }
                                else if (event.isNew() && !toggler.isActive()) {
                                    toggler.setActive(true);
                                }
                            }
                            else {
                                _this.contextWindow.setFixed(false);
                            }
                            _this.inspectComponent(itemView);
                        }
                        if (!_this.pageView.isLocked()) {
                            _this.minimizeContentFormPanelIfNeeded();
                        }
                    });
                    this.liveEditPageProxy.onItemViewDeselected(function (event) {
                        var toggler = _this.contentWizardPanel.getContextWindowToggler();
                        if (!toggler.isActive() && _this.contextWindow.isShownOrAboutToBeShown()) {
                            _this.contextWindow.slideOut();
                        }
                        else if (toggler.isActive() && !_this.contextWindow.isShownOrAboutToBeShown()) {
                            _this.contextWindow.slideIn();
                        }
                        _this.clearSelection();
                    });
                    this.liveEditPageProxy.onComponentAdded(function (event) {
                        if (api.ObjectHelper.iFrameSafeInstanceOf(event.getComponentView(), TextComponentView)) {
                            _this.minimizeContentFormPanelIfNeeded();
                        }
                    });
                    this.liveEditPageProxy.onComponentRemoved(function (event) {
                        if (!_this.pageModel.isPageTemplate() && _this.pageModel.getMode() == PageMode.AUTOMATIC) {
                            _this.pageModel.initializePageFromDefault(_this);
                        }
                        _this.clearSelection();
                    });
                    this.liveEditPageProxy.onComponentViewDragDropped(function (event) {
                        var componentView = event.getComponentView();
                        if (!componentView.isEmpty()) {
                            _this.inspectComponent(componentView);
                        }
                    });
                    this.liveEditPageProxy.onComponentDuplicated(function (event) {
                        _this.saveAndReloadOnlyComponent(event.getDuplicatedComponentView());
                    });
                    this.liveEditPageProxy.onComponentInspected(function (event) {
                        var componentView = event.getComponentView();
                        _this.contentWizardPanel.getContextWindowToggler().setActive(true);
                        _this.contextWindow.slideIn();
                        _this.inspectComponent(componentView);
                    });
                    this.liveEditPageProxy.onPageInspected(function (event) {
                        _this.contentWizardPanel.getContextWindowToggler().setActive(true);
                        _this.contextWindow.slideIn();
                        _this.inspectPage();
                    });
                    this.liveEditPageProxy.onComponentFragmentCreated(function (event) {
                        var fragmentView = event.getComponentView();
                        var componentType = event.getSourceComponentType().getShortName();
                        var componentName = fragmentView.getComponent().getName().toString();
                        api.notify.showSuccess("Fragment created from '" + componentName + "' " + componentType + ".");
                        _this.saveAndReloadOnlyComponent(event.getComponentView());
                        var summaryAndStatus = api.content.ContentSummaryAndCompareStatus.fromContentSummary(event.getFragmentContent());
                        new api.content.event.EditContentEvent([summaryAndStatus]).fire();
                    });
                    this.liveEditPageProxy.onShowWarning(function (event) {
                        api.notify.showWarning(event.getMessage());
                    });
                    this.liveEditPageProxy.onEditContent(function (event) {
                        new api.content.event.EditContentEvent(event.getModels()).fire();
                    });
                    this.liveEditPageProxy.onLiveEditPageInitializationError(function (event) {
                        api.notify.showError(event.getMessage(), false);
                        new app.wizard.ShowContentFormEvent().fire();
                        _this.contentWizardPanel.showForm();
                    });
                    this.liveEditPageProxy.onPageUnloaded(function (event) {
                        _this.contentWizardPanel.close();
                    });
                    this.liveEditPageProxy.onLiveEditPageDialogCreate(function (event) {
                        var modalDialog = HTMLAreaDialogHandler.createAndOpenDialog(event);
                        _this.liveEditPageProxy.notifyLiveEditPageDialogCreated(modalDialog, event.getConfig());
                    });
                    this.liveEditPageProxy.onPageTextModeStarted(function () {
                        setTimeout(function () {
                            _this.minimizeContentFormPanelIfNeeded();
                        }, 200);
                    });
                };
                LiveFormPanel.prototype.shade = function () {
                    api.liveedit.Shader.get().shade(this);
                };
                LiveFormPanel.prototype.minimizeContentFormPanelIfNeeded = function () {
                    if (this.contextWindow.isFloating() && !this.contentWizardPanel.isMinimized()) {
                        this.contentWizardPanel.toggleMinimize();
                    }
                };
                LiveFormPanel.prototype.inspectPage = function () {
                    this.contextWindow.showInspectionPanel(this.pageInspectionPanel);
                };
                LiveFormPanel.prototype.clearSelection = function () {
                    var pageModel = this.liveEditModel.getPageModel();
                    var customizedWithController = pageModel.isCustomized() && pageModel.hasController();
                    var isFragmentContent = pageModel.getMode() === PageMode.FRAGMENT;
                    if (pageModel.hasDefaultPageTemplate() || customizedWithController || isFragmentContent) {
                        this.contextWindow.clearSelection();
                    }
                    else {
                        this.inspectPage();
                    }
                };
                LiveFormPanel.prototype.clearPageViewSelectionAndOpenInspectPage = function () {
                    if (this.pageView && this.pageView.hasSelectedView()) {
                        this.pageView.getSelectedView().deselect();
                    }
                    this.contextWindow.showInspectionPanel(this.pageInspectionPanel);
                };
                LiveFormPanel.prototype.inspectRegion = function (regionView) {
                    var region = regionView.getRegion();
                    this.regionInspectionPanel.setRegion(region);
                    this.contextWindow.showInspectionPanel(this.regionInspectionPanel);
                };
                LiveFormPanel.prototype.inspectComponent = function (componentView) {
                    api.util.assertNotNull(componentView, "componentView cannot be null");
                    if (api.ObjectHelper.iFrameSafeInstanceOf(componentView, ImageComponentView)) {
                        this.imageInspectionPanel.setImageComponent(componentView);
                        this.contextWindow.showInspectionPanel(this.imageInspectionPanel);
                    }
                    else if (api.ObjectHelper.iFrameSafeInstanceOf(componentView, PartComponentView)) {
                        this.partInspectionPanel.setPartComponent(componentView);
                        this.contextWindow.showInspectionPanel(this.partInspectionPanel);
                    }
                    else if (api.ObjectHelper.iFrameSafeInstanceOf(componentView, LayoutComponentView)) {
                        this.layoutInspectionPanel.setLayoutComponent(componentView);
                        this.contextWindow.showInspectionPanel(this.layoutInspectionPanel);
                    }
                    else if (api.ObjectHelper.iFrameSafeInstanceOf(componentView, TextComponentView)) {
                        this.textInspectionPanel.setTextComponent(componentView);
                        this.contextWindow.showInspectionPanel(this.textInspectionPanel);
                    }
                    else if (api.ObjectHelper.iFrameSafeInstanceOf(componentView, FragmentComponentView)) {
                        this.fragmentInspectionPanel.setFragmentComponent(componentView);
                        this.contextWindow.showInspectionPanel(this.fragmentInspectionPanel);
                    }
                    else {
                        throw new Error("ComponentView cannot be selected: " + api.ClassHelper.getClassName(componentView));
                    }
                };
                return LiveFormPanel;
            })(api.ui.panel.Panel);
            page.LiveFormPanel = LiveFormPanel;
        })(page = wizard.page || (wizard.page = {}));
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='DefaultModels.ts' />
///<reference path='DefaultModelsFactory.ts' />
///<reference path='LiveEditPageProxy.ts' />
///<reference path='LiveFormPanel.ts' /> 
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var ContentSettingsModel = (function () {
            function ContentSettingsModel(content) {
                this.propertyChangedListeners = [];
                this.language = content.getLanguage();
                this.owner = content.getOwner();
            }
            ContentSettingsModel.prototype.getOwner = function () {
                return this.owner;
            };
            ContentSettingsModel.prototype.setOwner = function (owner, silent) {
                if (!silent) {
                    var event = new api.PropertyChangedEvent(ContentSettingsModel.PROPERTY_OWNER, this.owner, owner);
                    this.notifyPropertyChanged(event);
                }
                this.owner = owner;
                return this;
            };
            ContentSettingsModel.prototype.getLanguage = function () {
                return this.language;
            };
            ContentSettingsModel.prototype.setLanguage = function (lang, silent) {
                if (!silent) {
                    var event = new api.PropertyChangedEvent(ContentSettingsModel.PROPERTY_LANG, this.language, lang);
                    this.notifyPropertyChanged(event);
                }
                this.language = lang;
                return this;
            };
            ContentSettingsModel.prototype.onPropertyChanged = function (listener) {
                this.propertyChangedListeners.push(listener);
            };
            ContentSettingsModel.prototype.unPropertyChanged = function (listener) {
                this.propertyChangedListeners =
                    this.propertyChangedListeners.filter(function (curr) { return (curr != listener); });
            };
            ContentSettingsModel.prototype.notifyPropertyChanged = function (event) {
                this.propertyChangedListeners.forEach(function (listener) { return listener(event); });
            };
            ContentSettingsModel.prototype.equals = function (other) {
                if (!api.ObjectHelper.iFrameSafeInstanceOf(other, ContentSettingsModel)) {
                    return false;
                }
                else {
                    var otherModel = other;
                    return otherModel.owner == this.owner && otherModel.language == this.language;
                }
            };
            ContentSettingsModel.prototype.apply = function (builder) {
                builder.owner = this.owner;
                builder.language = this.language;
            };
            ContentSettingsModel.PROPERTY_OWNER = 'owner';
            ContentSettingsModel.PROPERTY_LANG = 'language';
            return ContentSettingsModel;
        })();
        wizard.ContentSettingsModel = ContentSettingsModel;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var FormView = api.form.FormView;
        var WizardStepValidityChangedEvent = api.app.wizard.WizardStepValidityChangedEvent;
        var ContentWizardStepForm = (function (_super) {
            __extends(ContentWizardStepForm, _super);
            function ContentWizardStepForm() {
                _super.call(this);
            }
            ContentWizardStepForm.prototype.update = function (data, unchangedOnly) {
                if (unchangedOnly === void 0) { unchangedOnly = true; }
                this.data = data;
                return this.formView.update(data.getRoot(), unchangedOnly);
            };
            ContentWizardStepForm.prototype.layout = function (formContext, data, form) {
                var _this = this;
                this.formContext = formContext;
                this.form = form;
                this.data = data;
                return this.doLayout(form, data).then(function () {
                    if (form.getFormItems().length === 0) {
                        _this.hide();
                    }
                });
            };
            ContentWizardStepForm.prototype.doLayout = function (form, data) {
                var _this = this;
                this.formView = new FormView(this.formContext, form, data.getRoot());
                return this.formView.layout().then(function () {
                    _this.formView.onFocus(function (event) {
                        _this.notifyFocused(event);
                    });
                    _this.formView.onBlur(function (event) {
                        _this.notifyBlurred(event);
                    });
                    _this.appendChild(_this.formView);
                    _this.formView.onValidityChanged(function (event) {
                        _this.previousValidation = event.getRecording();
                        _this.notifyValidityChanged(new WizardStepValidityChangedEvent(event.isValid()));
                    });
                    var formViewValid = _this.formView.isValid();
                    _this.notifyValidityChanged(new WizardStepValidityChangedEvent(formViewValid));
                });
            };
            ContentWizardStepForm.prototype.validate = function (silent) {
                return this.formView.validate(silent);
            };
            ContentWizardStepForm.prototype.displayValidationErrors = function (display) {
                this.formView.displayValidationErrors(display);
            };
            ContentWizardStepForm.prototype.getForm = function () {
                return this.form;
            };
            ContentWizardStepForm.prototype.getFormView = function () {
                return this.formView;
            };
            ContentWizardStepForm.prototype.getData = function () {
                return this.data;
            };
            ContentWizardStepForm.prototype.giveFocus = function () {
                return this.formView.giveFocus();
            };
            return ContentWizardStepForm;
        })(api.app.wizard.WizardStepForm);
        wizard.ContentWizardStepForm = ContentWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var PrincipalType = api.security.PrincipalType;
        var PrincipalLoader = api.security.PrincipalLoader;
        var FormItemBuilder = api.ui.form.FormItemBuilder;
        var PrincipalComboBox = api.ui.security.PrincipalComboBox;
        var LocaleComboBox = api.ui.locale.LocaleComboBox;
        var SettingsWizardStepForm = (function (_super) {
            __extends(SettingsWizardStepForm, _super);
            function SettingsWizardStepForm() {
                var _this = this;
                _super.call(this, "settings-wizard-step-form");
                this.updateUnchangedOnly = false;
                this.ignorePropertyChange = false;
                this.modelChangeListener = function (event) {
                    if (!_this.ignorePropertyChange) {
                        var value = event.getNewValue();
                        switch (event.getPropertyName()) {
                            case wizard.ContentSettingsModel.PROPERTY_LANG:
                                if (!_this.updateUnchangedOnly || !_this.localeCombo.isDirty()) {
                                    _this.localeCombo.setValue(value ? value.toString() : "");
                                }
                                break;
                            case wizard.ContentSettingsModel.PROPERTY_OWNER:
                                if (!_this.updateUnchangedOnly || !_this.ownerCombo.isDirty()) {
                                    _this.ownerCombo.setValue(value ? value.toString() : "");
                                }
                                break;
                        }
                    }
                };
            }
            SettingsWizardStepForm.prototype.layout = function (content) {
                var _this = this;
                this.content = content;
                this.localeCombo = new LocaleComboBox(1, content.getLanguage());
                var localeFormItem = new FormItemBuilder(this.localeCombo).
                    setLabel('Language').
                    build();
                var loader = new PrincipalLoader().setAllowedTypes([PrincipalType.USER]);
                this.ownerCombo = new PrincipalComboBox(loader, 1, content.getOwner() ? content.getOwner().toString() : undefined);
                var ownerFormItem = new FormItemBuilder(this.ownerCombo).
                    setLabel('Owner').
                    build();
                var fieldSet = new api.ui.form.Fieldset();
                fieldSet.add(localeFormItem);
                fieldSet.add(ownerFormItem);
                var form = new api.ui.form.Form().add(fieldSet);
                this.appendChild(form);
                form.onFocus(function (event) {
                    _this.notifyFocused(event);
                });
                form.onBlur(function (event) {
                    _this.notifyBlurred(event);
                });
                this.setModel(new wizard.ContentSettingsModel(content));
            };
            SettingsWizardStepForm.prototype.update = function (content, unchangedOnly) {
                if (unchangedOnly === void 0) { unchangedOnly = true; }
                this.updateUnchangedOnly = unchangedOnly;
                this.model.setOwner(content.getOwner()).setLanguage(content.getLanguage());
            };
            SettingsWizardStepForm.prototype.setModel = function (model) {
                var _this = this;
                api.util.assertNotNull(model, "Model can't be null");
                if (this.model) {
                    model.unPropertyChanged(this.modelChangeListener);
                }
                var ownerListener = function () {
                    var principals = _this.ownerCombo.getSelectedDisplayValues();
                    _this.ignorePropertyChange = true;
                    model.setOwner(principals.length > 0 ? principals[0].getKey() : null);
                    _this.ignorePropertyChange = false;
                };
                this.ownerCombo.onOptionSelected(function (event) { return ownerListener(); });
                this.ownerCombo.onOptionDeselected(function (option) { return ownerListener(); });
                var localeListener = function () {
                    _this.ignorePropertyChange = true;
                    model.setLanguage(_this.localeCombo.getValue());
                    _this.ignorePropertyChange = false;
                };
                this.localeCombo.onOptionSelected(function (event) { return localeListener(); });
                this.localeCombo.onOptionDeselected(function (option) { return localeListener(); });
                model.onPropertyChanged(this.modelChangeListener);
                this.model = model;
            };
            SettingsWizardStepForm.prototype.getModel = function () {
                return this.model;
            };
            SettingsWizardStepForm.prototype.giveFocus = function () {
                return this.ownerCombo.giveFocus();
            };
            return SettingsWizardStepForm;
        })(api.app.wizard.WizardStepForm);
        wizard.SettingsWizardStepForm = SettingsWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var AccessControlListView = api.ui.security.acl.AccessControlListView;
        var DivEl = api.dom.DivEl;
        var LabelEl = api.dom.LabelEl;
        var Button = api.ui.button.Button;
        var SecurityWizardStepForm = (function (_super) {
            __extends(SecurityWizardStepForm, _super);
            function SecurityWizardStepForm() {
                var _this = this;
                _super.call(this, "security-wizard-step-form");
                var label = new DivEl("input-label"), wrapper = new DivEl("wrapper required");
                this.label = new LabelEl("Permissions");
                wrapper.appendChild(this.label);
                label.appendChild(wrapper);
                this.inheritance = new DivEl();
                this.accessListView = new AccessControlListView();
                this.accessListView.setItemsEditable(false);
                this.editLink = new Button("Edit Permissions");
                this.editLink.addClass("edit-permissions");
                this.editLink.onFocus(function (event) {
                    _this.notifyFocused(event);
                });
                this.editLink.onBlur(function (event) {
                    _this.notifyBlurred(event);
                });
                var formView = new DivEl("form-view"), inputView = new DivEl("input-view valid"), inputTypeView = new DivEl("input-type-view"), inputOccurrenceView = new DivEl("input-occurrence-view single-occurrence"), inputWrapper = new DivEl("input-wrapper");
                inputWrapper.appendChildren(this.inheritance, this.accessListView, this.editLink);
                inputOccurrenceView.appendChild(inputWrapper);
                inputTypeView.appendChild(inputOccurrenceView);
                inputView.appendChildren(label, inputTypeView);
                formView.appendChild(inputView);
                this.appendChild(formView);
                this.editLink.onClicked(function () {
                    if (!!_this.content) {
                        new api.content.OpenEditPermissionsDialogEvent(_this.content).fire();
                    }
                });
                wizard.ContentPermissionsAppliedEvent.on(function (event) {
                    var content = event.getContent();
                    if (content.getId() === _this.content.getId()) {
                        _this.layout(content);
                    }
                });
            }
            SecurityWizardStepForm.prototype.layout = function (content) {
                var _this = this;
                this.accessListView.clearItems();
                content.getPermissions().getEntries().sort().forEach(function (entry) {
                    _this.accessListView.addItem(entry);
                    var entryView = _this.accessListView.getItemView(entry), selector = entryView.getPermissionSelector();
                    entryView.getValueChangedListeners().splice(0);
                    entryView.getPermissionSelector().hide();
                    entryView.onClicked(function () {
                        var isDisplayed = selector.getEl().getDisplay() !== "block";
                        _this.accessListView.getItemViews().forEach(function (itemView) {
                            itemView.getPermissionSelector().hide();
                        });
                        if (isDisplayed) {
                            selector.show();
                        }
                    });
                });
                var inheritsText = "";
                if (content.isInheritPermissionsEnabled() && content.isRoot() == false) {
                    inheritsText = "Inherits permissions from parent";
                    this.inheritance.addClass("inheritance");
                }
                else {
                    this.inheritance.removeClass("inheritance");
                }
                this.inheritance.setHtml(inheritsText);
                this.content = content;
            };
            SecurityWizardStepForm.prototype.update = function (content, unchangedOnly) {
                if (unchangedOnly === void 0) { unchangedOnly = true; }
                this.layout(content);
            };
            SecurityWizardStepForm.prototype.giveFocus = function () {
                return this.accessListView.giveFocus();
            };
            return SecurityWizardStepForm;
        })(api.app.wizard.WizardStepForm);
        wizard.SecurityWizardStepForm = SecurityWizardStepForm;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var CycleButton = api.ui.button.CycleButton;
        var TogglerButton = api.ui.button.TogglerButton;
        var ContentWizardToolbar = (function (_super) {
            __extends(ContentWizardToolbar, _super);
            function ContentWizardToolbar(params) {
                _super.call(this, "content-wizard-toolbar");
                _super.prototype.addAction.call(this, params.saveAction);
                _super.prototype.addAction.call(this, params.deleteAction);
                _super.prototype.addAction.call(this, params.duplicateAction);
                _super.prototype.addAction.call(this, params.previewAction);
                _super.prototype.addGreedySpacer.call(this);
                this.cycleViewModeButton = new CycleButton([params.showLiveEditAction, params.showFormAction]);
                this.componentsViewToggler = new TogglerButton("icon-clipboard", "Show Component View");
                this.contextWindowToggler = new TogglerButton("icon-cog", "Show Inspection Panel");
                this.contentWizardToolbarPublishControls = new wizard.ContentWizardToolbarPublishControls(params.publishAction);
                _super.prototype.addElement.call(this, this.contentWizardToolbarPublishControls);
                _super.prototype.addElement.call(this, this.componentsViewToggler);
                _super.prototype.addElement.call(this, this.contextWindowToggler);
                _super.prototype.addElement.call(this, this.cycleViewModeButton);
            }
            ContentWizardToolbar.prototype.getCycleViewModeButton = function () {
                return this.cycleViewModeButton;
            };
            ContentWizardToolbar.prototype.getContextWindowToggler = function () {
                return this.contextWindowToggler;
            };
            ContentWizardToolbar.prototype.getComponentsViewToggler = function () {
                return this.componentsViewToggler;
            };
            ContentWizardToolbar.prototype.getContentWizardToolbarPublishControls = function () {
                return this.contentWizardToolbarPublishControls;
            };
            return ContentWizardToolbar;
        })(api.ui.toolbar.Toolbar);
        wizard.ContentWizardToolbar = ContentWizardToolbar;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var DisplayNameScriptExecutor = (function () {
            function DisplayNameScriptExecutor() {
            }
            DisplayNameScriptExecutor.prototype.setFormView = function (value) {
                this.formView = value;
                return this;
            };
            DisplayNameScriptExecutor.prototype.setScript = function (value) {
                this.script = value;
                return this;
            };
            DisplayNameScriptExecutor.prototype.hasScript = function () {
                return !api.util.StringHelper.isBlank(this.script);
            };
            DisplayNameScriptExecutor.prototype.execute = function () {
                api.util.assertNotNull(this.formView, "formView not set");
                api.util.assertNotNull(this.script, "script not set");
                return this.safeEval(this.script, this.formView);
            };
            DisplayNameScriptExecutor.prototype.safeEval = function (script, formView) {
                function $() {
                    var paths = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        paths[_i - 0] = arguments[_i];
                    }
                    var strValues = [];
                    paths.forEach(function (path) {
                        var strValue = formView.getData().getString(path);
                        if (!api.util.StringHelper.isBlank(strValue)) {
                            strValues.push(strValue);
                        }
                    });
                    var strValue = "";
                    strValues.forEach(function (s, index) {
                        strValue += s;
                        if (index < strValues.length - 1) {
                            strValue += " ";
                        }
                    });
                    return strValue;
                }
                var result = '';
                try {
                    result = eval('var eval; var Function; var document; var location; ' +
                        'var window; var parent; var self; var top; ' +
                        script);
                }
                catch (e) {
                    console.error('Cannot evaluate script [' + script + '].', e);
                }
                return result;
            };
            return DisplayNameScriptExecutor;
        })();
        wizard.DisplayNameScriptExecutor = DisplayNameScriptExecutor;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app_1) {
    var wizard;
    (function (wizard_6) {
        var PropertyTree = api.data.PropertyTree;
        var ContentFormContext = api.content.form.ContentFormContext;
        var CompareStatus = api.content.CompareStatus;
        var ContentBuilder = api.content.ContentBuilder;
        var ContentName = api.content.ContentName;
        var ContentUnnamed = api.content.ContentUnnamed;
        var CreateContentRequest = api.content.CreateContentRequest;
        var UpdateContentRequest = api.content.UpdateContentRequest;
        var GetContentByIdRequest = api.content.GetContentByIdRequest;
        var ContentIconUrlResolver = api.content.ContentIconUrlResolver;
        var ExtraData = api.content.ExtraData;
        var SiteModel = api.content.site.SiteModel;
        var LiveEditModel = api.liveedit.LiveEditModel;
        var GetNearestSiteRequest = api.content.GetNearestSiteRequest;
        var ConfirmationDialog = api.ui.dialog.ConfirmationDialog;
        var ResponsiveManager = api.ui.responsive.ResponsiveManager;
        var ResponsiveRanges = api.ui.responsive.ResponsiveRanges;
        var ThumbnailUploader = api.content.ThumbnailUploaderEl;
        var WizardHeaderWithDisplayNameAndNameBuilder = api.app.wizard.WizardHeaderWithDisplayNameAndNameBuilder;
        var WizardStep = api.app.wizard.WizardStep;
        var ContentRequiresSaveEvent = api.content.ContentRequiresSaveEvent;
        var ImageErrorEvent = api.content.ImageErrorEvent;
        var MixinName = api.schema.mixin.MixinName;
        var MixinNames = api.schema.mixin.MixinNames;
        var GetMixinByQualifiedNameRequest = api.schema.mixin.GetMixinByQualifiedNameRequest;
        var ContentDeletedEvent = api.content.event.ContentDeletedEvent;
        var ContentUpdatedEvent = api.content.event.ContentUpdatedEvent;
        var ContentPublishedEvent = api.content.event.ContentPublishedEvent;
        var ContentsPublishedEvent = api.content.event.ContentsPublishedEvent;
        var ContentNamedEvent = api.content.event.ContentNamedEvent;
        var ActiveContentVersionSetEvent = api.content.event.ActiveContentVersionSetEvent;
        var DialogButton = api.ui.dialog.DialogButton;
        var ContentWizardPanel = (function (_super) {
            __extends(ContentWizardPanel, _super);
            function ContentWizardPanel(params, onSuccess, onError) {
                var _this = this;
                this.constructing = true;
                this.isContentFormValid = false;
                this.isSecurityWizardStepFormAllowed = false;
                this.requireValid = false;
                this.contentNamedListeners = [];
                this.parentContent = params.parentContent;
                this.defaultModels = params.defaultModels;
                this.site = params.site;
                this.contentType = params.contentType;
                this.displayNameScriptExecutor = new wizard_6.DisplayNameScriptExecutor();
                this.contentWizardHeader = new WizardHeaderWithDisplayNameAndNameBuilder().
                    setDisplayNameGenerator(this.displayNameScriptExecutor).
                    build();
                this.thumbnailUploader = new ThumbnailUploader({
                    name: 'thumbnail-uploader',
                    disabled: params.contentType.isImage(),
                    deferred: true
                });
                this.wizardActions = new app.wizard.action.ContentWizardActions(this);
                this.previewAction = this.wizardActions.getPreviewAction();
                this.publishAction = this.wizardActions.getPublishAction();
                var mainToolbar = new wizard_6.ContentWizardToolbar({
                    saveAction: this.wizardActions.getSaveAction(),
                    deleteAction: this.wizardActions.getDeleteAction(),
                    duplicateAction: this.wizardActions.getDuplicateAction(),
                    previewAction: this.wizardActions.getPreviewAction(),
                    publishAction: this.wizardActions.getPublishAction(),
                    showLiveEditAction: this.wizardActions.getShowLiveEditAction(),
                    showFormAction: this.wizardActions.getShowFormAction(),
                    showSplitEditAction: this.wizardActions.getShowSplitEditAction()
                });
                this.contextWindowToggler = mainToolbar.getContextWindowToggler();
                this.componentsViewToggler = mainToolbar.getComponentsViewToggler();
                this.cycleViewModeButton = mainToolbar.getCycleViewModeButton();
                this.contentWizardToolbarPublishControls = mainToolbar.getContentWizardToolbarPublishControls();
                this.showLiveEditAction = this.wizardActions.getShowLiveEditAction();
                this.showSplitEditAction = this.wizardActions.getShowSplitEditAction();
                this.showLiveEditAction.setEnabled(false);
                if (this.parentContent) {
                    this.contentWizardHeader.setPath(this.parentContent.getPath().prettifyUnnamedPathElements().toString() + "/");
                }
                else {
                    this.contentWizardHeader.setPath("/");
                }
                this.createSite = params.createSite;
                if (this.createSite || (params.persistedContent && params.persistedContent.isSite())) {
                    this.thumbnailUploader.addClass("site");
                }
                this.contentWizardStepForm = new wizard_6.ContentWizardStepForm();
                this.metadataStepFormByName = {};
                this.settingsWizardStepForm = new wizard_6.SettingsWizardStepForm();
                this.securityWizardStepForm = new wizard_6.SecurityWizardStepForm();
                wizard_6.ContentPermissionsAppliedEvent.on(function (event) { return _this.contentPermissionsUpdated(event.getContent()); });
                this.dataChangedListener = function () {
                    if (_this.isContentFormValid && _this.contentWizardToolbarPublishControls.isOnline()) {
                        _this.contentWizardToolbarPublishControls.setCompareStatus(CompareStatus.NEWER);
                    }
                };
                this.applicationAddedListener = function (event) {
                    _this.addMetadataStepForms(event.getApplicationKey());
                };
                this.applicationRemovedListener = function (event) {
                    _this.removeMetadataStepForms();
                };
                var isSiteOrWithinSite = this.site || this.createSite;
                var isPageTemplate = this.contentType.getContentTypeName().isPageTemplate();
                var isShortcut = this.contentType.getContentTypeName().isShortcut();
                if ((isSiteOrWithinSite || isPageTemplate) && !isShortcut) {
                    this.liveFormPanel = new wizard_6.page.LiveFormPanel({
                        contentWizardPanel: this,
                        contentType: this.contentType.getContentTypeName(),
                        defaultModels: params.defaultModels
                    });
                }
                if (this.contentType.hasContentDisplayNameScript()) {
                    this.displayNameScriptExecutor.setScript(this.contentType.getContentDisplayNameScript());
                }
                _super.call(this, {
                    tabId: params.tabId,
                    persistedItem: params.persistedContent,
                    formIcon: this.thumbnailUploader,
                    mainToolbar: mainToolbar,
                    header: this.contentWizardHeader,
                    actions: this.wizardActions,
                    livePanel: this.liveFormPanel,
                    split: !!this.liveFormPanel
                }, function () {
                    _this.onValidityChanged(function (event) {
                        _this.isContentFormValid = _this.isValid();
                        _this.thumbnailUploader.toggleClass("invalid", !_this.isValid());
                        _this.contentWizardToolbarPublishControls.setContentCanBePublished(_this.checkContentCanBePublished(false));
                    });
                    _this.addClass("content-wizard-panel");
                    if (_this.getSplitPanel()) {
                        _this.getSplitPanel().addClass("prerendered");
                    }
                    _this.inMobileViewMode = false;
                    var responsiveItem = ResponsiveManager.onAvailableSizeChanged(_this, _this.availableSizeChangedHandler.bind(_this));
                    _this.onRemoved(function (event) {
                        ResponsiveManager.unAvailableSizeChanged(_this);
                    });
                    _this.initOnShownHandler(responsiveItem);
                    if (_this.thumbnailUploader) {
                        _this.listenToFileUploaded();
                    }
                    _this.constructing = false;
                    onSuccess(_this);
                }, onError);
                this.initPublishButtonForMobile();
                this.handleSiteConfigApply();
                this.handleBrokenImageInTheWizard();
                api.app.wizard.MaskContentWizardPanelEvent.on(function (event) {
                    if (_this.getPersistedItem().getContentId().equals(event.getContentId())) {
                        _this.actions.suspendActions(event.isMask());
                    }
                });
                this.listenToContentEvents();
            }
            ContentWizardPanel.prototype.availableSizeChangedHandler = function (item) {
                if (this.isVisible()) {
                    this.updateStickyToolbar();
                    if (item.isInRangeOrSmaller(ResponsiveRanges._720_960)) {
                        this.inMobileViewMode = true;
                        if (this.isSplitView()) {
                            if (this.isMinimized()) {
                                this.toggleMinimize();
                            }
                            this.showForm();
                            this.cycleViewModeButton.selectActiveAction(this.wizardActions.getShowFormAction());
                        }
                    }
                    else {
                        if (this.inMobileViewMode && this.isLiveView()) {
                            this.inMobileViewMode = false;
                            this.showSplitEdit();
                        }
                        this.inMobileViewMode = false;
                    }
                }
            };
            ContentWizardPanel.prototype.initOnShownHandler = function (responsiveItem) {
                var _this = this;
                this.onShown(function (event) {
                    if (_this.getPersistedItem()) {
                        app.Router.setHash("edit/" + _this.getPersistedItem().getId());
                    }
                    else {
                        app.Router.setHash("new/" + _this.contentType.getName());
                    }
                    _this.wizardActions.getShowSplitEditAction().onExecuted(function () {
                        if (!_this.inMobileViewMode) {
                            if (!_this.isContentRenderable() && !_this.getPersistedItem().isSite()) {
                                _this.closeLiveEdit();
                                _this.contextWindowToggler.setEnabled(false);
                            }
                            else {
                                _this.cycleViewModeButton.selectActiveAction(_this.showLiveEditAction);
                            }
                        }
                    });
                    if (_this.isContentRenderable() || _this.getPersistedItem().isSite()) {
                        _this.wizardActions.getShowSplitEditAction().execute();
                    }
                    else {
                        if (!!_this.getSplitPanel()) {
                            _this.wizardActions.getShowFormAction().execute();
                        }
                    }
                    responsiveItem.update();
                });
            };
            ContentWizardPanel.prototype.listenToFileUploaded = function () {
                var _this = this;
                this.thumbnailUploader.onFileUploaded(function (event) {
                    var newPersistedContent = event.getUploadItem().getModel();
                    _this.setPersistedItem(newPersistedContent);
                    _this.updateMetadataAndMetadataStepForms(newPersistedContent);
                    _this.updateThumbnailWithContent(newPersistedContent);
                    var contentToDisplay = (newPersistedContent.getDisplayName() && newPersistedContent.getDisplayName().length > 0) ?
                        '\"' + newPersistedContent.getDisplayName() + '\"' : "Content";
                    api.notify.showFeedback(contentToDisplay + ' saved');
                });
            };
            ContentWizardPanel.prototype.handleSiteConfigApply = function () {
                var _this = this;
                var siteConfigApplyHandler = function (event) {
                    if (_this.getPersistedItem().getContentId().equals(event.getContentId())) {
                        _this.saveChanges();
                    }
                };
                ContentRequiresSaveEvent.on(siteConfigApplyHandler);
                this.onClosed(function () {
                    ContentRequiresSaveEvent.un(siteConfigApplyHandler);
                });
            };
            ContentWizardPanel.prototype.handleBrokenImageInTheWizard = function () {
                var _this = this;
                var brokenImageHandler = function (event) {
                    if (_this.getPersistedItem().getId() === event.getContentId().toString()) {
                        _this.wizardActions.enableDeleteOnly();
                        _this.publishAction.setEnabled(false);
                    }
                };
                ImageErrorEvent.on(brokenImageHandler);
                this.onClosed(function () {
                    ImageErrorEvent.un(brokenImageHandler);
                });
            };
            ContentWizardPanel.prototype.getContentType = function () {
                return this.contentType;
            };
            ContentWizardPanel.prototype.giveInitialFocus = function () {
                if (this.contentType.hasContentDisplayNameScript()) {
                    if (!this.contentWizardStepForm.giveFocus()) {
                        this.contentWizardHeader.giveFocus();
                    }
                }
                else {
                    this.contentWizardHeader.giveFocus();
                }
                this.startRememberFocus();
            };
            ContentWizardPanel.prototype.createSteps = function () {
                var _this = this;
                var applicationKeys = this.site ? this.site.getApplicationKeys() : [];
                var applicationPromises = applicationKeys.map(function (key) { return _this.fetchApplication(key); });
                return new api.security.auth.IsAuthenticatedRequest().sendAndParse().then(function (loginResult) {
                    _this.checkSecurityWizardStepFormAllowed(loginResult);
                    _this.enablePublishIfAllowed(loginResult);
                    return wemQ.all(applicationPromises);
                }).then(function (applications) {
                    for (var i = 0; i < applications.length; i++) {
                        var app = applications[i];
                        if (!app.isStarted()) {
                            var deferred = wemQ.defer();
                            deferred.reject(new api.Exception("Application '" + app.getDisplayName() +
                                "' required by the site is not available. " +
                                "Make sure all applications specified in the site configuration are installed and started.", api.ExceptionType.WARNING));
                            return deferred.promise;
                        }
                    }
                    var metadataMixinPromises = [];
                    metadataMixinPromises = metadataMixinPromises.concat(_this.contentType.getMetadata().map(function (name) {
                        return _this.fetchMixin(name);
                    }));
                    applications.forEach(function (app) {
                        metadataMixinPromises = metadataMixinPromises.concat(app.getMetaSteps().map(function (name) {
                            return _this.fetchMixin(name);
                        }));
                    });
                    return wemQ.all(metadataMixinPromises);
                }).then(function (mixins) {
                    var steps = [];
                    _this.contentWizardStep = new WizardStep(_this.contentType.getDisplayName(), _this.contentWizardStepForm);
                    steps.push(_this.contentWizardStep);
                    mixins.forEach(function (mixin, index) {
                        if (!_this.metadataStepFormByName[mixin.getMixinName().toString()]) {
                            var stepForm = new wizard_6.ContentWizardStepForm();
                            _this.metadataStepFormByName[mixin.getMixinName().toString()] = stepForm;
                            steps.splice(index + 1, 0, new WizardStep(mixin.getDisplayName(), stepForm));
                        }
                    });
                    _this.settingsWizardStep = new WizardStep("Settings", _this.settingsWizardStepForm);
                    steps.push(_this.settingsWizardStep);
                    if (_this.isSecurityWizardStepFormAllowed) {
                        steps.push(new WizardStep("Security", _this.securityWizardStepForm));
                    }
                    _this.setSteps(steps);
                    return mixins;
                });
            };
            ContentWizardPanel.prototype.close = function (checkCanClose) {
                if (checkCanClose === void 0) { checkCanClose = false; }
                if (this.liveFormPanel) {
                    this.liveFormPanel.skipNextReloadConfirmation(true);
                }
                _super.prototype.close.call(this, checkCanClose);
            };
            ContentWizardPanel.prototype.fetchMixin = function (name) {
                var deferred = wemQ.defer();
                new GetMixinByQualifiedNameRequest(name).sendAndParse().
                    then(function (mixin) {
                    deferred.resolve(mixin);
                }).catch(function (reason) {
                    deferred.reject(new api.Exception("Content cannot be opened. Required mixin '" + name.toString() + "' not found.", api.ExceptionType.WARNING));
                }).done();
                return deferred.promise;
            };
            ContentWizardPanel.prototype.fetchApplication = function (key) {
                var deferred = wemQ.defer();
                new api.application.GetApplicationRequest(key).sendAndParse().
                    then(function (mod) {
                    deferred.resolve(mod);
                }).catch(function (reason) {
                    deferred.reject(new api.Exception("Content cannot be opened. Required application '" + key.toString() + "' not found.", api.ExceptionType.WARNING));
                }).done();
                return deferred.promise;
            };
            ContentWizardPanel.prototype.saveChanges = function () {
                if (this.liveFormPanel) {
                    this.liveFormPanel.skipNextReloadConfirmation(true);
                }
                this.setRequireValid(false);
                return _super.prototype.saveChanges.call(this);
            };
            ContentWizardPanel.prototype.preLayoutNew = function () {
                var deferred = wemQ.defer();
                this.saveChanges().
                    then(function () {
                    deferred.resolve(null);
                }).catch(function (reason) {
                    deferred.reject(reason);
                }).done();
                return deferred.promise;
            };
            ContentWizardPanel.prototype.postLayoutNew = function () {
                var deferred = wemQ.defer();
                this.enableDisplayNameScriptExecution(this.contentWizardStepForm.getFormView());
                this.contentWizardHeader.initNames(this.getPersistedItem().getDisplayName(), this.getPersistedItem().getName().toString(), true);
                deferred.resolve(null);
                return deferred.promise;
            };
            ContentWizardPanel.prototype.isCurrentContentId = function (id) {
                return this.getPersistedItem() && id && this.getPersistedItem().getContentId().equals(id);
            };
            ContentWizardPanel.prototype.persistedItemPathIsDescendantOrEqual = function (path) {
                return this.getPersistedItem().getPath().isDescendantOf(path) || this.getPersistedItem().getPath().equals(path);
            };
            ContentWizardPanel.prototype.listenToContentEvents = function () {
                var _this = this;
                var deleteHandler = function (event) {
                    if (_this.getPersistedItem()) {
                        event.getDeletedItems().filter(function (deletedItem) {
                            return !!deletedItem;
                        }).forEach(function (deletedItem) {
                            if (deletedItem.isPending()) {
                                if (_this.getPersistedItem().getPath().equals(deletedItem.getContentPath())) {
                                    _this.contentWizardToolbarPublishControls.setCompareStatus(CompareStatus.PENDING_DELETE);
                                    _this.contentCompareStatus = CompareStatus.PENDING_DELETE;
                                }
                            }
                            else if (_this.persistedItemPathIsDescendantOrEqual(deletedItem.getContentPath())) {
                                _this.close();
                            }
                        });
                    }
                };
                var publishHandler = function (event) {
                    if (_this.isCurrentContentId(event.getContentId())) {
                        _this.contentWizardToolbarPublishControls.setCompareStatus(event.getCompareStatus());
                        _this.contentCompareStatus = event.getCompareStatus();
                        if (_this.contentCompareStatus === CompareStatus.NEW) {
                            _this.contentWizardHeader.disableNameGeneration(true);
                            ContentPublishedEvent.un(publishHandler);
                        }
                    }
                };
                var updateHandler = function (contentId, unchangedOnly) {
                    if (unchangedOnly === void 0) { unchangedOnly = true; }
                    var isCurrent = _this.isCurrentContentId(contentId);
                    var htmlAreas = _this.getHtmlAreasInForm(_this.getContentType().getForm());
                    var areasContainId = _this.doAreasContainId(htmlAreas, contentId.toString());
                    if (isCurrent || areasContainId) {
                        new GetContentByIdRequest(_this.getPersistedItem().getContentId()).sendAndParse().done(function (content) {
                            _this.setPersistedItem(content);
                            _this.updateWizardHeader(content);
                            _this.updateWizardStepForms(content, unchangedOnly);
                            _this.updateMetadataAndMetadataStepForms(content.clone(), unchangedOnly);
                            if (!unchangedOnly) {
                                _this.updateLiveFormOnVersionChange();
                            }
                            else if (_this.isContentRenderable() && areasContainId) {
                                _this.liveFormPanel.skipNextReloadConfirmation(true);
                                _this.liveFormPanel.loadPage();
                            }
                            _this.resetLastFocusedElement();
                        });
                    }
                };
                var activeContentVersionSetHandler = function (event) { return updateHandler(event.getContentId(), false); };
                var contentUpdatedHanlder = function (event) { return updateHandler(event.getContentId()); };
                ActiveContentVersionSetEvent.on(activeContentVersionSetHandler);
                ContentUpdatedEvent.on(contentUpdatedHanlder);
                ContentPublishedEvent.on(publishHandler);
                ContentDeletedEvent.on(deleteHandler);
                this.onClosed(function () {
                    ActiveContentVersionSetEvent.un(activeContentVersionSetHandler);
                    ContentUpdatedEvent.un(contentUpdatedHanlder);
                    ContentPublishedEvent.un(publishHandler);
                    ContentDeletedEvent.un(deleteHandler);
                });
            };
            ContentWizardPanel.prototype.updateLiveFormOnVersionChange = function () {
                var _this = this;
                var content = this.getPersistedItem(), formContext = this.createFormContext(content);
                if (!!this.siteModel) {
                    this.unbindSiteModelListeners();
                }
                if (this.liveFormPanel) {
                    var site = content.isSite() ? content : this.site;
                    this.siteModel = new SiteModel(site);
                    return this.initLiveEditModel(content, this.siteModel, formContext).then(function () {
                        _this.liveFormPanel.setModel(_this.liveEditModel);
                        _this.liveFormPanel.skipNextReloadConfirmation(true);
                        _this.liveFormPanel.loadPage();
                        _this.updatePreviewActionVisibility();
                        return wemQ(null);
                    });
                }
                if (!this.siteModel && content.isSite()) {
                    this.siteModel = new SiteModel(content);
                }
                if (this.siteModel) {
                    this.initSiteModelListeners();
                }
            };
            ContentWizardPanel.prototype.doAreasContainId = function (areas, id) {
                var data = this.getPersistedItem().getContentData();
                return areas.some(function (area) {
                    var property = data.getProperty(area);
                    if (property && property.hasNonNullValue() && property.getType().equals(api.data.ValueTypes.STRING)) {
                        return property.getString().indexOf(id) >= 0;
                    }
                });
            };
            ContentWizardPanel.prototype.getHtmlAreasInForm = function (formItemContainer) {
                var _this = this;
                var result = [];
                formItemContainer.getFormItems().forEach(function (item) {
                    if (api.ObjectHelper.iFrameSafeInstanceOf(item, api.form.FieldSet)) {
                        result = result.concat(_this.getHtmlAreasInForm(item));
                    }
                    else if (api.ObjectHelper.iFrameSafeInstanceOf(item, api.form.FormItemSet)) {
                        result = result.concat(_this.getHtmlAreasInForm(item));
                    }
                    else if (api.ObjectHelper.iFrameSafeInstanceOf(item, api.form.Input)) {
                        var input = item;
                        if (input.getInputType().getName() === "HtmlArea") {
                            result.push(input.getPath().toString());
                        }
                    }
                });
                return result;
            };
            ContentWizardPanel.prototype.layoutPersistedItem = function (persistedContent) {
                var _this = this;
                this.updateThumbnailWithContent(persistedContent);
                this.notifyValidityChanged(persistedContent.isValid());
                api.content.ContentSummaryAndCompareStatusFetcher.fetchByContent(persistedContent).
                    done(function (contentSummaryAndCompareStatus) {
                    _this.contentCompareStatus = contentSummaryAndCompareStatus.getCompareStatus();
                    _this.contentWizardHeader.disableNameGeneration(_this.contentCompareStatus !== CompareStatus.NEW);
                    _this.contentWizardToolbarPublishControls.setCompareStatus(_this.contentCompareStatus);
                    _this.managePublishButtonStateForMobile(_this.contentCompareStatus);
                });
                var viewedContent;
                var deferred = wemQ.defer();
                if (!this.constructing) {
                    viewedContent = this.assembleViewedContent(persistedContent.newBuilder()).build();
                    if (viewedContent.equals(persistedContent)) {
                        if (this.liveFormPanel) {
                            this.liveFormPanel.loadPage();
                        }
                    }
                    else {
                        console.warn("Received Content from server differs from what's viewed:");
                        if (!viewedContent.getContentData().equals(persistedContent.getContentData())) {
                            console.warn(" inequality found in Content.data");
                            if (persistedContent.getContentData() && viewedContent.getContentData()) {
                                console.warn(" comparing persistedContent.data against viewedContent.data:");
                                new api.data.PropertyTreeComparator().compareTree(persistedContent.getContentData(), viewedContent.getContentData());
                            }
                        }
                        if (!api.ObjectHelper.equals(viewedContent.getPage(), persistedContent.getPage())) {
                            console.warn(" inequality found in Content.page");
                            if (persistedContent.getPage() && viewedContent.getPage()) {
                                console.warn(" comparing persistedContent.page.config against viewedContent.page.config:");
                                new api.data.PropertyTreeComparator().compareTree(persistedContent.getPage().getConfig(), viewedContent.getPage().getConfig());
                            }
                        }
                        if (!api.ObjectHelper.arrayEquals(viewedContent.getAllExtraData(), persistedContent.getAllExtraData())) {
                            console.warn(" inequality found in Content.meta");
                        }
                        if (!api.ObjectHelper.equals(viewedContent.getAttachments(), persistedContent.getAttachments())) {
                            console.warn(" inequality found in Content.attachments");
                        }
                        if (!api.ObjectHelper.equals(viewedContent.getPermissions(), persistedContent.getPermissions())) {
                            console.warn(" inequality found in Content.permissions");
                        }
                        console.warn(" viewedContent: ", viewedContent);
                        console.warn(" persistedContent: ", persistedContent);
                        if (persistedContent.getType().isDescendantOfMedia()) {
                            this.updateMetadataAndMetadataStepForms(persistedContent.clone());
                        }
                        else {
                            ConfirmationDialog.get().
                                setQuestion("Received Content from server differs from what you have. Would you like to load changes from server?").
                                setYesCallback(function () { return _this.doLayoutPersistedItem(persistedContent.clone()); }).
                                setNoCallback(function () {
                            }).
                                show();
                        }
                    }
                    deferred.resolve(null);
                }
                else {
                    this.doLayoutPersistedItem(persistedContent.clone())
                        .then(function () {
                        deferred.resolve(null);
                    }).catch(function (reason) {
                        deferred.reject(reason);
                    }).done();
                }
                this.contentWizardHeader.setSimplifiedNameGeneration(persistedContent.getType().isDescendantOfMedia());
                this.contentWizardToolbarPublishControls.enableActionsForExisting(persistedContent);
                return deferred.promise;
            };
            ContentWizardPanel.prototype.updateThumbnailWithContent = function (content) {
                this.thumbnailUploader.
                    setParams({
                    id: content.getContentId().toString()
                }).
                    setEnabled(!content.isImage()).
                    setValue(new ContentIconUrlResolver().setContent(content).resolve());
                this.thumbnailUploader.toggleClass("invalid", !content.isValid());
            };
            ContentWizardPanel.prototype.doLayoutPersistedItem = function (content) {
                var _this = this;
                this.toggleClass("rendered", false);
                this.showLiveEditAction.setEnabled(false);
                this.previewAction.setVisible(false);
                this.previewAction.setEnabled(false);
                new GetNearestSiteRequest(content.getContentId()).sendAndParse().
                    then(function (parentSite) {
                    if ((parentSite && !content.getType().isShortcut()) || content.isSite()) {
                        _this.setupWizardLiveEdit(true);
                    }
                    else {
                        _this.setupWizardLiveEdit(false);
                    }
                }).catch(function (reason) {
                    _this.setupWizardLiveEdit(false);
                    api.DefaultErrorHandler.handle(reason);
                }).done();
                var parallelPromises = [this.createSteps()];
                return wemQ.all(parallelPromises).
                    spread(function (schemas) {
                    var formContext = _this.createFormContext(content);
                    var contentData = content.getContentData();
                    contentData.onChanged(_this.dataChangedListener);
                    var formViewLayoutPromises = [];
                    formViewLayoutPromises.push(_this.contentWizardStepForm.layout(formContext, contentData, _this.contentType.getForm()));
                    _this.displayNameScriptExecutor.setFormView(_this.contentWizardStepForm.getFormView());
                    _this.settingsWizardStepForm.layout(content);
                    _this.settingsWizardStepForm.getModel().onPropertyChanged(_this.dataChangedListener);
                    if (_this.isSecurityWizardStepFormAllowed) {
                        _this.securityWizardStepForm.layout(content);
                    }
                    schemas.forEach(function (schema, index) {
                        var extraData = content.getExtraData(schema.getMixinName());
                        if (!extraData) {
                            extraData = new ExtraData(schema.getMixinName(), new PropertyTree());
                            content.getAllExtraData().push(extraData);
                        }
                        var metadataFormView = _this.metadataStepFormByName[schema.getMixinName().toString()];
                        var metadataForm = new api.form.FormBuilder().addFormItems(schema.getFormItems()).build();
                        var data = extraData.getData();
                        data.onChanged(_this.dataChangedListener);
                        formViewLayoutPromises.push(metadataFormView.layout(formContext, data, metadataForm));
                    });
                    return wemQ.all(formViewLayoutPromises).spread(function () {
                        if (_this.liveFormPanel) {
                            if (!_this.liveEditModel) {
                                var site = content.isSite() ? content : _this.site;
                                _this.siteModel = new SiteModel(site);
                                return _this.initLiveEditModel(content, _this.siteModel, formContext).then(function () {
                                    _this.liveFormPanel.setModel(_this.liveEditModel);
                                    _this.liveFormPanel.loadPage();
                                    _this.updatePreviewActionVisibility();
                                    return wemQ(null);
                                });
                            }
                            else {
                                _this.liveFormPanel.loadPage();
                            }
                        }
                        if (!_this.siteModel && content.isSite()) {
                            _this.siteModel = new SiteModel(content);
                        }
                        if (_this.siteModel) {
                            _this.initSiteModelListeners();
                        }
                        return wemQ(null);
                    });
                });
            };
            ContentWizardPanel.prototype.setupWizardLiveEdit = function (renderable) {
                this.toggleClass("rendered", renderable);
                this.showLiveEditAction.setEnabled(renderable);
                this.showSplitEditAction.setEnabled(renderable);
                this.previewAction.setVisible(renderable);
                if (this.getEl().getWidth() > ResponsiveRanges._720_960.getMaximumRange() && renderable) {
                    this.wizardActions.getShowSplitEditAction().execute();
                }
            };
            ContentWizardPanel.prototype.initSiteModelListeners = function () {
                this.siteModel.onApplicationAdded(this.applicationAddedListener.bind(this));
                this.siteModel.onApplicationRemoved(this.applicationRemovedListener.bind(this));
            };
            ContentWizardPanel.prototype.unbindSiteModelListeners = function () {
                this.siteModel.unApplicationAdded(this.applicationAddedListener.bind(this));
                this.siteModel.unApplicationRemoved(this.applicationRemovedListener.bind(this));
            };
            ContentWizardPanel.prototype.removeMetadataStepForms = function () {
                var _this = this;
                var applicationKeys = this.siteModel.getApplicationKeys();
                var applicationPromises = applicationKeys.map(function (key) { return new api.application.GetApplicationRequest(key).sendAndParse(); });
                return wemQ.all(applicationPromises).
                    then(function (applications) {
                    var metadataMixinPromises = [];
                    applications.forEach(function (app) {
                        metadataMixinPromises = metadataMixinPromises.concat(app.getMetaSteps().map(function (name) {
                            return new GetMixinByQualifiedNameRequest(name).sendAndParse();
                        }));
                    });
                    return wemQ.all(metadataMixinPromises);
                }).then(function (mixins) {
                    var activeMixinsNames = api.schema.mixin.MixinNames.create().fromMixins(mixins).build();
                    var panelNamesToRemoveBuilder = MixinNames.create();
                    for (var key in _this.metadataStepFormByName) {
                        var mixinName = new MixinName(key);
                        if (!activeMixinsNames.contains(mixinName)) {
                            panelNamesToRemoveBuilder.addMixinName(mixinName);
                        }
                    }
                    var panelNamesToRemove = panelNamesToRemoveBuilder.build();
                    panelNamesToRemove.forEach(function (panelName) {
                        _this.removeStepWithForm(_this.metadataStepFormByName[panelName.toString()]);
                        delete _this.metadataStepFormByName[panelName.toString()];
                    });
                    return mixins;
                }).catch(function (reason) {
                    api.DefaultErrorHandler.handle(reason);
                }).done();
            };
            ContentWizardPanel.prototype.addMetadataStepForms = function (applicationKey) {
                var _this = this;
                new api.application.GetApplicationRequest(applicationKey).sendAndParse().
                    then(function (currentApplication) {
                    var mixinNames = currentApplication.getMetaSteps();
                    var mixinNamesToAdd = mixinNames.filter(function (mixinName) {
                        return !_this.metadataStepFormByName[mixinName.toString()];
                    });
                    var getMixinPromises = mixinNamesToAdd.map(function (name) {
                        return new GetMixinByQualifiedNameRequest(name).sendAndParse();
                    });
                    return wemQ.all(getMixinPromises);
                }).then(function (mixins) {
                    mixins.forEach(function (mixin) {
                        if (!_this.metadataStepFormByName[mixin.getMixinName().toString()]) {
                            var stepForm = new wizard_6.ContentWizardStepForm();
                            _this.metadataStepFormByName[mixin.getMixinName().toString()] = stepForm;
                            var wizardStep = new WizardStep(mixin.getDisplayName(), stepForm);
                            _this.insertStepBefore(wizardStep, _this.settingsWizardStep);
                            var extraData = new ExtraData(mixin.getMixinName(), new PropertyTree());
                            stepForm.layout(_this.createFormContext(_this.getPersistedItem()), extraData.getData(), mixin.toForm());
                        }
                    });
                    return mixins;
                }).catch(function (reason) {
                    api.DefaultErrorHandler.handle(reason);
                }).done();
            };
            ContentWizardPanel.prototype.initLiveEditModel = function (content, siteModel, formContext) {
                this.initSiteModelListeners();
                this.liveEditModel = LiveEditModel.create().
                    setParentContent(this.parentContent).
                    setContent(content).
                    setContentFormContext(formContext).
                    setSiteModel(siteModel).build();
                return this.liveEditModel.init(this.defaultModels.getPageTemplate(), this.defaultModels.getPageDescriptor());
            };
            ContentWizardPanel.prototype.postLayoutPersisted = function (existing) {
                var deferred = wemQ.defer();
                this.contentWizardHeader.initNames(existing.getDisplayName(), existing.getName().toString(), false);
                this.enableDisplayNameScriptExecution(this.contentWizardStepForm.getFormView());
                deferred.resolve(null);
                return deferred.promise;
            };
            ContentWizardPanel.prototype.persistNewItem = function () {
                return new wizard_6.PersistNewContentRoutine(this).setCreateContentRequestProducer(this.produceCreateContentRequest).execute().then(function (content) {
                    api.notify.showFeedback('Content created');
                    return content;
                });
            };
            ContentWizardPanel.prototype.postPersistNewItem = function (persistedContent) {
                var deferred = wemQ.defer();
                if (persistedContent.isSite()) {
                    this.site = persistedContent;
                }
                deferred.resolve(null);
                return deferred.promise;
            };
            ContentWizardPanel.prototype.produceCreateContentRequest = function () {
                var deferred = wemQ.defer();
                var parentPath = this.parentContent != null ? this.parentContent.getPath() : api.content.ContentPath.ROOT;
                if (this.contentType.getContentTypeName().isMedia()) {
                    deferred.resolve(null);
                }
                else {
                    deferred.resolve(new CreateContentRequest().
                        setRequireValid(this.requireValid).
                        setName(api.content.ContentUnnamed.newUnnamed()).
                        setParent(parentPath).
                        setContentType(this.contentType.getContentTypeName()).
                        setDisplayName(this.contentWizardHeader.getDisplayName()).
                        setData(new PropertyTree()).
                        setExtraData([]));
                }
                return deferred.promise;
            };
            ContentWizardPanel.prototype.updatePersistedItem = function () {
                var _this = this;
                var persistedContent = this.getPersistedItem();
                var viewedContent = this.assembleViewedContent(persistedContent.newBuilder()).build();
                var updatePersistedContentRoutine = new wizard_6.UpdatePersistedContentRoutine(this, persistedContent, viewedContent).
                    setUpdateContentRequestProducer(this.produceUpdateContentRequest);
                return updatePersistedContentRoutine.
                    execute().
                    then(function (content) {
                    if (persistedContent.getName().isUnnamed() && !content.getName().isUnnamed()) {
                        _this.notifyContentNamed(content);
                    }
                    var contentToDisplay = (content.getDisplayName() && content.getDisplayName().length > 0) ?
                        '\"' + content.getDisplayName() + '\"' : "Content";
                    api.notify.showFeedback(contentToDisplay + ' saved');
                    return content;
                });
            };
            ContentWizardPanel.prototype.produceUpdateContentRequest = function (persistedContent, viewedContent) {
                var persistedContent = this.getPersistedItem();
                var updateContentRequest = new UpdateContentRequest(persistedContent.getId()).
                    setRequireValid(this.requireValid).
                    setContentName(viewedContent.getName()).
                    setDisplayName(viewedContent.getDisplayName()).
                    setData(viewedContent.getContentData()).
                    setExtraData(viewedContent.getAllExtraData()).
                    setOwner(viewedContent.getOwner()).
                    setLanguage(viewedContent.getLanguage());
                return updateContentRequest;
            };
            ContentWizardPanel.prototype.hasUnsavedChanges = function () {
                var persistedContent = this.getPersistedItem();
                if (persistedContent == undefined) {
                    return true;
                }
                else {
                    var viewedContent = this.assembleViewedContent(new ContentBuilder(persistedContent)).build();
                    return !viewedContent.equals(persistedContent, true);
                }
            };
            ContentWizardPanel.prototype.enableDisplayNameScriptExecution = function (formView) {
                var _this = this;
                if (this.displayNameScriptExecutor.hasScript()) {
                    formView.onKeyUp(function (event) {
                        if (_this.displayNameScriptExecutor.hasScript()) {
                            _this.contentWizardHeader.setDisplayName(_this.displayNameScriptExecutor.execute());
                        }
                    });
                }
            };
            ContentWizardPanel.prototype.assembleViewedContent = function (viewedContentBuilder) {
                viewedContentBuilder.setName(this.resolveContentNameForUpdateRequest());
                viewedContentBuilder.setDisplayName(this.contentWizardHeader.getDisplayName());
                if (this.contentWizardStepForm) {
                    viewedContentBuilder.setData(this.contentWizardStepForm.getData());
                }
                var extraData = [];
                for (var key in this.metadataStepFormByName) {
                    if (this.metadataStepFormByName.hasOwnProperty(key)) {
                        extraData.push(new ExtraData(new MixinName(key), this.metadataStepFormByName[key].getData()));
                    }
                }
                viewedContentBuilder.setExtraData(extraData);
                this.settingsWizardStepForm.getModel().apply(viewedContentBuilder);
                viewedContentBuilder.setPage(this.assembleViewedPage());
                return viewedContentBuilder;
            };
            ContentWizardPanel.prototype.assembleViewedPage = function () {
                if (!this.liveFormPanel) {
                    return null;
                }
                return this.liveFormPanel.getPage();
            };
            ContentWizardPanel.prototype.resolveContentNameForUpdateRequest = function () {
                if (api.util.StringHelper.isEmpty(this.contentWizardHeader.getName())) {
                    if (this.getPersistedItem().getName().isUnnamed()) {
                        return this.getPersistedItem().getName();
                    }
                    else {
                        return ContentUnnamed.newUnnamed();
                    }
                }
                return ContentName.fromString(this.contentWizardHeader.getName());
            };
            ContentWizardPanel.prototype.setRequireValid = function (requireValid) {
                this.requireValid = requireValid;
            };
            ContentWizardPanel.prototype.showLiveEdit = function () {
                if (!this.inMobileViewMode) {
                    this.showSplitEdit();
                    return;
                }
                this.getSplitPanel().addClass("toggle-live");
                this.getSplitPanel().removeClass("toggle-form toggle-split prerendered");
                this.getMainToolbar().toggleClass("live", true);
                this.toggleClass("form", false);
                this.openLiveEdit();
                ResponsiveManager.fireResizeEvent();
            };
            ContentWizardPanel.prototype.showSplitEdit = function () {
                this.getSplitPanel().addClass("toggle-split");
                this.getSplitPanel().removeClass("toggle-live toggle-form prerendered");
                this.getMainToolbar().toggleClass("live", true);
                this.toggleClass("form", false);
                this.openLiveEdit();
                ResponsiveManager.fireResizeEvent();
            };
            ContentWizardPanel.prototype.showForm = function () {
                this.getSplitPanel().addClass("toggle-form");
                this.getSplitPanel().removeClass("toggle-live toggle-split prerendered");
                this.getMainToolbar().toggleClass("live", false);
                this.toggleClass("form", true);
                this.closeLiveEdit();
                ResponsiveManager.fireResizeEvent();
            };
            ContentWizardPanel.prototype.isSplitView = function () {
                return this.getSplitPanel() && this.getSplitPanel().hasClass("toggle-split");
            };
            ContentWizardPanel.prototype.isLiveView = function () {
                return this.getSplitPanel() && this.getSplitPanel().hasClass("toggle-live");
            };
            ContentWizardPanel.prototype.checkContentCanBePublished = function (displayValidationErrors) {
                if (this.contentWizardToolbarPublishControls.isPendingDelete()) {
                    return true;
                }
                if (!this.isContentFormValid) {
                    this.contentWizardStepForm.displayValidationErrors(displayValidationErrors);
                }
                var contentFormHasValidUserInput = this.contentWizardStepForm.getFormView().hasValidUserInput();
                var allMetadataFormsValid = true;
                var allMetadataFormsHasValidUserInput = true;
                for (var key in this.metadataStepFormByName) {
                    if (this.metadataStepFormByName.hasOwnProperty(key)) {
                        var form = this.metadataStepFormByName[key];
                        if (!form.isValid()) {
                            form.displayValidationErrors(displayValidationErrors);
                            allMetadataFormsValid = false;
                        }
                        var formHasValidUserInput = form.getFormView().hasValidUserInput();
                        if (!formHasValidUserInput) {
                            allMetadataFormsHasValidUserInput = false;
                        }
                    }
                }
                return this.isContentFormValid && allMetadataFormsValid && contentFormHasValidUserInput && allMetadataFormsHasValidUserInput;
            };
            ContentWizardPanel.prototype.getLiveFormPanel = function () {
                return this.liveFormPanel;
            };
            ContentWizardPanel.prototype.getContextWindowToggler = function () {
                return this.contextWindowToggler;
            };
            ContentWizardPanel.prototype.getComponentsViewToggler = function () {
                return this.componentsViewToggler;
            };
            ContentWizardPanel.prototype.getCloseAction = function () {
                return this.wizardActions.getCloseAction();
            };
            ContentWizardPanel.prototype.onContentNamed = function (listener) {
                this.contentNamedListeners.push(listener);
            };
            ContentWizardPanel.prototype.unContentNamed = function (listener) {
                this.contentNamedListeners = this.contentNamedListeners.filter(function (curr) {
                    return curr != listener;
                });
                return this;
            };
            ContentWizardPanel.prototype.getContentCompareStatus = function () {
                return this.contentCompareStatus;
            };
            ContentWizardPanel.prototype.notifyContentNamed = function (content) {
                var _this = this;
                this.contentNamedListeners.forEach(function (listener) {
                    listener.call(_this, new ContentNamedEvent(_this, content));
                });
            };
            ContentWizardPanel.prototype.contentPermissionsUpdated = function (content) {
                var persistedContent = this.getPersistedItem();
                if (persistedContent && (content.getId() === persistedContent.getId())) {
                    var updatedContent = persistedContent.newBuilder().
                        setInheritPermissionsEnabled(content.isInheritPermissionsEnabled()).
                        setPermissions(content.getPermissions().clone()).
                        build();
                    this.setPersistedItem(updatedContent);
                }
            };
            ContentWizardPanel.prototype.createFormContext = function (content) {
                var formContext = ContentFormContext.create().
                    setSite(this.site).
                    setParentContent(this.parentContent).
                    setPersistedContent(content).
                    setContentTypeName(this.contentType ? this.contentType.getContentTypeName() : undefined).
                    setShowEmptyFormItemSetOccurrences(this.isItemPersisted()).
                    build();
                return formContext;
            };
            ContentWizardPanel.prototype.checkSecurityWizardStepFormAllowed = function (loginResult) {
                if (this.getPersistedItem().isAnyPrincipalAllowed(loginResult.getPrincipals(), api.security.acl.Permission.WRITE_PERMISSIONS)) {
                    this.isSecurityWizardStepFormAllowed = true;
                }
            };
            ContentWizardPanel.prototype.isPrincipalPresent = function (principalKey, accessEntriesToCheck) {
                return accessEntriesToCheck.some(function (entry) {
                    if (entry.getPrincipalKey().equals(principalKey)) {
                        return true;
                    }
                });
            };
            ContentWizardPanel.prototype.enablePublishIfAllowed = function (loginResult) {
                var _this = this;
                var entries = this.getPersistedItem().getPermissions().getEntries();
                var accessEntriesWithPublishPermissions = entries.filter(function (item) {
                    return item.isAllowed(api.security.acl.Permission.PUBLISH);
                });
                loginResult.getPrincipals().some(function (principalKey) {
                    if (api.security.RoleKeys.ADMIN.equals(principalKey) ||
                        _this.isPrincipalPresent(principalKey, accessEntriesWithPublishPermissions)) {
                        _this.publishAction.setEnabled(true);
                        return true;
                    }
                });
            };
            ContentWizardPanel.prototype.updateMetadataAndMetadataStepForms = function (content, unchangedOnly) {
                if (unchangedOnly === void 0) { unchangedOnly = true; }
                for (var key in this.metadataStepFormByName) {
                    if (this.metadataStepFormByName.hasOwnProperty(key)) {
                        var mixinName = new MixinName(key);
                        var extraData = content.getExtraData(mixinName);
                        if (!extraData) {
                            extraData = new ExtraData(mixinName, new PropertyTree());
                            content.getAllExtraData().push(extraData);
                        }
                        var form = this.metadataStepFormByName[key];
                        form.getData().unChanged(this.dataChangedListener);
                        var data = extraData.getData();
                        data.onChanged(this.dataChangedListener);
                        form.update(data, unchangedOnly);
                    }
                }
            };
            ContentWizardPanel.prototype.updateWizardStepForms = function (content, unchangedOnly) {
                if (unchangedOnly === void 0) { unchangedOnly = true; }
                this.contentWizardStepForm.getData().unChanged(this.dataChangedListener);
                var contentCopy = content.clone();
                contentCopy.getContentData().onChanged(this.dataChangedListener);
                this.contentWizardStepForm.update(contentCopy.getContentData(), unchangedOnly);
                if (contentCopy.isSite()) {
                    this.siteModel.update(contentCopy);
                }
                this.settingsWizardStepForm.update(contentCopy, unchangedOnly);
                if (this.isSecurityWizardStepFormAllowed) {
                    this.securityWizardStepForm.update(contentCopy, unchangedOnly);
                }
            };
            ContentWizardPanel.prototype.updateWizardHeader = function (content) {
                this.updateThumbnailWithContent(content);
                this.contentWizardHeader.initNames(content.getDisplayName(), content.getName().toString(), true, false);
            };
            ContentWizardPanel.prototype.initPublishButtonForMobile = function () {
                var _this = this;
                var action = new api.ui.Action("Publish");
                action.setIconClass("publish-action");
                action.onExecuted(function () {
                    _this.publishAction.execute();
                });
                this.publishButtonForMobile = new DialogButton(action);
                this.publishButtonForMobile.addClass("mobile-edit-publish-button");
                this.subscribePublishButtonForMobileToPublishEvents();
                this.appendChild(this.publishButtonForMobile);
            };
            ContentWizardPanel.prototype.managePublishButtonStateForMobile = function (compareStatus) {
                var canBeShown = compareStatus !== CompareStatus.EQUAL;
                this.publishButtonForMobile.toggleClass("visible", canBeShown);
                this.publishButtonForMobile.setLabel("Publish " + api.content.CompareStatusFormatter.formatStatus(compareStatus) + " item");
            };
            ContentWizardPanel.prototype.subscribePublishButtonForMobileToPublishEvents = function () {
                var _this = this;
                var publishHandler = function (event) {
                    if (_this.getPersistedItem() && event.getContentIds()) {
                        var isPublished = (event.getContentIds().some(function (obj) {
                            return obj.toString() == _this.getPersistedItem().getId();
                        }));
                        if (isPublished) {
                            _this.managePublishButtonStateForMobile(CompareStatus.EQUAL);
                        }
                    }
                };
                var publishHandlerOfServerEvent = function (event) {
                    if (_this.getPersistedItem() && event.getContentId() &&
                        (_this.getPersistedItem().getId() === event.getContentId().toString())) {
                        _this.managePublishButtonStateForMobile(CompareStatus.EQUAL);
                    }
                };
                ContentsPublishedEvent.on(publishHandler);
                ContentPublishedEvent.on(publishHandlerOfServerEvent);
                this.onClosed(function () {
                    ContentPublishedEvent.un(publishHandlerOfServerEvent);
                    ContentsPublishedEvent.un(publishHandler);
                });
            };
            ContentWizardPanel.prototype.openLiveEdit = function () {
                this.getSplitPanel().showSecondPanel();
                this.liveFormPanel.clearPageViewSelectionAndOpenInspectPage();
                this.showMinimizeEditButton();
            };
            ContentWizardPanel.prototype.closeLiveEdit = function () {
                this.getSplitPanel().hideSecondPanel();
                this.hideMinimizeEditButton();
                if (this.isMinimized()) {
                    this.toggleMinimize();
                }
            };
            ContentWizardPanel.prototype.isContentRenderable = function () {
                var isPageTemplateWithNoController = this.contentType.getContentTypeName().isPageTemplate() &&
                    !this.liveEditModel.getPageModel().getController();
                return this.liveEditModel && (this.liveEditModel.isPageRenderable() || isPageTemplateWithNoController);
            };
            ContentWizardPanel.prototype.updatePreviewActionVisibility = function () {
                var _this = this;
                this.previewAction.setEnabled(this.isContentRenderable());
                this.liveEditModel.getPageModel().onPageModeChanged(function () {
                    _this.previewAction.setEnabled(_this.isContentRenderable());
                });
            };
            return ContentWizardPanel;
        })(api.app.wizard.WizardPanel);
        wizard_6.ContentWizardPanel = ContentWizardPanel;
    })(wizard = app_1.wizard || (app_1.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var PersistedNewContentRoutineContext = (function () {
            function PersistedNewContentRoutineContext() {
                this.content = null;
            }
            return PersistedNewContentRoutineContext;
        })();
        wizard.PersistedNewContentRoutineContext = PersistedNewContentRoutineContext;
        var PersistNewContentRoutine = (function (_super) {
            __extends(PersistNewContentRoutine, _super);
            function PersistNewContentRoutine(thisOfProducer) {
                _super.call(this, thisOfProducer);
                this.doneHandledContent = false;
            }
            PersistNewContentRoutine.prototype.setCreateContentRequestProducer = function (producer) {
                this.createContentRequestProducer = producer;
                return this;
            };
            PersistNewContentRoutine.prototype.execute = function () {
                var context = new PersistedNewContentRoutineContext();
                return this.doExecute(context);
            };
            PersistNewContentRoutine.prototype.doExecuteNext = function (context) {
                var _this = this;
                if (!this.doneHandledContent) {
                    return this.doHandleCreateContent(context).
                        then(function () {
                        _this.doneHandledContent = true;
                        return _this.doExecuteNext(context);
                    });
                }
                else {
                    return wemQ(context.content);
                }
            };
            PersistNewContentRoutine.prototype.doHandleCreateContent = function (context) {
                if (this.createContentRequestProducer != undefined) {
                    return this.createContentRequestProducer.call(this.getThisOfProducer()).
                        then(function (createContentRequest) {
                        return createContentRequest.sendAndParse().
                            then(function (content) {
                            context.content = content;
                        });
                    });
                }
                else {
                    return api.util.PromiseHelper.newResolvedVoidPromise();
                }
            };
            return PersistNewContentRoutine;
        })(api.util.Flow);
        wizard.PersistNewContentRoutine = PersistNewContentRoutine;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var CreatePageRequest = api.content.page.CreatePageRequest;
        var UpdatePageRequest = api.content.page.UpdatePageRequest;
        var DeletePageRequest = api.content.page.DeletePageRequest;
        var UpdatePersistedContentRoutineContext = (function () {
            function UpdatePersistedContentRoutineContext() {
                this.content = null;
            }
            return UpdatePersistedContentRoutineContext;
        })();
        wizard.UpdatePersistedContentRoutineContext = UpdatePersistedContentRoutineContext;
        var UpdatePersistedContentRoutine = (function (_super) {
            __extends(UpdatePersistedContentRoutine, _super);
            function UpdatePersistedContentRoutine(thisOfProducer, persistedContent, viewedContent) {
                _super.call(this, thisOfProducer);
                this.doneHandledContent = false;
                this.doneHandledPage = false;
                this.persistedContent = persistedContent;
                this.viewedContent = viewedContent;
            }
            UpdatePersistedContentRoutine.prototype.setUpdateContentRequestProducer = function (producer) {
                this.updateContentRequestProducer = producer;
                return this;
            };
            UpdatePersistedContentRoutine.prototype.execute = function () {
                var context = new UpdatePersistedContentRoutineContext();
                context.content = this.persistedContent;
                return this.doExecute(context);
            };
            UpdatePersistedContentRoutine.prototype.doExecuteNext = function (context) {
                var _this = this;
                if (!this.doneHandledContent) {
                    return this.doHandleUpdateContent(context).
                        then(function () {
                        _this.doneHandledContent = true;
                        return _this.doExecuteNext(context);
                    });
                }
                else if (!this.doneHandledPage) {
                    return this.doHandlePage(context).
                        then(function () {
                        _this.doneHandledPage = true;
                        return _this.doExecuteNext(context);
                    });
                }
                else {
                    return wemQ(context.content);
                }
            };
            UpdatePersistedContentRoutine.prototype.doHandleUpdateContent = function (context) {
                return this.updateContentRequestProducer.call(this.getThisOfProducer(), context.content, this.viewedContent).
                    sendAndParse().
                    then(function (content) {
                    context.content = content;
                });
            };
            UpdatePersistedContentRoutine.prototype.doHandlePage = function (context) {
                var pageCUDRequest = this.producePageCUDRequest(context.content, this.viewedContent);
                if (pageCUDRequest != null) {
                    return pageCUDRequest
                        .sendAndParse().
                        then(function (content) {
                        context.content = content;
                    });
                }
                else {
                    var deferred = wemQ.defer();
                    deferred.resolve(null);
                    return deferred.promise;
                }
            };
            UpdatePersistedContentRoutine.prototype.producePageCUDRequest = function (persistedContent, viewedContent) {
                if (persistedContent.isPage() && !viewedContent.isPage()) {
                    return new DeletePageRequest(persistedContent.getContentId());
                }
                else if (!persistedContent.isPage() && viewedContent.isPage()) {
                    var viewedPage = viewedContent.getPage();
                    return new CreatePageRequest(persistedContent.getContentId()).
                        setController(viewedPage.getController()).
                        setPageTemplateKey(viewedPage.getTemplate()).
                        setConfig(viewedPage.getConfig()).
                        setRegions(viewedPage.getRegions()).
                        setFragment(viewedPage.getFragment()).
                        setCustomized(viewedPage.isCustomized());
                }
                else if (persistedContent.isPage() && viewedContent.isPage()) {
                    var viewedPage = viewedContent.getPage();
                    return new UpdatePageRequest(persistedContent.getContentId()).
                        setController((viewedPage.getController())).
                        setPageTemplateKey((viewedPage.getTemplate())).
                        setConfig(viewedPage.getConfig()).
                        setRegions(viewedPage.getRegions()).
                        setFragment(viewedPage.getFragment()).
                        setCustomized(viewedPage.isCustomized());
                }
            };
            return UpdatePersistedContentRoutine;
        })(api.util.Flow);
        wizard.UpdatePersistedContentRoutine = UpdatePersistedContentRoutine;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard_7) {
        var Content = api.content.Content;
        var DefaultModels = app.wizard.page.DefaultModels;
        var DefaultModelsFactory = app.wizard.page.DefaultModelsFactory;
        var ContentWizardPanelFactory = (function () {
            function ContentWizardPanelFactory() {
                this.createSite = false;
            }
            ContentWizardPanelFactory.prototype.setContentIdToEdit = function (value) {
                this.contentId = value;
                return this;
            };
            ContentWizardPanelFactory.prototype.setContentTypeName = function (value) {
                this.contentTypeName = value;
                return this;
            };
            ContentWizardPanelFactory.prototype.setParentContent = function (value) {
                this.parentContent = value;
                return this;
            };
            ContentWizardPanelFactory.prototype.setCreateSite = function (value) {
                this.createSite = value;
                return this;
            };
            ContentWizardPanelFactory.prototype.setAppBarTabId = function (value) {
                this.appBarTabId = value;
                return this;
            };
            ContentWizardPanelFactory.prototype.createForNew = function () {
                var _this = this;
                this.creatingForNew = true;
                return this.loadContentType(this.contentTypeName).then(function (loadedContentType) {
                    _this.contentType = loadedContentType;
                    return _this.loadParentContent();
                }).then(function (loadedParentContent) {
                    _this.parentContent = loadedParentContent;
                    return _this.loadSite(loadedParentContent ? loadedParentContent.getContentId() : null);
                }).then(function (loadedSite) {
                    _this.siteContent = loadedSite;
                    return _this.loadDefaultModels(_this.siteContent, _this.contentTypeName);
                }).then(function (defaultModels) {
                    _this.defaultModels = defaultModels;
                    return _this.newContentWizardPanelForNew();
                });
            };
            ContentWizardPanelFactory.prototype.createForEdit = function (content) {
                var _this = this;
                this.creatingForNew = false;
                return this.getContentToEdit(content).then(function (contentType) {
                    _this.contentType = contentType;
                    return _this.loadParentContent();
                }).then(function (loadedParentContent) {
                    _this.parentContent = loadedParentContent;
                    return _this.loadSite(_this.contentId);
                }).then(function (loadedSite) {
                    if (!!loadedSite) {
                        _this.siteContent = loadedSite;
                    }
                    return _this.loadDefaultModels(_this.siteContent, _this.contentToEdit.getType());
                }).then(function (defaultModels) {
                    _this.defaultModels = defaultModels;
                    return _this.newContentWizardPanelForEdit();
                });
            };
            ContentWizardPanelFactory.prototype.loadContentToEdit = function () {
                return new api.content.GetContentByIdRequest(this.contentId).sendAndParse();
            };
            ContentWizardPanelFactory.prototype.getContentToEdit = function (content) {
                var _this = this;
                if (api.ObjectHelper.iFrameSafeInstanceOf(content, Content)) {
                    this.contentToEdit = content;
                    return this.loadContentType(this.contentToEdit.getType());
                }
                else {
                    return this.loadContentToEdit().then(function (loadedContentToEdit) {
                        _this.contentToEdit = loadedContentToEdit;
                        return _this.loadContentType(_this.contentToEdit.getType());
                    });
                }
            };
            ContentWizardPanelFactory.prototype.loadContentType = function (name) {
                var deferred = wemQ.defer();
                new api.schema.content.GetContentTypeByNameRequest(name).sendAndParse().
                    then(function (contentType) {
                    deferred.resolve(contentType);
                }).catch(function (reason) {
                    deferred.reject(new api.Exception("Content cannot be opened. Required content type '" + name.toString() +
                        "' not found.", api.ExceptionType.WARNING));
                }).done();
                return deferred.promise;
            };
            ContentWizardPanelFactory.prototype.loadSite = function (contentId) {
                return contentId ? new api.content.GetNearestSiteRequest(contentId).sendAndParse() : wemQ(null);
            };
            ContentWizardPanelFactory.prototype.loadDefaultModels = function (site, contentType) {
                if (site) {
                    return DefaultModelsFactory.create({
                        siteId: site.getContentId(),
                        contentType: contentType,
                        applications: site.getApplicationKeys()
                    });
                }
                else if (contentType.isSite()) {
                    return wemQ(new DefaultModels(null, null));
                }
                else {
                    return wemQ(null);
                }
            };
            ContentWizardPanelFactory.prototype.loadParentContent = function () {
                if (this.parentContent != null) {
                    return wemQ(this.parentContent);
                }
                else if (!this.creatingForNew && !this.contentToEdit.hasParent()) {
                    return wemQ(null);
                }
                else if (this.creatingForNew && this.parentContent == null) {
                    return wemQ(null);
                }
                return new api.content.GetContentByPathRequest(this.contentToEdit.getPath().getParentPath()).sendAndParse();
            };
            ContentWizardPanelFactory.prototype.newContentWizardPanelForNew = function () {
                var deferred = wemQ.defer();
                var wizardParams = new app.wizard.ContentWizardPanelParams().
                    setAppBarTabId(this.appBarTabId).
                    setContentType(this.contentType).
                    setParentContent(this.parentContent).
                    setSite(this.siteContent).
                    setDefaultModels(this.defaultModels);
                wizardParams.setCreateSite(this.createSite);
                new app.wizard.ContentWizardPanel(wizardParams, function (wizard) {
                    deferred.resolve(wizard);
                }, function (reason) {
                    deferred.reject(reason);
                });
                return deferred.promise;
            };
            ContentWizardPanelFactory.prototype.newContentWizardPanelForEdit = function () {
                var deferred = wemQ.defer();
                var wizardParams = new wizard_7.ContentWizardPanelParams().
                    setAppBarTabId(this.appBarTabId).
                    setContentType(this.contentType).
                    setParentContent(this.parentContent).
                    setPersistedContent(this.contentToEdit).
                    setSite(this.siteContent).
                    setDefaultModels(this.defaultModels);
                new wizard_7.ContentWizardPanel(wizardParams, function (wizard) {
                    deferred.resolve(wizard);
                }, function (reason) {
                    deferred.reject(reason);
                });
                return deferred.promise;
            };
            return ContentWizardPanelFactory;
        })();
        wizard_7.ContentWizardPanelFactory = ContentWizardPanelFactory;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var ContentWizardPanelParams = (function () {
            function ContentWizardPanelParams() {
                this.createSite = false;
            }
            ContentWizardPanelParams.prototype.setAppBarTabId = function (value) {
                this.tabId = value;
                return this;
            };
            ContentWizardPanelParams.prototype.setContentType = function (value) {
                this.contentType = value;
                return this;
            };
            ContentWizardPanelParams.prototype.setParentContent = function (value) {
                this.parentContent = value;
                return this;
            };
            ContentWizardPanelParams.prototype.setPersistedContent = function (value) {
                this.persistedContent = value;
                return this;
            };
            ContentWizardPanelParams.prototype.setSite = function (value) {
                this.site = value;
                return this;
            };
            ContentWizardPanelParams.prototype.setDefaultModels = function (value) {
                this.defaultModels = value;
                return this;
            };
            ContentWizardPanelParams.prototype.setCreateSite = function (value) {
                this.createSite = value;
                return this;
            };
            return ContentWizardPanelParams;
        })();
        wizard.ContentWizardPanelParams = ContentWizardPanelParams;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var ShowContentFormEvent = (function (_super) {
            __extends(ShowContentFormEvent, _super);
            function ShowContentFormEvent() {
                _super.apply(this, arguments);
            }
            ShowContentFormEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ShowContentFormEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ShowContentFormEvent;
        })(api.event.Event);
        wizard.ShowContentFormEvent = ShowContentFormEvent;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var ShowLiveEditEvent = (function (_super) {
            __extends(ShowLiveEditEvent, _super);
            function ShowLiveEditEvent() {
                _super.apply(this, arguments);
            }
            ShowLiveEditEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ShowLiveEditEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ShowLiveEditEvent;
        })(api.event.Event);
        wizard.ShowLiveEditEvent = ShowLiveEditEvent;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var ShowSplitEditEvent = (function (_super) {
            __extends(ShowSplitEditEvent, _super);
            function ShowSplitEditEvent() {
                _super.apply(this, arguments);
            }
            ShowSplitEditEvent.on = function (handler) {
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler);
            };
            ShowSplitEditEvent.un = function (handler) {
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler);
            };
            return ShowSplitEditEvent;
        })(api.event.Event);
        wizard.ShowSplitEditEvent = ShowSplitEditEvent;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var GridColumnBuilder = api.ui.grid.GridColumnBuilder;
        var ContentSummaryViewer = api.content.ContentSummaryViewer;
        var TreeGrid = api.ui.treegrid.TreeGrid;
        var TreeGridBuilder = api.ui.treegrid.TreeGridBuilder;
        var ContentSummaryAndCompareStatusFetcher = api.content.ContentSummaryAndCompareStatusFetcher;
        var CompareContentGrid = (function (_super) {
            __extends(CompareContentGrid, _super);
            function CompareContentGrid(content) {
                var _this = this;
                _super.call(this, new TreeGridBuilder().
                    setColumns([
                    new GridColumnBuilder().
                        setName("Name").
                        setId("displayName").
                        setField("displayName").
                        setFormatter(this.nameFormatter).
                        build()
                ]).
                    setPartialLoadEnabled(true).
                    setLoadBufferSize(20).
                    prependClasses("compare-content-grid"));
                this.content = content;
                this.onLoaded(function () {
                    _this.selectAll();
                });
            }
            CompareContentGrid.prototype.nameFormatter = function (row, cell, value, columnDef, node) {
                var viewer = node.getViewer("name");
                if (!viewer) {
                    viewer = new ContentSummaryViewer();
                    viewer.setObject(node.getData().getContentSummary());
                    node.setViewer("name", viewer);
                }
                return viewer.toString();
            };
            CompareContentGrid.prototype.fetchChildren = function (parentNode) {
                var parentContentId = parentNode && parentNode.getData() ? parentNode.getData().getContentId() : null;
                return api.content.ContentSummaryAndCompareStatusFetcher.fetchChildren(parentContentId).
                    then(function (data) {
                    return data.getContents();
                });
            };
            CompareContentGrid.prototype.hasChildren = function (elem) {
                return elem.hasChildren();
            };
            CompareContentGrid.prototype.getDataId = function (data) {
                return data.getId();
            };
            CompareContentGrid.prototype.refreshNodeData = function (parentNode) {
                var _this = this;
                return ContentSummaryAndCompareStatusFetcher.fetch(parentNode.getData().getContentId()).then(function (content) {
                    parentNode.setData(content);
                    _this.refreshNode(parentNode);
                    return parentNode;
                });
            };
            CompareContentGrid.prototype.sortNodeChildren = function (node) {
                var comparator;
                if (this.getRoot().getCurrentRoot() == node) {
                    comparator = new api.content.ContentNodeByDisplayNameComparator();
                }
                else {
                    comparator = new api.content.ContentNodeByModifiedTimeComparator();
                }
                var children = node.getChildren().sort(comparator.compare);
                node.setChildren(children);
                this.initData(this.getRoot().getCurrentRoot().treeToList());
            };
            return CompareContentGrid;
        })(TreeGrid);
        wizard.CompareContentGrid = CompareContentGrid;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var ScheduleAction = (function (_super) {
            __extends(ScheduleAction, _super);
            function ScheduleAction() {
                _super.call(this, "Schedule");
            }
            return ScheduleAction;
        })(api.ui.Action);
        wizard.ScheduleAction = ScheduleAction;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var ContentPermissionsAppliedEvent = (function (_super) {
            __extends(ContentPermissionsAppliedEvent, _super);
            function ContentPermissionsAppliedEvent(content) {
                _super.call(this);
                this.content = content;
            }
            ContentPermissionsAppliedEvent.prototype.getContent = function () {
                return this.content;
            };
            ContentPermissionsAppliedEvent.on = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.bind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            ContentPermissionsAppliedEvent.un = function (handler, contextWindow) {
                if (contextWindow === void 0) { contextWindow = window; }
                api.event.Event.unbind(api.ClassHelper.getFullName(this), handler, contextWindow);
            };
            return ContentPermissionsAppliedEvent;
        })(api.event.Event);
        wizard.ContentPermissionsAppliedEvent = ContentPermissionsAppliedEvent;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var AccessControlComboBox = api.ui.security.acl.AccessControlComboBox;
        var AccessControlList = api.security.acl.AccessControlList;
        var EditPermissionsDialog = (function (_super) {
            __extends(EditPermissionsDialog, _super);
            function EditPermissionsDialog() {
                var _this = this;
                this.dialogTitle = new EditPermissionsDialogTitle('Edit Permissions', '');
                _super.call(this, {
                    title: this.dialogTitle
                });
                this.addClass('edit-permissions-dialog');
                this.inheritPermissionsCheck = new api.ui.Checkbox().setLabel('Inherit permissions');
                this.inheritPermissionsCheck.addClass('inherit-perm-check');
                this.appendChildToContentPanel(this.inheritPermissionsCheck);
                var section = new api.dom.SectionEl();
                this.appendChildToContentPanel(section);
                var form = new api.ui.form.Form();
                section.appendChild(form);
                this.comboBox = new AccessControlComboBox();
                this.comboBox.addClass('principal-combobox');
                form.appendChild(this.comboBox);
                var comboBoxChangeListener = function () {
                    var currentEntries = _this.getEntries().sort();
                    var permissionsModified = !api.ObjectHelper.arrayEquals(currentEntries, _this.originalValues);
                    var inheritCheckModified = _this.inheritPermissionsCheck.isChecked() !== _this.originalInherit;
                    var overwriteModified = _this.overwriteChildPermissionsCheck.isChecked();
                    _this.applyAction.setEnabled(permissionsModified || inheritCheckModified || overwriteModified);
                };
                var changeListener = function () {
                    var inheritPermissions = _this.inheritPermissionsCheck.isChecked();
                    _this.comboBox.toggleClass('disabled', inheritPermissions);
                    if (inheritPermissions) {
                        _this.layoutInheritedPermissions();
                    }
                    _this.comboBox.getComboBox().setVisible(!inheritPermissions);
                    _this.comboBox.setEditable(!inheritPermissions);
                    comboBoxChangeListener();
                };
                this.inheritPermissionsCheck.onValueChanged(changeListener);
                this.overwriteChildPermissionsCheck = new api.ui.Checkbox().setLabel('Overwrite child permissions');
                this.overwriteChildPermissionsCheck.addClass('overwrite-child-check');
                this.appendChildToContentPanel(this.overwriteChildPermissionsCheck);
                this.applyAction = new api.ui.Action('Apply');
                this.applyAction.onExecuted(function () {
                    _this.applyPermissions();
                });
                this.addAction(this.applyAction, true);
                api.dom.Body.get().appendChild(this);
                this.comboBox.onOptionValueChanged(comboBoxChangeListener);
                this.comboBox.onOptionSelected(comboBoxChangeListener);
                this.comboBox.onOptionDeselected(comboBoxChangeListener);
                this.overwriteChildPermissionsCheck.onValueChanged(comboBoxChangeListener);
                this.parentPermissions = [];
                api.content.OpenEditPermissionsDialogEvent.on(function (event) {
                    _this.content = event.getContent();
                    _this.getParentPermissions().then(function (parentPermissions) {
                        _this.parentPermissions = parentPermissions.getEntries();
                        _this.setUpDialog();
                        _this.open();
                    }).catch(function () {
                        api.notify.showWarning('Could not read inherit permissions for content ' + _this.content.getPath().toString());
                    }).done();
                });
                this.addCancelButtonToBottom();
            }
            EditPermissionsDialog.prototype.applyPermissions = function () {
                var _this = this;
                var permissions = new AccessControlList(this.getEntries());
                var req = new api.content.ApplyContentPermissionsRequest().setId(this.content.getId()).
                    setInheritPermissions(this.inheritPermissionsCheck.isChecked()).
                    setPermissions(permissions).
                    setOverwriteChildPermissions(this.overwriteChildPermissionsCheck.isChecked());
                var res = req.sendAndParse();
                res.done(function (updatedContent) {
                    new wizard.ContentPermissionsAppliedEvent(updatedContent).fire();
                    api.notify.showFeedback('Permissions applied to content ' + updatedContent.getPath().toString());
                    _this.close();
                });
            };
            EditPermissionsDialog.prototype.setUpDialog = function () {
                var _this = this;
                this.comboBox.clearSelection(true);
                this.overwriteChildPermissionsCheck.setChecked(false);
                var contentPermissions = this.content.getPermissions();
                var contentPermissionsEntries = contentPermissions.getEntries();
                this.originalValues = contentPermissionsEntries.sort();
                this.originalInherit = this.content.isInheritPermissionsEnabled();
                this.originalValues.forEach(function (item) {
                    if (!_this.comboBox.isSelected(item)) {
                        _this.comboBox.select(item);
                    }
                });
                this.inheritPermissionsCheck.setChecked(this.content.isInheritPermissionsEnabled());
                this.comboBox.giveFocus();
            };
            EditPermissionsDialog.prototype.layoutInheritedPermissions = function () {
                var _this = this;
                this.comboBox.clearSelection(true);
                this.parentPermissions.forEach(function (item) {
                    if (!_this.comboBox.isSelected(item)) {
                        _this.comboBox.select(item);
                    }
                });
            };
            EditPermissionsDialog.prototype.getEntries = function () {
                return this.comboBox.getSelectedDisplayValues();
            };
            EditPermissionsDialog.prototype.getParentPermissions = function () {
                var _this = this;
                var deferred = wemQ.defer();
                var parentPath = this.content.getPath().getParentPath();
                if (parentPath && parentPath.isNotRoot()) {
                    new api.content.GetContentByPathRequest(parentPath).sendAndParse().then(function (content) {
                        deferred.resolve(content.getPermissions());
                    }).catch(function (reason) {
                        deferred.reject(new Error("Inherit permissions for [" + _this.content.getPath().toString() +
                            "] could not be retrieved"));
                    }).done();
                }
                else {
                    new api.content.GetContentRootPermissionsRequest().sendAndParse().then(function (rootPermissions) {
                        deferred.resolve(rootPermissions);
                    }).catch(function (reason) {
                        deferred.reject(new Error("Inherit permissions for [" + _this.content.getPath().toString() +
                            "] could not be retrieved"));
                    }).done();
                }
                return deferred.promise;
            };
            EditPermissionsDialog.prototype.show = function () {
                if (this.content) {
                    this.dialogTitle.setPath(this.content.getPath().toString());
                }
                else {
                    this.dialogTitle.setPath('');
                }
                _super.prototype.show.call(this);
                if (this.comboBox.getComboBox().isVisible()) {
                    this.comboBox.giveFocus();
                }
                else {
                    this.inheritPermissionsCheck.giveFocus();
                }
            };
            return EditPermissionsDialog;
        })(api.ui.dialog.ModalDialog);
        wizard.EditPermissionsDialog = EditPermissionsDialog;
        var EditPermissionsDialogTitle = (function (_super) {
            __extends(EditPermissionsDialogTitle, _super);
            function EditPermissionsDialogTitle(title, path) {
                _super.call(this, title);
                this.pathEl = new api.dom.PEl('path');
                this.pathEl.setHtml(path);
                this.appendChild(this.pathEl);
            }
            EditPermissionsDialogTitle.prototype.setPath = function (path) {
                this.pathEl.setHtml(path);
            };
            return EditPermissionsDialogTitle;
        })(api.ui.dialog.ModalDialogHeader);
        wizard.EditPermissionsDialogTitle = EditPermissionsDialogTitle;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var DialogButton = api.ui.dialog.DialogButton;
        var SpanEl = api.dom.SpanEl;
        var CompareStatus = api.content.CompareStatus;
        var ContentWizardToolbarPublishControls = (function (_super) {
            __extends(ContentWizardToolbarPublishControls, _super);
            function ContentWizardToolbarPublishControls(action) {
                _super.call(this, "toolbar-publish-controls");
                this.contentCanBePublished = false;
                this.userCanPublish = true;
                this.publishAction = action;
                this.publishAction.setIconClass("publish-action");
                this.publishButton = new DialogButton(action);
                this.publishButton.addClass("content-wizard-toolbar-publish-button");
                this.contentStateSpan = new SpanEl("content-status");
                this.appendChildren(this.contentStateSpan, this.publishButton);
            }
            ContentWizardToolbarPublishControls.prototype.setCompareStatus = function (compareStatus, refresh) {
                if (refresh === void 0) { refresh = true; }
                this.contentCompareStatus = compareStatus;
                if (refresh) {
                    this.refreshState();
                }
            };
            ContentWizardToolbarPublishControls.prototype.setContentCanBePublished = function (value, refresh) {
                if (refresh === void 0) { refresh = true; }
                this.contentCanBePublished = value;
                if (refresh) {
                    this.refreshState();
                }
            };
            ContentWizardToolbarPublishControls.prototype.setUserCanPublish = function (value, refresh) {
                if (refresh === void 0) { refresh = true; }
                this.userCanPublish = value;
                if (refresh) {
                    this.refreshState();
                }
            };
            ContentWizardToolbarPublishControls.prototype.refreshState = function () {
                var canBeEnabled = this.contentCompareStatus !== CompareStatus.EQUAL && this.contentCanBePublished && this.userCanPublish;
                this.publishAction.setEnabled(canBeEnabled);
                this.contentStateSpan.setHtml(this.getContentStateValueForSpan(this.contentCompareStatus), false);
            };
            ContentWizardToolbarPublishControls.prototype.isOnline = function () {
                return this.contentCompareStatus === CompareStatus.EQUAL;
            };
            ContentWizardToolbarPublishControls.prototype.isPendingDelete = function () {
                return this.contentCompareStatus == CompareStatus.PENDING_DELETE;
            };
            ContentWizardToolbarPublishControls.prototype.enableActionsForExisting = function (existing) {
                var _this = this;
                new api.security.auth.IsAuthenticatedRequest().
                    sendAndParse().
                    then(function (loginResult) {
                    var hasPublishPermission = api.security.acl.PermissionHelper.hasPermission(api.security.acl.Permission.PUBLISH, loginResult, existing.getPermissions());
                    _this.setUserCanPublish(hasPublishPermission);
                });
            };
            ContentWizardToolbarPublishControls.prototype.getContentStateValueForSpan = function (compareStatus) {
                var status = new api.dom.SpanEl();
                if (compareStatus === CompareStatus.EQUAL) {
                    status.addClass("online");
                }
                status.setHtml(api.content.CompareStatusFormatter.formatStatus(compareStatus));
                return "Item is " + status.toString();
            };
            return ContentWizardToolbarPublishControls;
        })(api.dom.DivEl);
        wizard.ContentWizardToolbarPublishControls = ContentWizardToolbarPublishControls;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var PageItemType = api.liveedit.PageItemType;
        var TextItemType = api.liveedit.text.TextItemType;
        var FragmentItemType = api.liveedit.fragment.FragmentItemType;
        var TextComponent = api.content.page.region.TextComponent;
        var PageComponentsItemViewer = (function (_super) {
            __extends(PageComponentsItemViewer, _super);
            function PageComponentsItemViewer(content) {
                this.content = content;
                _super.call(this, 'page-components-item-viewer');
            }
            PageComponentsItemViewer.prototype.resolveDisplayName = function (object) {
                if (api.ObjectHelper.iFrameSafeInstanceOf(object.getType(), TextItemType)) {
                    var textView = object;
                    var textComponent = textView.getComponent();
                    var viewer = object.getViewer();
                    return viewer.resolveDisplayName(textComponent, textView);
                }
                else if (api.ObjectHelper.iFrameSafeInstanceOf(object.getType(), FragmentItemType)) {
                    var fragmentView = object;
                    var fragmentComponent = fragmentView.getFragmentRootComponent();
                    if (fragmentComponent) {
                        if (api.ObjectHelper.iFrameSafeInstanceOf(fragmentComponent, TextComponent)) {
                            return this.extractTextFromTextComponent(fragmentComponent);
                        }
                        return fragmentComponent.getName().toString();
                    }
                }
                return object.getName();
            };
            PageComponentsItemViewer.prototype.resolveSubName = function (object, relativePath) {
                if (relativePath === void 0) { relativePath = false; }
                if (api.ObjectHelper.iFrameSafeInstanceOf(object.getType(), FragmentItemType)) {
                    var fragmentView = object;
                    var fragmentComponent = fragmentView.getFragmentRootComponent();
                    if (fragmentComponent) {
                        return fragmentComponent.getType().getShortName();
                    }
                }
                return object.getType() ? object.getType().getShortName() : "";
            };
            PageComponentsItemViewer.prototype.resolveIconUrl = function (object) {
                if (PageItemType.get().equals(object.getType())) {
                    return object.getIconUrl(this.content);
                }
                return null;
            };
            PageComponentsItemViewer.prototype.resolveIconClass = function (object) {
                return object.getIconClass();
            };
            PageComponentsItemViewer.prototype.extractTextFromTextComponent = function (textComponent) {
                var tmp = document.createElement("DIV");
                tmp.innerHTML = textComponent.getText();
                return (tmp.textContent || tmp.innerText || "").trim();
            };
            return PageComponentsItemViewer;
        })(api.ui.NamesAndIconViewer);
        wizard.PageComponentsItemViewer = PageComponentsItemViewer;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var GridColumnBuilder = api.ui.grid.GridColumnBuilder;
        var GridOptionsBuilder = api.ui.grid.GridOptionsBuilder;
        var TreeGrid = api.ui.treegrid.TreeGrid;
        var TreeGridBuilder = api.ui.treegrid.TreeGridBuilder;
        var PageView = api.liveedit.PageView;
        var PageItemType = api.liveedit.PageItemType;
        var RegionItemType = api.liveedit.RegionItemType;
        var RegionView = api.liveedit.RegionView;
        var LayoutItemType = api.liveedit.layout.LayoutItemType;
        var PageComponentsTreeGrid = (function (_super) {
            __extends(PageComponentsTreeGrid, _super);
            function PageComponentsTreeGrid(content, pageView) {
                this.content = content;
                this.pageView = pageView;
                _super.call(this, new TreeGridBuilder().
                    setColumns([
                    new GridColumnBuilder().
                        setName("Name").
                        setId("displayName").
                        setField("displayName").
                        setFormatter(this.nameFormatter.bind(this)).
                        setMinWidth(250).
                        setBehavior("selectAndMove").
                        build(),
                    new GridColumnBuilder().
                        setName("Menu").
                        setId("menu").
                        setMinWidth(45).
                        setMaxWidth(45).
                        setField("menu").
                        setCssClass("menu-cell").
                        setFormatter(this.menuFormatter).
                        build()
                ]).
                    setOptions(new GridOptionsBuilder().
                    setAutoHeight(true).
                    setShowHeaderRow(false).
                    setHideColumnHeaders(true).
                    setForceFitColumns(true).
                    setFullWidthRows(true).
                    setEnableCellNavigation(false).
                    setSelectedCellCssClass("selected cell").
                    setCheckableRows(false).
                    disableMultipleSelection(true).
                    setMultiSelect(false).
                    setRowHeight(45).
                    setDragAndDrop(true).
                    build()).
                    setShowToolbar(false).
                    setAutoLoad(true).
                    setExpandAll(true).
                    prependClasses("components-grid"));
                this.gridDragHandler = new wizard.PageComponentsGridDragHandler(this);
            }
            PageComponentsTreeGrid.prototype.queryScrollable = function () {
                return this;
            };
            PageComponentsTreeGrid.prototype.setPageView = function (pageView) {
                this.pageView = pageView;
                return this.reload();
            };
            PageComponentsTreeGrid.prototype.nameFormatter = function (row, cell, value, columnDef, node) {
                var viewer = node.getViewer("name");
                if (!viewer) {
                    var viewer = new wizard.PageComponentsItemViewer(this.content);
                    var data = node.getData();
                    viewer.setObject(data);
                    node.setViewer("name", viewer);
                    if (!(api.ObjectHelper.iFrameSafeInstanceOf(data, RegionView) || api.ObjectHelper.iFrameSafeInstanceOf(data, PageView))) {
                        viewer.addClass("draggable");
                    }
                }
                return viewer.toString();
            };
            PageComponentsTreeGrid.prototype.getDataId = function (data) {
                return data.getItemId().toString();
            };
            PageComponentsTreeGrid.prototype.hasChildren = function (data) {
                return this.getDataChildren(data).length > 0;
            };
            PageComponentsTreeGrid.prototype.fetch = function (node, dataId) {
                var deferred = wemQ.defer();
                var itemViewId = dataId ? new api.liveedit.ItemViewId(parseInt(dataId)) : node.getData().getItemId();
                deferred.resolve(this.pageView.getItemViewById(itemViewId));
                return deferred.promise;
            };
            PageComponentsTreeGrid.prototype.fetchRoot = function () {
                var deferred = wemQ.defer();
                if (this.pageView.getFragmentView()) {
                    deferred.resolve([this.pageView.getFragmentView()]);
                }
                else {
                    deferred.resolve([this.pageView]);
                }
                return deferred.promise;
            };
            PageComponentsTreeGrid.prototype.fetchChildren = function (parentNode) {
                var deferred = wemQ.defer();
                deferred.resolve(this.getDataChildren(parentNode.getData()));
                return deferred.promise;
            };
            PageComponentsTreeGrid.prototype.getDataChildren = function (data) {
                var children = [];
                var dataType = data.getType();
                if (PageItemType.get().equals(dataType)) {
                    var pageView = data;
                    children = pageView.getRegions();
                    if (children.length === 0) {
                        var fragmentRoot = pageView.getFragmentView();
                        if (fragmentRoot) {
                            return [fragmentRoot];
                        }
                    }
                }
                else if (RegionItemType.get().equals(dataType)) {
                    var regionView = data;
                    children = regionView.getComponentViews();
                }
                else if (LayoutItemType.get().equals(dataType)) {
                    var layoutView = data;
                    children = layoutView.getRegions();
                }
                return children;
            };
            PageComponentsTreeGrid.prototype.menuFormatter = function (row, cell, value, columnDef, node) {
                var wrapper = new api.dom.SpanEl();
                var icon = new api.dom.DivEl("menu-icon");
                wrapper.getEl().setInnerHtml(icon.toString(), false);
                return wrapper.toString();
            };
            return PageComponentsTreeGrid;
        })(TreeGrid);
        wizard.PageComponentsTreeGrid = PageComponentsTreeGrid;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var TextComponentView = api.liveedit.text.TextComponentView;
        var FragmentComponentView = api.liveedit.fragment.FragmentComponentView;
        var Mask = api.ui.mask.Mask;
        var ResponsiveManager = api.ui.responsive.ResponsiveManager;
        var ResponsiveRanges = api.ui.responsive.ResponsiveRanges;
        var PageComponentsView = (function (_super) {
            __extends(PageComponentsView, _super);
            function PageComponentsView(liveEditPage) {
                var _this = this;
                _super.call(this, 'page-components-view');
                this.selectionChangedHandler = api.util.AppHelper.debounce(this.selectItem, 500, this.clicked);
                this.beforeInsertActionListeners = [];
                this.mouseDown = false;
                this.liveEditPage = liveEditPage;
                this.onHidden(function (event) { return _this.hideContextMenu(); });
                var closeButton = new api.ui.button.CloseButton();
                closeButton.onClicked(function (event) { return _this.hide(); });
                this.onRemoved(function () {
                    if (_this.contextMenu) {
                        _this.contextMenu.remove();
                    }
                });
                this.header = new api.dom.H2El('header');
                this.header.setHtml('Components');
                this.appendChildren(closeButton, this.header);
                this.setModal(false).setFloating(true).setDraggable(true);
                this.onShown(function (event) {
                    _this.constrainToParent();
                    _this.getHTMLElement().style.display = "";
                    if (_this.pageView && _this.pageView.isLocked()) {
                        _this.mask.show();
                    }
                });
                this.responsiveItem = ResponsiveManager.onAvailableSizeChanged(api.dom.Body.get(), function (item) {
                    var smallSize = item.isInRangeOrSmaller(ResponsiveRanges._360_540);
                    if (!smallSize && _this.isVisible()) {
                        _this.constrainToParent();
                    }
                    if (item.isRangeSizeChanged()) {
                        _this.setModal(smallSize).setDraggable(!smallSize);
                    }
                });
            }
            PageComponentsView.prototype.setPageView = function (pageView) {
                var _this = this;
                if (this.mask) {
                    this.destroyMask();
                }
                this.pageView = pageView;
                if (!this.tree && this.content && this.pageView) {
                    this.createTree(this.content, this.pageView);
                    this.initMask();
                }
                else if (this.tree) {
                    this.tree.deselectAll();
                    this.tree.setPageView(pageView).then(function () {
                        _this.initMask();
                    });
                }
                this.pageView.onRemoved(function () {
                    ResponsiveManager.unAvailableSizeChangedByItem(_this.responsiveItem);
                });
                this.pageView.onPageLocked(this.pageLockedHandler.bind(this));
            };
            PageComponentsView.prototype.destroyMask = function () {
                this.mask.remove();
                this.mask = null;
                if (this.pageView) {
                    this.pageView.unPageLocked(this.pageLockedHandler.bind(this));
                }
            };
            PageComponentsView.prototype.initMask = function () {
                var _this = this;
                this.mask = new Mask(this.tree);
                this.appendChild(this.mask);
                if (this.pageView.isLocked()) {
                    this.mask.show();
                }
                this.mask.onContextMenu(function (event) { return _this.maskClickHandler(event); });
                this.mask.onClicked(function (event) { return _this.maskClickHandler(event); });
            };
            PageComponentsView.prototype.setContent = function (content) {
                this.content = content;
                if (!this.tree && this.content && this.pageView) {
                    this.createTree(this.content, this.pageView);
                }
            };
            PageComponentsView.prototype.createTree = function (content, pageView) {
                var _this = this;
                this.tree = new wizard.PageComponentsTreeGrid(content, pageView);
                this.liveEditPage.onItemViewSelected(function (event) {
                    if (!event.isNew() && !_this.pageView.isLocked()) {
                        var selectedItemId = _this.tree.getDataId(event.getItemView());
                        _this.tree.selectNode(selectedItemId);
                        _this.tree.getGrid().focus();
                    }
                });
                this.liveEditPage.onItemViewDeselected(function (event) {
                    _this.tree.deselectNodes([_this.tree.getDataId(event.getItemView())]);
                });
                this.liveEditPage.onComponentAdded(function (event) {
                    var parentNode = _this.tree.getRoot().getCurrentRoot().findNode(_this.tree.getDataId(event.getParentRegionView()));
                    if (parentNode) {
                        _this.tree.deselectAll();
                        var index = event.getParentRegionView().getComponentViews().indexOf(event.getComponentView());
                        if (index >= 0) {
                            _this.tree.insertNode(event.getComponentView(), false, index, parentNode).then(function () {
                                _this.tree.expandNode(parentNode);
                                if (event.getComponentView().isSelected()) {
                                    _this.tree.selectNode(_this.tree.getDataId(event.getComponentView()));
                                }
                                if (_this.tree.hasChildren(event.getComponentView())) {
                                    var componentNode = _this.tree.getRoot().getCurrentRoot().findNode(_this.tree.getDataId(event.getComponentView()));
                                    _this.tree.expandNode(componentNode, true);
                                }
                                if (api.ObjectHelper.iFrameSafeInstanceOf(event.getComponentView(), TextComponentView)) {
                                    _this.bindTreeTextNodeUpdateOnTextComponentModify(event.getComponentView());
                                }
                                if (api.ObjectHelper.iFrameSafeInstanceOf(event.getComponentView(), FragmentComponentView)) {
                                    _this.bindTreeFragmentNodeUpdateOnComponentLoaded(event.getComponentView());
                                }
                                _this.constrainToParent();
                            });
                        }
                    }
                });
                this.liveEditPage.onComponentRemoved(function (event) {
                    _this.tree.deleteNode(event.getComponentView());
                    _this.tree.updateNode(event.getParentRegionView()).then(function () {
                        _this.tree.refresh();
                    });
                });
                this.liveEditPage.onComponentLoaded(function (event) {
                    var oldDataId = _this.tree.getDataId(event.getOldComponentView());
                    var oldNode = _this.tree.getRoot().getCurrentRoot().findNode(oldDataId);
                    oldNode.removeChildren();
                    _this.tree.updateNode(event.getNewComponentView(), oldDataId).then(function () {
                        var newDataId = _this.tree.getDataId(event.getNewComponentView());
                        if (_this.tree.hasChildren(event.getNewComponentView())) {
                            var newNode = _this.tree.getRoot().getCurrentRoot().findNode(newDataId);
                            _this.tree.expandNode(newNode, true);
                        }
                        if (event.getNewComponentView().isSelected()) {
                            _this.tree.selectNode(newDataId);
                            _this.scrollToItem(newDataId);
                        }
                        if (api.ObjectHelper.iFrameSafeInstanceOf(event.getNewComponentView(), TextComponentView)) {
                            _this.bindTreeTextNodeUpdateOnTextComponentModify(event.getNewComponentView());
                        }
                        if (api.ObjectHelper.iFrameSafeInstanceOf(event.getNewComponentView(), FragmentComponentView)) {
                            _this.bindTreeFragmentNodeUpdateOnComponentLoaded(event.getNewComponentView());
                        }
                    });
                });
                this.liveEditPage.onComponentReset(function (event) {
                    var oldDataId = _this.tree.getDataId(event.getOldComponentView());
                    if (_this.tree.hasChildren(event.getOldComponentView())) {
                        var oldNode = _this.tree.getRoot().getCurrentRoot().findNode(oldDataId);
                        oldNode.removeChildren();
                        _this.tree.refreshNode(oldNode);
                    }
                    _this.tree.updateNode(event.getNewComponentView(), oldDataId).then(function () {
                        if (event.getNewComponentView().isSelected()) {
                            var newDataId = _this.tree.getDataId(event.getNewComponentView());
                            _this.tree.selectNode(newDataId);
                        }
                    });
                });
                this.clickListener = function (event, data) {
                    var elem = new api.dom.ElementHelper(event.target);
                    if (_this.sameRowClicked(data.row)) {
                        _this.hideContextMenu();
                    }
                    else {
                        _this.clicked = true;
                    }
                    if (elem.hasClass('toggle')) {
                        return;
                    }
                    _this.tree.getGrid().selectRow(data.row);
                    api.liveedit.Highlighter.get().hide();
                    if (_this.isMenuIconClicked(data.cell)) {
                        _this.showContextMenu(data.row, { x: event.pageX, y: event.pageY });
                    }
                    if (_this.isModal()) {
                        _this.hide();
                    }
                };
                this.tree.getGrid().subscribeOnClick(this.clickListener);
                this.tree.getGrid().subscribeOnMouseEnter(function (event, data) {
                    if (api.ui.DragHelper.get().isVisible()) {
                        return;
                    }
                    var rowElement = event.target, selected = false;
                    while (!rowElement.classList.contains("slick-row")) {
                        if (rowElement.classList.contains("selected")) {
                            selected = true;
                        }
                        rowElement = rowElement.parentElement;
                    }
                    if (!_this.pageView.isLocked()) {
                        _this.highlightRow(rowElement, selected);
                    }
                });
                this.tree.getGrid().subscribeOnMouseLeave(function (event, data) {
                    api.liveedit.Highlighter.get().hide();
                });
                this.tree.onSelectionChanged(function (data, nodes) {
                    if (nodes.length > 0 && _this.isModal()) {
                        _this.hide();
                    }
                    var treeNode = data[0];
                    if (treeNode && !treeNode.getData().isSelected()) {
                        _this.clicked ? _this.selectItem(treeNode) :
                            _this.selectionChangedHandler(treeNode);
                        _this.clicked = false;
                    }
                    _this.hideContextMenu();
                });
                this.tree.getGrid().subscribeOnContextMenu(function (event) {
                    event.stopPropagation();
                    event.preventDefault();
                    var cell = _this.tree.getGrid().getCellFromEvent(event);
                    _this.showContextMenu(cell.row, { x: event.pageX, y: event.pageY });
                });
                this.appendChild(this.tree);
                this.tree.onRemoved(function (event) { return _this.tree.getGrid().unsubscribeOnClick(_this.clickListener); });
                this.tree.onLoaded(function () { return _this.bindTextComponentViewsUpdateOnTextModify(); });
            };
            PageComponentsView.prototype.bindTextComponentViewsUpdateOnTextModify = function () {
                var _this = this;
                this.tree.getGrid().getDataView().getItems().map(function (dataItem) {
                    return dataItem.getData();
                }).filter(function (itemView) {
                    return api.ObjectHelper.iFrameSafeInstanceOf(itemView, TextComponentView);
                }).forEach(function (textComponentView) {
                    _this.bindTreeTextNodeUpdateOnTextComponentModify(textComponentView);
                });
            };
            PageComponentsView.prototype.bindTreeTextNodeUpdateOnTextComponentModify = function (textComponentView) {
                var _this = this;
                var handler = function () { return _this.tree.updateNode(textComponentView); };
                textComponentView.onKeyUp(handler);
                textComponentView.getHTMLElement().onpaste = handler;
            };
            PageComponentsView.prototype.bindTreeFragmentNodeUpdateOnComponentLoaded = function (fragmentComponentView) {
                var _this = this;
                fragmentComponentView.onFragmentContentLoaded(function (e) {
                    _this.tree.updateNode(e.getFragmentComponentView());
                });
            };
            PageComponentsView.prototype.selectItem = function (treeNode) {
                treeNode.getData().selectWithoutMenu();
                this.scrollToItem(treeNode.getDataId());
            };
            PageComponentsView.prototype.isDraggable = function () {
                return this.draggable;
            };
            PageComponentsView.prototype.setDraggable = function (draggable) {
                var _this = this;
                var body = api.dom.Body.get();
                if (!this.draggable && draggable) {
                    var lastPos;
                    if (!this.mouseDownListener) {
                        this.mouseDownListener = function (event) {
                            if (PageComponentsView.debug) {
                                console.log('mouse down', _this.mouseDown, event);
                            }
                            if (!_this.mouseDown && event.buttons == 1) {
                                event.preventDefault();
                                event.stopPropagation();
                                _this.mouseDown = true;
                                lastPos = {
                                    x: event.clientX,
                                    y: event.clientY
                                };
                            }
                        };
                    }
                    if (!this.mouseUpListener) {
                        this.mouseUpListener = function (event) {
                            if (PageComponentsView.debug) {
                                console.log('mouse up', _this.mouseDown, event);
                            }
                            if (_this.mouseDown) {
                                if (event) {
                                    event.preventDefault();
                                    event.stopPropagation();
                                }
                                _this.mouseDown = false;
                            }
                        };
                    }
                    if (!this.mouseMoveListener) {
                        this.mouseMoveListener = function (event) {
                            if (_this.mouseDown) {
                                if (event.buttons != 1) {
                                    _this.mouseUpListener();
                                    return;
                                }
                                event.preventDefault();
                                event.stopPropagation();
                                var el = _this.getEl(), newPos = {
                                    x: event.clientX,
                                    y: event.clientY
                                }, offset = el.getOffset(), newOffset = {
                                    top: offset.top + newPos.y - lastPos.y,
                                    left: offset.left + newPos.x - lastPos.x
                                };
                                _this.constrainToParent(newOffset);
                                lastPos = newPos;
                                _this.hideContextMenu();
                            }
                        };
                    }
                    this.header.onMouseDown(this.mouseDownListener);
                    body.onMouseUp(this.mouseUpListener);
                    body.onMouseMove(this.mouseMoveListener);
                }
                else if (this.draggable && !draggable) {
                    this.header.unMouseDown(this.mouseDownListener);
                    body.unMouseUp(this.mouseUpListener);
                    body.unMouseMove(this.mouseMoveListener);
                }
                this.toggleClass('draggable', draggable);
                this.draggable = draggable;
                return this;
            };
            PageComponentsView.prototype.constrainToParent = function (offset) {
                var parentEl, parentOffset, el = this.getEl(), offset = offset || el.getOffset();
                if (this.getParentElement()) {
                    parentEl = this.getParentElement().getEl();
                    parentOffset = parentEl.getOffset();
                }
                else {
                    parentEl = api.dom.WindowDOM.get();
                    parentOffset = {
                        top: 0,
                        left: 0
                    };
                }
                el.setMaxHeightPx(parentEl.getHeight());
                el.setOffset({
                    top: Math.max(parentOffset.top, Math.min(offset.top, parentOffset.top + parentEl.getHeight() - el.getHeightWithBorder())),
                    left: Math.max(parentOffset.left, Math.min(offset.left, parentOffset.left + parentEl.getWidth() - el.getWidthWithBorder()))
                });
            };
            PageComponentsView.prototype.isFloating = function () {
                return this.floating;
            };
            PageComponentsView.prototype.setFloating = function (floating) {
                this.toggleClass('floating', floating);
                this.floating = floating;
                return this;
            };
            PageComponentsView.prototype.isModal = function () {
                return this.modal;
            };
            PageComponentsView.prototype.setModal = function (modal) {
                this.toggleClass('modal', modal);
                if (this.tree) {
                    this.tree.getGrid().resizeCanvas();
                }
                this.modal = modal;
                return this;
            };
            PageComponentsView.prototype.scrollToItem = function (dataId) {
                var node = this.tree.getRoot().getCurrentRoot().findNode(dataId);
                if (node) {
                    node.getData().scrollComponentIntoView();
                    this.tree.scrollToRow(this.tree.getGrid().getDataView().getRowById(node.getId()));
                }
            };
            PageComponentsView.prototype.pageLockedHandler = function (value) {
                if (this.mask) {
                    if (value) {
                        this.mask.show();
                    }
                    else {
                        this.mask.hide();
                    }
                }
            };
            PageComponentsView.prototype.maskClickHandler = function (event) {
                event.stopPropagation();
                event.preventDefault();
                if (this.contextMenu && this.contextMenu.isVisible()) {
                    this.hideContextMenu();
                }
                else {
                    this.showContextMenu(null, { x: event.pageX, y: event.pageY });
                }
            };
            PageComponentsView.prototype.isMenuIconClicked = function (cellNumber) {
                return cellNumber == 1;
            };
            PageComponentsView.prototype.showContextMenu = function (row, clickPosition) {
                var _this = this;
                var node = this.tree.getGrid().getDataView().getItem(row);
                if (node) {
                    var itemView = node.getData(), pageView = itemView.getPageView();
                }
                else {
                    pageView = this.pageView;
                }
                var contextMenuActions;
                if (pageView.isLocked()) {
                    contextMenuActions = pageView.getLockedMenuActions();
                }
                else {
                    contextMenuActions = itemView.getContextMenuActions();
                }
                if (!this.contextMenu) {
                    this.contextMenu = new api.liveedit.ItemViewContextMenu(null, contextMenuActions, false);
                    this.contextMenu.onHidden(this.removeMenuOpenStyleFromMenuIcon.bind(this));
                }
                else {
                    this.contextMenu.setActions(contextMenuActions);
                }
                this.contextMenu.getMenu().onBeforeAction(function (action) {
                    _this.pageView.setDisabledContextMenu(true);
                    if (action.hasParentAction() && action.getParentAction().getLabel() == "Insert") {
                        _this.notifyBeforeInsertAction();
                    }
                });
                this.contextMenu.getMenu().onAfterAction(function (action) {
                    setTimeout(function () {
                        _this.pageView.setDisabledContextMenu(false);
                        _this.contextMenu.getMenu().clearActionListeners();
                    }, 500);
                });
                this.setMenuOpenStyleOnMenuIcon(row);
                var x = clickPosition.x;
                var y = clickPosition.y;
                this.contextMenu.showAt(x, y, false);
            };
            PageComponentsView.prototype.setMenuOpenStyleOnMenuIcon = function (row) {
                var stylesHash = {};
                stylesHash[row] = { menu: "menu-open" };
                this.tree.getGrid().setCellCssStyles("menu-open", stylesHash);
            };
            PageComponentsView.prototype.removeMenuOpenStyleFromMenuIcon = function () {
                this.tree.getGrid().removeCellCssStyles("menu-open");
            };
            PageComponentsView.prototype.hideContextMenu = function () {
                if (this.contextMenu && this.contextMenu.isVisible()) {
                    this.contextMenu.hide();
                }
            };
            PageComponentsView.prototype.sameRowClicked = function (clickedRow) {
                var currentlySelectedRow = this.tree.getGrid().getSelectedRows()[0];
                return clickedRow == currentlySelectedRow;
            };
            PageComponentsView.prototype.highlightRow = function (rowElement, selected) {
                if (selected) {
                    api.liveedit.Highlighter.get().hide();
                }
                else {
                    var elementHelper = new api.dom.ElementHelper(rowElement);
                    var dimensions = elementHelper.getDimensions();
                    var nodes = this.tree.getRoot().getCurrentRoot().treeToList(), hoveredNode = nodes[new api.dom.ElementHelper(rowElement).getSiblingIndex()];
                    if (hoveredNode) {
                        var data = hoveredNode.getData();
                        if (data.getType().isComponentType()) {
                            api.liveedit.Highlighter.get().highlightElement(dimensions, data.getType().getConfig().getHighlighterStyle());
                        }
                    }
                }
            };
            PageComponentsView.prototype.onBeforeInsertAction = function (listener) {
                this.beforeInsertActionListeners.push(listener);
            };
            PageComponentsView.prototype.unBeforeInsertAction = function (listener) {
                this.beforeInsertActionListeners = this.beforeInsertActionListeners.filter(function (currentListener) {
                    return listener != currentListener;
                });
            };
            PageComponentsView.prototype.notifyBeforeInsertAction = function () {
                var _this = this;
                this.beforeInsertActionListeners.forEach(function (listener) {
                    listener.call(_this);
                });
            };
            PageComponentsView.debug = false;
            return PageComponentsView;
        })(api.dom.DivEl);
        wizard.PageComponentsView = PageComponentsView;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
var app;
(function (app) {
    var wizard;
    (function (wizard) {
        var GridDragHandler = api.ui.grid.GridDragHandler;
        var RegionView = api.liveedit.RegionView;
        var PageView = api.liveedit.PageView;
        var LayoutComponentView = api.liveedit.layout.LayoutComponentView;
        var FragmentComponentView = api.liveedit.fragment.FragmentComponentView;
        var DragHelper = api.ui.DragHelper;
        var ElementHelper = api.dom.ElementHelper;
        var PageComponentsGridDragHandler = (function (_super) {
            __extends(PageComponentsGridDragHandler, _super);
            function PageComponentsGridDragHandler() {
                _super.apply(this, arguments);
            }
            PageComponentsGridDragHandler.prototype.handleDragInit = function (e, dd) {
                var row = this.getRowByTarget(new ElementHelper(e.target)), nodes = this.contentGrid.getRoot().getCurrentRoot().treeToList(), draggedNode = nodes[row.getSiblingIndex()];
                if (draggedNode.getData().isDraggableView()) {
                    e.stopImmediatePropagation();
                }
            };
            PageComponentsGridDragHandler.prototype.handleDragStart = function () {
                _super.prototype.handleDragStart.call(this);
                api.liveedit.Highlighter.get().hide();
                this.getDraggableItem().getChildren().forEach(function (childEl) {
                    childEl.removeClass("selected");
                });
                DragHelper.get().setDropAllowed(true);
                api.dom.Body.get().appendChild(DragHelper.get());
                api.dom.Body.get().onMouseMove(this.handleHelperMove);
                this.contentGrid.onMouseLeave(this.handleMouseLeave);
                this.contentGrid.onMouseEnter(this.handleMouseEnter);
            };
            PageComponentsGridDragHandler.prototype.handleDragEnd = function (event, data) {
                api.dom.Body.get().unMouseMove(this.handleHelperMove);
                api.dom.Body.get().removeChild(DragHelper.get());
                this.contentGrid.unMouseLeave(this.handleMouseLeave);
                this.contentGrid.unMouseEnter(this.handleMouseEnter);
                _super.prototype.handleDragEnd.call(this, event, data);
            };
            PageComponentsGridDragHandler.prototype.handleBeforeMoveRows = function (event, data) {
                var dataList = this.contentGrid.getRoot().getCurrentRoot().treeToList();
                var draggableRow = data.rows[0], insertBefore = data.insertBefore;
                var insertPosition = (draggableRow > insertBefore) ? insertBefore : insertBefore + 1;
                this.updateDragHelperStatus(draggableRow, insertPosition, dataList);
                if (DragHelper.get().isDropAllowed()) {
                    _super.prototype.handleBeforeMoveRows.call(this, event, data);
                }
                return true;
            };
            PageComponentsGridDragHandler.prototype.handleMoveRows = function (event, args) {
                if (DragHelper.get().isDropAllowed()) {
                    _super.prototype.handleMoveRows.call(this, event, args);
                }
            };
            PageComponentsGridDragHandler.prototype.makeMovementInNodes = function (draggableRow, insertBefore) {
                var root = this.contentGrid.getRoot().getCurrentRoot();
                var dataList = root.treeToList();
                var item = dataList.slice(draggableRow, draggableRow + 1)[0];
                var insertPosition = (draggableRow > insertBefore) ? insertBefore : insertBefore + 1;
                this.moveIntoNewParent(item, insertPosition, dataList);
                dataList.splice(dataList.indexOf(item), 1);
                dataList.splice(insertBefore, 0, item);
                return dataList.indexOf(item);
            };
            PageComponentsGridDragHandler.prototype.getModelId = function (model) {
                return model ? model.getItemId() : null;
            };
            PageComponentsGridDragHandler.prototype.handleMovements = function (rowDataId, moveBeforeRowDataId) {
                return;
            };
            PageComponentsGridDragHandler.prototype.moveIntoNewParent = function (item, insertBefore, data) {
                var insertData = this.getParentPosition(insertBefore, data), regionPosition = insertData.parentPosition, insertIndex = insertData.insertIndex;
                var newParent = data[regionPosition];
                if (newParent == item.getParent() && data.indexOf(item) < insertBefore) {
                    insertIndex--;
                }
                this.contentGrid.deselectAll();
                item.getData().deselect();
                item.getData().moveToRegion(newParent.getData(), insertIndex);
                item.getData().select(null, api.liveedit.ItemViewContextMenuPosition.NONE);
                this.contentGrid.refresh();
                return data[regionPosition];
            };
            PageComponentsGridDragHandler.prototype.updateDragHelperStatus = function (draggableRow, insertBeforePos, data) {
                var parentPosition = this.getParentPosition(insertBeforePos, data).parentPosition;
                var parentComponentNode = data[parentPosition], parentComponentView = parentComponentNode.getData(), draggableComponentView = data[draggableRow].getData();
                if (parentComponentView) {
                    if (api.ObjectHelper.iFrameSafeInstanceOf(draggableComponentView, LayoutComponentView)) {
                        if (parentComponentView.getName() != "main") {
                            DragHelper.get().setDropAllowed(false);
                            return;
                        }
                    }
                    if (api.ObjectHelper.iFrameSafeInstanceOf(parentComponentView, RegionView)) {
                        if (api.ObjectHelper.iFrameSafeInstanceOf(draggableComponentView, FragmentComponentView)) {
                            if (api.ObjectHelper.iFrameSafeInstanceOf(parentComponentView.getParentItemView(), LayoutComponentView)) {
                                if (draggableComponentView.containsLayout()) {
                                    DragHelper.get().setDropAllowed(false);
                                    return;
                                }
                            }
                        }
                        DragHelper.get().setDropAllowed(true);
                        var draggableItem = this.getDraggableItem();
                        if (draggableItem) {
                            this.updateDraggableItemPosition(draggableItem, parentComponentNode.calcLevel());
                        }
                        return;
                    }
                }
                DragHelper.get().setDropAllowed(false);
            };
            PageComponentsGridDragHandler.prototype.updateDraggableItemPosition = function (draggableItem, parentLevel) {
                var margin = parentLevel * api.ui.treegrid.TreeGrid.LEVEL_STEP_INDENT;
                var nodes = draggableItem.getEl().getElementsByClassName("toggle icon");
                if (nodes.length == 1) {
                    nodes[0].setMarginLeft(margin + "px");
                }
            };
            PageComponentsGridDragHandler.prototype.getParentPosition = function (insertBeforePos, data) {
                var parentPosition = insertBeforePos, insertIndex = 0;
                if (!data[insertBeforePos - 1]) {
                    return { parentPosition: 0, insertIndex: 0 };
                }
                var calcLevel = data[parentPosition - 1].calcLevel();
                var isFirstChildPosition = (data[insertBeforePos]
                    ? data[insertBeforePos - 1].calcLevel() < data[insertBeforePos].calcLevel()
                    : false) ||
                    (api.ObjectHelper.iFrameSafeInstanceOf(data[insertBeforePos - 1].getData(), RegionView));
                do {
                    parentPosition = parentPosition <= 0 ? 0 : parentPosition - 1;
                    var parentComponentNode = data[parentPosition], parentComponentView = parentComponentNode.getData();
                    if (parentComponentNode.calcLevel() == calcLevel && !isFirstChildPosition) {
                        insertIndex++;
                    }
                } while (!(api.ObjectHelper.iFrameSafeInstanceOf(parentComponentView, RegionView) ||
                    (api.ObjectHelper.iFrameSafeInstanceOf(parentComponentView, LayoutComponentView) &&
                        (parentComponentNode.isExpanded() && parentComponentNode.getChildren().length > 0)) ||
                    api.ObjectHelper.iFrameSafeInstanceOf(parentComponentView, PageView))
                    || (parentComponentNode.calcLevel() >= calcLevel && !isFirstChildPosition));
                return { parentPosition: parentPosition, insertIndex: insertIndex };
            };
            PageComponentsGridDragHandler.prototype.getRowByTarget = function (el) {
                return (el && el.hasClass("slick-row")) ? el : this.getRowByTarget(el.getParent());
            };
            PageComponentsGridDragHandler.prototype.handleMouseLeave = function () {
                DragHelper.get().setVisible(false);
            };
            PageComponentsGridDragHandler.prototype.handleMouseEnter = function () {
                DragHelper.get().setVisible(true);
            };
            PageComponentsGridDragHandler.prototype.handleHelperMove = function (event) {
                DragHelper.get().getEl().setLeftPx(event.pageX);
                DragHelper.get().getEl().setTopPx(event.pageY);
            };
            return PageComponentsGridDragHandler;
        })(GridDragHandler);
        wizard.PageComponentsGridDragHandler = PageComponentsGridDragHandler;
    })(wizard = app.wizard || (app.wizard = {}));
})(app || (app = {}));
///<reference path='ContentSettingsModel.ts' />
///<reference path='ContentWizardStepForm.ts' />
///<reference path='SettingsWizardStepForm.ts' />
///<reference path='SecurityWizardStepForm.ts' />
///<reference path='ContentWizardToolbar.ts' />
///<reference path='DisplayNameScriptExecutor.ts' />
///<reference path='ContentWizardPanel.ts' />
///<reference path='PersistNewContentRoutine.ts' />
///<reference path='UpdatePersistedContentRoutine.ts' />
///<reference path='ContentWizardPanelFactory.ts' />
///<reference path='ContentWizardPanelParams.ts' />
///<reference path='ShowContentFormEvent.ts' />
///<reference path='ShowLiveEditEvent.ts' />
///<reference path='ShowSplitEditEvent.ts' />
///<reference path='CompareContentGrid.ts' />
///<reference path='ScheduleAction.ts' />
///<reference path='ContentPermissionsAppliedEvent.ts' />
///<reference path='EditPermissionsDialog.ts' />
///<reference path='ContentWizardToolbarPublishControls.ts' />
///<reference path='PageComponentsItemViewer.ts' />
///<reference path='PageComponentsTreeGrid.ts' />
///<reference path='PageComponentsView.ts' />
///<reference path='PageComponentsGridDragHandler.ts' />
var components;
(function (components) {
})(components || (components = {}));
var application = (function () {
    var application = new api.app.Application('content-studio', 'Content Studio', 'CM', 'content-studio');
    application.setPath(api.rest.Path.fromString(app.Router.getPath()));
    application.setWindow(window);
    this.serverEventsListener = new api.app.ServerEventsListener([application]);
    var messageId;
    this.lostConnectionDetector = new api.system.LostConnectionDetector();
    this.lostConnectionDetector.setAuthenticated(true);
    this.lostConnectionDetector.onConnectionLost(function () {
        api.notify.NotifyManager.get().hide(messageId);
        messageId = api.notify.showError("Lost connection to server - Please wait until connection is restored", false);
    });
    this.lostConnectionDetector.onSessionExpired(function () {
        api.notify.NotifyManager.get().hide(messageId);
        window.location.href = api.util.UriHelper.getToolUri("");
    });
    this.lostConnectionDetector.onConnectionRestored(function () {
        api.notify.NotifyManager.get().hide(messageId);
    });
    return application;
})();
function getApplication(id) {
    return application;
}
function initToolTip() {
    var ID = api.StyleHelper.getCls("tooltip", api.StyleHelper.COMMON_PREFIX), CLS_ON = "tooltip_ON", FOLLOW = true, DATA = "_tooltip", OFFSET_X = 0, OFFSET_Y = 20, pageX = 0, pageY = 0, showAt = function (e) {
        var ntop = pageY + OFFSET_Y, nleft = pageX + OFFSET_X;
        var tooltipText = api.util.StringHelper.escapeHtml(wemjq(e.target).data(DATA));
        var tooltipWidth = tooltipText.length * 7.5;
        var windowWidth = wemjq(window).width();
        if (nleft + tooltipWidth >= windowWidth) {
            nleft = windowWidth - tooltipWidth;
        }
        wemjq("#" + ID).html(tooltipText).css({
            position: "absolute", top: ntop, left: nleft
        }).show();
    };
    wemjq(document).on("mouseenter", "*[title]", function (e) {
        wemjq(this).data(DATA, wemjq(this).attr("title"));
        wemjq(this).removeAttr("title").addClass(CLS_ON);
        wemjq("<div id='" + ID + "' />").appendTo("body");
        if (e.pageX) {
            pageX = e.pageX;
        }
        if (e.pageY) {
            pageY = e.pageY;
        }
        showAt(e);
    });
    wemjq(document).on("mouseleave click", "." + CLS_ON, function (e) {
        if (wemjq(this).data(DATA)) {
            wemjq(this).attr("title", wemjq(this).data(DATA));
        }
        wemjq(this).removeClass(CLS_ON);
        wemjq("#" + ID).remove();
    });
    if (FOLLOW) {
        wemjq(document).on("mousemove", "." + CLS_ON, showAt);
    }
}
function startApplication() {
    var application = api.app.Application.getApplication();
    var body = api.dom.Body.get();
    var appBar = new api.app.bar.AppBar(application);
    var appPanel = new app.ContentAppPanel(appBar, application.getPath());
    body.appendChild(appBar);
    body.appendChild(appPanel);
    var contentDeleteDialog = new app.remove.ContentDeleteDialog();
    app.browse.ContentDeletePromptEvent.on(function (event) {
        contentDeleteDialog.
            setContentToDelete(event.getModels()).
            setYesCallback(event.getYesCallback()).
            setNoCallback(event.getNoCallback()).
            open();
    });
    app.browse.ContentPublishPromptEvent.on(function (event) {
        var contentPublishDialog = new app.publish.ContentPublishDialog();
        contentPublishDialog.setSelectedContents(event.getModels());
        contentPublishDialog.initAndOpen();
    });
    var newContentDialog = new app.create.NewContentDialog();
    app.browse.ShowNewContentDialogEvent.on(function (event) {
        var parentContent = event.getParentContent()
            ? event.getParentContent().getContentSummary() : null;
        if (parentContent != null) {
            new api.content.GetContentByIdRequest(parentContent.getContentId()).sendAndParse().
                then(function (newParentContent) {
                if (parentContent.hasParent() && parentContent.getType().isTemplateFolder()) {
                    new api.content.GetContentByPathRequest(parentContent.getPath().getParentPath()).
                        sendAndParse().then(function (grandParent) {
                        newContentDialog.setParentContent(newParentContent);
                        newContentDialog.open();
                    }).catch(function (reason) {
                        api.DefaultErrorHandler.handle(reason);
                    }).done();
                }
                else {
                    newContentDialog.setParentContent(newParentContent);
                    newContentDialog.open();
                }
            }).catch(function (reason) {
                api.DefaultErrorHandler.handle(reason);
            }).done();
        }
        else {
            newContentDialog.setParentContent(null);
            newContentDialog.open();
        }
    });
    initToolTip();
    api.util.AppHelper.preventDragRedirect();
    var sortDialog = new app.browse.SortContentDialog();
    var moveDialog = new app.browse.MoveContentDialog();
    var editPermissionsDialog = new app.wizard.EditPermissionsDialog();
    application.setLoaded(true);
    this.serverEventsListener.start();
    this.lostConnectionDetector.startPolling();
    window.onmessage = function (e) {
        if (e.data.appLauncherEvent) {
            var eventType = api.app.AppLauncherEventType[e.data.appLauncherEvent];
            if (eventType == api.app.AppLauncherEventType.Show) {
                appPanel.activateCurrentKeyBindings();
            }
        }
    };
    api.content.event.ContentServerEventsHandler.getInstance().start();
}
///<reference path='../../../common/js/_all.d.ts' />
///<reference path='app/_module.ts' />
///<reference path='app/view/detail/_module.ts' />
///<reference path='app/browse/filter/_module.ts' />
///<reference path='app/action/_module.ts' />
///<reference path='app/browse/action/_module.ts' />
///<reference path='app/browse/action/handler/_module.ts' />
///<reference path='app/browse/_module.ts' />
///<reference path='app/remove/_module.ts' />
///<reference path='app/create/_module.ts' />
///<reference path='app/view/_module.ts' />
///<reference path='app/publish/_module.ts' />
///<reference path='app/wizard/action/_module.ts' />
///<reference path='app/wizard/page/contextwindow/insert/_module.ts' />
///<reference path='app/wizard/page/contextwindow/inspect/_module.ts' />
///<reference path='app/wizard/page/contextwindow/inspect/page/_module.ts' />
///<reference path='app/wizard/page/contextwindow/inspect/region/_module.ts' />
///<reference path='app/wizard/page/contextwindow/_module.ts' />
///<reference path='app/wizard/page/_module.ts' />
///<reference path='app/wizard/_module.ts' />
///<reference path='main.ts' />
//# sourceMappingURL=_all.js.map